c  htran.sun.big.f
c  Last Modified by VJH on 10/7/98
c
c   ******************************************************************
c   ******************************************************************
c   ******************************************************************
c
c                       H  o  t  z  T  r  a  n
c
c        Statistical Package for Applications in Economics and
c                        the Social Sciences
c
c   **********          U N I X       D R I V E R           ************
c
c                      THE BIG VERSION OF HOTZTRAN
c
c   This file contains the front end for HotzTran for use with the UNIX
c   operating system on HP 800 series computers or SUN Sparcstations.
c   It must be linked with the other subroutines which comprise HotzTran
c   in order to create a complete executable version of the program.
c
c   Copyright (c)  1985, 1990  Robert B. Avery  and  V. Joseph Hotz
c
c   All rights to this program are reserved.  It may not be reproduced
c   in whole or in part without permission of the authors.
c
c   The following subroutines are called by this MAIN PROGRAM:
c   DATAON  HOTZTR  CONTRL  MINREG

c   This version is a modified version of the file HTDRIVER.VAX.  It
c   contains imported versions of the routines USEO,USEM,USER and
c   PUNCHA from the file MAINDRV.F.  Modifications made by Jeff Smith
c   on July 3-5, 1989.  Key modifications are:
c
c   1. The call to FOR$TIME was added.
c
c   2. The array XH() was redimensioned to allow for longer file names.
c
c   3. Input routines were changed to allow upper or lower case. 
c
c   Further modifications made by Jeff Smith around April 14, 1990 and
c   Joe Hotz (around November 28, 1990).  These include:
c
c   1. Further lengthening of the acceptable filenames.
c
c   2. Changing of the welcoming script.
c
c   3. Incorporates changes for use of Downhill Simplex Minimization
c      Method.
c
c   4. Changing of the device numbers assigned to the various files so
c      that they do not conflict with SUN default device assignments.
c
c   DEVICE NUMBER      VARIABLE      DESCRIPTION
c   ---------------------------------------------
c   14                 IP            Hotztran output file.
c   15                 INP           Input file.
c   16                 INN           Data file.
c   17                 IPC         Coefficient Punch file.
c   18                 INT           Internal format save file output.
c   19                 INZ           Temporary run data.
c
c   ******************************************************************
c   ******************************************************************
c   *****************************************************************
c
c------------------DIMENSIONS & DECLARATIONS-----------------------------
      DOUBLE PRECISION AA(1),EMAX,FMAX
      DIMENSION IB(1),VM(6)
      CHARACTER*40 filep
      CHARACTER*24  fdate
      CHARACTER*40 XH
      CHARACTER*10 WH,VM,FFRT
c   CHARACTER*8 THETIME
c
c   ** CHANGE **
c   These designations are necessary for error handling and for
c   the timer.
c 
c    INTEGER*2 M,D,Y
c    CHARACTER*9 DDDD
c    CHARACTER*8 TTTT
c    INTEGER*4 HDLR
c    EXTERNAL HDLR
c    EXTERNAL FOR$TIME
c-------------------------COMMON BLOCKS----------------------------------
      COMMON /A/ A1(4)
      COMMON /B/ IP,INP,IPC,INT,IQV,NOBS,NVAR,NTIME,KCORE,IDIM,IPK,
     1A5(22),M10,A6(5),JOBS,LWI,MO,MD,MY
      COMMON /C/ INN,IPR,A2(38)
      COMMON /D/ A3(19),INZ,A7(4)
      COMMON /E/ XH(6),WH(24)
      COMMON /F/ A4(32),EMAX,FMAX
      COMMON /G/ ISAMP
      COMMON /PUNCH/ filep
c
c   ** CHANGE *** 
c   Set the dimension of core in common AB to the desired core
c   amount.  This should be at least 8000.  Icore should be the same.
c
      COMMON AB(3600000)
c---------------------EQUIVALENCE STATEMENTS-----------------------------
      EQUIVALENCE(AA(1),AB(1),IB(1))
c------------------------DATA STATEMENTS---------------------------------
      DATA VM/' ','Input','Data ','Print','Punch','Save '/
C
c-----------------BEGINNING OF MAIN SUBROUTINE---------------------------
      ICORE=3600000
      KCORE=ICORE
c   
c   ** CHANGE **
c   The following 2 cards set under/overflow check.  They should be
c   commented out on non-IBM systems.
c
c   CALL ERRSET(208,0,-1,1)
c   CALL ERRSET(207,260,-1,1)
c
c   ** CHANGE **
c   Set print file device number.
c
      IP=14
c
c   ** CHANGE **
c   Set card input file device number.
c
      INP=15
c
c   ** CHANGE **
c   INN is the observation input device.  It is set by input from the 
c   terminal.
c
      INN=16
c
c   ** CHANGE **
c   Set device number for punch file.
c
      IPC=17
c
c   ** CHANGE **
c   Set temporary disk device used (option) for observations.
c
      INT=18
c
c   ** CHANGE **
c   Set temporary disk device used (option) for run data.
c
      INZ=19
c
c   ** CHANGE **
c   Set default on printer line width (80 characters = 1).
c
      LWI=1
c
c   ** CHANGE **
c   Set maximum power of e allowed by system.
c
      EMAX=150.D0
c
c   ** CHANGE **
c   Set maximum probit argument value allowed by system.
c
      FMAX=9.D0
c
c   On a UNIX system, users are prompted for the specs of their
c   control card file, the data (observation) file, (if different),
c   the printed output file, and the punch (disk output) file.  The
c   command 'INPUT' on the data control card is now irrelevant.  
c   Additionally, users are prompted as to whether or not their files
c   are formatted.
c 
      write(*,5)
5     format(/,/,5X,'WELCOME TO UNIX(tm) HOTZTRAN',
     $       /,/,3X,'Version as of December 1, 1991',
     $       /,5X,'COPYRIGHT (C) 1985, 1990 by Robert Avery and',
     $         ' V. Joseph Hotz',/5x,'This Version Uses A Large ',
     $     'Amount of Memory',
     &    //5x,'Read /u1/hotz/htran/HotzTran.Update for Latest Updates',
     &    ' to Program',
     $       //,5X,'Enter the status (old or new) and file ',
     $         'name for each of the files'/,5x,'to be used in',
     $       ' response to the following prompts. ',' Use the format',
     $        /,5x, 'A3,1X,A40.'
     $       /)
c
c   Loop to read in file names.
c
      do 7 I=1,5
        write(6,6) VM(I+1)
6       format(5X,A5,' File =>',$)
        read(5,8) WH(I),XH(I)
8       format(A3,1X,A40)
7     continue
      filep = XH(4)
      write(6,11)
11    format(/,5X,'Is the data file formatted (YES/NO)? =>',$)
      read(5,8) FFRT
c
c   Set default of data file to control card file if blank.
c
      IF(XH(2).EQ.XH(1)) WH(2)=VM(1)
      IF(WH(2).EQ.VM(1)) INN=INP
c
c   Set default line width to 80 and print file device to standard output
c   if print file is the terminal
c
      if (XH(3).eq.'TERMINAL') then
        LWI = 1
        IP = 6
        endif
c
c   Set punch to print file if same file name.
c
      IF (XH(4).EQ.XH(3)) IPC=IP
      IF (XH(4).EQ.XH(3)) WH(4)=VM(1)
c
c   Loop to open files.
c
      do 16 I=1,5
c
c     If punch file blank, then no punch.
c
        if (WH(I).ne.VM(1)) then
          I1 = INP
          if (I.eq.2) I1 = INN
          if (I.eq.3) I1 = IP
          if (I.eq.4) I1 = IPC
          if (I.eq.5) I1 = INT
c    
c       Open data file.  Note that the variable FFRT contains the
c       users response to the question of whether or not the data
c       file is formatted.
c
          if(I.eq.2) then
            if(FFRT.eq.'YES'.or.FFRT.eq.'yes'
     $          .or.FFRT.eq.'Y'.or.FFRT.eq.'y') then
              open(unit=I1,status=WH(I),file=XH(I),form='formatted')
            else
              open(unit=I1,status=WH(I),file=XH(I),
     $          form='unformatted')
              endif
            endif
          if(I.eq.1) open(unit=I1,status=WH(I),file=XH(I))
          if(I.eq.3.and.XH(3).ne.'TERMINAL') then
            open(unit=I1,status='unknown',file=XH(I))
            endif
          if(I.eq.4) then
            open(unit=I1,status='unknown',file=XH(I))
            endif
          if (I.eq.5) then
            open(unit=I1,status='unknown',file=XH(I),form='unformatted')
            endif
          endif
16    continue
c
c   Open temporary file.
c
      open(unit=INZ,status='scratch',form='unformatted')
c
c
c   Write header to output file indicating that the run is occuring on
c   the Suns rather than Cicero.
c
        write(IP,17) fdate()
17      format(16X,18x,'HOTZTRAN RUN  ',/,/,27X,A24,/,/,17X,
     $    'This HotzTran Run is being executed on a SUN.',/
     $    23x,'Version as of December 1, 1991',/18x,'This Version ',
     $     'Uses A Large Amount of Memory',//6x,
     &    'Read /u1/hotz/htran/HotzTran.Update for Latest Updates',
     &    ' to Program',/)
c
c   Write file names and unit numbers to output files.
c
      do 19 I = 1,5
        if (WH(I).ne.VM(1)) then
          I1 = INP
          if (I.eq.2) I1 = INN
          if (I.eq.3) I1 = IP
          if (I.eq.4) I1 = IPC
          if (I.eq.5) I1 = INT
          if (XH(3).ne.'TERMINAL') then
            write(IP,18) I1,VM(I+1),XH(I)
18          format(6X,'Fortran Device',I3,' for ',A5,
     $        ' is File: ',A40)
            endif
          endif
19    continue
c
c   Write blank line to output file.
c
        write(IP,21)
21      format(/)
20    M10=0
      INS=INN
      ISAMP=0
25    ISAMP=ISAMP+1
c
c   ** CHANGE **
c   Set default device for observation input file.
c
      INN=INS
      IGL=0
c
c   Call DATAON which reads in observation cards and data.
c
      CALL DATAON(AB,IB,AA,I1,J1)
c
c   Determine which type of run is present.
c
   30 J=ICORE-485
      CALL CARDRD(AB(J),AB,NVAR,ID,0)
      IGL=IGL+1
      IF(ID.EQ.7) GO TO 25
      IF(ID-5) 40,60,50
   40 I2=J1*2
      M10=M10+1
      KCORE=ICORE-I2
      DO 45 I=1,484
   45 AB(I2+I-1)=AB(J+I-1)
c
c   ** CHANGE **
c   Call HOTZTRAN driver.  Comment out if using CONTIM/MINREG alone.
c
      CALL HOTZTR(AB,AB(I1),AB(I2),IB(I2),AA(J1))
      GO TO 30
   50 I2=J1*2
      M10=M10+1
      KCORE=ICORE-I2
      DO 55 I=1,481
   55 AB(I2+I-1)=AB(J+I-1)
c
c   ** CHANGE **
c   Call CONTIM driver.  Comment out if using only HOTZTRAN/MINREG.
c
      CALL CONTRL(AB,AB(I1),IB,AA,I2)
      GO TO 30
   60 IF(IGL.GT.1) GO TO 65
      J2=J1+(NVAR+1)*(NVAR+2)/2
      I2=J2*2
      INN=2
      IF(IPR.GE.3.OR.IQV.GE.3) INN=0
      GO TO 70
   65 INN=2
      J2=J1+(NVAR+1)*(NVAR+2)/2
      I2=J2*2
   70 KCORE=ICORE-I2
      IPK=0
      I=I2+2*NVAR+4
      DO 75 L=1,481
   75 AB(I+L-1)=AB(J+L-1)
c
c   ** CHANGE **
c   This statement calls the driver for the MINREG routine.  It should
c   be commented out if only HOTZTRAN/CONTIM is being used.
c
      CALL MINREG(AB,AB(I1),AA(J1),AB(I2),IB(I2),AA(J2))
c
c   Read sample or master card for next MINREG run.
c
      J=I2+2*NVAR+4
      CALL CARDRD(AB(J),AB,NVAR,IC,1)
      IPK=0
      IGL=IGL+1
      IF(IC.EQ.7) GO TO 25
      IF(IC-5) 40,65,50
      END
c-----------------------END OF MAIN SUBROUTINE----------------------------

c************************************************************************
c************************************************************************
c   CKTIME           (SUBROUTINE IN MAIN PART OF HOTZTRAN)
c   This routine is called by VINCEN and SEARCH.  It should be filled by
c   the user.  The first call should initialize the timer to zero.
c   Subsequent calls should put cumulative CPU time in seconds into the
c   variable tim1.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CKTIME(ind,ikd)

c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,tim1,tim2,msec
c    real timearry(2)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(ikd) 1,1,2
c
c     ** CHANGE *** 
c     Initialize timer to zero on this call.
c
    1   continue
c      IPR=LIB$INIT_TIMER(MSEC)
        return
    2   continue
c
c     ** CHANGE ***
c     The following line may have to be changed on some VAX systems.
c     It computes used CPU seconds (in units of 1/100 of a second).
c
c     tim1=dtime(timearry)
c     tim1=timearry(1)
        tim1 = 0
c
c   If CPU time used exceeds the amount allowed (SEC), then stop
c   iteration.
c
      if(tim1.ge.sec) ind=5
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   USER            (SUBROUTINE IN MAIN PART OF HOTZTRAN)
c   This version is imported here from the file MAINDRV.F.
C
c   x    = observation vector to be filled
c   nvar = number of variables
c   inum = number of the observations
c            (including excluded observations)
c   inn  = input device
c   idd  = return code
c
c      0 = process and continue (default)
c      1 = don't process but continue
c      2 = process this observation then stop
c      3 = don't process this observation and stop
c      4 = error in input terminate program
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine USER(x,nvar,inum,inn,idd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension x(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   USEM         (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   xx is the lower triangular moment matrix to be filled. nvar is
c   total c variables (not incl. constant which is last). inn is input
c   device. set idd=1 if input error. matrix is (nvar+1)*(nvar+2)/2.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine USEM(xx,nvar,inn,idd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   USEO             (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   data is the entire observation matrix. it is dimensioned lobs
c   by nvar, where nvar is c variables read (excl. constant) and lobs
c   is the observation dimension. nobs is the number of observations.
c   if read to end-of-file set nobs to right amount on return. fill
c   all rows of data up to nobs. inn is the input device. set idd=1
c   if input error.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine USEO(data,lobs,nvar,nobs,inn,idd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension data(lobs,nvar)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PUNCHA         (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   This subroutine punches the coefficient vectors.
c
c   This subroutine calls the following subroutines:
c   
c   This subroutine is called by the following subroutines:
c   MAIN Program  AMOEBA  SEARCH  CONTIM  MINREG
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PUNCHA(x,l1,sc,isc,h)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),sc(1),h(1)
      character*40 filep
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a1(2),ipc,dum(41)
      common /punch/ filep
c-------------------BEGINNING OF SUBROUTINE------------------------------
c    open(unit=ipc,file = filep,status='old',access='append')
c    open(unit=ipc,file=filep,status='old')
 60   format(1x,i5,1x,a20)      
      if(isc.eq.0) go to 20
      write(ipc,10) (x(i),i=1,l1)
c
c   ** CHANGE **
c   Reset coefficient punch format if desired.
c
   10 format(5d16.9)
c    close(ipc)
      return
   20 do 30 i=1,l1
   30 h(i)=x(i)*sc(i)
      write(ipc,10) (h(i),i=1,l1)
c    close(ipc) 
      return
      end
c-------------------------END OF SUBROUTINE------------------------------


c************************************************************************
c************************************************************************
c   HOTZTR        (KEY SUBROUTINE)
c   Main driver subroutine for HotzTran.
c
c   The following subroutines are called by this driver:
c   CONMAS  CONBAS  MARKY  RDREST  READCF  RESCL  DASORT  VINCEN
C   PUNCHA  ERRCHK
c    
c   This subroutine is called by the MAIN PROGRAM.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine HOTZTR(vnam,xbata,ab,ib,aa)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension vnam(1),ab(1),xbata(1),ib(1)
      double precision aa(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a1(6),nvar,ntime,kcore,dum(35)
      common /c/ me,nt,igm,istan,istar,irho,irhp,lt,iscal,a2(3),ipun,mm,
     1nl,ir,ln,igs,ifs,lm,iwo,dumc(19)
      common /d/ k,n,jb,kobs,lv,lw,lr,le,igmm,lz,lp,my,ny,l1,a6(4),iqz,
     *dumd(5)
      common /f/ a5(20),dumf(16)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      ierror=0
      nvar=nvar+1
c   Call CONMAS which reads and processes the master control card
      call CONMAS(ab,vnam,ierror)
      if(ierror.gt.0) go to 190
      ny=10*me
      if(igm.eq.4) ny=8*me+me*(me-1)/2
      i2=ny+1
      i5=i2+nvar*(nt+1)*2+1
      i8=i5+me*2*nvar+1
c***************************
c   Correction made by Hotz (3/31/88)
c   i3=kcore-11*me-1
      i3=kcore-11*me-2
c***************************
      i4=i3-nvar-1
      j5=i4-nvar-1
c
c   Changed from j6=i4-2*484 by JEFF SMITH 12/1/88      
c
      j6=j5-2*484
      j1=j6-1
c   Call CONBAS which reads equation control cards
      call CONBAS(ab(j6),ib,ab,aa,ib(j5),ib(i5),ab(i3),ib(i4),i8,i7,i9,
     1j9,j1,vnam,ierror)
      if(ierror.gt.0) go to 190
      j1=(i8+1)/2
c   Read restriction card (optional)
      if(ir.eq.0) go to 25
      j2=0
      j4=i8+(j6-i8)/4-3*le
      i1=j4+1
      j1=(j4+(j6-i8)/4-3*le)/2+1
      j6=j1-le-1
      i5=j6-le-1
      lr=(i5-le-1)*2
      do 5 i=1,le
    5 ib(lr+i-1)=0
      do 10 i=1,ir
      call MARKY(ab(i1),1,10,vnam,nvar,ierror)
      if(ierror.gt.0) go to 190
c   Call RDREST which decodes restrictions
      call RDREST(ib(i8),ib(i8),aa(j1),j2,ab(i1),aa(j6),aa(j6),aa(i5),
     1ib(i8),le,ib(lr),k,j7,0,my,ierror)
      if(ierror.gt.0) go to 190
      ab(i1-1)=j7
      i1=i1+j7+1
   10 continue
      j6=i1-j4
      i5=i8+j2+1
      do 15 i=1,j6
   15 ab(i5+i-1)=ab(j4+i-1)
      j6=(i5+j6)/2+2
      do 20 i=1,j2
   20 aa(j6+i-1)=aa(j1+i-1)
      j1=j6+j2
c   Set program array dimensions
   25 if((igm.eq.2.or.igm.eq.3).and.istar.le.2) my=0
      lr=(nt*(nt-1)/2)
      if(irho.eq.0) lr=0
      lw=me*(me-1)/2
      if(irhp.eq.0) lw=0
      j7=j1
      if(irho.gt.0) j7=j1+lr*me
      j4=j7
      if(irhp.gt.0) j4=j7+lw
      j2=j4
      if(igm.eq.3.and.(iwo.eq.0.or.igs.gt.0)) j2=j4+le
c   Read coefficient starting values
      if(istar.le.1.or.istar.eq.3.or.irho.eq.3.or.irhp.eq.3) call READCF
     1(a5,aa(j2),le,l1)
c   Read weighting coefficient starting values
      if(istar.eq.1.or.(istar.eq.3.and.(irho.eq.3.or.irhp.eq.3))) call 
     1READCF(a5,aa(j4),le,l1)
c   Read time period correlation starting values
      i1=lr*me
      if(irho.eq.1.or.(irho.eq.3.and.istar.le.1)) call READCF(a5,aa(j1),
     1i1,l1)
c   Read equation correlation starting values
      if(irhp.eq.1.or.(irhp.eq.3.and.istar.le.1)) call READCF(a5,aa(j7),
     1lw,l1)
      if(l1.lt.0) go to 180
      i6=(j2+max0(lz,le))*2+2
      i1=i6+3*me
      j8=i2+k*nt
      j0=j5/2-k-2
      i=me+1
c   Scale data if disk is used
      if(iscal.eq.0.and.nl.eq.0.and.iqz.gt.0) call RESCL(aa,aa(j2),
     1aa(j0),ab,ib(i),ib,ib(j8),aa,ib,aa,ib,0)
      if(kobs.ne.1) kobs=min0(kobs,j0*2/jb-i1/jb-2)
      nvar=nvar-1
c   Call DASORT which extracts the observation matrix used
      call DASORT(xbata,ab(i1),ab(i3),ib(j5),ib(i4),ib,ib(i2),ib(j8),
     1ib(i6),aa(j0),j3,i1,ierror)
      if(ierror.ne.0) go to 185
      i4=j8+me*k
      j5=(j3+k+1)/2+1
c   Call VINCEN main program.
      kcore=kcore-j5*2
      call VINCEN(aa(j2),ib,ib(i2),ib(j8),ib(i4),vnam,ab(i1),aa(j5),
     1aa(j4),aa(j1),aa(j7),aa(j6),ib(i8),ib(i7),ab(i9),ab(i5),aa(j9),
     2ib(j3),ib(i6),ierror)
c   Write parameters on disk (punch)
      if(ipun.ge.1) call PUNCHA(aa(j2),le,aa,1,aa)
      i1=lr*me
      if(ipun.ge.1.and.irho.gt.0) call PUNCHA(aa(j1),i1,aa,1,aa)
      if(ipun.ge.1.and.irhp.gt.0) call PUNCHA(aa(j7),lw,aa,1,aa)
      if(ierror.ne.0) go to 185
      return
  180 ierror=1
      go to 190
  185 if(ierror.gt.0) go to 190
      me=-ierror
      ierror=8
  190 call ERRCHK(ierror,me)
      if(ierror.le.8.or.ierror.eq.14) stop
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   VINCEN        (KEY SUBROUTINE)
c   Main sub-driver program for iterations and estimation.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
c   MOFSTR  FEINIT  START  RESTRN  CPRINT  RESCL  BROWN  WEPETE  
C   CKTIME  FCTGR  STEDE  SECDRV  SCHNBL  FLEPOW  STANER  PRINTA
C   PRINTB  ECOVWR  RESIDL  AMOEBA
c
c   This subroutine is called by the following subroutines:
c   HOTZTR
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine VINCEN(x,joe,loe,moe,noe,vnam,xdata,xx,xs,w,z,r,
     1iii,iin,abn,abr,rn,lar,koe,ind5)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),x(1),f,f1,fff,trial1,fact,aaa,r(1),
     1bb,epsg,epsp,epsf,pr,xs(1),w(1),z(1),rn(1)
      dimension xdata(1),joe(me,10),loe(1),moe(1),noe(1),iii(1),vd(10),
     1iin(1),abn(1),abr(1),vnam(1),lar(1),koe(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,tim1,tim2,dum
      common /b/ ip,inp,ipc,a2(5),kcore,a1(31),lwi,dumb(3)
      common /c/ me,nt,igm,istan,istar,irho,irhp,lt,iscal,ivcb,jc,a4(3),
     1nl,ir,ln,igs,ifs,lm,iwo,ira,ires,jres,irip,dumc(15)
      common /d/ a5(4),lv,lw,lr,le,igmm,lz,lp,my,ny,l1,lee,lg,lh,a6(4),
     2lpp,dumd(2)
      common /f/ a3(8),trial1,fact,aaa,bb,maxtry,iter,pr,epsg,epsp,epsf,
     1maxite,iv1,iv2,dumf(7)
      common /hess/ ll1,ihhh,lle
c------------------------DATA STATEMENTS---------------------------------
      data vd/4HTime,4H Per,4Hiod ,4HEqua,4Htion,1H ,4H Sta,4Hrtin,
     *4Hg Va
     1,4Hlues/
c-------------------BEGINNING OF SUBROUTINE------------------------------
c**********************************
       ll1 = l1*(l1+1)/2
       lle = le*(le+1)/2
c**********************************
c   Call MOFSTR for hermite points for single factor ML.  
      if(igm.eq.2) call MOFSTR
      igp=0
      call FEINIT(1)
c   Set basic run codes
      igmm=igm
c*****************************
      if(igm.ge.2.and.istar.ge.3.and.(jc.lt.4.or.jc.eq.8.or.jc.eq.9)) 
     &    igmm=1
c*****************************
      i0=le+2
c   Branch if only error correlations Computed
      if(irho.eq.3.or.irhp.eq.3) go to 60
c   Set array dimensions and parameter # (l1) for run
    2 l1=le
      if(igmm.eq.5) l1=lr*me
      if(igmm.eq.6) l1=lw
      i1=i0+(l1+1)*(l1+2)/2
      if(jc.ge.10)i1=i0+(l1+1)*(l1+1)
      if(igmm.eq.3.and.lg.gt.l1.and.istar.eq.2) i1=i0+lg*(lg+1)/2
      if(igmm.eq.3.and.lg.gt.l1.and.istar.eq.2.and.jc.ge.10)
     1 i1=i0+lg*lg
      if(nl.gt.0) i1=i1+le
      if(igmm.ge.5) i1=max0(i1,i0+le*le/2+le/2+2*me)+2
      if(igmm.ge.5.and.jc.ge.10) i1=max0(i1,i0+le*le+me+me)+2
      i2=i1+max0(le+1,l1,lz,lp,me)
      i3=i2+l1
      if(jc.ge.10) i3=i3+l1*9
      if(igmm.eq.3.and.lg.gt.l1) i3=i2+lg
      if(igmm.eq.3.and.lg.gt.l1.and.jc.ge.10) i3=i2+lg*10
      i4=i3+l1
      i5=max0(i4+l1,(nt+1)*(nt+2)/2+1+i0,i2+me*31)
      maxcor=i5*2+l1*(l1+1)+le+10*me*nt
      if(igm.eq.2) maxcor=max0(maxcor,2*i5+max0(me,nt)*48+le*le+le)
      if(igm.eq.3) maxcor=(i5+max0(max0(5*nt,lz)+lz,le*le/2+le/2+2)+2*le
     1*lz+lz*(lz+1)/2+2*le)*2
      if(igm.eq.4) maxcor=max0(maxcor,2*i5+12*me+le*le+6*le)
      if(igmm.ge.5) maxcor=max0(maxcor,i5*2+le*le+le+l1*l1+3*l1+8+l1*le*
     12+l1*lz*2+lz*2+nt*12+lz*le*2)
      if(igs.gt.0) maxcor=max0(maxcor,2*i5+lp*lp*2+max0(lz*lz*2,lp*lp+lp
     1+2+max0(nt*14+lp*2,lp*lp*2)))
      if(igm.eq.4.and.igmm.eq.1) l1=lpp
      if(igm.eq.4.and.igmm.eq.1) le=lpp
c   Stop execution if not enough core
    3 if(maxcor.gt.kcore) ind5=kcore-maxcor
      if(maxcor.gt.kcore) return
      if(igmm.ge.5) go to 12
      i=i5+le*2+4
      ind1=i
      ist=i+lz
      if(igmm.eq.3) ind1=ist+2*lg*lh
      if(ir.gt.0) maxcor=2*ind1+le*(le+1)
      if(maxcor.gt.kcore) go to 3
c   Compute 0/1 or ols regression for starting values
      if(istar.eq.2.or.istar.eq.4) call START(x,xx(i0),xx(i2),xx(i1),
     1xx(i5),xdata,joe,loe,moe,koe,lar,r,iii,xx(ist),xx(ind1),xx(i),
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,9),1,xx,
     3iscal,ind5)
      if((istar.eq.2.or.istar.eq.4).and.ir.gt.0) call RESTRN(x,xx,xx,r,
     1iii,0)
c   Set starting value for rho of  single factor  ML
    4 i=2
      if(ira.eq.2) i=6
      ist=i5+2*le+4
      if(igmm.eq.2.and.(istar.eq.2.or.istar.eq.4)) call START(x,xx(i0),x
     1x(i1),xx(ist),xx(i5),xdata,joe,loe,moe,koe,lar,r,iii,r,r,r,
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,9),i,
     3xx,iscal,ind5)
      if(igmm.eq.4.and.(istar.eq.2.or.istar.eq.4)) call START(x,xx(i0),x
     1x(i1),x(lpp),xx(i5),xdata,joe,loe,moe,koe,lar,r,iii,r,r,r,
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,9),5,
     3xx,iscal,ind5)
      if(igmm.gt.1.and.istar.ge.3) go to 9
      call CPRINT(18)
      if(lwi.eq.0) write(ip,5) (x(i),i=1,le)
    5 format(6x,10g12.5)
      if(lwi.eq.1) write(ip,6) (x(i),i=1,le)
    6 format(1x,7g11.4)
      if(istar.eq.1.and.lwi.eq.0) write(ip,7) (vd(i),i=7,10),(xs(i),i=1,
     1le)
    7 format(//50x,'Weighting Matrix',4a4,/(6x,10g12.5))
      if(istar.eq.1.and.lwi.eq.1) write(ip,8) (vd(i),i=7,10),(xs(i),i=1,
     1le)
    8 format(//24x,'Weighting Matrix',4a4,/(1x,7g11.4))
c   Scale data and parameter vector
      if(iscal.eq.0) call RESCL(xx,x,xx(i0),xdata,joe(1,2),loe,moe,r,iii
     1,rn,iin,1)
    9 if((istar.eq.1.and.iscal.ne.0).or.igm.ne.3.or.iwo.eq.1) go to 11
c   Set scale of weighting matrix parameters
      do 10 i=1,le
      if(istar.eq.1) xs(i)=xs(i)/xx(i)
      if(istar.ne.1) xs(i)=x(i)
   10 continue
c   Branch if parameters not estimated
   11 if(jc.eq.5) go to 48
      go to 18
   12 if(igp.eq.1) go to 18
c   Compute starting values for time period error correlations
      if(irho.eq.2.or.(irho.eq.3.and.istar.ge.2)) call START(x,xx(i0),xx
     1(i1),w,xx(i5),xdata,joe,loe,moe,koe,lar,r,iii,r,r,r,joe(1,2),
     2joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,9),3,xx,iscal,ind5)
c   Compute starting values for equation error correlations
      if(irhp.eq.2.or.(irhp.eq.3.and.istar.ge.2)) call START(x,xx(i0),xx
     1(i1),z,xx(i5),xdata,joe,loe,moe,koe,lar,r,iii,r,r,r,joe(1,2),
     2joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,9),4,xx,iscal,ind5)
      call CPRINT(18)
      if((irho.eq.3.or.irhp.eq.3).and.lwi.eq.0) write(ip,5) (x(i),i=1,le
     1)
      if((irho.eq.3.or.irhp.eq.3).and.lwi.eq.1) write(ip,6) (x(i),i=1,le
     1)
      if((irho.eq.3.or.irhp.eq.3).and.(istar.eq.1.or.istar.eq.3).and.lwi
     1.eq.0) write(ip,7) (vd(i),i=7,10),(xs(i),i=1,le)
      if((irho.eq.3.or.irhp.eq.3).and.(istar.eq.1.or.istar.eq.3).and.lwi
     1.eq.1) write(ip,8) (vd(i),i=7,10),(xs(i),i=1,le)
      if(irho.gt.0.and.lwi.eq.0) write(ip,13) (vd(i),i=1,3),(vd(i),i=7,1
     10),(w(i),i=1,l1)
   13 format(/46x,3a4,'Correlation',4a4,/(6x,10g12.5))
      if(irho.gt.0.and.lwi.eq.1) write(ip,14) (vd(i),i=1,3),(vd(i),i=7,1
     10),(w(i),i=1,l1)
   14 format(/20x,3a4,'Correlation',4a4,/(1x,7g11.4))
      if(irhp.gt.0.and.lwi.eq.0) write(ip,13) (vd(i),i=4,10),(z(i),i=1,
     1lw)
      if(irhp.gt.0.and.lwi.eq.1) write(ip,14) (vd(i),i=4,10),(z(i),i=1,
     1lw)
      if(istar.eq.3) istar=1
      if(irho.lt.3.and.irhp.lt.3) go to 16
      if(iscal.eq.0) call RESCL(xx,x,xx(i0),xdata,joe(1,2),loe,moe,r,iii
     1,rn,iin,1)
      if(igm.ne.3.or.iwo.gt.0) go to 16
      do 15 i=1,le
      if(istar.eq.1.and.iscal.eq.0) xs(i)=xs(i)/xx(i)
      if(istar.ne.1) xs(i)=x(i)
   15 continue
   16 do 17 i=1,le
   17 xx(i5+i-1)=x(i)
c   Branch if errors encountered during run setup
   18 if(ind5.gt.0) return
      if(igmm.ge.5) go to 20
      lg=kcore/2-1
      do 19 lh=i5,lg
   19 xx(lh)=0.d0
   20 lg=0
      lh=0
c   Store moment matrix for moment sufficient equations
      if(nl.eq.0.and.igmm.le.4) call BROWN(xx(i5),xx(i1),xdata,joe,moe,
     1loe,koe,joe(1,3),joe(1,2),joe(1,7),igmm)
      maxcor=maxcor+lg
      if(maxcor.gt.kcore) go to 3
c   Compute optimal weighting matrix
      if(igmm.eq.3.and.iwo.eq.0) call WEPETE(xs,xdata,joe,loe,moe,rn,iin
     1,xx(i5),xx,iscal,ind5)
      if(ind5.gt.0) return
      f=0.d0
c   Set parameters for fletcher-powell.
      pr=.05d0
      maxtry=15
      iter=0
c*****************************
c   THE FOLLOWING HAS BEEN ADJUSTED IN ORDER TO INCREASE THE NUMBER OF 
c   TRIES WITHIN AN ITERACTION FOR I.V. ESTIMATION.   Change made by
c   V. Joseph Hotz 1/21/88
      if(igmm.eq.3) maxtry=18
c*****************************
      trial1=.1d0
      fact=.1d0
      aaa=2.d0
      bb=.75d0
c   Initialize timer to zero
      call CKTIME(ind3,0)
      ind1=-1
      ind2=-1
      ind3=-1
      ind4=-1
      if(jc.eq.4) go to 24
c************************
      if(jc.lt.8.or.jc.gt.9) go to 264
c   Call AMOEBA which executes Downhill Simplex Iterations
      if(igmm.le.4) call AMOEBA(l1,x,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,iscal,ind1)
      if(igmm.eq.5) call AMOEBA(l1,w,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,1,ind1)
      if(igmm.eq.6) call AMOEBA(l1,z,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,1,ind1)
      fff=f
      go to 23
 264  continue
c************************
c   Call function gradient routine. igmm < 5 is oc estimators. igmm=5
c   Is time period correlations. igmm=6 is equation correlations.
      ind1=0
      if(igmm.le.4) call FCTGR(x,f,xx(i1),xdata,joe,r,iii,rn,iin,xx(i5),
     1xx,iscal,ind1)
      if(igmm.eq.5) call FCTGR(w,f,xx(i1),xdata,joe,r,iii,rn,iin,xx(i5),
     1xx,iscal,ind1)
      if(igmm.eq.6) call FCTGR(z,f,xx(i1),xdata,joe,r,iii,rn,iin,xx(i5),
     1xx,iscal,ind1)
      if(ind1.eq.1.or.maxite.eq.0.or.jc.ge.2) go to 23
c   Call STEDE which executes steepest descent iterations
      if(igmm.le.4) call STEDE(l1,x,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,iscal,ind1)
      if(igmm.eq.5) call STEDE(l1,w,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,1,ind1)
      if(igmm.eq.6) call STEDE(l1,z,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,1,ind1)
      if((ind1.ne.1.and.ind1.ne.6).or.jc.eq.1) go to 24
   23 if(ind1.eq.1.or.maxite.eq.0) ind2=-2
c   Calculate information matrix and invert it
c************************
       if(jc.eq.8.or.jc.ge.10) go to 24
c************************
      if(igmm.le.4) call SECDRV(xx(i0),x,xx(i2),xdata,joe,loe,moe,r,
     1 iii,rn,iin,xx(i5),xx,iscal,ind2)
      if(igmm.eq.5) call SECDRV(xx(i0),w,xx(i2),xdata,joe,loe,moe,r,
     1 iii,rn,iin,xx(i5),xx,iscal,ind2)
      if(igmm.eq.6) call SECDRV(xx(i0),z,xx(i2),xdata,joe,loe,moe,r,
     1 iii,rn,iin,xx(i5),xx,iscal,ind2)
   24 f1=f
      iter1=iter
      tim2=tim1
      if(maxite.eq.0) ind1=6
      if(ind1.ne.1.and.ind1.ne.6.and.jc.lt.2) go to 25
c********************
      if(jc.eq.4.or.jc.eq.8) go to 30
c********************
      if(jc.ge.2.and.ind1.eq.0) ind1=-1
c   Stop if problems or convergence in STEDE
      if(ind1.eq.1) ind5=12
      if((ind1.ge.0.and.ind1.ne.6).or.ind1.eq.0) go to 25
      ind1=4
      ind3=0
c********************
c   Following line added so that estima=1 works. 
c   Change made 8/25/90 by V. Joseph Hotz
      if(jc.eq.1) go to 25
c********************
      if(jc.lt.10) go to 245
c********************
      if(igmm.le.4) call SCHNBL(l1,x,xx(i1),xx(i2),xx(i0),f,lt,xdata,
     1 joe,loe,moe,r,iii,rn,iin,xx(i5),xx,iscal,ind3)
      if(igmm.eq.5) call SCHNBL(l1,w,xx(i1),xx(i2),xx(i0),f,lt,xdata,
     1 joe,loe,moe,r,iii,rn,iin,xx(i5),xx,iscal,ind3)
      if(igmm.eq.6) call SCHNBL(l1,z,xx(i1),xx(i2),xx(i0),f,lt,xdata,
     1 joe,loe,moe,r,iii,rn,iin,xx(i5),xx,iscal,ind3)
      go to 249
c   Call FLEPOW which executes fletcher-powell iterations
  245 if(igmm.le.4) call FLEPOW(l1,x,xx(i2),xx(i1),xx(i3),xx(i4),xx(i0),
     1f,lt,xdata,joe,r,iii,rn,iin,xx(i5),xx,iscal,ind3)
      if(igmm.eq.5) call FLEPOW(l1,w,xx(i2),xx(i1),xx(i3),xx(i4),xx(i0),
     1f,lt,xdata,joe,r,iii,rn,iin,xx(i5),xx,1,ind3)
      if(igmm.eq.6) call FLEPOW(l1,z,xx(i2),xx(i1),xx(i3),xx(i4),xx(i0),
     1f,lt,xdata,joe,r,iii,rn,iin,xx(i5),xx,1,ind3)
      fff=f
  249 iter=iter-iter1
      if(ind3.eq.1) ind5=13
   25 if(((ind3.lt.0.and.ind1.ne.0).or.ind3.gt.0).and.lwi.eq.0) write(ip
     1,26) (xx(i1+i-1),i=1,l1)
   26 format(/40x,'Values of First Derivatives When Iterations ',
     1'Terminated',/(6x,10g12.5))
      if(((ind3.lt.0.and.ind1.ne.0).or.ind3.gt.0).and.lwi.eq.1) write(ip
     1,27) (xx(i1+i-1),i=1,l1)
   27 format(/8x,'----- Values of First Derivatives When Iterations ',
     1'Terminated -----',/(1x,7g11.4))
      if(igmm.ne.3.or.dabs(f).lt..1) go to 30
      ist=i5+lg+(1-iwo)*lz*(lz+1)/2+max0(lz,nt*5*me)
      if(lwi.eq.0) write(ip,28) (xx(ist+i-1),i=1,lz)
   28 format(/37x,'Values of Orthogonality Conditions When Iterations ',
     1'Terminated',/(6x,10g12.5))
      if(lwi.eq.1) write(ip,29) (xx(ist+i-1),i=1,lz)
   29 format(/5x,'----- Values of Orthogonality Conditions When ',
     1'Iterations Terminated -----',/(1x,7g11.4))
   30 f=0.d0
      ind6=0
   31 ind6=ind6+1
      if(igmm.ge.5) go to 32
      if(ind5.gt.0) go to 35
      ist=0
      if(istan.eq.1.or.(igm.ne.igmm.and.istan.eq.2)) ist=1
      if(istan.eq.3.and.(igmm.eq.1.or.igmm.eq.4)) ist=3
      if(ind6.eq.2) ist=2
      go to 33
c   Compute standard errors of residual correlations
   32 if(igmm.eq.5) call STANER(xx(i0),xs,w,x,xx(i1),xdata,joe,loe,moe,
     1noe,r,iii,rn,iin,xx(i5),f,xx(i2),igm,4,xx,iscal,ind5)
      if(igmm.eq.6) call STANER(xx(i0),xs,z,x,xx(i1),xdata,joe,loe,moe,
     1noe,r,iii,rn,iin,xx(i5),f,xx(i2),igm,2,xx,iscal,ind5)
      go to 34
c   Compute standard errors of coefficients
   33 call STANER(xx(i0),xs,w,x,xx(i1),xdata,joe,loe,moe,noe,r,iii,rn,
     1iin,xx(i5),f,xx(i2),igmm,ist,xx,iscal,ind5)
      if(igm.eq.4.and.igmm.eq.1) le=lpp+me*(me-1)/2
   34 if((ind3.gt.-1.or.ind1.eq.0).and.ind5.eq.0) ind4=0
      if(ind5.gt.0) ind4=1
c   Re-scale parameters
 35   if(igmm.lt.5.and.iscal.eq.0) call RESCL(xx,x,xx(i0),xdata,joe,
     1loe,moe,r,iii,rn,iin,2)
c   Print coefficients
      call PRINTA(x,w,z,xx(i0),ind1,ind2,ind3,ind4,fff,f1,iter,iter1,
     1vnam,joe,moe,noe,koe,abn,abr,lar,joe(1,2),joe(1,3),joe(1,4),
     2joe(1,5),joe(1,6),joe(1,7),joe(1,9),xx(i2),ind6,ist,maxcor)
      if(ind5.ne.0) return
c   Print covariance from information matrix
      if(ivcb.gt.0) call PRINTB(xx(i0),l1,igmm,ist)
      if(igmm.ge.5) go to 65
      if(ind6.eq.2.or.istan.ne.2.or.igm.ne.igmm) go to 40
c   If standard errors are Computed two ways, branch and do again.
      if(iscal.eq.0) call RESCL(xx,x,xx(i0),xdata,joe,loe,moe,r,iii,rn,
     1iin,5)
      go to 31
   40 if(igm.eq.igmm) go to 50
      if(iscal.eq.0) call RESCL(xx,x,xx,xdata,joe,loe,moe,r,iii,rn,
     1iin,3)
c   If type=1 used for starting values branch and do final estimates
      igmm=igm
      if(igm.ne.3) l1=le
      go to 4
   48 if(iscal.eq.0) call RESCL(xx,x,xx,xdata,joe,loe,moe,r,iii,rn,
     1iin,4)
   50 if(igs.eq.0.and.ires.eq.0.and.jres.eq.0.and.irip.eq.0) go to 55
      if(iscal.eq.0) call RESCL(xx,x,xx,xdata,joe,loe,moe,r,iii,rn,
     1iin,3)
c   If equation error covariances written call ECOVWR
      if(irip.gt.0) call ECOVWR(x,xdata,joe,loe,iin,iin(ny),rn,xx(i5),
     1joe(1,5),joe(1,6),joe(1,8),joe(1,9))
c   If residuals are written call RESIDL
      call FEINIT(2)
      if(ires.ne.0.or.jres.ne.0) call RESIDL(x,xdata,joe,loe,moe,xx(i5),
     1iin,iin(ny),rn,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),
     2xx,iscal)
      if(igs.eq.0) go to 54
c   If exogeneity testing done call STANER
      call STANER(xx(i0),xs,w,x,xx(i1),xdata,joe,loe,moe,noe,r,iii,
     1rn,iin,xx(i5),f,xx(i2),igm,5,xx,iscal,ind5)
c   Print exogeneity tests
      call PRINTA(xx(i1),w,z,xx(i5),ind1,ind2,ind3,ind4,f,f1,iter,iter1,
     1vnam,joe,moe,noe,koe,abn,abr,lar,joe(1,2),joe(1,3),joe(1,4),
     2joe(1,5),joe(1,6),joe(1,7),joe(1,9),xx(i2),2,5,maxcor)
      if(ivcb.gt.0) call PRINTB(xx(i5),lp,3,3)
   54 if(iscal.eq.0) call RESCL(xx,x,xx,xdata,joe,loe,moe,r,iii,rn,
     1iin,4)
   55 if(irho.eq.0.and.irhp.eq.0) return
      if(iscal.eq.0) call RESCL(xx,x,xx,xdata,joe,loe,moe,r,iii,rn,
     1iin,3)
c   Prepare data to estimate epsilon correlations
   60 igmm=5
      if(irho.eq.0.or.igp.eq.1) igmm=6
      if(jc.eq.5) jc=0
      go to 2
   65 igp=igp+1
      if(igmm.eq.5.and.irhp.gt.0) go to 60
      if(iscal.eq.0) call RESCL(xx,x,xx,xdata,joe,loe,moe,r,iii,rn,
     1iin,4)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   AMOEBA        (SUBROUTINE IN MAIN PART OF HOTZTRAN)
c   This is a subroutine controls the SIMPLEX method of Optimization.
c   Using this method in HotzTran may be particularly useful when you
c   don't have a good idea about starting values for parameters.
c 
c   This routine minimizes the function F0(XSIMP) where XSIMP is the NSIMP x 1
c   vector of parameters, by a downhill simplex method of Nelder and Mead.
c   It uses, within the routine, the matrix PSIMP whose NSIMP+1 rows are 
c   NSIMP-dimensional vectors which are vertices of the starting simplex.
c   [The dimensions of PSIMP are PSIMP(NSIMP+1,NSIMP).]
c   The routine also makes use of the vector YSIMP, which is
c   of length NSIMP+1, whose components must be initialized to the
c   values of F0 evaluated at the NSIMP+1 vertices (rows) of PSIMP. 
c   Within the routine, it uses FTOL, the fractional convergence 
c   tolerance to be achieved in the function value and the variable
c   STPSIM which is the initial step size used to calculate the SIMPLEX
c   from an initial set of starting values.  On output, PSIMP and YSIMP 
c   will have been reset to NSIMP+1 new points all within FTOL of a 
c   minimum function value, and ITER gives the number of iterations taken.
c
c   This algorithm is a modified version of the Downhill Simplex Method 
c   algorithm found in "Numerical Recipes", pp. 289-293.  It was originally
c   developed by Nelder and Mead, 1965,  Computer Journal, Vol. 7, p. 308.
c
c   Note that the input files for HotzTran will now contain some new
c   options to control this optimization method.  In particular, the 
c   following are new options:
c
c   slamb = number (not in double precision format)
c             This number is the initial step size used to construct
c             the simplex.  It can be either a positive or negative number.
c             The program constructs a tetrahydron by adding the value of
c             slamb to each of the scaled (if scale=0) or unscaled (if scale=1)
c             coefficients to construct the tetrahydron.  It may be useful
c             when trying out different starting values for this method to
c             vary slamb (in absolute value and in sign) to search over the
c             estimation surface.  The DEFAULT is slamb = 1.0.
c
c   ssimp = 0,1, or 2.
c             This integer controls whether the program writes the 
c             intermediate values of the full parameter vector associated 
c             with the best vertex on the simplex to the usual punch file.
c             If ssimp = 0, it DOES NOT write out the intermediate values at
c             any iteration.  If ssimp = 1, it writes the coefficients at
c             the FINAL Iteration.  if ssimp = 2, the program writes out
c             the coefficients at each iteration.  The DEFAULT is ssimp=0.
c
c   numer = 0,1.
c             This integer controls whether HotzTran will printout a 
c             comparison between the program's gradients (which are 
c             calculated explicitly) and the gradients calculated 
c             NUMERICALLY.  This option is to be used to test whether
c             programmed gradients (in User-supplied routines) are
c             correct.  If numer=0, HotzTran does NOT do a test of 
c             numerical derivatives;  If numer=1, HotzTran only does
c             a calculation of the numerical and programmed derivative,
c             prints out both sets of derivatives, and then stops.  The
c             DEFAULT setting is numer=0.  NOTE that when using numer=1,
c             one should ALWAYS set:
c                        estima=8
c                        itera=1
c                        scal=1
c                        slamb=(small number, e.g., .001 or lower, as
c                               slamb is the perturbation in the parameter 
c                               used to calculate the numerical 
c                               derivative.)
c
c   estima = 8 or 9.
c             While the estima is an existing option, it now has two
c             new options.  If estima=8, the program will ONLY use 
c             the Downhill Simplex Optimizer.  If estima=9, the program
c             will first use the Downhill Simplex Optimizer and then
c             automatically go into the Fletcher Powell Optimizer.
c             The latter option thus will enable one, in one run, to use
c             the Simplex Optimizer to get one good starting values and 
c             then continue with a gradient-based method while the former
c             option just uses the Simplex Optimizer to get good starting
c             values and then stops.
c
c   gtol = number
c             Again, this is an existing option on the MASTER CONTROL 
c             CARD, namely the tolerance for the size of the largest
c             gradient when using either the Steepest Descent or 
c             Fletcher-Powell Methods in HotzTran.  When using
c             the Downhill Simplex Method, the program will use the
c             gtol value for FTOL, the tolerance described above.
c             The DEFAULT value for the gtol is .00001 .   When using
c             the Simplex Optimizer, I would set gtol=.001 on the
c             MASTER CONTROL CARD so that you don't bog down in trying
c             to get this Optimizer to get you very close to an optimum.
c
c   scale = 0 or 1
c             This option controls whether HotzTran scales the coefficients
c             according to the starting values or not (scale=0 it scales and
c             and scale=1 it does not).  You probably will have better 
c             luck with setting scale=0 (the DEFAULT value).  This is based 
c             on initial experiences with this optimizer.
c   
c   sigma = 0,1,2,3, or 4
c             This option controls whether the variance of the equation error
c             is estimated as a VARIANCE or as its STANDARD DEVIATION.  (See
c             manual for full range of options.)  When using the Downhill
c             Simplex Minimizer, YOU MUST ALWAYS USE sigma=0,1 or 3.  If the
c             Minimizer tries to set these equation error STANDARD DEVIATIONS
c             to negative values, the program will take their absolute values
c             and proceed.  In general, initial experience indicates that 
c             this optimizer may have difficulty in estimating equation error 
c             standard deviations.  The user needs to be cautious when using 
c             this method on such models.
c
c   rho = 0, or 1
c             This option controls whether the inter-equation error 
c             correlations or covariances are, in fact, estimated as 
c             correlations or covariances.  If rho=0, they are estimated as
c             correlations and if rho=1, they are estimated as covariances.
c             Always set rho=1, i.e., estimate them as covariances.  This is
c             necessary because it is not possible to constrain this optimizer
c             from trying values for correlations outside -1 to 1.  It might be
c             advisable to initially ignore the inter-equation error 
c             correlations and use this optimizer to get you decent starting 
c             values for the other parameters and then use gradient methods 
c             (Steepest Descent or Fletcher-Powell) in a subsequent run.
c
c   When using this optimizer, the program is currently setup to deal with
c   problems in which the total number of parameters being estimated,
c   both restricted and unrestricted, is less than or equal to 700, and the
c   number of unrestricted parameters is less than or equal to 600.  If your
c   problem exceeds this amount, you will have to make the following 
c   modifications to the HotzTran code.
c   (1)  In the dimension statement below, set the dimension of iplace( )
c        to a value exceeding the number of total (restricted and un-
c        restricted) parameters used in the problem.
c   (2)  In the double precision statements below change the 200 and 201's
c        to values, k and k+1, where k exceeds the number of unrestricted
c        parameters in the particular problem.  Also set the variable
c        INSIM = k in the code of the subroutines AMOEBA and SHRNK.
c
c   Finally, note that when using the user supplied subroutine, 
c   KIMBAL to calculate the function/gradients, one can cut down on
c   computation time but not calculating the full gradients during
c   calls to a customized KIMBAL.  To accomplish this, one simply
c   includes the following common block in KIMBAL,
c
c    common /simp1/ last,istsim,ipb,jcc,NUMER
c
c   Then, structure the KIMBAL subroutine so that:
c   (a) if(last.eq.0), bypass the calculation of your programmed 
c       gradients AND at the end of the routine, calculate the 
c       gradients as follows:
c
c         do 200 i = 1,NGRAD (NGRAD = number of parameters)
c         g(i) = - vd
c    200    continue
c
c   (b) if(last.eq.1), go ahead and calculate the programmed gradients.
c       This last step will enable you to get standard errors when
c       the simplex method has been completed.
c   Note that the DEFAULT in the program is last=1 so, in general,
c   Hotztran will go ahead and compute the gradients for a problem even
c   though the Simplex Optimizer will not use them.  The above reprogramming
c   option will enable one to turn on and off the feature of not doing
c   these extra calculations when using the KIMBAL subroutine.
c
c   This subroutine calls the following subroutines:
c   SHRNK   USHRNK   PUNCHA   CPRINT   FCTGR   
c
c   This subroutine is called by the following subroutines:
c   VINCEN   
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine AMOEBA(n,x,y,g,h,d,f0,ii,xdata,joe,r,iii,rn,iin,vb,
     1sc,isc,ind)
      
c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),y(1),g(1),h(1),d(1),trial,fact,aa,bb,f0,
     &prZ,trial1,egr,epa,egf,epsg,epsp,epsf,vb(1),r(1),rn(1),sc(1),
     &XSIMP(600),XTEMP(600),PR(600),PRR(600),PBAR(600),PSIMP(601,600),
     &YSIMP(601),YPR,YPRR,RTOL,FTOL,GAMMA,ALPHA,BETA,STPSIM,XJ,del,
     &PARAM(600)
      dimension xdata(1),joe(1),iii(1),iin(1),iplace(700),ix(600)
c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,tim1,tim2,dumt
      common /b/ ip,a1(7),kcore,idim,ipk,t(20),m8,m9,m10,a8(6),lwi,
     *dum(3)
      common /c/ me,nt,igm,istan,istar,irho,irhp,lt,iscal,ivcb,jc,a4(3),
     1nl,ir,ln,igs,ifs,lm,iwo,ira,ires,jres,irip,dumc(15)
      common /d/ a5(4),lv,lw,lr,le,igmm,lz,lp,my,ny,l1,lee,lg,lh,a6(4),
     2lpp,dumd(2)
      common /f/ trial,egr,epa,egf,trial1,fact,aa,bb,maxtry,iter,prZ,
     1epsg,epsp,epsf,maxite,iv1,iv2,na1,na2,dumf(5)
      common /simp1/ last,istsim,ipb,jcc,NUMER
      common /simp2/ stpsim
      common /simp3/ iplace
c-------------------BEGINNING OF SUBROUTINE------------------------------
c
c   Note that this subroutine is written so that NSIMP.le.INSIM.
      INSIM = 600     
c   If the number of unrestricted parameters in a particular run exceeds
c   INSIM, the program will stop and advise the user to clean this up.
c
c   The following is an index to turn on writing to standard out
c   It is used for purposes of debugging.  If IWRITE = 0, nothing
c   is written.
c
      iwrite=0
      jcc = jc
      last = 0
c
c   Print the Iteration Heading.
c
        if(ii.eq.0.and.NUMER.ne.1) call CPRINT(23)
c
c   Initialize parameters used in simplex method.
c
c
      ftol = epsg
      del = stpsim
      alpha = 1.d0
      beta = .5d0
      gamma = 2.00
c
c   Note that this subroutine is written so that NSIMP.le.INSIM.
      INSIM = 600     
      NSIMP = INSIM
c   If the number of unrestricted parameters in a particular run exceeds
c   INSIM, the program will stop and advise the user to clean this up.
c
c   Shrink full coefficient vector (x) to vector of unrestricted
c   parameters (XSIMP).
c
        last = 1
        call FCTGR(x,f0,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)
        call SHRNK(x,n,g,XSIMP,NSIMP,0)
      if(NSIMP.gt.INSIM) then
         write(ip,950)
         write(ip,1032)
1032     format(/,14x,'1. Number of Unrestricted Parameters Exceeds',
     $          'Current',/,17x,'HotzTran Capacity.  See Comments in',
     $          /,17x,'Subroutine AMOEBA.F for Modifying Capacity.',/)
         ind=1
         return
      endif
c
c   If Function can't be evaluated at Starting Values Return.
c
        if(ind.gt.0) then
           write(ip,950)
           write(ip,2188)
2188       format(/,14x,'1. Could Not Evaluate Function at Starting',
     $            'Values.'/,17x,'Adjust and Try Again.')
           return
        endif  
c  
        mpts = NSIMP+1
c
c    Calculate Gradients Numerically and Print them out along side
c    the analytically calculated gradients in g( ).
c
	if(NUMER.EQ.1) then
	   write(ip,7767)
7767	format(//,'1',19x,'***** CHECK OF GRADIENT CALCULATIONS '
     &       '*****',//,5x,'Gradient',6x,'Parameter Value ',5x,
     &       'Numerical Value ',5x,'Programmed Value'/,5x,72('-'))
           if(ind.gt.0)write(ip,77311)
77311      format(7x,'**** CAUTION:  Following Programmed Values ',
     &                     'May Be Inacurrate ****')
	   igg=0
	   do 3152 kv=1,n
                y(kv) = x(kv)
                if(iplace(kv).eq.0) go to 3152
                igg=igg+1
                if(isc.eq.0) then
                   PARAM(igg) = x(kv)*sc(kv)
                else
                   PARAM(igg) = x(kv)
                endif
	        pbar(igg)=g(kv)
                ix(igg)= kv
 3152      continue      
           last = 0
           do 2321 jgt=1,NSIMP
        	do 4105 kz=1,NSIMP
	        XTEMP(kz) = XSIMP(kz)
4105    	continue
	        XJ = XSIMP(jgt)           
                   xtemp(jgt) = xj * (1.d0 + stpsim)
		ind=0
 	        call USHRNK(y,n,h,XTEMP,NSIMP)
        	call FCTGR(y,YSIMP(jgt),h,xdata,joe,r,iii,rn,
     $               iin,vb,sc,isc,ind)
                   YSIMP(jgt) = (YSIMP(jgt)-F0)/(xj * stpsim)
		write(ip,7762) ix(jgt),PARAM(jgt),YSIMP(jgt),PBAR(jgt)
 7762		format(5x,'grad(',i3,')',4x,d16.9,2(5x,d16.9))
                if(ind.gt.0)write(ip,77310)
77310           format(7x,'**** CAUTION:  Previous Numerical Value ',
     &                     'May Be Inacurrate ****')
 2321           CONTINUE
	        iter=1
                IND=0
                last=1
	        return
 	endif		 

        ind = 0
        last = 0
c
c   Based on starting values and f0, fill in last row of PSIMP( , )
c   and last element in YSIMP( ).
c
        YSIMP(mpts) = f0
        do 2105 kz=1,NSIMP
        PSIMP(mpts,kz) = XSIMP(kz)
        XTEMP(kz) = XSIMP(kz)
2105    continue
c
c   Initialize the first NSIMP rows of PSIMP( , ) matrix and the 
c   first NSIMP elements in YSIMP( ).
c
        ktry = 0
        kmax = 0
        do 2004 j=1,NSIMP
        ktry = 0
 2103     continue
          if(ktry.gt.10) then
             ind=1
             write(ip,950)
 950         format(//22x,'Summary of Simplex Method Convergence')
             write(ip,2311) j
2311         format(/,14x,'1. Initial Simplex Could Not be Built',
     $              ' with 10 Reductions',/,17X,'/Increments of',
     $              ' Initial Step Size on the ',I3,'th Vertex'/)
             if(jc.eq.9) write(ip,970)
 970         format(14x,'2. Program will Continue Using ',
     &           'Fletcher-Powell Minimizer'/)
             last = 1
             return
          endif
          XJ = XSIMP(j)
          XTEMP(j) = XJ + del
          ind = 0
          call USHRNK(x,n,g,XTEMP,NSIMP)
          call FCTGR(x,YSIMP(j),g,xdata,joe,r,iii,rn,iin,vb,sc,
     $               isc,ind)
          if(ind.gt.0) then 
             del = del/2.d0
             ktry = ktry + 1
             go to 2103
           endif
           do 2005 kz=1,NSIMP
             PSIMP(j,kz) = XTEMP(kz)
             XTEMP(kz) = XSIMP(kz)
2005       continue
        del = stpsim     
        kmax = max0(ktry,kmax)
2004    continue
c
c  Determine which row of PSIMP has the highest (worst) function value
c  (YSIMP( )), which row has the next highest, and which row has 
c  the lowest (best)  function value.
c
      iter=0
1     ilo = 1
      if(YSIMP(1).gt.YSIMP(2)) then
	  ihi=1
          inhi=2
      else
         ihi=2
	  inhi=1
      endif
c
c  Loop over the points in the simplex.
c
      do 11 i=1,mpts
	if(YSIMP(i).lt.YSIMP(ilo)) ilo=i
	if(YSIMP(i).gt.YSIMP(ihi)) then
		inhi=ihi
		ihi=i
	else if(YSIMP(i).gt.YSIMP(inhi)) then
		if(i.ne.ihi) inhi=i
	endif
11	continue
c
c   Compute the fractional range from the highest to the lowest and 
c   return if satisfactory.
c
	rtol = 2.d0 * dabs(YSIMP(ihi) - YSIMP(ilo))/
     $    (dabs(YSIMP(ihi)) + dabs(YSIMP(ilo)))
c
c    Print out iteration information.
c
        if(ITER.ge.0.and.ii.eq.0) WRITE(IP,3231) ITER,YSIMP(ILO),RTOL
3231    FORMAT(12x,i4,5x,g14.7,8x,g14.7)
c
c    If ssimp=2 (istsim.eq.2) Write out full coefficient vector (x) to 
c    PUNCH file using subroutine PUNCHA.
c
        if(istsim.eq.2) then
            do 283 iv=1,NSIMP
            XSIMP(iv) = PSIMP(ilo,iv)
 283        continue
            call USHRNK(x,n,g,XSIMP,NSIMP)
            call FCTGR(x,YSIMP(ilo),g,xdata,joe,r,iii,rn,iin,vb,sc,
     $                  isc,ind)
            call PUNCHA(x,n,sc,isc,h)
        endif
c
        call CKTIME(ind,1)
c
c   Check to see if Limit on CPU Time exceeded.
c
	if(ind.gt.0) then
c
c    If Time Limit exceeded, write error message, calculate function 
c    at best vertex found so far, and if ssimp=1 (istsim.eq.1) 
c    write out full coefficient vector (x) to PUNCH file.  Then return. 
c
             write(ip,950)
             write(ip,960) KMAX
             write(ip,3233)ITER
             write(ip,9231) tim1
9231         format(14x,'3. CPU Time Expired.  Simplex Iterations ',
     $         'Used ',/17x,f10.3,' CPU Seconds'/)
           do 7832 k=1,NSIMP
              XSIMP(k) = PSIMP(ilo,k)
7832       continue
           last = 1
           ind = 0
           call USHRNK(x,n,g,XSIMP,NSIMP)
           call FCTGR(x,f0,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)
           if(istsim.eq.1) call PUNCHA(x,n,sc,isc,h)
           ind=5
           return
        endif
c
        ind = 0
c
c   Check to see of Iterations exceeded.
c
	if(iter.ge.maxite) then
           ind = 4
c
c    If Iterations exceeded, write error message, calculate function 
c    at best vertex found so far, and if ssimp=1 (istsim.eq.1) 
c    write out full coefficient vector (x) to PUNCH file.  Then return. 
c
             write(ip,950)
             write(ip,960) KMAX
960      format(/,14x,'1. Required as Many as ',I3,' Reductions of',
     $          ' Initial Step',/,17x,'Size to Construct',
     $               ' A Vertex of Initial Simplex'/)
           write(ip,3233)ITER
3233       format(14x,'2. Function Did Not Converge After ',I4,
     $               ' Iterations'/)
             write(ip,9531) tim1
9531         format(14x,'3. Simplex Iterations Used ',
     $         f10.3,' CPU Seconds.'/)
             if(jc.eq.9) write(ip,971)
 971         format(14x,'4. Program will Continue Using ',
     &           'Fletcher-Powell Minimizer'/)
           do 7332 k=1,NSIMP
              XSIMP(k) = PSIMP(ilo,k)
7332       continue
           last = 1
           ind = 0
           call USHRNK(x,n,g,XSIMP,NSIMP)
           call FCTGR(x,f0,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)           
           if(istsim.eq.1) call PUNCHA(x,n,sc,isc,h)
           return
        endif
c
c   Check of convergence criteria.
c
	if(rtol.lt.ftol) then
c
c    If Converged, calculate function at best vertex, if ssimp=1 (istsim.eq.1)
c    write out full coefficient vector (x) to PUNCH file, and return
c
           write(ip,950)
           write(ip,960) KMAX
           if(jc.eq.8) then
              write(ip,3243) iter
3243          format(14x,'2. Function Convergence After ',I4,
     $               ' Iterations.  Optimum',/17x,'Achieved!!'/)
              write(ip,9531) tim1
           endif
           if(jc.eq.9) then
              write(ip,3244) iter
3244          format(14x,'2. Function Convergence After ',I4,
     $               ' Iterations Based',/,17x,'on Tolerance.'/)
              write(ip,9531) tim1
              write(ip,971)
           endif
           do 783 iv=1,NSIMP
           XSIMP(iv) = PSIMP(ilo,iv)
 783       continue
           last = 1
           ind = 0
           call USHRNK(x,n,g,XSIMP,NSIMP)
           call FCTGR(x,f0,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)           
           if(istsim.eq.1) call PUNCHA(x,n,sc,isc,h)
           return
        endif
c
c   Begin a new iteration.  Compute the vector average of all points 
c   except the highest, i.e., the center of the "face" of the simplex
c   across from the highest point.  Subsequently, we will explore along
c   the ray from the high point through that center.
c
        iter = iter+1

	do 12 j = 1,NSIMP
		PBAR(j) = 0.d0
12	continue
	do 14 i = 1,mpts
		if(i.ne.ihi) then
			do 13 j = 1,NSIMP
				PBAR(j) = PBAR(j) + PSIMP(i,j)
13			continue
		endif
14	continue
c
c   Extrapolate by a factor alpha through the face, i.e., reflect the 
c   simplex from the highest point.
c
	do 15 j = 1,NSIMP
		PBAR(j) = PBAR(j)/NSIMP
                PR(j) = (1.d0 + alpha) * PBAR(j) - alpha * PSIMP(ihi,j)
15	continue
c
c   Evaluate the function at the reflected point. 
c
        ind = 0
        call USHRNK(x,n,g,PR,NSIMP)
        call FCTGR(x,YPR,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)           
c 
c   If this reflection gives a resulting function value better than
c   the best point, i.e., a lower function value, try an additional 
c   extrapolation by a factor gamma.
c
	if(YPR.le.YSIMP(ilo).and.ind.le.0) then
                do 16 j = 1,NSIMP
                   PRR(j) = gamma*PR(j) + (1.d0 - gamma)*PBAR(j)
 16             continue
c
c   Check out the function at this extrapolated point.
c
      ind = 0
      call USHRNK(x,n,g,PRR,NSIMP)
      call FCTGR(x,YPRR,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)           
c
c   If the additional extrapolation succeeded, use it to replace the 
c   current highest (worst) row in PSIMP.
c
      if(YPRR.lt.YSIMP(ilo).and.ind.le.0) then
                do 17 j = 1,NSIMP
                   PSIMP(ihi,j)= PRR(j)
 17             continue
                YSIMP(ihi) = YPRR
      else
c
c   If the additional extrapolation failed, we can still use the reflected
c   point.
c
               do 18 j = 1,NSIMP
                   PSIMP(ihi,j) = PR(j)
 18             continue
                YSIMP(ihi) = YPR
      endif
c
c   Check to see if the reflected point is worse than the second-highest.
c
      else if(YPR.ge.YSIMP(inhi).or.ind.gt.0) then
c
c   If it is better than the highest, then replace the highest.
c
          if(YPR.lt.YSIMP(ihi)) then
                do 19 j = 1,NSIMP
                   PSIMP(ihi,j) = PR(j)
 19             continue
            YSIMP(ihi) = YPR
          endif
c 
c  Look for an intermediate lower point.
c
          do 21 j = 1,NSIMP
             PRR(j) = beta * PSIMP(ihi,j) + (1.d0 - beta) * PBAR(j)
 21       continue
c
c   Perform a contraction of the simplex along one dimension and
c   evaluate the function.
c
      ind = 0
      call USHRNK(x,n,g,PRR,NSIMP)
      call FCTGR(x,YPRR,g,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)           
c
c   Check to see if the contraction gives a function improvement.
c
          if(YPRR.lt.YSIMP(ihi).and.ind.le.0) then
c
c   If so, accept it.
c
             do 22 j = 1,NSIMP
                PSIMP(ihi,j) = PRR(j)
 22          continue
             YSIMP(ihi) = YPRR
          else
c
c   If can't seem to get rid of that high point, then contract around
c   the lowest (best) point.
c
             do 24 i = 1,mpts
                if(i.ne.ilo) then
                   do 23 j = 1,NSIMP
                      PR(j) = 0.5d0 * (PSIMP(i,j) + PSIMP(ilo,j))
                      PSIMP(i,j) = PR(j)
 23                continue
              ind = 0
              call USHRNK(x,n,g,PR,NSIMP)
              call FCTGR(x,YSIMP(i),g,xdata,joe,r,iii,rn,iin,
     $                   vb,sc,isc,ind)
          endif
 24       continue
      endif
      else
c
c   If here, we have the case that the original reflection gives a 
c   middling point.  Replace the old high point and continue.
c
         do 25 j = 1,NSIMP
            PSIMP(ihi,j) = PR(j)
 25      continue
         YSIMP(ihi) = YPR
      endif
c
c  Continue on to test of doneness or the next iteration.
c
      go to 1
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SHRNK        (SUBROUTINE IN MAIN PART OF HOTZTRAN)
c   This subroutine shrinks the full parameter vector, X, to a vector, 
c   XSIMP, which contains only those parameters which are unrestricted.
c   n is the dimension of X and NSIMP is the dimension of XSIMP.
c
c   This subroutine calls the following subroutines:
c
c   This subroutine is called by the following subroutines:
c   AMOEBA  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SHRNK(x,n,g,XSIMP,NSIMP,iind)
      
c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),XSIMP(1),g(1)
      dimension iplace(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /simp1/ last,istsim,ipb,jcc,NUMER
      common /simp3/ iplace
c-------------------BEGINNING OF SUBROUTINE------------------------------
      INSIM = 500
      if(iind.eq.0) then
         NSIMP = 0
         do 1 i = 1,n
            iplace(i) = 0
            if(g(i).eq.0.d0) go to 1
            NSIMP = NSIMP + 1
      if(NSIMP.gt.INSIM) return
            XSIMP(NSIMP) = x(i)
            iplace(i) = 1.0
 1       continue
      else
         NSIMP = 0
         do 2 i = 1,n
            if(iplace(i).eq.0) go to 2
            NSIMP = NSIMP + 1
            XSIMP(NSIMP) = x(i)
 2       continue  
      endif
      return
      end
C-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   USHRNK        (SUBROUTINE IN MAIN PART OF HOTZTRAN)
c   This subroutine unshrinks the parameter vector, XSIMP, to the 
c   full parameter vector, X.  n is the dimension of X and NSIMP is 
c   the dimension of XSIMP.
c
c   This subroutine calls the following subroutines:
c
c   This subroutine is called by the following subroutines:
c   AMOEBA 
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine USHRNK(x,n,g,XSIMP,NSIMP)
      
c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),XSIMP(1)
      dimension iplace(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /simp1/ last,istsim,ipb,jcc,NUMER
      common /simp3/ iplace
c-------------------BEGINNING OF SUBROUTINE------------------------------
      NSIMP = 0
      do 1 i = 1,n
      if(iplace(i).eq.1) then
      NSIMP = NSIMP + 1
      x(i) = XSIMP(NSIMP)
      endif
 1    continue
      return
      end
C-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   APRINT          (SUBROUTINE OF MAIN PART OF HOTZTRAN)         
c   Prints moment or correlation matrix.
c
c   This subroutine calls the following subroutines:
c   CPRINT
c
c   This subroutine is called by the following subroutines:
c   READOM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine APRINT(xx,vnam,nvar,x,c,d,nobs,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension xx(1),vnam(9,nvar),c(1),d(1),x(1)
      double precision xx,c,d
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(30),m8,a2(8),lwi,dum(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      call CPRINT(3)
      if(id.eq.0.and.lwi.eq.0) write(ip,5)
    5 format(56x,'Sample Moment Matrix',/)
      if(id.eq.0.and.lwi.eq.1) write(ip,10)
   10 format(30x,'Sample Moment Matrix',/)
      if(id.eq.1.and.lwi.eq.0) write(ip,15)
   15 format(54x,'Sample Correlation Matrix',/)
      if(id.eq.1.and.lwi.eq.1) write(ip,20)
   20 format(28x,'Sample Correlation Matrix',/)
      i1=0
      i2=0
   25 i1=i2+1
      if(i1.gt.1.and.id.eq.0) call CPRINT(13)
      if(i1.gt.1.and.id.eq.1) call CPRINT(14)
      i2=i1+6
      if(lwi.eq.1) i2=i1+4
      if(i2.gt.nvar) i2=nvar
      i5=0
      do 60 i3=i1,nvar
      i5=i5+1
      if(lwi.eq.1.and.i5.gt.5) i5=5
      if(i5.gt.7) i5=7
      i4=(i3*(i3-1))/2+i1-1
      if(m8.eq.58.and.id.eq.0.and.lwi.eq.0) call CPRINT(13)
      if(m8.eq.58.and.id.eq.1.and.lwi.eq.0) call CPRINT(14)
      m8=m8+1
      if(lwi.eq.0.and.m8.eq.7) write(ip,30) ((vnam(j,i),j=1,8),i,i=i1,i2
     1)
   30 format(14x,7(2x,8a1,'(',i3,')',1x),/)
      if(lwi.eq.1.and.m8.eq.7) write(ip,35) ((vnam(j,i),j=1,8),i,i=i1,i2
     1)
   35 format(15x,5(1x,8a1,'(',i2,')'))
      if(id.eq.0) go to 55
      do 40 i=1,i5
      x(i)=0.
      if(d(i3).gt.0..and.d(i1+i-1).gt.0.) x(i)=((xx(i4+i)-c(i3)*c(i1+i-1
     1)*float(nobs))/float(nobs-1))/(d(i3)*d(i1+i-1))
      if(i3.eq.i1+i-1) x(i)=1.
   40 continue
      if(lwi.eq.0) write(ip,45) (vnam(j,i3),j=1,8),i3,(x(i),i=1,i5)
   45 format(1x,8a1,'(',i3,')',g15.7,6g16.7)
      if(lwi.eq.1) write(ip,50) (vnam(j,i3),j=1,8),i3,(x(i),i=1,i5)
   50 format(1x,8a1,'(',i3,')',1x,5g13.5)
      go to 60
   55 if(lwi.eq.0) write(ip,45) (vnam(j,i3),j=1,8),i3,(xx(i4+i),i=1,i5)
      if(lwi.eq.1) write(ip,50) (vnam(j,i3),j=1,8),i3,(xx(i4+i),i=1,i5)
   60 continue
      if(i2.lt.nvar) go to 25
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   ARLING        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates cross-products of first derivatives.
c
c   This subroutine is called by the following subroutines:
c   FCHOTZ  FCJOEY  FCLARS  FCMOFF  FCPELD  START  COMPUT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine ARLING(s,g,le,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision s(1),g(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l=0
      do 5 i=1,le
      if(id.eq.3) g(i)=g(i)*2.d0
      do 5 j=1,i
      l=l+1
    5 s(l)=s(l)+g(i)*g(j)
      if(id.eq.1) return
      do 10 i=1,le
   10 g(i)=0.d0
      if(id.eq.2) g(le)=1.d0
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   BELTON        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Accumulates moments over time periods.
c
c   This subroutine is called by the following subroutines:
c   BROWN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine BELTON(gg,xdata,loe,i,l,i5,jj,zx,yx,id1,id4)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision gg,zx,yx,wt,vrs,b1,b2,b3
      dimension xdata(jb,kobs),loe(k,nt)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(32),kvrs,jwt,dum(4)
      common /c2/ vrs
      common /d/ k,n,jb,kobs,lv,dumd(19)
      if(id1.gt.1) go to 10
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i=0
      do 5 j=1,nt
      if(xdata(lv+i5+j,jj).lt.2.) i=1
    5 continue
      return
   10 wt=1.d0
      b1=0.d0
      b2=0.d0
      b3=0.d0
      do 80 j=1,nt
      if(jwt.eq.0) go to 15
      i2=loe(jwt,j)
      wt=dble(xdata(i2,jj))/vrs
   15 i1=loe(i,j)
      if(((id1.eq.5.or.id1.eq.7).and.j.ne.1.and.j.ne.nt).or.(id1.ge.8.an
     1d.j.eq.1)) go to 80
      go to (20,20,22,35,20,40,25,60,65),id1
   20 i2=loe(l,j)
      go to 30
   22 if(id4.eq.1) zx=zx+wt
   25 i2=lv+nt+i5+j
      if(id4.eq.1) yx=yx+wt*dble(xdata(i2,jj))**2
   30 gg=gg+dble(xdata(i1,jj))*dble(xdata(i2,jj))*wt
      go to 80
   35 i2=loe(l,j)
      go to 42
   40 i2=lv+nt+i5+j
      if(id4.eq.1) yx=yx+wt*dble(xdata(i2,jj))
   42 b1=b1+dble(xdata(i1,jj))
      b2=b2+dble(xdata(i2,jj))
      b3=b3+wt
      go to 80
   60 i2=loe(l,j)
      i3=loe(l,j-1)
      go to 70
   65 i2=lv+nt+i5+j
      i3=i2-1
      if(id4.eq.1) yx=yx+wt*dble(xdata(i2,jj))*dble(xdata(i3,jj))
   70 i4=loe(i,j-1)
      gg=gg+wt*(dble(xdata(i1,jj))*dble(xdata(i3,jj))+dble(xdata(i4,jj))
     1*dble(xdata(i2,jj)))
   80 continue
      if(id1.ne.4.and.id1.ne.6) return
      gg=gg+b1*b2/b3
      if(id4.eq.1) yx=yx*yx/b3
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   BOSTON        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Puts first derivatives of equations in vector.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   KIMBAL
c
c   This subroutine is called by the following subroutines:
c   FCHOTZ  FCJOEY  FCLARS  FCMOFF  FCPELD  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine BOSTON(g1,g2,g3,joe1,moe,loe,z,g,k,joe2,joe3,joe4,x,
     1 i6,jtype,sc,iscal,nl)
c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision g1,g2,g3,g(1),gx,x(1),sc(1)
      dimension z(1),loe(1),moe(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /k/ jeff, JOFunc, izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i9=joe1
      gx=1.d0
      if(jtype.eq.1) gx=0.d0
      if(i6.le.jeff) call KIMBAL(g1,g,x,z,i9,loe,moe,gx,i6,k,sc,
     1iscal,1)
c$$$$$$$$$$$$$$$$$$$$$$$
      if(nl.gt.0.or.i6.le.jeff.or.JOFunc.gt.0) go to 8
c$$$$$$$$$$$$$$$$$$$$$$$
      i9=joe1
c   Put derivatives with respect to variable coefficients in vector
      do 5 i=1,k
      if(moe(i).gt.7) go to 5
      i9=i9+1
      l=loe(i)
      g(i9)=g(i9)*gx-g1*dble(z(l))
    5 continue
c   Put derivatives with respect to sigma in vector
    8 if(joe2.ge.1) g(joe3)=g(joe3)-g2
c   Put derivatives with respect to rho in vector
      if(joe4.gt.0) g(joe4)=g(joe4)-g3
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   BROWN        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Accumulates moments for equations where moments are sufficient.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   WITKOW  BELTON
c
c   This subroutine is called by the following subroutines:
c   BROWN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine BROWN(gg,x1,xdata,joe,moe,loe,koe,job,joa,jom,igmm)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision gg(1),yx,zx,x1(1)
      dimension xdata(jb,kobs),joe(1),moe(k,me),loe(k,nt),koe(3,me),
     1job(1),joa(1),jom(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a2(14),ln,a7(4),ira,dum(18)
      common /d/ k,n,jb,kobs,a3(3),le,igm,lz,a1(5),lg,lh,mobs,
     *iqz,inz,dumd(4)
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(igmm.eq.2.and.ira.eq.2) return
      lh=1
      ii=0
      do 5 i6=1,me
      if(job(i6).ge.0.or.joe(i6).lt.8.or.(igmm.eq.4.and.koe(1,i6).ne.mob
     1s).or.i6.le.jeff.or.JOFunc.gt.0) lh=0
      if(job(i6).lt.0.and.i6.gt.jeff) ii=ii+1
    5 continue
      if(ii.eq.0.or.(ii.eq.1.and.igmm.eq.4)) return
      jj=1
      do 200 ii=1,n
      if(iqz.eq.0) jj=ii
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      lg=0
      i5=0
      do 150 i6=1,me
      if(job(i6).ge.0.or.i6.le.jeff) go to 145
      zx=0.d0
      yx=0.d0
      go to (10,30,70,100),igmm
   10 do 20 i=1,k
      if(moe(i,i6).gt.7) go to 20
      do 15 l=1,i
      if(moe(l,i6).gt.7) go to 15
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,i5,i5,jj,zx,yx,0,1,0)
   15 continue
   20 continue
      j=0
      do 25 i=1,k
      if(moe(i,i6).gt.7) go to 25
      lg=lg+1
      j=j+1
      call WITKOW(gg(lg),xdata,loe,i,i,i5,i5,jj,zx,yx,j,2,0)
   25 continue
      go to 92
   30 call BELTON(gg,xdata,loe,i,l,i5,jj,zx,yx,1,0)
      if(i.eq.0) go to 32
      lh=0
      lg=lg+((jom(i6)-joa(i6)-2)*(jom(i6)-joa(i6)+1)/2+1)*(ira+2)+1
      go to 145
   32 do 40 i=1,k
      if(moe(i,i6).gt.7) go to 40
      do 35 l=1,i
      if(moe(l,i6).gt.7) go to 35
      lg=lg+1
      call BELTON(gg(lg),xdata,loe,i,l,i5,jj,zx,yx,2,0)
   35 continue
   40 continue
      j=0
      do 45 i=1,k
      if(moe(i,i6).gt.7) go to 45
      lg=lg+1
      j=j+1
      call BELTON(gg(lg),xdata,loe,i,l,i5,jj,zx,yx,3,j)
   45 continue
      lg=lg+2
      gg(lg-1)=gg(lg-1)+yx
      gg(lg)=gg(lg)+zx
      j6=ira+4
      do 50 i=1,k
      if(moe(i,i6).gt.7) go to 50
      do 47 l=1,i
      if(moe(l,i6).gt.7) go to 47
      lg=lg+1
      call BELTON(gg(lg),xdata,loe,i,l,i5,jj,zx,yx,j6,0)
   47 continue
   50 continue
      yx=0.d0
      j=0
      j6=j6+2
      do 55 i=1,k
      if(moe(i,i6).gt.7) go to 55
      lg=lg+1
      j=j+1
      call BELTON(gg(lg),xdata,loe,i,l,i5,jj,zx,yx,j6,j)
   55 continue
      lg=lg+1
      gg(lg)=gg(lg)+yx
      if(ira.eq.0) go to 145
      do 62 i=1,k
      if(moe(i,i6).gt.7) go to 62
      do 60 l=1,i
      if(moe(l,i6).gt.7) go to 60
      lg=lg+1
      call BELTON(gg(lg),xdata,loe,i,l,i5,jj,zx,yx,8,0)
   60 continue
   62 continue
      yx=0.d0
      j=0
      do 64 i=1,k
      if(moe(i,i6).gt.7) go to 64
      lg=lg+1
      j=j+1
      call BELTON(gg(lg),xdata,loe,i,l,i5,jj,zx,yx,9,j)
   64 continue
      lg=lg+1
      gg(lg)=gg(lg)+yx
      go to 145
   70 do 78 i=1,k
      if(moe(i,i6).gt.7) go to 78
      do 76 l=1,k
      if(moe(l,i6).ge.15) go to 76
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,i5,i5,jj,zx,yx,0,1,0)
      if(moe(l,i6).eq.0.or.moe(l,i6).eq.4.or.moe(l,i6).eq.8) go to 76
      do 74 j=2,ln
      if(moe(l,i6).eq.3.or.moe(l,i6).eq.7.or.moe(l,i6).eq.11.or.moe(l,i6
     1).eq.14) go to 72
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,i5,i5,jj,zx,yx,0,3,j)
   72 if(moe(l,i6).eq.2.or.moe(l,i6).eq.6.or.moe(l,i6).eq.10.or.moe(l,i6
     1).eq.13) go to 74
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,i5,i5,jj,zx,yx,0,5,j)
   74 continue
   76 continue
   78 continue
      i=0
      do 90 l=1,k
      if(moe(l,i6).ge.15) go to 90
      lg=lg+1
      i=i+1
      call WITKOW(gg(lg),xdata,loe,l,l,i5,i5,jj,zx,yx,i,2,0)
      if(moe(l,i6).eq.0.or.moe(l,i6).eq.4.or.moe(l,i6).eq.8) go to 90
      do 85 j=2,ln
      if(moe(l,i6).eq.3.or.moe(l,i6).eq.7.or.moe(l,i6).eq.11.or.moe(l,i6
     1).eq.14) go to 80
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,l,l,i5,i5,jj,zx,yx,0,4,j)
   80 if(moe(l,i6).eq.2.or.moe(l,i6).eq.6.or.moe(l,i6).eq.10.or.moe(l,i6
     1).eq.13) go to 85
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,l,l,i5,i5,jj,zx,yx,0,6,j)
   85 continue
   90 continue
   92 lg=lg+2
      gg(lg-1)=gg(lg-1)+yx
      gg(lg)=gg(lg)+zx
      go to 145
  100 x1(i6)=0.d0
      if(i6.eq.1) go to 145
      j5=0
      do 142 j6=1,i6
      if(job(j6).ge.0.or.j6.eq.i6) go to 140
      do 110 i=1,k
      if(moe(i,i6).gt.7) go to 110
      do 105 l=1,k
      if(moe(l,j6).gt.7) go to 105
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,i5,j5,jj,zx,yx,0,1,0)
  105 continue
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,i,j5,i5,jj,zx,yx,0,2,0)
  110 continue
      do 113 l=1,k
      if(moe(l,j6).gt.7) go to 113
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,l,l,i5,j5,jj,zx,yx,0,2,0)
  113 continue
      call WITKOW(gg(lg+1),xdata,loe,i,l,i5,j5,jj,gg(lg+2),yx,0,7,0)
      lg=lg+3
      if(mobs.ne.koe(1,i6).or.mobs.ne.koe(1,j6).or.joe(i6).lt.8.or.joe(j
     16).lt.8) go to 115
      if(x1(j6).ne.0.) go to 125
      x1(j6)=lg
  115 gg(lg)=lg
      do 121 i=1,k
      if(moe(i,j6).gt.7) go to 121
      do 117 l=1,i
      if(moe(l,j6).gt.7) go to 117
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,j5,i5,jj,zx,yx,0,1,0)
  117 continue
  121 continue
      zx=0.d0
      yx=0.d0
      j=0
      do 123 i=1,k
      if(moe(i,j6).gt.7) go to 123
      lg=lg+1
      j=j+1
      call WITKOW(gg(lg),xdata,loe,i,i,j5,i5,jj,zx,yx,j,2,0)
  123 continue
      lg=lg+2
      gg(lg-1)=gg(lg-1)+yx
      gg(lg)=gg(lg)+zx
      go to 128
  125 gg(lg)=x1(j6)
  128 lg=lg+1
      if(mobs.ne.koe(1,i6).or.mobs.ne.koe(1,j6).or.joe(i6).lt.8.or.joe(j
     16).lt.8) go to 129
      if(x1(i6).ne.0.) go to 135
      x1(i6)=lg
  129 gg(lg)=lg
      do 131 i=1,k
      if(moe(i,i6).gt.7) go to 131
      do 130 l=1,i
      if(moe(l,i6).gt.7) go to 130
      lg=lg+1
      call WITKOW(gg(lg),xdata,loe,i,l,i5,j5,jj,zx,yx,0,1,0)
  130 continue
  131 continue
      zx=0.d0
      yx=0.d0
      j=0
      do 133 i=1,k
      if(moe(i,i6).gt.7) go to 133
      lg=lg+1
      j=j+1
      call WITKOW(gg(lg),xdata,loe,i,i,i5,j5,jj,zx,yx,j,2,0)
  133 continue
      lg=lg+2
      gg(lg-1)=gg(lg-1)+yx
      gg(lg)=gg(lg)+zx
      go to 140
  135 gg(lg)=x1(i6)
  140 if(joe(j6).ge.2) j5=j5+nt
  142 j5=j5+nt
  145 if(joe(i6).ge.2) i5=i5+nt
  150 i5=i5+nt
  200 continue
      if(iqz.gt.0) rewind inz
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CALC      (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Evaluates part of non-linear expressions.
c
c   This subroutine is called by the following subroutines:
c   PAREN  XBETA  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CALC(i1,i2,r,loe,z,x,v1,v2,c,g,s,i4,k4,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),v,r,v1,v2,c,g(1),POW,s(1)
      dimension loe(1),z(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Branch for derivatives
      if(id.gt.1) go to 50
      if(i1) 2,40,10
c   Branch if z is logged
    2 if(i1.lt.-1000) go to 5
      i3=loe(-i1)
      v=dble(z(i3))
      go to 20
    5 i3=loe(-i1-1000)
      v=dlog(dble(abs(z(i3))))
      go to 20
c   Branch if first beta is logged
   10 if(i1.gt.1000) go to 15
      v=x(i1)
      go to 20
c   Branch if first variable is a constant
   15 if(i1.gt.2000) go to 17
      v=dlog(dabs(x(i1-1000)))
      go to 20
   17 if(i2.gt.0) go to 18
      i3=loe(-i2)
      v1=v1*dabs(r)**(dble(2002-i1)*dble(z(i3)))
      return
   18 v1=v1*dabs(r)**(dble(2002-i1)*x(i2))
      return
c   Branch on second variable (exponent)
   20 if(i2) 25,30,35
   25 i3=loe(-i2)
      v1=v1*dabs(v)**(r*dble(z(i3)))
      return
   30 v1=v1*POW(v,r)
      return
   35 v1=v1*dabs(v)**(r*x(i2))
   40 return
   50 v1=0.d0
      v2=0.d0
      if((i1.le.0.or.i1.gt.2000).and.(i2.le.0.or.id.eq.4)) return
      if(i1) 55,40,65
   55 if(i1.lt.-1000) go to 60
      i3=loe(-i1)
      v2=c*dlog(dble(abs(z(i3))))*r
      go to 125
   60 i3=loe(-i1-1000)
      v2=c*dlog(dlog(dble(abs(z(i3)))))*r
      go to 125
   65 if(i1.gt.2000) go to 120
      if(i1.gt.1000) go to 95
      i4=i1
      if(x(i1).eq.0.) return
      if(i2) 70,75,85
   70 i3=loe(-i2)
      v1=c*dble(z(i3))*r/x(i1)
      go to 77
   75 v1=c*r/x(i1)
   77 if(id.ne.4) go to 140
   80 i=i1*(i1+1)/2
      s(i)=s(i)-v1/x(i1)
      return
   85 v1=c*r*x(i2)/x(i1)
      v2=c*r*dlog(dabs(x(i1)))
      if(id.ne.4) go to 125
      i=IYYM(i1,i2)
      s(i)=s(i)+c*r/x(i1)
      go to 80
   95 i4=i1-1000
      if(x(i4).eq.0.) return
      if(i2) 100,105,115
  100 i3=loe(-i2)
      v1=c*dble(z(i3))*r/(dlog(dabs(x(i4)))*x(i4))
      go to 110
  105 v1=c*r/(dlog(dabs(x(i4)))*x(i4))
  110 if(id.ne.4) go to 140
      i=i4*(i4+1)/2
      s(i)=s(i)-(1.d0+1.d0/dlog(dabs(x(i4))))*v1/x(i4)
      return
  115 v1=c*r*x(i2)/(dlog(dabs(x(i4)))*x(i4))
      v2=c*r*dlog(dabs(dlog(dabs(x(i4)))))
      if(id.ne.4) go to 125
      i=IYYM(i4,i2)
      if(x(i2).ne.0.) s(i)=s(i)+v1/x(i2)
      go to 110
  120 v2=c*dlog(r)*dble(2002-i1)
  125 if(id-3) 127,130,128
  127 if(i2.gt.k4) go to 140
      j=IYYM(k4,i2)
      s(j)=s(j)+v2
      go to 140
  128 g(i2)=g(i2)+v2
      go to 140
  130 j=i2*(i2-1)/2
      do 135 i=1,i2
      j=j+1
  135 s(j)=s(j)+v2*g(i)
  140 if(v1.eq.0.) return
      if(id-3) 142,145,143
  142 if(i4.gt.k4) return
      j=IYYM(k4,i4)
      s(j)=s(j)+v1
      return
  143 g(i4)=g(i4)+v1
      return
  145 j=i4*(i4-1)/2
      do 150 i=1,i4
      j=j+1
  150 s(j)=s(j)+v1*g(i)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CARDRD        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads transition or master card and determines program type.
c
c   This subroutine calls the following subroutines:
C   CPRINT  MARKY  DECODS  ERRCHK
c
c   This subroutine is called by the following subroutines:
c   MINREG  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CARDRD(ab,vnam,nvar,ic,ie)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension vm(14),id(5),vnam(1),ab(1)
      double precision v
c------------------------DATA STATEMENTS---------------------------------
      data vm/1Hs,1Ht,1Ho,1Ha,1Hm,1Hr,1He,1Hn,1Hy,1Hc,1H ,1Hw,1Hd,1Hp/
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Read card if not MINREG
      if(ie.eq.1) go to 1
      call CPRINT(17)
      call MARKY(ab,0,4,vnam,nvar,i)
      if(i.gt.0) go to 90
    1 i=0
      ic=0
    2 if(i.ge.481.or.(ab(i).eq.vm(11).and.ab(i+1).eq.vm(11))) go to 60
      i=i+1
c   Stop branch
      if(ab(i).eq.vm(1).and.ab(i+1).eq.vm(2)) go to 30
      if(ab(i).eq.vm(1).and.ab(i+1).eq.vm(4)) go to 5
      if((ab(i).eq.vm(6).and.ab(i+1).eq.vm(7).and.ab(i+2).eq.vm(12)).or.
     1(ab(i).eq.vm(7).and.ab(i+1).eq.vm(8).and.ab(i+2).eq.vm(13)).or.(ab
     2(i).eq.vm(2).and.ab(i+1).eq.vm(9))) go to 10
      go to 2
    5 if(ab(i+2).eq.vm(5).and.ab(i+5).eq.vm(7).and.(i.eq.1.or.ab(i-1).eq
     1.vm(11))) go to 7
      go to 2
    7 if(ic.ge.1.and.ic.le.6) go to 90
      ic=7
      i=i+2
      go to 2
   10 if(i.eq.1.or.ab(i-1).eq.vm(11)) go to 12
      go to 2
   12 i=i-1
      call DECODS(ab,i,id,v)
      j=id(3)
      if(id(1)-5) 2,15,20
   15 end file j
      go to 2
   20 if(id(1).eq.20) go to 25
      rewind j
      go to 2
   25 if(ic.ne.0) go to 90
      ic=id(3)
      go to 2
   30 if(ab(i+2).eq.vm(3).and.ab(i+3).eq.vm(14).and.(i.eq.1.or.ab(i-1).e
     1q.vm(11))) go to 100
      go to 2
   60 if(ic.gt.0.or.ie.eq.1) return
   90 call ERRCHK(15,0)
  100 stop
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CATCH        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Checks for probit/logit evaluations which are out of bounds.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/16/90.
c
c   This subroutine calls the following subroutines:
C   ERRWRT  
c
c   This subroutine is called by the following subroutines:
c   CLEVE  FCHOTZ - FCPELD  RANDAL  RESIDL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CATCH(ii,j,i6,bx,id,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision bx,emax,fmax
      dimension amy(2)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(39),lwi,dum(3)
      common /c/ a3(25),iut1,iut2,dumc(13)
c*********************************
      COMMON /F/ A2(31),IOUT,EMAX,FMAX
      common /simp1/ last,istsim,ipb,jcc,NUMER
c*********************************
c------------------------DATA STATEMENTS---------------------------------
      data amy/4HSigm,4HRho /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      go to (5,20,22,30,40,50,60),id
c   Check for value of equation sigma (bx)
    5 if(bx.gt.0.) return
      if(iout.le.1.and.lwi.eq.0) write(ip,10) amy(1),bx,i6,ii
   10 format(/39x,a4,' is ',g13.5,' Equation',i5,' Observation',i6)
      if(iout.le.1.and.lwi.eq.1) write(ip,15) amy(1),bx,i6,ii
   15 format(/13x,a4,' is ',g13.5,' Equation',i5,' Observation',i6)
c*********************************
      if(last.eq.0.and.(jcc.eq.8.or.jcc.eq.9)) then
          bx=dabs(bx)
          ind=1
      else
          bx=.01d0
          if(iout.eq.0) ind=1
      endif
c*********************************
      return
    
c   Check for value of equation/time period correlation rho (bx)
   20 if(dabs(bx).lt.1.d0) return
   22 if(bx.gt.0.d0.and.bx.lt.1.d0) return
      if(iout.le.1.and.lwi.eq.0) write(ip,10) amy(2),bx,i6,ii
      if(iout.le.1.and.lwi.eq.1) write(ip,15) amy(2),bx,i6,ii
      if(dabs(bx).ge.1.) bx=dsign(.999d0,bx)
      if(id.eq.3.and.bx.lt.0.) bx=0.1d-10
c*********************************
      if(last.eq.0.and.(jcc.eq.8.or.jcc.eq.9)) then
          ind=1
      else
          if(iout.eq.0) ind=1
      endif
c*********************************
      return
c   Check for value of argument of cumulative normal for probit (bx)
   30 if(dabs(bx).lt.fmax) return
      j1=j-iut1+1
      if(iut1.gt.iut2.and.j.gt.iut2) j1=j+(iut1-iut2)
      if(iout.le.1) call ERRWRT(ii,amy,j1,i6,0,bx)
      bx=(fmax-1.d0)*dsign(1.d0,bx)
c*********************************
      if(last.eq.0.and.(jcc.eq.8.or.jcc.eq.9)) then
          ind=1
      else
          if(iout.eq.0) ind=1
      endif
c*********************************
      return
c   Check for value of e power for logit (bx)
   40 if(dabs(bx).lt.emax) return
      j1=j-iut1+1
      if(iut1.gt.iut2.and.j.gt.iut2) j1=j+(iut1-iut2)
      if(iout.le.1) call ERRWRT(ii,amy,j1,i6,0,bx)
      bx=(emax-1.d0)*dsign(1.d0,bx)
c*********************************
      if(last.eq.0.and.(jcc.eq.8.or.jcc.eq.9)) then
          ind=1
      else
          if(iout.eq.0) ind=1
      endif
c*********************************
      return
c   Check for stop rule on fixed effect iterations (set to 10)
   50 j=j+1
      if(j.lt.10) return
      if(iout.le.1) call ERRWRT(ii,amy,0,i6,11,bx)
      bx=0.d0
      if(iout.eq.0) ind=2
      return
c   Check for bivariate probit cutoff
   60 if(bx.lt.1.and.bx.gt.1.d-25) return
      j1=j-iut1+1
      if(iut1.gt.iut2.and.j.gt.iut2) j1=j+(iut1-iut2)
      if(iout.le.1) call ERRWRT(ii,amy,j1,i6,0,bx)
      if(bx.lt.1.d-25) bx=1.d-25
      if(bx.ge.1.) bx=.999999999999d0
c*********************************
      if(last.eq.0.and.(jcc.eq.8.or.jcc.eq.9)) then
          ind=1
      else
          if(iout.eq.0) ind=1
      endif
c*********************************
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CKTIME        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Checks elapsed CPU time against time constraint set by user.  First
c   Call should initialize timer to zero. Subsequent calls should
c   Put cumulative cpu time in seconds into variable tim1.
c
c   This subroutine is called by the following subroutines:
c   VINCEN  SEARCH  CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
c   CKTIME(ind,ikd)        
c   Real   msec,secnds,sec,tim1,tim2
c   Integer*8 itime,$CPUTIME
c-------------------------COMMON BLOCKS----------------------------------
c   Common /a/ sec,tim1,tim2,msec
c   Itime=$CPUTIME()
c   Tim1=itime/40000000
c   If(ikd) 1,1,2
c** change *** initialize timer to zero on this call.
c   1 msec = tim1
c   Tim1 = 0.0
c   Return
c** change *** place cumulative cpu seconds into tim1. do not use tim2.
c   2 tim1 = tim1 - msec
c** change *** the following should be deleted if a timer is used.
c    tim1=-1.
c   If cpu time used greater than amount allowed (sec), stop iteration
c   If(tim1.ge.sec) ind=5
c   Return
c   End
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CHSKY         (SUBROUTINE OF MAIN PART OF HOTZTRAN)         
c
c   Provided to V. Joseph Hotz by George Yates.
c
c   Calculates cholesky factor of a square matrix.
c
c   The arguments are:
c   a      is the matrix to be factored.  It consists of the lower triangular
c          n(n+1)/2 elements stored in a vector.
c   b      is the cholesky factor matrix.  It consists of the lower triangular
c          n(n+1)/2 elements stored in a vector.
c   n      is the rank of the a matrix.
c   nonpos is an integer indicating the condition of the factorization.  If
c          nonpos=0 the matrix a is singular; if nonpos=1, the matrix is 
c          nonsingular.
c         
c   This subroutine calls the following subroutines:
c   
c
c   This subroutine is called by the following subroutines:
c   
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CHSKY(a,b,n,nonpos)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
        double precision a(1),b(1),x,y
c        implicit real*8 (a-h,o-z)
c        real*8 a(1),b(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
	nonpos=1
	nsin=n*(n+1)/2
	if(a(1).lt.1.0d-30) go to 98
	x=dsqrt(a(1))
	b(1)=x
	if(n-1)6665,6665,105
  105	n1=n-1
	kc=1
	ifir=1
	do 101 j=1,n1
	kc=kc+j
  101	b(kc)=a(kc)/x
	do 100 i=1,n1
	ifir=ifir+i
	kc=ifir
	x=0.0d0
	do 102 j=1,i
	x=x+b(kc)*b(kc)
  102	kc=kc+1
	x=a(kc)-x
	if(x.lt.1.0d-30) go to 98
	x=dsqrt(x)
	b(kc)=x
	ii=i+1
	if(ii.eq.n) go to 6665
	jc=ifir
	do 103 j=ii,n1
	jc=jc+j
	ic=jc
	kc=ifir
	y=0.0d0
	do 104 k=1,i
	y=y+b(ic)*b(kc)
	kc=kc+1
  104	ic=ic+1
  103	b(ic)=(a(ic)-y)/x
  100	continue
 6665	return
   98	nonpos=0
	return
	end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CLEVE        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates function/derivative.  
C   In this subroutine the following are the elements of bb( ) array:
c   bb(1) is 1st derivative of function w.r.t. x'b or g(x,b); wt 
c                       is weight
c   bb(2) is 1st derivative of function w.r.t. equation error sigma
c   bb(3) is minus 2nd derivative d^2f/d(x'b)^2 or d^2f/d(g(x,b))^2
c   bb(4) is minus 2nd derivative d^2f/d(x'b)d(sigma) or
c                       d^2f/d(g(x,b))d(sigma)
c   bb(5) is minus 2nd derivative d^2f/d(g(x,b))d(sigma)^2
c
c   Func is equation log-likelihood
c
c   This subroutine calls the following subroutines:
C   CATCH  
c
c   This subroutine is called by the following subroutines:
C   FCHOTZ - FCPELD  RESIDL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CLEVE(bb,joe0,joe2,joe4,ff,xd1,xd2,xd3,ii,j,i6,xm,func,
     1wt,jnd,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision bb(6),ff(2),fx,yx,cx,FSTAT,f1,xm(1),func,wt,f2
c-------------------BEGINNING OF SUBROUTINE------------------------------
      f1=ff(1)
c   Add fixed effect
      if(joe2.gt.0) f1=f1+dble(xd3)
      if(joe0.lt.0) go to 80
c   Scale x'beta by sigma
      f1=f1/ff(2)
      if(xd1.ge.2.) go to 32
c   Adjust bounded tobits for value of the masspoint
      if(joe0.eq.2.or.joe0.eq.3.or.(joe0.eq.4.and.xd1.eq.1.).or.(joe0.eq
     1.5.and.xd1.eq.0.)) f1=f1-dble(xd2)/ff(2)
c   Yx is one for y=1 and minus one for zero -- do probit Calculations
      yx=2.d0*dble(xd1)-1.d0
      f1=-f1*yx
      call CATCH(ii,j,i6,f1,4,ind)
c   Compute cumulative normal probability
      cx=FSTAT(f1,0.,0.,0.,3)
c   Compute normal density used in gradients
      fx=FSTAT(f1,0.,0.,0.,7)/ff(2)
c   Branch by 1=normal 2=FCJOEY normal 3=full 2nd derv data 4=fixed ef
c   5=FCMOFF/FCHOTZ/FCPELD  6=fcpeld full 2nd 7,8=fcmoff/fchotz
      go to (5,10,14,24,28,28,28,15),jnd
    5 bb(1)=wt*yx*fx/cx
      if(joe0.ge.1) bb(2)=bb(1)*f1*yx
      func=func+wt*dlog(cx)
      go to 90
   10 bb(1)=wt*yx*fx/cx
      if(joe0.ge.1) bb(2)=bb(1)*f1*yx
      bb(3)=bb(1)*(bb(1)/wt-f1*yx/ff(2))
      if(joe0.eq.0) return
      bb(4)=bb(3)*f1*yx+bb(1)/ff(2)
      bb(5)=bb(4)*f1*yx+bb(2)*f1*yx/ff(2)
      go to 90
   14 bb(1)=wt*yx*fx/cx
      f2=dlog(cx)
      func=func+wt*f2
      if(joe0.ge.1) bb(2)=bb(1)*f1*yx
      bb(3)=bb(1)*(bb(1)/wt-f1*yx/ff(2))
      if(joe0.eq.0) go to 16
      bb(4)=bb(3)*f1*yx+bb(1)/ff(2)
      bb(5)=bb(4)*f1*yx+bb(2)*f1*yx/ff(2)
      go to 16
   15 f2=dlog(cx)
   16 xm(1)=xm(1)+wt
      xm(2)=xm(2)+wt*dble(xd1)
      xm(6)=xm(6)+wt*f2
      if(joe0.gt.1) go to 18
      xm(3)=xm(3)+wt*(dble(xd1)-1.d0)*(cx-1.d0)
      xm(4)=xm(4)+dble(xd1)*cx*wt
      xm(5)=xm(5)+wt*((1.d0-cx)**2)
      xm(7)=xm(7)+wt*f1*ff(2)
      if(xd1.eq.0) cx=1.d0-cx
      yx=.1d0
      do 17 i=2,9
      if(cx.ge.yx.and.cx.lt.yx+.1) m=i
   17 yx=yx+.1d0
      if(cx.ge..9) m=10
      if(cx.lt..1) m=1
      i=xd1
      xm(20-i*10+m)=xm(20-i*10+m)+wt
      go to 90
   18 f1=-f1*yx
      if(joe0.eq.2.or.joe0.eq.3.or.(joe0.eq.4.and.xd1.eq.1.).or.(joe0.eq
     1.5.and.xd1.eq.0.)) f1=f1+dble(xd2)/ff(2)
      xm(3)=xm(3)+wt*f1*ff(2)
      xm(4)=xm(4)+wt*(f1*ff(2))**2
      if(joe0.lt.4.or.(joe0.eq.4.and.xd1.eq.1.).or.(joe0.eq.5.and.xd1.eq
     1.0.)) xm(5)=xm(5)+wt
      xm(7)=xm(7)+wt*xd2
      if((joe0.eq.4.and.xd1.eq.0.).or.(joe0.eq.5.and.xd1.eq.1.)) xm(31)=
     1xm(31)+wt
      if(xd1.eq.0) f1=-fx/(1.d0-cx)
      if(xd1.eq.1) f1=fx/cx
      go to 44
   24 bb(1)=wt*yx*fx/cx
      bb(3)=bb(1)*(bb(1)/wt-f1*yx/ff(2))
   26 return
   28 ff(1)=f1
      ff(3)=cx
      ff(4)=fx
      ff(5)=yx
      ff(6)=0.d0
      if(jnd-6) 26,30,15
   30 bb(1)=-wt*yx*fx/cx
      if(joe0.eq.0) return
      bb(2)=bb(1)*f1*yx
      go to 90
c   Compute gradients/function for regression -- bb's same as probit
   32 f1=dble(xd2)/ff(2)-f1
c   Branch by 1=normal 2=FCJOEY normal 3=full 2nd derv data 4=fixed ef
      go to (33,35,40,48,72,72,72,76),jnd
   33 bb(1)=wt*f1/ff(2)
      func=func-wt*((f1**2)/2.d0+dlog(ff(2))+.91893853205d0)
      bb(2)=wt*((f1**2)-1.d0)/ff(2)
      go to 50
   35 bb(1)=wt*f1/ff(2)
      bb(2)=wt*((f1**2)-1.d0)/ff(2)
      bb(3)=wt/(ff(2)**2)
      bb(4)=2.d0*f1*bb(3)
      bb(5)=(3.d0*f1**2-1.d0)*bb(3)
      go to 50
   40 bb(1)=wt*f1/ff(2)
      f2=-((f1**2)/2.d0+dlog(ff(2))+.91893853205d0)
      func=func+wt*f2
      bb(2)=wt*((f1**2)-1.d0)/ff(2)
      bb(3)=wt/(ff(2)**2)
      bb(4)=2.d0*f1*bb(3)
      bb(5)=(3.d0*f1**2-1.d0)*bb(3)
   42 xm(1)=xm(1)+wt
      xm(2)=xm(2)+wt*dble(xd2)
      xm(6)=xm(6)+wt*f2
      xm(3)=xm(3)+wt*(dble(xd2)-f1*ff(2))
      if(joe0.lt.8) go to 43
      xm(4)=xm(4)+wt*dble(xd2)**2
      xm(5)=xm(5)+wt*(f1*ff(2))**2
      go to 44
   43 xm(4)=xm(4)+wt*(dble(xd2)-f1*ff(2))**2
      cx=dble(xd2)-(dble(xd1)-2.d0)
      if(joe0.eq.7.or.joe0.eq.5.or.joe0.eq.3) cx=dble(xd2)+(dble(xd1)-2.
     1d0)
      xm(7)=xm(7)+wt*cx
   44 cx=dmin1(xm(11),xm(12),xm(13),xm(14),xm(15))
      if(f1*ff(2).lt.cx) go to 46
      do 45 i=1,5
      if(xm(10+i).ne.cx) go to 45
      xm(10+i)=f1*ff(2)
      xm(20+i)=1000*ii+j
      go to 46
   45 continue
   46 cx=dmax1(xm(16),xm(17),xm(18),xm(19),xm(20))
      if(f1*ff(2).gt.cx) go to 50
      do 47 i=1,5
      if(xm(15+i).ne.cx) go to 47
      xm(15+i)=f1*ff(2)
      xm(25+i)=1000*ii+j
      go to 50
   47 continue
   48 bb(1)=wt*f1/ff(2)
      bb(3)=wt/(ff(2)**2)
      if(joe0.ne.6.and.joe0.ne.7) return
      go to 52
   50 if((joe0.ne.6.and.joe0.ne.7).or.xd1.lt.2) go to 90
c   Compute function gradient addition for truncated -- bb's same
   52 yx=13.d0-dble(2*joe0)
      f1=(f1-yx*(dble(xd1)-2.d0)/ff(2))*yx
      call CATCH(ii,j,i6,f1,4,ind)
      cx=FSTAT(f1,0.,0.,0.,3)
      fx=FSTAT(f1,0.,0.,0.,7)*yx/(cx*ff(2))
      go to (55,60,65,70,68,68,68,68),jnd
   55 bb(1)=bb(1)-fx*wt
      bb(2)=bb(2)-fx*f1*yx*wt
      func=func-wt*dlog(cx)
      go to 90
   60 bb(1)=bb(1)-fx*wt
      bb(2)=bb(2)-fx*f1*yx*wt
      bb(3)=bb(3)-fx*(fx-f1*yx/ff(2))*wt
      bb(4)=bb(4)-fx*((fx-f1*yx/ff(2))*f1*yx+1.d0/ff(2))*wt
      bb(5)=bb(5)-fx*f1*yx*(((fx-f1*yx/ff(2))*f1*yx+1.d0/ff(2))+1.d0/ff(
     12))*wt
      go to 90
   65 bb(1)=bb(1)-fx*wt
      f2=-dlog(cx)
      func=func+wt*f2
      bb(2)=bb(2)-fx*f1*yx*wt
      bb(3)=bb(3)-fx*(fx-f1*yx/ff(2))*wt
      bb(4)=bb(4)-fx*((fx-f1*yx/ff(2))*f1*yx+1.d0/ff(2))*wt
      bb(5)=bb(5)-fx*f1*yx*(((fx-f1*yx/ff(2))*f1*yx+1.d0/ff(2))+1.d0/ff(
     12))*wt
   68 xm(6)=xm(6)+wt*f2
      xm(5)=xm(5)+wt*cx
      go to 90
   70 bb(1)=bb(1)-fx*wt
      bb(3)=bb(3)-fx*(fx-f1*yx/ff(2))*wt
      return
   72 ff(1)=dble(xd1)/ff(2)-f1
      ff(3)=f1
      ff(5)=1.d0
      ff(6)=1.d0
      if(jnd-6) 26,74,76
   74 bb(1)=-wt*f1/ff(2)
      bb(2)=-wt*((f1**2)-1.d0)/ff(2)
      go to 90
   76 f2=-((f1**2)/2.d0+dlog(ff(2))+.91893853205d0)
      go to 42
c   1st/second derivatives of binary logit
   80 call CATCH(ii,j,i6,f1,5,ind)
      yx=dexp(f1)
      f2=-dlog(1.d0+yx)+f1*dble(xd1)
      bb(1)=-yx/(1.d0+yx)+dble(xd1)
      bb(3)=yx/((1.d0+yx)**2)
      if(jnd.eq.1.or.jnd.eq.3) func=func+f2
      if(jnd.ne.3) return
      cx=yx/(1.d0+yx)
      if(xd1.eq.0.) cx=1.d0-cx
      go to 16
c   Adjust 1st/second derivatives of sigma if variance is estimated
   90 if(joe4.le.1.or.joe4.eq.3) return
      bb(2)=bb(2)/(2.d0*ff(2))
      if(jnd.ne.3) return
      bb(4)=bb(4)/(2.d0*ff(2))
      bb(5)=(bb(5)/(4.0*ff(2))-bb(2))/ff(2)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   COEFFC      (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes standard errors/t statistics
c
c   This subroutine is called by the following subroutines:
C   PRINTA  PRINTC  BPRINT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine COEFFC(d1,d2,d3,df,x1,x2)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision d1,d2,d3,x1,x2,FSTAT
c-------------------BEGINNING OF SUBROUTINE------------------------------
      d1=0.d0
      if(x2.gt.0.) d1=dsqrt(x2)
      d2=0.d0
      if(d1.gt.0.) d2=x1/d1
      d3=0.d0
      if(d1.gt.0.) d3=FSTAT(d2,df,0.,0.,2)*100.d0
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CONBAS        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads and processes equation control cards.
c
c   This subroutine calls the following subroutines:
C   MARKY  MALLAR  DECODS  MYRON  RDREST  ERRWRT
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CONBAS(a,joe,ab,aa,lar,mar,tar,nar,i8,i7,i9,j9,m1,vnam,
     1ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension a(1),id(5),lar(1),mar(nvar,2,me),tar(me,11),joe(1),
     1ab(1),nar(1),vb(12),vnam(1)
      double precision v,aa(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a3(4),nobs,nvar,a4(24),m8,a7(5),inam,dum(6)
      common /c/ me,nt,igm,a8(10),mm,nl,ir,ln,igs,ifs,lm,a1(2),ires,
     1a2(10),iwt,a5(2),ifxi,dumb(3)
      common /d/ k,n,jb,kobs,lv,lw,lr,le,igmm,lz,lp,my,ny,l1,lee,lg,lh,
     1iccn,a6(2),lq,lpp,lpq,dumd
c------------------------DATA STATEMENTS---------------------------------
      data vb/1He,1Hs,1Hp,1He,1Hv,1Hc,1Hn,1H=,1H ,1Hd,1H0,1H1/
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Zero out variable counter
      do 5 i=1,nvar
    5 lar(i)=0
      lar(nvar)=1
c   Read time variation card
      call MARKY(a,0,5,vnam,nvar,ierror)
      if(ierror.gt.0) return
      j5=0
      i6=0
      ifxi=0
      lee=0
      m8=0
      lg=0
      lh=0
      do 7 i=1,484
      if(a(i).eq.vb(9).and.a(i+1).eq.vb(9)) go to 8
      if(a(i).ne.vb(8)) go to 7
      if(a(i+1).eq.vb(6)) lee=1
      if(a(i+1).eq.vb(10)) m8=1
      if(a(i+1).eq.vb(6)) a(i+1)=vb(11)
      if(a(i+1).eq.vb(10)) a(i+1)=vb(12)
    7 continue
    8 if(lee.eq.0.and.m8.eq.0) go to 15
   10 call MALLAR(a,j5,id,vnam,nvar,ierror)
      if(ierror.gt.0) return
      if(id(1).eq.0) go to 15
      if(id(1).lt.0.or.id(1).gt.nvar.or.i6.gt.id(1).or.id(2).gt.1.or.id(
     13).lt.0.or.id(3).gt.1) go to 320
      if(id(4).eq.0) go to 12
      if(i6.gt.0) go to 320
      i6=id(1)
      i4=id(3)
      go to 10
   12 i=id(1)
      if(i6.eq.0) i4=id(3)
      if(i6.eq.0) i6=i
      do 13 j=i6,i
      lar(j)=1-i4
      if(id(2).eq.1) lar(j)=2
   13 continue
      i6=0
      go to 10
c   Initialize parameter counters
   15 i6=0
      do 20 j=1,me
      joe(j)=jb-1
      do 17 l=1,9
   17 joe(l*me+j)=0
      joe(4*me+j)=igmm
      do 18 i=1,11
   18 tar(j,i)=0.
      tar(j,8)=1.
      tar(j,9)=nobs
      do 20 l=1,nvar
   20 mar(l,1,j)=15
      if(igm.ne.4) go to 24
      j=me*(me-1)/2
      do 23 l=1,j
   23 joe(8*me+l)=-lz
   24 le=0
      lp=0
      lz=0
      jb=0
      if(lee.eq.0.and.m8.eq.0) go to 30
c   Read basic equation card
   25 call MARKY(a,0,5,vnam,nvar,ierror)
      if(ierror.gt.0) return
   30 i6=i6+1
      j5=0
   35 call DECODS(a,j5,id,v)
      if(id(1).lt.0) go to 305
      if(id(1).eq.0) go to 60
      if(id(1).ne.4.and.id(1).ne.6.and.id(1).ne.13.and.id(1).ne.21.and.i
     1d(1).ne.19.and.id(1).ne.24) go to 300
      if(id(1)-6) 40,43,47
   40 joe(3*me+i6)=id(3)
      tar(i6,5)=id(4)
      tar(i6,6)=id(5)
      tar(i6,7)=v
      go to 35
   43 if(id(2).eq.9) go to 45
      tar(j,10)=v
      go to 35
   45 joe(2*me+i6)=id(3)
      go to 35
   47 if(id(1)-19) 48,50,52
   48 joe(i6)=id(3)-1
      go to 35
   50 joe(4*me+i6)=id(3)
      go to 35
   52 if(id(2).eq.3) go to 54
      if(id(2).ne.15) go to 305
      if(id(4).eq.0) id(4)=1
      tar(i6,1)=id(4)
      tar(i6,2)=id(3)
      tar(i6,3)=id(5)
      tar(i6,4)=v
      go to 35
   54 if(id(3).eq.0) id(3)=1
      if(id(5).eq.0) id(5)=nobs
      tar(i6,8)=id(3)
      tar(i6,9)=id(5)
      if(id(3).le.0.or.id(5).gt.nobs.or.id(3).gt.id(5)) go to 310
      if(id(1).eq.21) go to 35
      tar(i6,8)=id(5)+1
      tar(i6,9)=id(3)
      go to 35
   60 if(joe(i6).eq.0.and.joe(4*me+i6).gt.0) joe(i6)=1
      if(joe(i6).gt.1.and.joe(4*me+i6).le.0) joe(4*me+i6)=1
      if(igm.ne.3.and.joe(4*me+i6).gt.2) joe(4*me+i6)=joe(4*me+i6)-2
      if(joe(i6).ge.2.and.joe(i6).lt.8.and.(tar(i6,5).eq.2..or.tar(i6,5)
     1.eq.4.)) joe(i6)=joe(i6)+1
      if(joe(i6).gt.1.and.joe(i6).ne.6.and.joe(i6).ne.7.and.joe(2*me+i6)
     1.eq.0) joe(2*me+i6)=-1
      if(joe(3*me+i6).gt.nvar.or.tar(i6,2).gt.nvar.or.tar(i6,6).gt.nvar.
     1or.(joe(i6).ge.2.and.tar(i6,5).ge.5.).or.(joe(i6).eq.4.and.tar(i6,
     25).le.0.).or.(joe(3*me+i6).le.0.and.joe(i6).le.8).or.(joe(3*me+i6)
     3.ne.0.and.joe(i6).eq.9)) go to 320
      if((joe(2*me+i6).gt.0.and.(nt.le.1.or.igm.eq.2.or.igm.eq.4)).or.((
     1joe(i6).lt.0.or.joe(i6).eq.6.or.joe(i6).eq.7).and.(igm.eq.2.or.igm
     2.eq.4))) go to 310
      if(joe(2*me+i6).gt.0) ifxi=1
      if(joe(i6).eq.9) joe(3*me+i6)=nvar
      if(igm.ne.3.and.nl.gt.0) go to 95
c   Read equation variable card
      call MARKY(a,0,6,vnam,nvar,ierror)
      if(ierror.gt.0) return
      i9=0
      j5=0
      j8=0
      m2=iccn
      if(joe(2*me+i6).gt.0) m2=1
      my=0
   65 call MALLAR(a,j5,id,vnam,nvar,ierror)
      if(ierror.gt.0) return
      if(id(1).eq.0) go to 70
      if(id(1).lt.0.or.id(1).gt.nvar.or.j8.gt.id(1)) go to 320
      if(id(1).eq.nvar) go to 68
      if(id(4).eq.0) go to 66
      if(j8.gt.0) go to 320
      j8=id(1)
      j9=id(3)
      go to 65
   66 i=id(1)
      if(j8.eq.0) j9=id(3)
      if(j8.eq.0) j8=i
      do 67 j=j8,i
      i9=i9+1
      if(j9.eq.1.and.mar(j,1,i6).ne.15) i9=i9-2
      if(j9.eq.0) mar(j,1,i6)=id(2)
      if(j9.eq.1) mar(j,1,i6)=15
   67 continue
      j8=0
      go to 65
   68 m2=id(3)
      if(id(3).eq.0) my=id(2)
      if(id(4).ne.0) go to 320
      go to 65
   70 if(i9.le.0.and.m2.eq.1) go to 320
      if(m2.eq.0) mar(nvar,1,i6)=my
c   Check equation o.c. conditions etc.
      if(nl.eq.0) jb=jb+nt
      if(nl.eq.0.and.joe(i6).ge.2) jb=jb+nt
      if(igm.ne.4) joe(8*me+i6)=lz
      joe(me+i6)=le
      do 73 i=1,nvar
      if((nt.eq.1.or.igm.ne.3.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,
     11,i6).ge.1.and.mar(i,1,i6).le.3) mar(i,1,i6)=0
      if((nt.eq.1.or.igm.ne.3.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,
     11,i6).ge.4.and.mar(i,1,i6).le.7) mar(i,1,i6)=4
      if((nt.eq.1.or.igm.ne.3.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,
     11,i6).ge.8.and.mar(i,1,i6).le.11) mar(i,1,i6)=8
      if((nt.eq.1.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,1,i6).ge.12.
     1and.mar(i,1,i6).le.14) mar(i,1,i6)=15
      if(igm.ne.3.and.mar(i,1,i6).ge.8) mar(i,1,i6)=15
      if(nl.gt.0.and.mar(i,1,i6).ge.12.and.mar(i,1,i6).le.14) mar(i,1,i6
     1)=mar(i,1,i6)-7
      if(nl.gt.0.and.mar(i,1,i6).ge.8.and.mar(i,1,i6).le.11) mar(i,1,i6)
     1=mar(i,1,i6)-8
      if(nl.gt.0.and.mar(i,1,i6).eq.4) mar(i,1,i6)=15
c   Count parameters
      if(mar(i,1,i6).le.7) le=le+1
      if(mar(i,1,i6).lt.4.or.(mar(i,1,i6).ge.8.and.mar(i,1,i6).le.11)) l
     1z=lz+1
      if(mar(i,1,i6).eq.1.or.mar(i,1,i6).eq.5.or.mar(i,1,i6).eq.9.or.mar
     1(i,1,i6).eq.12) lz=lz+2*(ln-1)
      if(mar(i,1,i6).eq.2.or.mar(i,1,i6).eq.3.or.mar(i,1,i6).eq.6.or.mar
     1(i,1,i6).eq.7.or.mar(i,1,i6).eq.10.or.mar(i,1,i6).eq.11.or.mar(i,1
     2,i6).eq.13.or.mar(i,1,i6).eq.14) lz=lz+ln-1
      if(lar(i).le.2.and.mar(i,1,i6).lt.15) lar(i)=lar(i)+10
   73 continue
      if(joe(i6).ge.1) le=le+1
      joe(5*me+i6)=le
      if(igm.eq.2) le=le+1
      if(igm.eq.2) lz=lz+1
      joe(6*me+i6)=le
      if((igm.ne.3.and.joe(i6).ge.1).or.(igm.eq.3.and.joe(i6).ge.2.and.j
     1oe(4*me+i6).le.2)) lz=lz+1
      lg=max0(lg,lz-joe(8*me+i6))
      lh=max0(lh,le-joe(me+i6))
      if(igs.eq.0) go to 95
c   Read equation testing variable card
      do 74 i=1,nvar
   74 mar(i,2,i6)=mar(i,1,i6)
      call MARKY(a,0,7,vnam,nvar,ierror)
      if(ierror.gt.0) return
      lee=0
      j5=0
      j8=0
   80 call MALLAR(a,j5,id,vnam,nvar,ierror)
      if(ierror.gt.0) return
      if(id(1).eq.0) go to 85
      if(id(1).lt.0.or.id(1).gt.nvar.or.j8.gt.id(1)) go to 320
      if(id(4).eq.0) go to 81
      if(j8.gt.0) go to 320
      j8=id(1)
      j9=id(3)
      go to 80
   81 i=id(1)
      if(j8.eq.0) j9=id(3)
      if(j8.eq.0) j8=i
      do 82 j=j8,i
      if(mar(j,2,i6).ne.mar(j,1,i6)) lee=lee-1
      if(j9.eq.0) mar(j,2,i6)=id(2)
      if(j9.eq.1) mar(j,2,i6)=mar(j,1,i6)
      if(mar(j,2,i6).ne.mar(j,1,i6)) lee=lee+1
   82 continue
      j8=0
      go to 80
   85 joe(9*me+i6)=lp
      if(lee.eq.0) lp=lp+lz-joe(8*me+i6)
      if(lee.eq.0) go to 95
      do 90 i=1,nvar
      if((nt.eq.1.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,2,i6).ge.1.a
     1nd.mar(i,2,i6).le.3) mar(i,2,i6)=0
      if((nt.eq.1.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,2,i6).ge.4.a
     1nd.mar(i,2,i6).le.7) mar(i,2,i6)=4
      if((nt.eq.1.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,2,i6).ge.8.a
     1nd.mar(i,2,i6).le.11) mar(i,2,i6)=8
      if((nt.eq.1.or.lar(i).eq.1.or.lar(i).eq.11).and.mar(i,2,i6).ge.12.
     1and.mar(i,2,i6).le.14) mar(i,2,i6)=15
      if(nl.gt.0.and.mar(i,2,i6).ge.12.and.mar(i,2,i6).le.14) mar(i,2,i6
     1)=mar(i,2,i6)-7
      if(nl.gt.0.and.mar(i,2,i6).ge.8.and.mar(i,2,i6).le.11) mar(i,2,i6)
     1=mar(i,2,i6)-8
      if(nl.gt.0.and.mar(i,2,i6).eq.4) mar(i,2,i6)=15
      if(nl.gt.0.and.mar(i,1,i6).gt.7.and.mar(i,2,i6).le.7) go to 310
      if((mar(i,1,i6).eq.1.or.mar(i,1,i6).eq.9).and.mar(i,2,i6).ne.1.and
     1.mar(i,2,i6).ne.9) go to 310
      if((mar(i,1,i6).eq.5.or.mar(i,1,i6).eq.12).and.mar(i,2,i6).ne.5.an
     1d.mar(i,2,i6).ne.12) go to 310
      if((mar(i,1,i6).eq.2.or.mar(i,1,i6).eq.10).and.mar(i,2,i6).ne.1.an
     1d.mar(i,2,i6).ne.2.and.mar(i,2,i6).ne.9.and.mar(i,2,i6).ne.10) go
     2to 310
      if((mar(i,1,i6).eq.3.or.mar(i,1,i6).eq.11).and.mar(i,2,i6).ne.1.an
     1d.mar(i,2,i6).ne.3.and.mar(i,2,i6).ne.9.and.mar(i,2,i6).ne.11) go
     2to 310
      if((mar(i,1,i6).eq.6.or.mar(i,1,i6).eq.13).and.mar(i,2,i6).ne.5.an
     1d.mar(i,2,i6).ne.6.and.mar(i,2,i6).ne.12.and.mar(i,2,i6).ne.13) go
     2 to 310
      if((mar(i,1,i6).eq.7.or.mar(i,1,i6).eq.14).and.mar(i,2,i6).ne.5.an
     1d.mar(i,2,i6).ne.7.and.mar(i,2,i6).ne.12.and.mar(i,2,i6).ne.14) go
     2 to 310
      if(mar(i,2,i6).lt.4.or.(mar(i,2,i6).ge.8.and.mar(i,2,i6).le.11)) l
     1p=lp+1
      if(mar(i,2,i6).eq.1.or.mar(i,2,i6).eq.5.or.mar(i,2,i6).eq.9.or.mar
     1(i,2,i6).eq.12) lp=lp+2*(lm-1)
      if(mar(i,2,i6).eq.2.or.mar(i,2,i6).eq.3.or.mar(i,2,i6).eq.6.or.mar
     1(i,2,i6).eq.7.or.mar(i,2,i6).eq.10.or.mar(i,2,i6).eq.11.or.mar(i,1
     2,i6).eq.13.or.mar(i,2,i6).eq.14) lp=lp+lm-1
      if(lar(i).le.2.and.mar(i,2,i6).lt.15) lar(i)=lar(i)+10
   90 continue
      if(joe(i6).ge.2.and.joe(4*me+i6).le.2) lp=lp+1
   95 if(i6.lt.me) go to 25
      lpp=le
      if(igm.eq.4) le=le+me*(me-1)/2
c   Read o.c. condition test cards
      i6=i8
      if(ifs.eq.0) go to 120
      do 115 i=1,ifs
      call MARKY(a,0,8,vnam,nvar,ierror)
      if(ierror.gt.0) go to 300
      j5=0
      call DECODS(a,j5,id,v)
      if(id(1).ne.19.or.id(2).ne.21) go to 300
      joe(i6+1)=1
      joe(i6+2)=id(3)
      l=2
  100 j=-1
  105 j5=j5+1
      call MYRON(a(j5),i7)
      if(i7.gt.10) go to 110
      if(j.lt.0) j=0
      j=j*10+i7-1
      go to 105
  110 if(i7.ne.20) go to 300
      if(j.lt.0) go to 115
      l=l+1
      joe(i6+1)=joe(i6+1)+1
      joe(i6+l)=j
      go to 100
  115 i6=i6+l
  120 i7=i6+1
      my=0
c   Read non-linear equations
      if(nl.eq.0) go to 170
      lq=0
      lee=0
      j2=0
      m2=i7+(m1-i7)/5-225
      i9=m2+125
      i6=i9+(m1-i7)/5-200
      i3=i6+1
      do 123 i=m2,i3
  123 joe(i)=0
      j9=(i6+(m1-i7)/5-200)/2+1
      j8=j9+120
      m1=j8+250
      j1=m1+120
      do 145 i=1,me
      jb=jb+nt
      if(joe(i).ge.2) jb=jb+nt
      j7=0
      joe(me+i)=j2
  125 j7=j7+1
      if(j7.eq.2) joe(5*me+i)=j2
      if(j7.eq.3) joe(6*me+i)=j2
      if(j7.eq.3.and.igm.eq.1) joe(8*me+i)=1
      if(j7.eq.3.and.igm.eq.1) joe(9*me+i)=lq
      if(j7.gt.3) go to 145
      if((j7.gt.1.and.nl.gt.1).or.(j7.eq.2.and.joe(i).le.0).or.(j7.eq.3.
     1and.igm.ne.2)) go to 125
c   Read equation (j7=1) sigma (j7=2) or rho (j7=3)
      call MARKY(ab(i3),1,9,vnam,nvar,ierror)
      if(ierror.gt.0) return
      if(ab(i3).ne.vb(j7).and.ab(i3).ne.vb(j7+3)) go to 330
      if(ab(i3).eq.vb(5).and.j7.eq.2.and.(joe(4*me+i).eq.1.or.joe(4*me+i
     1).eq.3)) joe(4*me+i)=joe(4*me+i)+1
      if(ab(i3).eq.vb(2).and.j7.eq.2.and.(joe(4*me+i).eq.2.or.joe(4*me+i
     1).eq.4)) joe(4*me+i)=joe(4*me+i)-1
      j5=1
  130 j5=j5+1
      call MYRON(ab(j5+i3-1),l)
      if(l.gt.10) go to 135
      go to 130
  135 if(l.ne.21) go to 330
      j5=j5+1
      lee=lee+1
c   Call RDREST which decodes equations
      call RDREST(joe(i7),joe(i9),aa(j1),j2,ab(i3),aa(j9),aa(j8),aa(m1),
     1joe(m2),lq,lar,nvar,j5,1,joe(7*me+i),ierror)
      if(ierror.gt.0) return
      if(inam.eq.0) call MALLAR(ab,j5,id,vnam,nvar,i3)
      ab(i3-1)=j5
      i3=i3+j5+1
      go to 125
  145 my=max0(my,joe(7*me+i))
      lpq=0
      lpp=lq
      le=lq
      if(igm.ne.4.or.nl.gt.1) go to 165
      i4=0
      do 160 i=2,me
      j7=i-1
      do 160 j=1,j7
      i4=i4+1
      joe(8*me+i4)=j2
c   Read equation correlations if igm=4
      call MARKY(ab(i3),1,9,vnam,nvar,ierror)
      if(ierror.gt.0) return
      if(ab(i3).ne.vb(3).and.ab(i3).ne.vb(6)) go to 330
      if(ab(i3).eq.vb(6)) joe(8*me+i4)=-j2
      j5=1
  150 j5=j5+1
      call MYRON(ab(j5+i3-1),l)
      if(l.gt.10) go to 155
      go to 150
  155 if(l.ne.21) go to 330
      j5=j5+1
      lee=lee+1
c   Call RDREST which decodes equations
      call RDREST(joe(i7),joe(i9),aa(j1),j2,ab(i3),aa(j9),aa(j8),aa(m1),
     1joe(m2),le,lar,nvar,j5,1,lpq,ierror)
      if(ierror.gt.0) return
      if(inam.eq.0) call MALLAR(ab,j5,id,vnam,nvar,i3)
      ab(i3-1)=j5
  160 i3=i3+j5+1
      my=max0(my,lpq)
c   Check for all coefficients
  165 do 167 i=1,le
      if(joe(m2+i-1).ne.1) go to 330
  167 continue
      if(nl.eq.1) go to 170
      do 169 i=1,me
      if(joe(i).ge.1) le=le+1
      joe(5*me+i)=le
      if(igm.eq.2) le=le+1
  169 joe(6*me+i)=le
      lpp=le
      if(igm.eq.4) le=le+me*(me-1)/2
c   Count variables actually used in run
  170 k=0
      lv=0
      i4=nvar*nt+ny
      j5=i4
      do 180 i=1,nvar
      nar(i)=0
      if(lar(i).le.2) go to 180
      k=k+1
      nar(i)=k
      do 175 j=1,nt
      j5=j5+1
      if(j.eq.1.or.lar(i).ne.11) lv=lv+1
  175 joe(j5)=lv
  180 continue
      if(iwt.eq.0) go to 183
      do 182 j=1,nt
      j5=j5+1
      if(j.eq.1.or.(lar(iwt).ne.1.and.lar(iwt).ne.11)) lv=lv+1
  182 joe(j5)=lv
      k=k+1
  183 if(ifxi.gt.0) lv=lv+me
      jb=jb+lv
      if(ires.gt.0) jb=jb+1
      j5=i4
      do 184 i=1,k
      do 184 j=1,nt
      j5=j5+1
  184 joe(ny+j*k-k+i)=joe(j5)
      j5=ny+k*nt
      if(igm.ne.3.and.nl.gt.0) go to 195
      do 188 i=1,me
      do 185 j=1,nvar
      if(lar(j).le.2) go to 185
      j5=j5+1
      joe(j5)=mar(j,1,i)
  185 continue
      if(iwt.eq.0) go to 188
      j5=j5+1
      joe(j5)=15
  188 continue
      if(igs.eq.0) go to 195
      do 193 i=1,me
      do 190 j=1,nvar
      if(lar(j).le.2) go to 190
      j5=j5+1
      joe(j5)=mar(j,2,i)
  190 continue
      if(iwt.eq.0) go to 193
      j5=j5+1
      joe(j5)=15
  193 continue
  195 if(ifs.eq.0) go to 197
      j=i7-i8-1
      do 196 i=1,j
  196 joe(j5+i)=joe(i+i8)
  197 i8=j5+i7-i8+2
      if(nl.eq.0) return
      do 200 i=1,j2
      j=joe(i7+i-1)
      if(j.lt.0.and.j.gt.-1000) j=-nar(-j)
      if(j.lt.-1000.and.j.gt.-2000) j=-nar(-j-1000)-1000
  200 joe(i8+i-1)=j
      i7=i8
      do 210 i=1,j2
      j=joe(i9+i-1)
      if(j.lt.0.and.j.gt.-1000) j=-nar(-j)
      if(j.lt.-1000.and.j.gt.-2000) j=-nar(-j-1000)-1000
  210 joe(i7+j2+i-1)=j
      i9=i7+j2+j2
      ny=j2+1
      j5=i3-i6
      do 212 i=1,j5
  212 ab(i9+i-1)=ab(i6+i-1)
      j9=(i9+i3-i6+1)/2+2
      do 216 i=1,j2
  216 aa(j9+i-1)=aa(j1+i-1)
      i8=(j9+j2)*2+2
      return
  300 i=j5-4
      call ERRWRT(0,a(i),8,0,0,v)
  305 ierror=2
      return
  310 ierror=3
      return
  320 ierror=4
      return
  330 ierror=7
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CONDAT        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads data control card.
c
c   This subroutine calls the following subroutines:
C   MARKY  DECODS  MYRON  DAVID  VARNAM  TRANSL  RDREST  ERRWRT 
c
c   This subroutine is called by the following subroutines:
C   DATAON  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CONDAT(a,fmt,aa,ib,i3,i4,i5,i6,i8,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension a(1),fmt(1),id(5),ib(1),az(12)
      double precision v,aa(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,inp,ipc,int,iqv,nobs,nvar,ntime,kcore,a1(25),mi1,
     1mi2,gl,inam,mtime,mzq,lwi,dum(3)
      common /c/ inn,ipr,ifm,isz,jcore,itran,ntar,imin,imax,dumc(31)
c** change *** this contains transformation codes < > i f
c------------------------DATA STATEMENTS---------------------------------
      data az/1Hu,1Ht,1H=,1Ho,4H    ,1Hm,1H<,1H>,1Hi,1Hf,1Hr,1H)/
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Set defaults
      ifm=0
      ipr=0
      nvar=-1
      nobs=0
      inam=0
      ntime=1
      iqv=0
      isz=0
      itran=0
      mi1=0
      mtime=0
c   Read data control card
      call MARKY(a,0,1,a,j5,ierror)
      if(ierror.gt.0) return
      j5=0
   30 j2=2
      if(a(j5+1).ne.az(6)) go to 34
      do 32 l=1,8
      if(a(j5+1+l).eq.az(7)) j2=1
      if(a(j5+1+l).eq.az(8)) j2=3
      if(a(j5+1+l).eq.az(7).or.a(j5+1+l).eq.az(8)) a(j5+1+l)=az(3)
   32 continue
   34 call DECODS(a,j5,id,v)
      if(id(1)) 205,79,35
   35 if(id(1).eq.22.and.id(2).eq.1) go to 40
      if(id(1).eq.15.and.id(2).eq.2) go to 45
      if(id(1).eq.6.and.id(2).eq.15) go to 50
      if(id(1).eq.16.and.id(2).eq.18) go to 65
      if(id(1).eq.9.and.id(2).eq.9) go to 70
      if(id(1).eq.9.and.id(2).eq.14) go to 75
      if(id(1).eq.20.and.id(2).eq.9) go to 67
      if(id(1).eq.20.and.id(2).eq.3) go to 77
      if(id(1).eq.20.and.id(2).eq.18) go to 78
      if(id(1).eq.14.and.id(2).eq.1) go to 42
      if(id(1).eq.13.and.id(2).eq.9) go to 38
      if(id(1).eq.12.and.id(2).eq.9) go to 36
      go to 200
   36 lwi=id(3)
      go to 30
   38 gl=sngl(v)
      mi1=j2
      go to 30
   40 nvar=id(3)
      go to 30
   42 inam=id(3)
      go to 30
   45 nobs=id(3)
      go to 30
   50 if(id(3).ge.0) ifm=id(3)
      if(id(3).ge.0) go to 30
      call MYRON(a(j5+1),j)
      if(j.ne.18) go to 200
      l=0
   55 j5=j5+1
      call MYRON(a(j5),j)
      if(j.eq.20) go to 60
      l=0
      isz=isz+1
      fmt(isz)=az(5)
      fmt(isz)=a(j5)
      if(j.eq.19) go to 62
      go to 55
   60 l=l+1
      if(l.gt.1) go to 200
      go to 55
   62 if(isz.lt.2) go to 200
      ifm=1
      call DAVID(a(j5+1),j)
      if(j.eq.28) j5=j5+1
      go to 30
   65 ipr=id(3)
      go to 30
   67 mtime=id(3)
      go to 30
   70 iqv=id(3)
      go to 30
   75 inn=id(3)
      go to 30
   77 ntime=id(3)
      go to 30
   78 itran=id(3)
      go to 30
   79 if(inn.eq.0) inn=inp
c*****************
c  set iqv=1, int=29, inn=28
c    iqv = 1
c    inn = 28
c    int = 29
c*****************
      if(iqv.eq.1) int=inn
      if(nvar.eq.0.or.(iqv.eq.1.and.ifm.ne.0).or.(nobs.eq.0.and.ifm.eq.0
     1.and.inp.eq.inn).or.ntime.le.0.or.((iqv.eq.1.or.ifm.ge.4).and.itra
     2n.gt.0).or.(ifm.ge.4.and.(ipr.eq.2.or.ipr.eq.4.or.ipr.eq.7)).or.(i
     3fm.ge.4.and.iqv.lt.3).or.mtime.lt.0.or.mtime.gt.nvar.or.(mtime.gt.
     40.and.ntime.le.1.and.iqv.eq.1)) go to 210
      if(ntime.le.1.and.mtime.gt.0) ntime=10
c   Read title card
      read(inp,80,end=190,err=190) (a1(i),i=3,22)
c** change *** set format to (17a4,a2,2a1) for 72 column input file.
   80 format(17a4,a2,2a1)
      if(lwi.eq.0) write(ip,81) (a1(i),i=3,22)
   81 format(41x,'TITLE',5x,20a4)
      if(lwi.eq.1) write(ip,82) (a1(i),i=3,20)
   82 format('TITLE    ',18a4)
c   Read variable names
      j0=9*(nvar+itran+1)+1
      if(inam.eq.0.and.nvar.ne.0) call VARNAM(a(j0),a,0,nvar,ierror)
      if(ierror.gt.0) return
      ntar=nvar
      ncar=nvar
      j0=j0/2+1
      imin=0
      imax=0
      if(itran.le.0) return
      nvar=nvar+itran+150
      j2=0
      i=(kcore-1600-6*(itran+150)-5*nvar)/5
      j1=i+j0
      i3=(j1+2*nvar)*2+2
      i4=i3+i
      i5=i4+i
      i6=i5+i
      i8=kcore-484-6*(itran+150)
      i9=i8-484
      do 83 l=i4,i6
   83 ib(l-1)=0
      do 84 l=ntar,nvar
   84 ib(i6+l-1)=0
      do 85 l=1,ntar
   85 ib(i6+l-1)=1
      l=0
      do 125 j4=1,itran
      j6=1
      j7=1
      j8=0
      i7=nvar+i6
c   Read transformation card
      call MARKY(a(i7),1,3,a,ncar,ierror)
      if(ierror.gt.0) return
c   Check for for statement
      if(a(i7).ne.az(10)) go to 90
      if(a(i7+1).ne.az(4).or.a(i7+2).ne.az(11)) go to 220
      do 86 j=1,3
   86 a(i7+j)=az(j)
      j=i7+3
   87 j=j+1
      if(j.gt.i7+30) go to 220
      if(a(j).ne.az(12)) go to 87
      a(j)=az(5)
      call DECODS(a,i7,id,v)
c   Set limits of for do loop
      j6=id(3)
      j7=id(5)
      if(j6.gt.j7) go to 220
      j8=1
      do 88 j5=1,484
      a(i9+j5-1)=a(i7+j5)
      if(a(i9+j5-1).eq.az(5)) go to 90
   88 continue
      go to 220
c   Loop over do loop
   90 do 125 i=j6,j7
      if(j8.eq.0) go to 94
      i7=i6+nvar
      j=0
      j9=0
   91 j=j+1
      j5=0
      if(a(i9+j-1).eq.az(7)) go to 92
      j5=1
      if(a(i9+j-1).eq.az(9).and.((j.ne.1.and.j.ne.4).or.(j.eq.1.and.a(i9
     1+1).ne.az(10)).or.(j.eq.4.and.(a(i9+1).ne.az(10).or.a(i9+2).ne.az(
     22))))) go to 92
      j9=j9+1
      a(i7+j9-1)=a(i9+j-1)
      go to 93
   92 call TRANSL(a(i9),a(i7),j,j9,i,j5,ierror)
      if(ierror.gt.0) go to 220
      go to 91
   93 if(a(i7+j9-1).ne.az(5)) go to 91
   94 l=l+1
      a(i8+6*l-5)=0.
c   Check for if statement
      if(a(i7).ne.az(9)) go to 120
      if(a(i7+1).ne.az(10)) go to 220
      call DAVID(a(i7+2),j5)
c   Branch if iftime or ifcros
      if(j5.eq.3.or.j5.eq.20) go to 95
      if(j5.le.27) go to 220
      a(i8+6*l-5)=3.
      a(i7)=az(1)
      a(i7+1)=az(4)
      a(i7+2)=az(3)
      go to 105
   95 i7=i7+1
      call MYRON(a(i7+2),j)
      if(j.eq.18) go to 100
      if(j.ne.22) go to 220
      go to 95
  100 do 102 j=1,3
  102 a(i7+j-1)=az(j)
      a(i8+6*l-5)=2.
      if(j5.eq.20) a(i8+6*l-5)=1.
  105 j=i7+2
  110 j=j+1
      if(j.gt.i7+30) go to 220
      if(a(j).ne.az(12)) go to 110
      a(j)=az(5)
c   Decode if statement
      i7=i7-1
      call DECODS(a,i7,id,v)
      i7=i7+1
      if(id(1).le.0.or.id(1).ne.21) go to 220
      do 115 j=1,3
  115 a(i8+6*l-5+j)=id(j+2)
      a(i8+6*l-1)=v
      if(a(i8+6*l-5).eq.3..and.id(4).eq.0) a(i8+6*l-3)=1.
      if(id(5).lt.0) a(i8+6*l-2)=0.
      if(a(i8+6*l-5).le.2..and.id(3).le.0) a(i8+6*l-4)=1.
      if(a(i8+6*l-5).eq.1..and.id(5).le.0) a(i8+6*l-2)=ntime
      if(a(i8+6*l-5).eq.2..and.id(5).le.0) a(i8+6*l-2)=max0(100000,nobs)
      if((a(i8+6*l-5).le.2..and.a(i8+6*l-4).gt.a(i8+6*l-2)).or.(a(i8+6*l
     1-5).eq.3..and.(id(3).le.0.or.id(3).gt.nvar.or.id(5).gt.nvar))) go
     2to 220
  120 a(i8+6*l)=j2
c   Call RDREST which processes transformation
      call RDREST(ib(i3),ib(i4),aa(j0),j2,a(i7),aa(j1),aa(j1),aa(j1),ib(
     1i5),0,ib(i6),nvar,j5,2,j,ierror)
      if(ierror.gt.0) go to 220
  125 continue
      itran=l
      j6=6*itran
      j7=i8+1
      i8=kcore-484-6*itran
      do 127 l=1,j6
  127 a(i8+j6-l)=a(j7+j6-l)
      nvar=ntar
      j5=0
      do 135 l=1,itran
      if(ib(i6+l+ntar-1).eq.0) go to 130
      if(j5.eq.1) go to 220
      nvar=l+ntar
      go to 135
  130 j5=1
  135 continue
c   Read transformation variable names not read
      if(inam.eq.0.and.nvar.ne.ncar) call VARNAM(a(i7),a,ncar,nvar,
     1ierror)
      i6=i8-j2-1
      do 140 l=1,j2
  140 ib(i6+j2-l)=ib(i5+j2-l)
      i5=i6-j2-1
      do 145 l=1,j2
  145 ib(i5+j2-l)=ib(i4+j2-l)
      i4=i5-j2-1
      do 150 l=1,j2
  150 ib(i4+j2-l)=ib(i3+j2-l)
      i3=(i4-2*j2-4)/2
      do 155 l=1,j2
  155 aa(i3+j2-l)=aa(j0+j2-l)
      return
  190 ierror=1
      return
  200 i=max0(j5-4,1)
      call ERRWRT(0,a(i),8,0,0,v)
  205 ierror=2
      return
  210 ierror=3
      return
  220 ierror=7
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CONMAS        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads and processes master control card.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   DECODS  ERRWRT  
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CONMAS(a,vnam,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension a(1),ni(2,51),id(5),vnam(1)
      double precision v,epsg,epsp,epsf,fetol,stpsim
c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,dum(3)
      common /b/ a4(5),nobs,nvar,ntime,a2(26),mi1,mi2,dumb(8)
      common /c/ jj(32),vj,iwt,a3(3),kfetol,dum1(2)
      common /c3/ fetol
      common /d/ k,n,jb,kobs,a7(4),igmm,lz,lp,my,ny,l1,a1(3),iccn,iqz,
     1a8(4),la
      common /f/ a5(20),epsg,epsp,epsf,maxite,a6(4),iout,dumf(4)
c********************
      common /k/ jeff,JOFunc,izprt
      common /simp1/ last,istsim,ipb,jcc,NUMER
      common /simp2/ stpsim
c********************
c------------------------DATA STATEMENTS---------------------------------
c NI         | 1  |  2 |  3  |  4  |  5  |  6 | 7 | 8  |  9 | 10 |
      data ni/5,17,20,9,20,25,16,19,19,20,20,3,5,3,9,16,19,3,16,3,
c    |11  | 12 | 13 |14 | 15  | 16 | 17 | 18 | 19  | 20  | 21  | 22 | 
     $5,19,3,14,3,23,8,5,14,15,18,5,12,1,20,5,20,19,20,12,15,16,18,1,
c    | 23  | 24  | 25  | 26  | 27 | 28  | 29 | 30 | 31  | 32 | 33 |
     $18,16,18,23,13,23,21,20,21,3,21,15,9,20,19,5,13,15,6,15,19,9,
c    | 34 | 35 | 36  | 37 |38 | 39 | 40 | 41 |42 | 43  | 44 | 45 |
     $18,8,7,20,16,20,6,20,9,9,13,9,3,15,23,5,6,5,15,21,13,1,14,6,
c    | 46  | 47  | 48 | 49 | 50  | 51  |
     $19,12,19,19,15,5,15,6,14,21,26,16/
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Set defaults for options
      do 10 i=4,30
   10 jj(i)=0
      vj=0.
      jj(1)=1
      jj(14)=6
      jj(26)=1
      jj(27)=ntime
      jj(2)=ntime
      la=ntime
      jeff=0
      JOFunc=0
      NUMER=0
      izprt=0
      if(nobs.eq.1) la=0
      kobs=nobs
      jj(3)=-1
      jj(31)=1
      jj(32)=nobs
      maxite=50
      epsg=.00001d0
      epsp=.0001d0
      epsf=.0000001d0
      fetol=.00001d0
      stpsim = 1.d0
      istsim = 0
      last = 1
      igmm=0
      sec=5.
      jb=-1
      l1=0
      lz=0
      iqz=0
c****************************************
c  Change made to avoid problems with 'miss' option,
c  set the default at miss=2.  Then it can be undone.
c      mi2=0
      mi2=2
c****************************************
      iccn=0
      iwt=0
      iout=0
c   Decode master card for general program options
      j5=0
   30 call DECODS(a,j5,id,v)
      if(id(1)) 205,50,35
   35 if(id(1).eq.21.or.id(1).eq.24) go to 46
      do 40 l=1,51
      if(id(1).eq.ni(1,l).and.id(2).eq.ni(2,l)) go to 43
   40 continue
      go to 200
   43 if(l.le.25) go to 44
      if(l.eq.30) sec=v
      if(l.eq.29) maxite=id(3)
      if(l.eq.31) jb=id(3)
      if(l.eq.32.and.id(3).lt.0) go to 200
      if(l.eq.32) l1=id(3)
      if(l.eq.33) igmm=id(3)
      if(l.eq.34) lz=id(3)
      if(l.eq.35) epsg=v
      if(l.eq.36) epsp=v
      if(l.eq.37) epsf=v
      if(l.eq.38) iqz=id(3)
      if(l.eq.39.and.mi1.ne.0) mi2=ifix(sngl(v))
      if(l.eq.40) iccn=id(3)
      if(l.eq.41) iwt=id(3)
      if(l.eq.42) fetol=v
      if(l.eq.43) iout=id(3)
      if(l.eq.44) la=id(3)
      if(l.eq.45) jeff=id(3)
      if(l.eq.46) stpsim=v
      if(l.eq.47) istsim=id(3)
      if(l.eq.48) jeff=id(3)
      if(l.eq.49) JOFunc=id(3)
      if(l.eq.50) NUMER=id(3)
      if(l.eq.51) izprt=id(3)
      go to 30
   44 jj(l)=id(3)
      if(l.eq.17.or.l.eq.20) jj(l)=id(3)+1
      go to 30
   46 if(id(2)-15) 49,48,47
   47 if(id(3).eq.0) id(3)=1
      if(id(5).eq.0) id(5)=ntime
      jj(26)=id(3)
      jj(27)=id(5)
      jj(2)=id(5)-id(3)+1
      if(id(5).gt.ntime.or.id(3).gt.id(5).or.id(3).le.0) go to 210
      if(id(1).eq.21) go to 30
      jj(26)=id(5)+1
      jj(27)=id(3)
      jj(2)=ntime-jj(26)+jj(27)
      go to 30
   48 jj(29)=id(3)
      jj(30)=id(5)
      vj=v
      if(id(4).eq.0) id(4)=1
      jj(28)=id(4)
      go to 30
   49 if(id(3).eq.0) id(3)=1
      if(id(5).eq.0) id(5)=nobs
      jj(31)=id(3)
      jj(32)=id(5)
      kobs=id(5)-id(3)+1
      if(id(3).le.0.or.id(5).gt.nobs.or.id(3).gt.id(5)) go to 210
      if(id(1).eq.21) go to 30
      jj(31)=id(5)+1
      jj(32)=id(3)
      kobs=nobs-jj(31)+jj(32)
      go to 30
   50 if(jj(3).lt.0.or.jj(1).lt.1) go to 210
c   Reset program controls
      if(iqz.gt.0) kobs=1
      if(iqz.gt.0.and.(jj(5).eq.2.or.jj(5).eq.4)) jj(9)=1
      if(jj(3).ne.2) jj(14)=0
      if(jeff.gt.0) jj(4)=3
      if(jj(3).eq.2.and.(jj(2).eq.1.or.jj(22).ne.2)) jj(4)=0
      if((jj(3).eq.2.or.jj(3).eq.3).and.jj(4).eq.3) jj(4)=0
      if(jj(17).eq.0.or.jj(17).ge.jj(2)) jj(17)=jj(2)
      if(jj(20).eq.0) jj(20)=jj(17)
      la=la+1
      if(la.ge.jj(2)) la=0
      if(jj(3).eq.2.and.jj(22).le.1) la=0
      if(jj(3).ne.4) jj(25)=0
      if((jj(15).gt.0.or.jj(1).eq.1).and.mi2.eq.1) mi2=2
      if((jj(6).eq.3.or.jj(7).eq.3).and.jj(3).ne.3.and.(jj(5).eq.1.or.jj
     1(5).eq.3)) jj(5)=jj(5)-1
      if(jj(3).ne.3) jj(21)=0
c   Check for consistancy errors in options
      if(jj(11).eq.7) go to 210
      if((jj(3).eq.1.and.jj(5).ge.3).or.(jj(3).ne.3.and.(jj(5).eq.1.or.j
     1j(18).gt.0)).or.(jj(18).eq.0.and.jj(19).gt.0).or.jj(20).lt.jj(17).
     2or.jj(3).gt.4.or.(jj(6).gt.0.and.(jj(3).eq.4.or.jj(3).eq.2.or.jj(2
     3).le.1)).or.(jj(3).eq.2.and.((jj(22).eq.2.and.jj(1).le.1).or.(jj(2
     42).le.1.and.jj(2).le.1))).or.(jj(15).eq.1.and.jj(5).eq.3)) go to 2
     110
      if((jj(15).gt.0.and.jj(5).gt.1.and.jj(5).ne.3).or.(jj(3).eq.2.and.
     1(jj(14).lt.1.or.jj(14).gt.9)).or.nvar.lt.1.or.(jj(3).eq.4.and.jj(1
     2).lt.2).or.(jj(7).gt.0.and.(jj(1).lt.2.or.jj(3).eq.4.or.jj(3).eq.2
     3)).or.iwt.gt.nvar) go to 210
c$$$$$$$$$$$$$$$$$$$$$$$
      if((jeff.gt.0.or.JOFunc.gt.0).and.((jj(3).eq.2.and.jj(4).eq.0).or.
     1jj(15).gt.0)) go to 210
c$$$$$$$$$$$$$$$$$$$$$$$
c   Check for variables out of bounds
      if(jj(28).gt.0.and.(jj(29).eq.0.or.jj(29).gt.nvar.or.jj(30).gt.nva
     1r)) go to 220
      return
  200 i=j5-4
      call ERRWRT(0,a(i),8,0,0,v)
  205 ierror=2
      return
  210 ierror=3
      return
  220 ierror=4
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CPRINT        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Prints headings and page numbers
c
c   This subroutine is called by the following subroutines:
C   VINCEN  CARDRD  FLEPOW  HEADNG  PRINTA  PRINTB  READOM  RESIDL  
C   SEARCH  STEDE  CONTIM  PRINTC  BPRINT  PREPOR  PREPRS  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CPRINT(id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension c(2),a(2)
      character*20 filep
c   Character*9 datex
c   Character*8 timex
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a23(1),ipc,a1(5),kcore,idim,ipk,t(20),m8,m9,m10,
     *a6(6),lwi,dum(3)
      common /punch/ filep
      common /hess/ ll1,ihhh,lle
      common /k/ jeff,JOFunc,izprt
c------------------------DATA STATEMENTS---------------------------------
      data c/4hPage,4H No./
c** change ** a(1),a(2) Can be changed in the print for date, etc.
      data a/4HHotz,4HTran/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      m9=m9+1
      m8=6
      if(id.gt.10) go to 20
      if(id.eq.5) go to 15
      if(lwi.eq.0) write(ip,10) (t(i),i=1,20),c(1),c(2),m9
   10 format('1',1x,2x,2x,10('*'),1x,20a4,1x,10('*'),3x,2a4,i4,/)
      if(lwi.eq.1) write(ip,12) (t(i),i=1,20)
   12 format(//,1x,19a4,a3,/)
      return
   15 if(lwi.eq.0) write(ip,18)m10,c(1),c(2),m9,(t(i),
     1i=1,20)
   18 format('1',1x,2x,31x,'M O D E L   N U M B E R',i6,39x,
     12a4,i4,//15x,10('*'),1x,20a4,1x,10('*'),/)
      if(lwi.eq.1) write(ip,19) m10,(t(i),i=1,20)
      if(lwi.eq.1.and.izprt.eq.1) write(ipc,19) m10
   19 format(//,13x,14x,'M O D E L   N U M B E R',i4,7x//1x,
     119a4,a3,//)
      m8=14
      return
   20 i=id-10
      go to (25,35,45,55,65,75,85,95,105,125,135,145,245,
     &       345,445,545),i
   25 write(ip,30) c(1),c(2),m9
   30 format('1',1x,20x,10('-'),' Observation Vectors',
     1' Continued ',10('-'),28x,2a4,i4,2x/)
      m8=2
      return
   35 write(ip,40) c(1),c(2),m9
   40 format('1',1x,20x,10('-'),' Variable Statistics',
     1' Continued ',10('-'),28x,2a4,i4,2x/)
      return
   45 if(lwi.eq.0) write(ip,50) c(1),c(2),m9
   50 format('1',1x,23x,10('-'),' Moment Matrix Continued '
     1,10('-'),31x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,52) 
   52 format(//,1x,2x,10('-'),' Moment Matrix Continued ',
     110('-'),2x/)
      return
   55 if(lwi.eq.0) write(ip,60) c(1),c(2),m9
   60 format('1',21x,10('-'),' Correlation Matrix Continued ',
     110('-'),29x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,57)
   57 format(//,1x,2x,10('-'),' Correlation Matrix Continued ',
     110('-'),2x/)
      return
   65 write(ip,70) m10,c(1),c(2),m9
   70 format('1',1x,21x,10('-'),' Model Number',i4,
     1' Continued ',10('-'),30x,2a4,i4,2x/)
      m8=4
      return
   75 if(lwi.eq.0) write(ip,80) c(1),c(2),m9,kcore
   80 format('1',2x,26x,10('*'),' Data Control Cards ',10('*'),
     134x,2a4,i4,//41x,'Allowable Words of Core ',8('.'),i8)
      if(lwi.eq.1) write(ip,84) kcore
   84 format('1',11x,10('*'),' Data Control Cards ',10('*'),2x/30x
     1,'Allowable Words of Core ',8('.'),i8)
      return
   85 if(lwi.eq.0) write(ip,90) c(1),c(2),m9
   90 format('1',1x,26x,10('*'),' RUN CONTROL CARDS ',10('*'),
     134x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,92) 
   92 format(//,8x,12x,10('*'),' RUN CONTROL CARDS ',10('*'),2x/)
      return
   95 if(lwi.eq.0) write(ip,100) c(1),c(2),m9
  100 format('1',1x,21x,10('-'),' Coefficient Starting Values ',
     110('-'),29x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,102)
  102 format(///20x,'----- Coefficient Starting Values -----')
      return
  105 if(lwi.eq.0) write(ip,110) c(1),c(2),m9
  110 format('1',1x,19x,'***** Behavior Under Steepest Descent',
     1' Iterations ****',27x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,112) 
  112 format(//,2x,9x,' ***** Behavior Under Steepest Descent',
     1' Iterations *****',2x)
      if(lwi.eq.0) write(ip,115)
  115 format(9x,'Iteration  Try    Abscissa',10x,'Slope',6x,'Function',
     1' Value   Function Cng%    Max. Gradient    Max. Para. Cng%',
     2/9x,113('-'))
      if(lwi.eq.1) write(ip,117)
  117 format(/,'Iter  Step_Size    Slope    Function   Func_Chg%',
     &     '     Gradient       Para_Chg%',/79('-'))
      return
  125 if(lwi.eq.0) write(ip,130) c(1),c(2),m9
  130 format('1',1x,19x,'***** Behavior Under Fletcher Powell',
     1' Iterations ****',27x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,132)
  132 format(//,2x,10x,' ***** Behavior Under Fletcher Powell',
     1' Iterations *****',2x)
      if(lwi.eq.0) write(ip,115)
      if(lwi.eq.1) write(ip,117)
      return
  135 write(ip,140) c(1),c(2),m9
  140 format('1',1x,26x,'*****',5x,'Iterations Continued',
     15x,'****',34x,2a4,i4,2x/)
      if(lwi.eq.0) write(ip,115)
      return
  145 if(lwi.eq.0) write(ip,150) c(1),c(2),m9
  150 format('1',1x,28x,'-----',5x,'Matrix Continued',
     15x,'----',36x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,152)
  152 format(//,21x,'-----     Matrix Continued     -----',/)
      return
  245 if(lwi.eq.0) write(ip,246) c(1),c(2),m9
  246 format('1',1x,18x,'***** Behavior Under Downhill Simplex',
     1' Iterations ****',27x,2a4,i4,2x/)
      if(lwi.eq.1) write(ip,247) 
  247 format(//,12x,' ***** Behavior Under Downhill Simplex',
     1' Iterations *****',2x)
  248 write(ip,249)
  249 format(/,12x,'Iter',5x,'Function Value',3x,'Fract. ',
     &  'Range: High - Low Values',/12x,57('-'))
      return
 345  write(ip,346)
 346  format(/6x,'***** Based on CHOLESKY FACTORIZATION, Matrix Being',
     &    ' Inverted *****',/6x,'*****                   ',
     &    'is Truly SINGULAR                    *****'/)
      return
 445  write(ip,446) ihhh
 446  format(/,12x,'** Hessian Condition of Matrix ',
     &    'Being Inverted = ',i3,' **')
      return
 545  write(ip,546)
 546  format(//,4x,'** Inconsistent Options.  You must use type=1',
     &' with ofunc > 0 Option **')
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DANNYP        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes chi-square test of restrictions
c
c   This subroutine calls the following subroutines:
C   MATIN5  
c
c   This subroutine is called by the following subroutines:
C   STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DANNYP(f,im,lars,y,vb,wk,xd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision f,y(1),vb(1),wk(1),xd(1),det
      dimension lars(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l=0
      do 10 i=1,im
      do 10 j=1,i
      l=l+1
      i1=IYYM(lars(i),lars(j))
   10 xd(l)=vb(i1)
      call MATIN5(im,xd,xd,wk,det,1,l)
      f=0.d0
      if(l.gt.0) return
      l=0
      do 15 i=1,im
      i1=lars(i)
      do 15 j=1,i
      i2=lars(j)
      l=l+1
      if(j.ne.i) f=f+xd(l)*y(i1)*y(i2)
   15 f=f+xd(l)*y(i1)*y(i2)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DASORT        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads and fills observation vector.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DASORT(xbata,xdata,tar,lar,nar,joe,loe,moe,koe,xx,j3,
     1i0,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision vrs,crs,fx,gx,xx(1)
      dimension xbata(idim,nvar),xdata(jb,1),lar(1),nar(1),tar(me,11),
     1joe(1),loe(k,nt),moe(k,me),koe(3,me)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(2),int,iqv,nobs,nvar,ntime,kcore,idim,a5(21),m8,
     1a9(2),mi1,mi2,a6(2),mtime,jobs,lwi,dum(3)
      common /c/ me,nt,a2(6),iscal,a8(5),nl,a0(7),ires,a3(2),iut1,iut2,
     1iu1,iu2,iu3,iu4,iu5,vr,iwt,kvrs,jwt,ifxi,dumc(3)
      common /c2/ vrs
      common /d/ k,nn,jb,kobs,lv,a4(12),mobs,iqz,inz,dumd(4)
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      mit=iut1-1
      if(iut2.lt.iut1) mit=0
      n=1
      mobs=0
      nn=0
      vrs=0.d0
      crs=0.d0
      jwt=0
      if(iwt.gt.0) jwt=k
      i3=1
      if(iqv.eq.0) i3=0
      do 5 i=1,3
      do 5 j=1,me
    5 koe(i,j)=0
      i=0
      i1=0
      do 60 l8=1,jobs
      if(iqv.gt.0) read(int) (xbata(1,l),l=1,nvar)
      if(iqv.eq.0) i3=i3+1
      l5=0
      if(mtime.eq.0) go to 7
      l7=xbata(i3,mtime)
      if(l7.le.i1.and.i.gt.0) go to 32
    6 if(l7.le.i1.or.i.eq.0) l5=1
      i1=iabs(l7)
      go to 8
c   Loop over time periods
    7 i1=i1+1
      if(i1.gt.ntime.or.i.eq.0) l5=1
      if(l5.eq.1) i1=1
    8 if(l5.eq.0) go to 10
      i4=0
      l3=0
      fx=0.d0
      gx=0.d0
      i=i+1
      do 9 l=lv,jb
    9 xdata(l,n)=-1.
c   Eliminate unwanted time periods/observations
   10 if(iu5.ge.iu4.and.i.gt.iu5) go to 65
      if((iu5.ge.iu4.and.i.lt.iu4).or.(iu5.lt.iu4.and.i.ge.iu5.and.i.lt.
     1iu4).or.(iut2.ge.iut1.and.(i1.lt.iut1.or.i1.gt.iut2)).or.(iut2.lt.
     2iut1.and.i1.ge.iut2.and.i1.lt.iut1)) go to 30
      i2=i1-mit
      if(i1.gt.iut2) i2=i1-(iut1-iut2)
      i9=1
      if((iu1.gt.0.and.iu3.gt.0.and.IOBS(xbata(i3,iu2),xbata(i3,iu3),iu1
     1).eq.0).or.(iu1.gt.0.and.iu3.le.0.and.IOBS(xbata(i3,iu2),vr,iu1).e
     2q.0)) i9=2
      i5=0
      mi=0
c   Fill in dependent variables by equation
      do 20 j=1,me
      mj=0
      if(i9.eq.2) go to 17
      if((tar(j,8).le.tar(j,9).and.(i.lt.tar(j,8).or.i.gt.tar(j,9))).or.
     1(tar(j,8).gt.tar(j,9).and.i.ge.tar(j,9).and.i.lt.tar(j,8))) go to
     217
      if(tar(j,1).eq.0.) go to 11
      l=tar(j,2)
      i7=tar(j,1)
      i8=tar(j,3)
c   Check if this observation/time period used for this equation
      if(i8.gt.0.and.IOBS(xbata(i3,l),xbata(i3,i8),i7).eq.0) go to 17
      if(i8.le.0.and.IOBS(xbata(i3,l),tar(j,4),i7).eq.0) go to 17
   11 i7=joe(3*me+j)
      if(joe(j).eq.9) go to 12
      if(MISS(xbata(i3,i7)).ne.0) mj=1
      xdata(lv+i5+i2,n)=0.
c   Fill in dependent variable
      l=tar(j,5)
      if(l.le.0.or.joe(j).eq.8) go to 13
      i8=tar(j,6)
      if(i8.gt.0.and.MISS(xbata(i3,i8)).ne.0) mj=1
      s=tar(j,7)
      if(i8.gt.0) s=xbata(i3,i8)
      r=IOBS(xbata(i3,i7),s,l)
      xdata(lv+i5+i2,n)=r
      if(joe(j).le.1) go to 14
      if(r.le.0..and.(joe(j).eq.6.or.joe(j).eq.7)) go to 17
      if(r.gt.0.) xdata(lv+i5+nt+i2,n)=xbata(i3,i7)
      if(r.le.0.) xdata(lv+i5+nt+i2,n)=s
      if(r.gt.0.) xdata(lv+i5+i2,n)=abs(xbata(i3,i7)-s)+2.
      if(r.le.0..and.(joe(j).eq.3.or.joe(j).eq.5)) xdata(lv+i5+i2,n)=1
      if(r.le.0.or.(joe(j).ne.4.and.joe(j).ne.5)) go to 14
      i8=6-joe(j)
      r=IOBS(xbata(i3,i7),0.,i8)
      if(r.gt.0.) go to 14
      xdata(lv+i5+i2,n)=float(5-joe(j))
      xdata(lv+i5+nt+i2,n)=s
      go to 14
   12 xdata(lv+i5+i2,n)=2.
      xdata(lv+i5+nt+i2,n)=0.
      go to 14
   13 if(joe(j).le.1) xdata(lv+i5+i2,n)=float(IOBS(xbata(i3,i7),0.,1))
      if(joe(j).eq.6.and.xbata(i3,i7).le.0.) go to 17
      if((joe(j).ge.6.and.joe(j).le.8).or.(joe(j).eq.2.and.xbata(i3,i7).
     1gt.0.)) xdata(lv+i5+i2,n)=2.+abs(xbata(i3,i7))
      if(joe(j).ge.2) xdata(lv+i5+nt+i2,n)=xbata(i3,i7)
   14 if(mi2.eq.0) go to 16
      if(mj.eq.1) go to 17
      do 15 l=1,nvar
      if(nar(l).eq.0) go to 15
      i8=nar(l)
      if(moe(i8,j).le.11.and.MISS(xbata(i3,l)).ne.0) mj=1
   15 continue
      if(mj.eq.1) go to 17
   16 i4=i4+1
      i9=0
      go to 18
   17 xdata(lv+i5+i2,n)=-1.
   18 if(joe(j).ge.2) i5=i5+nt
      mi=mi+mj
   20 i5=i5+nt
      if(i9.ne.0) go to 30
      if(mi2.lt.2.or.mi.eq.0) go to 24
      i5=0
      do 22 l=1,me
c********************************
c Correction made by Hotz 3/31/88
c    if(xdata(lv+i5+i2,n).lt.0.) go to 22
      if(xdata(lv+i5+i2,n).lt.0.) go to 21
      xdata(lv+i5+i2,n)=-1.
      i4=i4-1
c   If(joe(l).ge.2) i5=i5+nt
   21 if(joe(l).ge.2) i5=i5+nt
c*******************************
   22 continue
      go to 30
c   Fill in independent variables
   24 l3=l3+1
      do 25 l=1,nvar
      if(nar(l).eq.0.or.(l3.gt.1.and.lar(l).eq.11)) go to 25
      i5=nar(l)
      i7=loe(i5,i2)
      xdata(i7,n)=xbata(i3,l)
   25 continue
      if(iwt.eq.0) go to 29
      i7=loe(jwt,i2)
      if(l3.eq.1.or.(lar(iwt).ne.1.and.lar(iwt).ne.11)) xdata(i7,n)=xbat
     1a(i3,iwt)
      if(xdata(i7,n).le.0.) go to 26
      fx=fx+dble(xdata(i7,n))
      gx=gx+1.d0
      go to 29
   26 i5=0
      do 28 l=1,me
      if(xdata(lv+i5+i2,n).lt.0.) go to 27
      xdata(lv+i5+i2,n)=-1.
      i4=i4-1
   27 if(joe(l).ge.2) i5=i5+nt
   28 i5=i5+nt
   29 if(l3.gt.1.or.lar(nvar+1).lt.11) go to 30
      i5=nar(nvar+1)
      i7=loe(i5,i2)
      xdata(i7,n)=1.
   30 if((mtime.eq.0.and.i1.lt.ntime).or.(mtime.gt.0.and.l8.lt.jobs)) go
     1 to 60
   32 if(nt.lt.2.or.ifxi.eq.0) go to 39
c   Check for constant observations with fixed effect and tobit/probit
      i5=0
      do 38 j=1,me
      if(joe(2*me+j).le.0) go to 37
      xdata(lv-me+j,n)=tar(j,10)
      if(joe(j).ge.6) go to 37
      i7=0
      r=-1.
      do 35 l=1,nt
      if(xdata(lv+i5+l,n).lt.0.) go to 35
      i7=i7+1
      if(xdata(lv+i5+l,n).ge.2.) go to 37
      if(xdata(lv+i5+l,n).ne.r.and.r.ge.0.) go to 37
      r=xdata(lv+i5+l,n)
   35 continue
      do 36 l=1,nt
   36 xdata(lv+i5+l,n)=-1.
      if(i7.gt.0) i4=i4-i7
   37 if(joe(j).ge.2) i5=i5+nt
   38 i5=i5+nt
   39 if(i4.eq.0) go to 55
      if(ires.gt.0) xdata(jb,n)=i
      if(iwt.gt.0) vrs=vrs+fx
      if(iwt.gt.0) crs=crs+gx
      if(m8.eq.0) go to 48
c   Check for deviations about cross-sectional means
      do 42 l=1,nvar
      if(lar(l).ne.12) go to 42
      gx=0.d0
      i5=nar(l)
      do 40 i2=1,nt
      i7=loe(i5,i2)
   40 gx=gx+dble(xdata(i7,n))
      gx=gx/dble(nt)
      do 41 i2=1,nt
      i7=loe(i5,i2)
   41 xdata(i7,n)=xdata(i7,n)-gx
   42 continue
      i5=0
      do 46 l=1,me
      i2=joe(3*me+l)
      if(joe(l).ne.8.or.(lar(i2).ne.2.and.lar(i2).ne.12)) go to 45
      gx=0.d0
      fx=0.d0
      do 43 i2=1,nt
      if(xdata(lv+i5+i2,n).lt.0.) go to 43
      gx=gx+dble(xdata(lv+i5+nt+i2,n))
      fx=fx+1.d0
   43 continue
      if(fx.eq.0.) go to 45
      gx=gx/fx
      do 44 i2=1,nt
      if(xdata(lv+i5+i2,n).lt.0.) go to 44
      xdata(lv+i5+nt+i2,n)=xdata(lv+i5+nt+i2,n)-gx
   44 continue
   45 if(joe(l).ge.2) i5=i5+nt
   46 i5=i5+nt
   48 mobs=mobs+i4
      if(iqz.eq.0) go to 51
c$$$$$$$$$$$$$$$$$$$$$$$
      if(nl.gt.0.or.iscal.gt.0.or.jeff.gt.0.or.JOFunc.gt.0) go to 50
c$$$$$$$$$$$$$$$$$$$$$$$
c   Scale data on disk
      l=0
      do 49 j=1,k
      i2=1
      if(nt.gt.1.and.loe(j,1).ne.loe(j,2)) i2=nt
      do 49 i8=1,i2
      l=l+1
   49 xdata(l,n)=xdata(l,n)*xx(j)
   50 write(inz) (xdata(i1,n),i1=1,jb)
   51 if(n.gt.kobs) go to 90
   52 nn=nn+1
      i5=0
      do 54 j=1,me
      l=0
      do 53 i2=1,nt
      if(xdata(lv+i5+i2,n).ge.0.) l=l+1
      if(xdata(lv+i5+i2,n).eq.0.) koe(2,j)=koe(2,j)+1
      if(xdata(lv+i5+i2,n).eq.1.) koe(3,j)=koe(3,j)+1
   53 continue
      if(l.gt.0) tar(j,11)=tar(j,11)+1.
      koe(1,j)=koe(1,j)+l
      if(joe(j).ge.2) i5=i5+nt
   54 i5=i5+nt
      if(iqz.eq.0) n=n+1
   55 if(mtime.gt.0.and.l8.lt.jobs) go to 6
   60 continue
   65 if(iqv.gt.0) rewind int
      if(iqz.gt.0) end file inz
      if(iqz.gt.0) rewind inz
      if(iqz.eq.0) kobs=n
      if(iwt.gt.0) vrs=vrs/crs
      if(lwi.eq.0) write(ip,70)
   70 format(///41x,'Run Data',5x,'Cross-',3x,'Total',4x,'Lower',6x,'Upp
     1er',/53x,'Sections',2x,'Obsv.',2(2x,'Masspoint'),/)
      if(lwi.eq.1) write(ip,72)
   72 format(//15x,'Run Data',5x,'Cross-',3x,'Total',4x,'Lower',6x,'Uppe
     1r',/27x,'Sections',2x,'Obsv.',2(2x,'Masspoint'),/)
      do 78 i=1,me
      j=tar(i,11)
      if(lwi.eq.0) write(ip,74) i,j,(koe(i2,i),i2=1,3)
   74 format(41x,'Equation',i3,i6,2i9,i11)
      if(lwi.eq.1) write(ip,76) i,j,(koe(i2,i),i2=1,3)
   76 format(15x,'Equation',i3,i6,2i9,i11)
   78 continue
      j3=i0+kobs*jb
      i4=nvar+1
      do 80 i=1,i4
      if(nar(i).le.0) go to 80
      l=nar(i)
      joe(j3+l-1)=i
   80 continue
      do 85 i=1,me
      if(joe(i).ne.3.and.joe(i).ne.5) go to 85
      i2=koe(3,i)
      koe(3,i)=koe(2,i)
      koe(2,i)=i2
   85 continue
      return
   90 ierror=-(nobs*nn/i)*jb
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DATAON        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads and processes data control card
c
c   This subroutine calls the following subroutines:
C   CONDAT  READOM  ERRCHK  
c
c   This subroutine is called by the following subroutines:
C   MAIN PROGRAM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DATAON(ab,ib,aa,i1,j1)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension ab(1),vb(12),ib(1)
      double precision aa(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a3(4),iqv,nobs,nvar,ntime,kcore,idim,ipk,
     1a1(20),m8,m9,a2(4),inam,mtime,jobs,dum(4)
      common /c/ inn,ipr,ifm,isz,jcore,itran,ntar,imin,imax,lcore,
     *dumc(30)
c------------------------DATA STATEMENTS---------------------------------
      data vb/1Hc,1Ho,1Hn,1Hs,1Ht,1Ha,1Hu,1Hm,1Hb,1He,1Hr,1H /
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Set control card printer
      ipk=0
      m9=0
      i6=kcore-481
c   Call CONDAT which reads the data control card/transformations
      call CONDAT(ab,ab(i6),aa,ib,m3,m4,m5,m6,m2,ierror)
      if(ifm.ne.1) i6=kcore
      if(itran.eq.0) m3=(i6-1)/2
      if(ierror.gt.0) go to 200
      jobs=nobs*ntime
      if(mtime.gt.0) jobs=nobs
      i1=(nvar+1)*9+1
      if(inam.eq.0) go to 28
c   Number variables
      do 27 i4=1,nvar
      j1=(i4-1)*9
      ab(j1+1)=vb(3)
      do 26 j=2,6
   26 ab(j1+j)=vb(j+5)
      ab(j1+7)=vb(12)
   27 ab(j1+8)=vb(12)
   28 ab(i1-3)=vb(3)
      ab(i1-2)=vb(5)
      do 29 j=1,6
   29 ab(i1-10+j)=vb(j)
      ab(i1-1)=8.
      if(iqv.eq.1.and.ipr.eq.0) go to 170
      i4=m3*2-nvar-2
      i7=i4-imax+imin-2
      j1=(i7-1)/2
      if(ipr.eq.0) go to 30
      i5=i7-3*nvar-1
      j1=(i5-1)/2-2*nvar-1
   30 j2=j1
      if(ipr.ge.3.or.iqv.ge.3) j2=j1-(nvar+1)*(nvar+2)/2-1
      lcore=jobs
      if(lcore.eq.0.and.(iqv.eq.0.or.iqv.eq.4.or.ifm.eq.3)) lcore=(j2*2-
     1i1)/nvar-1
      jcore=lcore
      if(iqv.ge.1.and.ifm.ne.3) jcore=1+imax-imin
      if(i1+jcore*nvar.gt.j2*2) go to 180
c   Call READOM which reads observations
      call READOM(ab,ab(i1),ab(i6),ab(i4),ab(i5),aa(j1),aa(j2),aa(m3),
     1ib(m4),ib(m5),ib(m6),ab(m2),ib(i7),ierror)
      if(ierror.gt.0) go to 200
  170 idim=jobs
      if(iqv.ne.0.and.iqv.ne.4) idim=1
      j1=(i1+nvar*idim+1)/2+1
      if(iqv.lt.3.and.ipr.lt.3) return
      i5=(nvar+1)*(nvar+2)/2
      do 175 i4=1,i5
  175 aa(j1+i4-1)=aa(j2+i4-1)
      return
  180 ierror=8
      inn=i1+nobs*ntime*nvar-j2*2
  200 call ERRCHK(ierror,inn)
      stop
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DAVID        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decodes alpha control card codes. 
c
c   This subroutine is called by the following subroutines:
C   CONDAT  DECODS  KWAST  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DAVID(a,k)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension b(28)
c------------------------DATA STATEMENTS---------------------------------
      data b/1Ha,1Hb,1Hc,1Hd,1He,1Hf,1Hg,1Hh,1Hi,1Hj,1Hk,1Hl,1Hm,1Hn,1Ho
     1,1Hp,1Hq,1Hr,1Hs,1Ht,1Hu,1Hv,1Hw,1Hx,1Hy,1Hz,1H=,1H /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 10 k=1,28
      if(a.eq.b(k)) return
   10 continue
      k=29
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DECODS        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decodes free format program options and variables
c
c   This subroutine calls the following subroutines:
C   DAVID  MYRON  ERRWRT  
c
c   This subroutine is called by the following subroutines:
C   CARDRD  CONBAS  CONDAT  CONMAS  CONTRL  MINREG  
c-----------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DECODS(a,j5,id,v)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension a(1),id(1)
      double precision v
c-------------------BEGINNING OF SUBROUTINE------------------------------
      j5=j5+1
      do 10 j=1,5
   10 id(j)=0
      v=0.d0
      call DAVID(a(j5),j)
      if(j.ge.29.or.j.eq.27) go to 140
      if(j.eq.28) return
      id(1)=j
      j5=j5+1
      call DAVID(a(j5),j)
      if(j.ge.27) go to 140
      id(2)=j
      if(id(1).eq.4.and.(id(2).eq.9.or.id(2).eq.21)) id(1)=9
      l=2
      if(id(1).ne.19.or.(id(2).ne.20.and.id(2).ne.1)) go to 15
      call DAVID(a(j5+1),j)
      if(j.ne.15.and.j.ne.13) go to 15
      id(4)=1
   13 j5=j5+1
      call DAVID(a(j5),j)
      if(j.eq.28) return
      l=l+1
      if(l.gt.6) go to 140
      go to 13
   15 j5=j5+1
      call DAVID(a(j5),j)
      if(j.eq.27) go to 20
      l=l+1
      if(j.ge.28.or.l.gt.6) go to 140
      go to 15
   20 if((id(1).ne.4.and.id(1).ne.21.and.id(1).ne.13.and.id(1).ne.23.and
     1.id(1).ne.24.and.id(1).ne.20).or.(id(1).eq.13.and.id(2).ne.15).or.
     2(id(1).eq.20.and.id(2).ne.9)) go to 70
      l=0
   25 j5=j5+1
      call DAVID(a(j5),j)
      l=l+1
      if(id(1).eq.23) go to 35
      if(id(1)-13) 32,27,40
   27 if(l.gt.1) go to 30
      if(j.eq.8) id(3)=2
      if(j.eq.5) id(3)=4
      if(j.eq.3) id(3)=8
      if(j.eq.13) id(3)=6
      if(j.eq.14) id(3)=10
      if(j.eq.15) id(3)=9
      if(j.eq.6) id(3)=11
      if(j.eq.16) id(3)=1
      if(j.eq.4) id(3)=5
      if(j.eq.20) id(3)=3
      if(j.eq.20) call DAVID(a(j5+1),id(4))
      if(j.eq.20.and.id(4).eq.18) id(3)=7
      if(j.eq.18) id(3)=9
      if(j.eq.9) id(3)=10
      if(j.ne.12.and.id(3).eq.0) go to 140
      go to 25
   30 if(j.eq.28) return
      if(l.gt.10) go to 140
      go to 25
   32 if((id(2).gt.3.and.id(2).ne.6).or.j.eq.22) go to 35
      j5=j5-1
      id(4)=-1
      go to 70
   35 if(j.ne.22) go to 140
      go to 70
   40 if(j.ne.22) go to 45
      if(id(2).eq.19) id(2)=15
      if(id(2).ne.15.and.id(1).ne.20) go to 140
      go to 70
   45 j5=j5-1
      if(id(2).eq.19.or.id(1).eq.20) id(2)=3
      go to 70
   50 if(j.eq.20.and.(id(1).eq.4.or.id(2).eq.15)) return
      call DAVID(a(j5),l)
      if(j.ne.11.and.l.ne.20) go to 140
      if(l.eq.20) go to 69
      if((id(1).eq.21.or.id(1).eq.24).and.id(2).ne.15) go to 140
      call DAVID(a(j5+1),j)
      call DAVID(a(j5+2),l)
      call MYRON(a(j5+3),id(4))
      j5=j5+3
      if(id(4).ne.11.or.(j.ne.7.and.j.ne.12.and.j.ne.5.and.j.ne.14)) go
     1to 140
      if(id(1).eq.24) go to 55
      id(4)=1
      if(j.eq.12.and.l.eq.20) id(4)=2
      if(j.eq.7.and.l.eq.5) id(4)=3
      if(j.eq.12.and.l.eq.5) id(4)=4
      if(j.eq.5) id(4)=5
      if(j.eq.14) id(4)=6
      go to 60
   55 id(4)=4
      if(j.eq.12.and.l.eq.20) id(4)=3
      if(j.eq.7.and.l.eq.5) id(4)=2
      if(j.eq.12.and.l.eq.5) id(4)=1
      if(j.eq.5) id(4)=6
      if(j.eq.14) id(4)=5
   60 id(5)=-1
      call DAVID(a(j5+1),j)
      if(j.ne.22) go to 85
      j5=j5+1
   61 id(5)=-1
   62 j5=j5+1
      call MYRON(a(j5),j)
      if(j.gt.10) go to 63
      if(id(5).lt.0) id(5)=0
      id(5)=id(5)*10+j-1
      go to 62
   63 if(id(5).lt.0) go to 140
      return
   69 call DAVID(a(j5+1),j)
      j5=j5+1
      if(j.ne.15) go to 140
      go to 61
   70 if((id(1).eq.19.and.id(2).eq.5).or.(id(2).eq.20.and.(id(1).eq.7.or
     1.id(1).eq.16.or.id(1).eq.6)).or.(id(1).eq.13.and.id(2).eq.9).or.(i
     2d(1).eq.6.and.id(2).eq.5).or.(id(1).eq.12.and.(id(2).eq.6.or.id(2)
     3.eq.19)).or.(id(1).eq.7.and.id(2).eq.1).or.(id(1).eq.19.and.id(2).
     4eq.12)) go to 85
      id(3)=-1
      if((id(1).ne.6.or.id(2).ne.15).and.(id(1).ne.20.or.id(2).ne.25)) g
     1o to 75
      call MYRON(a(j5+1),j)
      if(j.eq.18) return
      if(j.le.10) go to 75
      call DAVID(a(j5+1),j)
      if(j.ne.13.and.j.ne.3) go to 71
      id(3)=5
      if(j.eq.3) id(3)=6
      l=0
      go to 72
   71 call DAVID(a(j5+4),l)
      j5=j5+4
      if((j.ne.21.and.j.ne.24).or.(l.ne.13.and.l.ne.15.and.l.ne.18)) go
     1to 140
      id(3)=2
      if(l.eq.15) id(3)=3
      if(l.eq.13) id(3)=4
      l=4
   72 j5=j5+1
      call DAVID(a(j5),j)
      if(j.eq.28) return
      l=l+1
      if(j.eq.27.or.j.eq.29.or.l.gt.6) go to 140
      go to 72
   75 j5=j5+1
      call MYRON(a(j5),j)
      if(j.gt.10) go to 80
      if(id(3).lt.0) id(3)=0
      id(3)=id(3)*10+j-1
      go to 75
   80 if(id(1).eq.4.or.id(1).eq.21.or.id(1).eq.24) go to 50
      if(id(3).lt.0.or.(j.ne.20.and.j.ne.14)) go to 140
      return
   85 l=0
      ln=0
      v=0.d0
      lm=0
   90 j5=j5+1
      call MYRON(a(j5),j)
      l=l+1
      if(l.eq.1.and.(j.eq.14.or.j.eq.15)) go to 110
      if(j-11) 95,105,115
   95 if(lm.eq.0) v=v*10.d0+dble(j-1)
      if(lm.gt.0) v=v+dble(j-1)/(10.d0**lm)
      if(lm.gt.0) lm=lm+1
      go to 90
  105 if(lm.gt.0) go to 140
      lm=1
      go to 90
  110 if(j.eq.15) ln=1
      go to 90
  115 if(j.ne.20.or.(l.eq.1.and.j.eq.20)) go to 140
      if(ln.eq.1) v=-v
      return
  140 id(1)=-1
      ln=max0(1,j5-4)
      j=j5-ln+1
      call ERRWRT(0,a(ln),j,0,0,v)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   ECOVWR        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Writes covariance matrix of equation errors on device irip if
c
c   This subroutine calls the following subroutines:
C   XBETA  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine ECOVWR(x,xdata,joe,loe,iin,jjn,rn,gm,jod,jol,jon,joh)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision f(2),gm(1),rn(1),x(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),iin(1),jjn(1),jod(1),
     1jol(1),jon(1),joh(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a6(2),ipc,dum2(41)
      common /c/ me,nt,a1(12),nl,a4(9),irip,dum1(15)
      common /d/ k,n,jb,kobs,lv,a2(2),le,a3(3),my,a5(6),iqz,inz,lq,lpp,
     1lpq,dumd
c-------------------BEGINNING OF SUBROUTINE------------------------------
C**********************
      if(irip.gt.0) irip=ipc
      write(irip,1144)
 1144 format(1x,'**** Estimated Covariance Matrix of Equation'
     & ' Errors Follows ****')
C**********************
      jj=1
      do 100 ii=1,n
      if(nl.eq.1.and.iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
      do 100 i7=1,nt
      i5=0
      j=0
      do 20 i6=1,me
      if(nl.eq.1.and.xdata(lv+i5+i7,jj).lt.0.) go to 100
      f(2)=1.d0
      if(joe(i6).le.0) go to 10
      if(nl.eq.1) go to 5
      i9=jol(i6)
      f(2)=dabs(x(i9))
      go to 10
    5 call XBETA(x,x,x,iin,jjn,rn,f(2),f(1),xdata(1,jj),loe(1,i7),
     1jol(i6),jon(i6),lq,0)
   10 if(jod(i6).eq.1.or.jod(i6).eq.3) f(2)=f(2)**2
      j=j+i6
      gm(j)=f(2)
      if(joe(i6).ge.2) i5=i5+nt
   20 i5=i5+nt
      i9=0
      i8=0
      i3=lpp
      do 45 i=2,me
      i9=i9+1
      i1=i-1
      do 45 j=1,i1
      i9=i9+1
      i8=i8+1
      if(nl.ne.1) f(1)=x(i8+i3)
      i5=iabs(joh(i8))
      if(nl.eq.1) call XBETA(x,x,x,iin,jjn,rn,f(1),f(2),xdata(1,jj),
     1loe(1,i7),i5,lpq,le,0)
      if(joh(i8).ge.0) f(1)=f(1)*dsqrt(gm(i9-j))*dsqrt(gm(i9-j+i))
   45 gm(i9)=f(1)
      i9=me*(me+1)/2
      write(irip,50) (gm(i),i=1,i9)
   50 format(5d16.9)
      go to 110
  100 continue
  110 if(nl.eq.1.and.iqz.gt.0) rewind inz
C**********************
      write(irip,1145)
 1145 format(1x,'**** End of Estimated Covariance Matrix'
     & ' of Equation Errors ****')
C**********************
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   ERRCHK        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Prints program errors and terminates program.
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  CARDRD  ERRCHK  CONTRL  CONTIM  MINREG  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine ERRCHK(ierror,nn)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension z(6,15)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(39),lwi,dum(3)
c------------------------DATA STATEMENTS---------------------------------
      data z/4HRead,4H EOF,4H on ,4HCont,4Hrol ,4HCard,4HInva,4Hlid ,
     *4HOpti
     1,4Hon C,4Homma,4Hnd  ,4HInco,4Hnsis,4Htent,4H Opt,4Hions,4H Req
     2,4HVari,4Hable,4H # O,4Hut o,4Hf Ra,4Hnge ,4HCore,4H Exc,4Heed ,
     *4HDuri
     3,4Hng R,4Head ,4HRead,4H Err,4Hor E,4Hncou,4Hnter,4Hed  ,4HRest
     4,4Hr/Tr,4Hans/,4HNon-,4HLin ,4HCard,4HMore,4H Cor,4He Wo,4Hrds ,
     54HNeed,4Hed  ,4Hin W,4Heigh,4Hting,4H Mat,4Hrix ,1H ,4Hin C,
     *4Hompu,
     64Hte S,4Htart,4Hing ,4HVal.,4Hin C,4Hompu,4Hte S,4Htand,4Hard ,
     *4HErr.
     7,4Hin S,4Hteep,4Hest ,4HDesc,4Hent ,1H ,4Hin F,4Hletc,4Hher ,
     *4HPowe
     8,4Hll  ,1H ,4Hin V,4Haria,4Hble ,4HName,1H ,1H ,4HMast,4Her C,
     94Hard ,4HOrde,1Hr,1H /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(lwi.eq.0) write(ip,5)
    5 format(//48x,6('*'),' Run Error -- See Manual ',6('*'))
      if(lwi.eq.1) write(ip,10)
   10 format(//22x,6('*'),' Run Error -- See Manual ',6('*'))
      if(lwi.eq.0) write(ip,15) ierror,(z(i,ierror),i=1,6)
   15 format(49x,'Error',i3,2x,6a4)
      if(lwi.eq.1) write(ip,20) ierror,(z(i,ierror),i=1,6)
   20 format(23x,'Error',i3,2x,6a4)
      if(lwi.eq.0.and.(ierror.eq.5.or.ierror.eq.6)) write(ip,25) nn
   25 format(57x,'Observation',i7)
      if(lwi.eq.1.and.(ierror.eq.5.or.ierror.eq.6)) write(ip,30) nn
   30 format(31x,'Observation',i7)
      if(lwi.eq.0.and.ierror.eq.8) write(ip,35) nn
   35 format(58x,'at Least',i8)
      if(lwi.eq.1.and.ierror.eq.8) write(ip,40) nn
   40 format(32x,'at Least',i8)
      if(ierror.gt.8.and.ierror.lt.14) return
      if(lwi.eq.0) write(ip,45)
   45 format(/59x,'Job Terminated')
      if(lwi.eq.1) write(ip,50)
   50 format(/33x,'Job Terminated')
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   ERRWRT        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Prints error location.
c
c   This subroutine is called by the following subroutines:
C   CATCH  CONBAS  CONDAT  CONMAS  DECODS  MATCH  RDREST  CONTRL  
C   DISCRT  RECALC  YCALC  MINREG  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine ERRWRT(id,a,i1,i2,i3,f)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision f
      dimension a(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(39),lwi,dum(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(id.gt.0) go to 20
      if(lwi.eq.0) write(ip,10) (a(i),i=1,i1)
   10 format(/54x,'Error Location -- ',8a1)
      if(lwi.eq.1) write(ip,15) (a(i),i=1,i1)
   15 format(/28x,'Error Location -- ',8a1)
      return
   20 if(lwi.eq.0) write(ip,25) id,i1,i2
   25 format(///34x,'Error in Evaluating Observation',i6,' Time Period',
     1i4,' Equation',i3)
      if(lwi.eq.1) write(ip,30) id,i1,i2
   30 format(///8x,'Error in Evaluating Observation',i6,' Time Period',
     1i4,' Equation',i3)
      if(i3.lt.11) go to 50
      if(lwi.eq.0) write(ip,40)
   40 format(49x,'Could Not Converge on Fixed Effect')
      if(lwi.eq.1) write(ip,45)
   45 format(23x,'Could Not Converge on Fixed Effect')
      return
   50 if(lwi.eq.0) write(ip,55) f
   55 format(55x,'x''beta = ',g13.5)
      if(lwi.eq.1) write(ip,60) f
   60 format(29x,'x''beta = ',g13.5)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FCHOTZ        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes function/gradient for bivariate ML.
c   Jnd=0 is no time max. like; jnd=1 is cross-products of 1st deriv's
c   Jnd=2 is time summed cross-products of 1st deriv's; jnd=3 is ex-
c   Pectation of 2nd derivatives.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CATCH  MOVING  XBETA  PITTSB  CLEVE  FUNCTM  BOSTON  ARLING  IYYM
C   FSTAT  RANDAL  
c
c   This subroutine is called by the following subroutines:
C   FCTGR  SECDRV  STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FCHOTZ(x,f,g,s,xdata,joe,loe,moe,ff,iin,jjn,rn,xx,vv,
     1joa,job,jod,jol,jon,joh,stor,xm,jnd,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),s(1),f,FSTAT,bx,ff(6,me),cx,dx,ex,ax,
     1fx,rn(1),FUNCTM,gg(5),hh(15),yx,f3,f4,g3,g4,xx(1),wt,vrs,vv(le,5),
     2stor(1),xm(31,me),sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),job(1),jod(1),jol(1),jon(1),joh(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(12),nl,a5(19),kvrs,jwt,dum(4)
      common /c2/ vrs
      common /d/ k,n,jb,kobs,lv,a2(2),le,a3(3),my,a4(3),lg,lh,mobs,iqz,
     1inz,lq,lpp,lpq,la
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
c$$$$$$$$$$$$$$$$$$$$$$$
      if(JOFunc.gt.0) then
          call cprint(26)
          stop
      endif
c$$$$$$$$$$$$$$$$$$$$$$$
      lgs=5
      if(jnd.eq.3) lgs=7
      wt=1.d0
      if(nl.eq.1) go to 8
      i8=lpp
      do 5 i6=1,me
      i9=jol(i6)
      if(joe(i6).ge.1) call CATCH(0,0,i6,x(i9),1,ind)
      if(i6.eq.1.or.joh(1).lt.0) go to 5
      do 4 j=2,i6
      i8=i8+1
    4 call CATCH(0,0,i8,x(i8),2,ind)
    5 continue
    8 if(lh.gt.0.and.jnd.eq.0) go to 105
      jj=1
      do 100 ii=1,n
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
c   Loop over time periods
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,le,1)
      do 100 i7=1,nt
      if(jwt.gt.0) i5=loe(jwt,i7)
      if(jwt.gt.0) wt=dble(xdata(i5,jj))/vrs
      i5=0
c   Loop over equations
      do 15 i6=1,me
      ff(6,i6)=-1.d0
c   Branch if observation not wanted
      if(xdata(lv+i5+i7,jj).lt.0.) go to 14
c   Calculate x'b and sigma
      if(nl.eq.0) go to 10
      call XBETA(x,g,g,iin,jjn,rn,ff(1,i6),cx,xdata(1,jj),loe(1,i7),
     1joa(i6),jon(i6),lq,0)
      if(nl.gt.1) go to 10
      ff(2,i6)=1.d0
      if(joe(i6).ge.1) call XBETA(x,g,g,iin,jjn,rn,ff(2,i6),cx,
     1xdata(1,jj),loe(1,i7),jol(i6),jon(i6),lq,0)
      call CATCH(ii,i7,i6,ff(2,i6),1,ind)
      go to 12
   10 call PITTSB(ff(1,i6),ff(2,i6),joa(i6),moe(1,i6),loe(1,i7),xdata(1,
     1jj),x,k,joe(i6),jol(i6),i6,sc,iscal,nl)
c   Calculate single equation function/gradient values
   12 if(jod(i6).eq.2) ff(2,i6)=dsqrt(ff(2,i6))
      call CLEVE(gg,joe(i6),0,0,ff(1,i6),xdata(lv+i5+i7,jj),
     1xdata(lv+i5+nt+i7,jj),0.0,ii,i7,i6,xm(1,i6),ax,wt,lgs,ind)
   14 if(joe(i6).ge.2) i5=i5+nt
   15 i5=i5+nt
      if(ind.gt.0) go to 102
      i8=0
c   Loop over combinations of equations
      do 98 i=2,me
      i1=i-1
      do 98 j=1,i1
      i8=i8+1
      if(lg.gt.0.and.job(i).lt.0.and.job(j).lt.0.and.jnd.eq.0.and.ff(6,i
     1).gt.0..and.ff(6,j).gt.0..and.i.gt.jeff.and.j.gt.jeff) go to 98
      do 20 i2=1,5
   20 gg(i2)=0.d0
      do 21 i2=1,15
   21 hh(i2)=0.d0
      if(ff(6,i).ge.0..and.ff(6,j).ge.0.) go to 26
c   Branch if observations for both equations missing
      if(ff(6,i).lt.0..and.ff(6,j).lt.0.) go to 98
c   Calculate first/sec derivative if one equation missing observation
      i2=i
      if(ff(6,i).lt.0.) i2=j
      ji=1
      if(i2.eq.j) ji=3
      jji=(ji*5-3)/2
      if(ff(6,i2).gt.0.) go to 22
      f=f-dlog(ff(3,i2))*wt
      gg(ji)=ff(5,i2)*ff(4,i2)/ff(3,i2)
      if(joe(i2).ge.1) gg(ji+1)=gg(ji)*ff(1,i2)*ff(5,i2)
      if(jnd.lt.3) go to 23
      hh(jji)=gg(ji)*(gg(ji)-ff(1,i2)*ff(5,i2)/ff(2,i2))
      if(joe(i2).eq.0) go to 23
      hh(jji+ji)=hh(jji)*ff(1,i2)*ff(5,i2)+gg(ji)/ff(2,i2)
      hh(jji+ji+1)=ff(1,i2)*ff(5,i2)*(hh(jji+ji)+gg(ji+1)/ff(2,i2))
      go to 23
   22 f=f+wt*((ff(3,i2)**2)/2.d0+dlog(ff(2,i2))+.91893983205d0)
      gg(ji)=ff(3,i2)/ff(2,i2)
      gg(ji+1)=((ff(3,i2)**2)-1.d0)/ff(2,i2)
      if(jnd.lt.3) go to 23
      hh(jji)=1.d0/(ff(2,i2)**2)
      hh(jji+ji)=2.d0*ff(3,i2)*hh(jji)
      hh(jji+ji+1)=(3.d0*ff(3,i2)**2-1.d0)*hh(jji)
   23 if(jod(i2).eq.1.or.joe(i2).eq.0) go to 24
      if(jnd.ne.0.or.lg.eq.0) gg(ji+1)=gg(ji+1)/(2.d0*ff(2,i2))
      if(jnd.lt.3) go to 24
      hh(jji+ji)=hh(jji+ji)/(2.d0*ff(2,i2))
      hh(jji+ji+1)=(hh(jji+ji+1)/(4.d0*ff(2,i2))-gg(ji+1))/ff(2,i2)
   24 if(jnd.ge.3.and.my.eq.0) go to 60
      if(ji.eq.1) go to 50
      go to 54
c   Set value of ijth equation pair correlation (Covariance)
   26 if(nl.ne.1) ax=x(i8+lpp)
      m8=iabs(joh(i8))
      if(nl.eq.1) call XBETA(x,g,g,iin,jjn,rn,ax,yx,xdata(1,jj),
     1loe(1,i7),m8,lpq,le,0)
      if(joh(i8).lt.0) ax=ax/(ff(2,i)*ff(2,j))
      call CATCH(ii,i7,i,ax,2,ind)
      dx=1.d0-ax**2
      ex=dsqrt(dx)
      yx=1.d0
      if(ff(6,i).eq.0..and.ff(6,j).eq.0.) go to 40
      if(ff(6,i).eq.0.) go to 28
      if(ff(6,j).eq.0.) go to 30
c   Calculate function/first derivatives if both equations continuous
      fx=(ff(3,j)-ax*ff(3,i))/ex
      f=f+wt*((ff(3,i)**2)/2.d0+(fx**2)/2.d0+dlog(ff(2,i))+dlog(ff(2,j)*
     1ex)+1.8378770641d0)
      gg(1)=(ff(3,i)-fx*ax/ex)/ff(2,i)
      gg(2)=gg(1)*ff(3,i)-1.d0/ff(2,i)
      gg(3)=fx/(ex*ff(2,j))
      gg(4)=gg(3)*ff(3,j)-1.d0/ff(2,j)
      gg(5)=-(fx*(ff(3,j)*ax-ff(3,i))/ex-ax)/dx
      if(jnd.lt.3) go to 43
c   Calculate second derivatives if both equations continuous
      hh(1)=1.d0/(dx*ff(2,i)**2)
      hh(2)=hh(1)*ff(3,i)+gg(1)/ff(2,i)
      hh(3)=hh(2)*ff(3,i)+gg(2)/ff(2,i)
      hh(4)=-ax/(dx*ff(2,i)*ff(2,j))
      hh(5)=hh(4)*ff(3,i)
      hh(6)=1.d0/(dx*ff(2,j)**2)
      hh(7)=hh(4)*ff(3,j)
      hh(8)=hh(7)*ff(3,i)
      hh(9)=hh(6)*ff(3,j)+gg(3)/ff(2,j)
      hh(10)=hh(9)*ff(3,j)+gg(4)/ff(2,j)
      hh(11)=((ff(3,j)*ax-ff(3,i))*ax+fx*ex)/(dx**2*ff(2,i))
      hh(12)=hh(11)*ff(3,i)
      hh(13)=-(ff(3,j)*ax-ff(3,i)+fx*ax*ex)/(dx**2*ff(2,j))
      hh(14)=hh(13)*ff(3,j)
      hh(15)=((ff(3,j)*ax-ff(3,i))/(ex*dx))**2+fx*(fx*ex+2.d0*ax*(ff(3,j
     1)*ax-ff(3,i)))/(ex*dx**2)+(1.d0+ax**2)/(dx**2)
      go to 43
   28 i9=j
      j9=i
      ij=3
      ji=1
      go to 32
   30 i9=i
      j9=j
      ij=1
      ji=3
c   Calculate func./1st derivs if one eq. continuous & other censored
   32 fx=-((-ff(1,j9)*ff(5,j9)+ax*ff(3,i9))/ex)*ff(5,j9)
      call CATCH(ii,i7,i9,fx,4,ind)
      bx=FSTAT(fx,0.,0.,0.,7)/(ex*ff(2,j9))
      cx=FSTAT(fx,0.,0.,0.,3)
      f=f+wt*((ff(3,i9)**2)/2.d0+dlog(ff(2,i9))+.91893983205d0-dlog(cx))
      gg(ij)=ff(3,i9)/ff(2,i9)-bx*ax*ff(5,j9)*ff(2,j9)/(cx*ff(2,i9))
      gg(ij+1)=ff(3,i9)*gg(ij)-1.d0/ff(2,i9)
      gg(ji)=bx*ff(5,j9)/cx
      if(joe(j9).ge.1) gg(ji+1)=ff(1,j9)*ff(5,j9)*gg(ji)
      gg(5)=bx*(ff(3,i9)-ff(1,j9)*ff(5,j9)*ax)*ff(5,j9)*ff(2,j9)/(dx*cx)
      if(jnd.lt.3) go to 43
      iij=(ij*5-3)/2
c   Calculate 2nd derivs if one eq. continuous & other censored
      hh(iij)=(bx*ax*ax*ff(5,j9)*ff(2,j9)*(-fx*ff(5,j9)/ex+bx*ff(5,j9)*f
     1f(2,i9)/cx)/cx+1.d0)/(ff(2,i9)**2)
      hh(iij+ij)=ff(3,i9)*hh(iij)+gg(ij)/ff(2,i9)
      hh(iij+ij+1)=ff(3,i9)*hh(iij+ij)+gg(ij+1)/ff(2,i9)
      hh(4)=-ax*ff(5,j9)*bx*(-fx*ff(5,j9)/ex+bx*ff(5,j9)*ff(2,j9)/cx)/(c
     1x*ff(2,i9))
      hh(4+ij)=ff(3,i9)*hh(4)
      jji=(ji*5-3)/2
      hh(jji)=bx*ff(5,j9)*(-fx*ff(5,j9)/(ex*ff(2,j9))+bx*ff(5,j9)/cx)/cx
      if(joe(j9).eq.0) go to 39
      hh(ji+4)=ff(1,j9)*ff(5,j9)*hh(4)
      hh(8)=hh(ji+4)*ff(3,i9)
      hh(jji+ji)=ff(1,j9)*ff(5,j9)*hh(jji)+gg(ji)/ff(2,j9)
      hh(jji+ji+1)=ff(1,j9)*ff(5,j9)*hh(jji+ji)+gg(ji+1)/ff(2,j9)
   39 fx=-gg(5)*(bx/cx-fx/(ex*ff(2,j9)))+bx*ax/(dx*cx)
      hh(10+ij)=ff(5,j9)*ff(2,j9)*(bx/cx+fx*ax)/ff(2,i9)
      hh(11+ij)=ff(3,i9)*hh(10+ij)
      hh(10+ji)=-ff(5,j9)*fx
      if(joe(j9).ge.1) hh(11+ji)=ff(1,j9)*ff(5,j9)*hh(10+ji)
      hh(15)=-gg(5)*(fx*cx/bx+2.d0*ax/dx)+bx*ff(2,j9)*ff(1,j9)/(cx*dx)
      go to 43
c   Calculate function/first derivatives if both equations censored
   40 if(ff(5,j).ne.ff(5,i)) yx=-yx
      ax=ax*yx
      fx=FUNCTM(ff(1,i),ff(1,j),ax,ff(3,i),ff(3,j),1)
      call CATCH(ii,i7,i,fx,7,ind)
      gg(5)=yx*FUNCTM(ff(1,i),ff(1,j),ax,ff(3,i),ff(3,j),0)/fx
      f=f-dlog(fx)*wt
      bx=-(ff(1,i)*ax-ff(1,j))/ex
      cx=-(ff(1,j)*ax-ff(1,i))/ex
      call CATCH(ii,i7,i,bx,4,ind)
      f3=FSTAT(bx,0.,0.,0.,3)
      call CATCH(ii,i7,j,cx,4,ind)
      f4=FSTAT(cx,0.,0.,0.,3)
      gg(1)=ff(5,i)*ff(4,i)*f3/fx
      gg(3)=ff(5,j)*ff(4,j)*f4/fx
      if(joe(i).ge.1) gg(2)=ff(5,i)*gg(1)*ff(1,i)
      if(joe(j).ge.1) gg(4)=ff(5,j)*gg(3)*ff(1,j)
      if(jnd.lt.3) go to 43
c   Calculate second derivatives if both equations censored
      g3=FSTAT(bx,0.,0.,0.,7)
      g4=FSTAT(cx,0.,0.,0.,7)
      hh(15)=-gg(5)*(yx*(dx*(ff(1,i)*ff(1,j)+ax)-ax*(ff(1,i)*(ff(1,i)-ax
     1*ff(1,j))+ff(1,j)**2))/(dx**2)-gg(5))
      hh(11)=-gg(5)*(cx*ff(5,i)/(ex*ff(2,i))-gg(1))
      hh(13)=-gg(5)*(bx*ff(5,j)/(ex*ff(2,j))-gg(3))
      hh(1)=ff(4,i)*(g3*ax/ex-ff(1,i)*ff(5,i)*f3)/(fx*ff(2,i))+gg(1)**2
      hh(6)=ff(4,j)*(g4*ax/ex-ff(1,j)*ff(5,j)*g3)/(fx*ff(2,j))+gg(3)**2
      hh(4)=-ff(5,i)*ff(5,j)*ff(4,i)*g3/(ex*ff(2,j)*fx)+gg(1)*gg(3)
      if(joe(i).eq.0) go to 42
      hh(2)=ff(5,i)*ff(1,i)*hh(1)+gg(1)/ff(2,i)
      hh(3)=ff(5,i)*ff(1,i)*hh(2)+ff(5,i)*ff(1,i)*gg(1)/ff(2,i)
      hh(5)=ff(5,i)*ff(1,i)*hh(4)
      hh(12)=ff(1,i)*ff(5,i)*hh(11)
   42 if(joe(j).eq.0) go to 43
      hh(9)=ff(5,j)*ff(1,j)*hh(6)+gg(3)/ff(2,j)
      hh(10)=ff(5,j)*ff(1,j)*hh(9)+ff(5,j)*ff(1,j)*gg(3)/ff(2,j)
      hh(7)=ff(5,j)*ff(1,j)*hh(4)
      hh(14)=ff(1,j)*ff(5,j)*hh(13)
      if(joe(i).ge.1) hh(8)=ff(5,i)*ff(1,i)*hh(7)
c   Adjust values if covariance or variances specified
   43 if(lg.gt.0.and.job(i).lt.0.and.job(j).lt.0.and.jnd.eq.0.and.j.gt.
     1 jeff.and.i.gt.jeff) go to 48   
      if(joh(i8).ge.0) go to 46
      if(joe(i).ge.1) gg(2)=gg(2)-yx*ax*gg(5)/ff(2,i)
      if(joe(j).ge.1) gg(4)=gg(4)-yx*ax*gg(5)/ff(2,j)
      gg(5)=gg(5)/(ff(2,i)*ff(2,j))
      if(jnd.lt.3) go to 46
      if(joe(i).eq.0) go to 44
      hh(2)=hh(2)-yx*ax*hh(11)/ff(2,i)
      hh(5)=hh(5)-yx*ax*hh(13)/ff(2,i)
      hh(3)=hh(3)-yx*ax*(2.d0*gg(5)*ff(2,j)+2.d0*hh(12)-yx*ax*hh(15)/ff(
     12,i))/ff(2,i)
      if(joe(j).ge.1) hh(8)=hh(8)-yx*ax*(hh(12)/ff(2,j)+hh(14)/ff(2,i)-y
     1x*ax*hh(15)/(ff(2,i)*ff(2,j))+gg(5))
      hh(12)=(hh(12)-yx*ax*hh(15)/ff(2,i)+gg(5)*ff(2,j))/(ff(2,i)*ff(2,j
     1))
   44 if(joe(j).eq.0) go to 45
      hh(7)=hh(7)-yx*ax*hh(11)/ff(2,j)
      hh(9)=hh(9)-yx*ax*hh(13)/ff(2,j)
      hh(10)=hh(10)-yx*ax*(2.d0*gg(5)*ff(2,i)+2.d0*hh(14)-yx*ax*hh(15)/f
     1f(2,j))/ff(2,j)
      hh(14)=(hh(14)-yx*ax*hh(15)/ff(2,j)+gg(5)*ff(2,i))/(ff(2,i)*ff(2,j
     1))
   45 hh(11)=hh(11)/(ff(2,i)*ff(2,j))
      hh(13)=hh(13)/(ff(2,i)*ff(2,j))
      hh(15)=hh(15)/(ff(2,i)*ff(2,j))
   46 if(lg.gt.0.and.jnd.eq.0) go to 48
      if(jod(i).eq.1.or.joe(i).eq.0) go to 47
      gg(2)=gg(2)/(2.d0*ff(2,i))
      if(jnd.lt.3) go to 47
      hh(2)=hh(2)/(2.d0*ff(2,i))
      hh(5)=hh(5)/(2.d0*ff(2,i))
      hh(8)=hh(8)/(2.d0*ff(2,i))
      hh(3)=(hh(3)/(4.d0*ff(2,i))-gg(2))/ff(2,i)
      hh(12)=hh(12)/(2.d0*ff(2,i))
   47 if(jod(j).eq.1.or.joe(j).eq.0) go to 48
      gg(4)=gg(4)/(2.d0*ff(2,j))
      if(jnd.lt.3) go to 48
      hh(9)=hh(9)/(2.d0*ff(2,j))
      hh(7)=hh(7)/(2.d0*ff(2,j))
      hh(8)=hh(8)/(2.d0*ff(2,j))
      hh(10)=(hh(10)/(4.d0*ff(2,j))-gg(4))/ff(2,j)
      hh(14)=hh(14)/(2.d0*ff(2,j))
   48 if(jnd.ge.3.and.my.eq.0) go to 60
c   Put rho first derivative in vector
      gg(5)=gg(5)*wt
      if(nl.ne.1) g(i8+lpp)=g(i8+lpp)-gg(5)
      if(nl.eq.1) call XBETA(x,g,g,iin,jjn,rn,gg(5),cx,xdata(1,jj),
     1loe(1,i7),m8,lpq,le,1)
c   Put beta and sigma derivatives of both equations in vector
   50 gg(1)=gg(1)*wt
      gg(2)=gg(2)*wt
      if(nl.eq.0) go to 53
      call XBETA(x,g,g,iin,jjn,rn,gg(1),cx,xdata(1,jj),loe(1,i7),
     1joa(i),jon(i),lq,1)
      if(nl.gt.1) go to 53
      if(joe(i).ge.1) call XBETA(x,g,g,iin,jjn,rn,gg(2),cx,xdata(1,jj),
     1loe(1,i7),jol(i),jon(i),lq,1)
      go to 54
   53 call BOSTON(gg(1),gg(2),cx,joa(i),moe(1,i),loe(1,i7),xdata(1,jj),
     1g,k,joe(i),jol(i),0,x,i6,0,sc,iscal,nl)
   54 if(ff(6,j).lt.0.) go to 60
      gg(3)=gg(3)*wt
      gg(4)=gg(4)*wt
      if(nl.eq.0) go to 58
      call XBETA(x,g,g,iin,jjn,rn,gg(3),cx,xdata(1,jj),loe(1,i7),
     1joa(j),jon(j),lq,1)
      if(nl.gt.1) go to 58
      if(joe(j).ge.1) call XBETA(x,g,g,iin,jjn,rn,gg(4),cx,xdata(1,jj),
     1loe(1,i7),jol(j),jon(j),lq,1)
      go to 60
   58 call BOSTON(gg(3),gg(4),cx,joa(j),moe(1,j),loe(1,i7),
     1xdata(1,jj),g,k,joe(j),jol(j),0,x,i6,0,sc,iscal,nl)
   60 if(jnd.lt.3) go to 98
      if(jwt.eq.0) go to 63
      do 61 i2=1,15
   61 hh(i2)=hh(i2)*wt
      if(my.ne.0) go to 63
      do 62 i2=1,5
   62 gg(i2)=gg(i2)*wt
   63 if(nl.gt.0) go to 80
c   Put second derivatives in matrix
      jji=k+1
      i9=joa(i)
      i2=0
      do 78 ji=1,jji
      if(ji.eq.jji) go to  64
      if(moe(ji,i).gt.7) go to 78
      i9=i9+1
      ij=loe(ji,i7)
      l=(lpp+i8)*(lpp+i8-1)/2+i9
      s(l)=s(l)+hh(11)*dble(xdata(ij,jj))
      go to 65
   64 if(joe(i).eq.0) go to 78
      i9=i9+1
      l=(lpp+i8)*(lpp+i8-1)/2+i9
      s(l)=s(l)+hh(12)
   65 j9=joa(j)
      i2=i2+1
      m9=i9*(i9-1)/2
      do 75 jk=1,jji
      if(jk.eq.jji) go to 67
      if(moe(jk,j).gt.7) go to 75
      j9=j9+1
      kj=loe(jk,i7)
      if(ji.eq.jji) s(m9+j9)=s(m9+j9)+hh(5)*dble(xdata(kj,jj))
      if(ji.lt.jji) s(m9+j9)=s(m9+j9)+hh(4)*dble(xdata(ij,jj))*dble(xdat
     1a(kj,jj))
      if(i2.gt.1) go to 75
      l=(lpp+i8)*(lpp+i8-1)/2+j9
      s(l)=s(l)+hh(13)*dble(xdata(kj,jj))
      go to 69
   67 if(joe(j).eq.0) go to 75
      j9=j9+1
      if(ji.lt.jji) s(m9+j9)=s(m9+j9)+hh(7)*dble(xdata(ij,jj))
      if(ji.eq.jji) s(m9+j9)=s(m9+j9)+hh(8)
      if(i2.gt.1) go to 75
      l=(i8+lpp)*(i8+lpp-1)/2+j9
      s(l)=s(l)+hh(14)
   69 k9=joa(j)
      l=j9*(j9-1)/2+k9
      do 70 li=1,k
      if(moe(li,j).gt.7) go to 70
      k9=k9+1
      if(k9.gt.j9) go to 75
      il=loe(li,i7)
      l=l+1
      if(jk.lt.jji) s(l)=s(l)+hh(6)*dble(xdata(kj,jj))*dble(xdata(il,jj)
     1)
      if(jk.eq.jji) s(l)=s(l)+hh(9)*dble(xdata(il,jj))
   70 continue
      if(jk.eq.jji) s(l+1)=s(l+1)+hh(10)
   75 continue
      j9=joa(i)
      l=i9*(i9-1)/2+j9
      do 76 jk=1,k
      if(moe(jk,i).gt.7) go to 76
      j9=j9+1
      if(j9.gt.i9) go to 78
      kj=loe(jk,i7)
      l=l+1
      if(ji.eq.jji) s(l)=s(l)+hh(2)*dble(xdata(kj,jj))
      if(ji.lt.jji) s(l)=s(l)+hh(1)*dble(xdata(ij,jj))*dble(xdata(kj,jj)
     1)
   76 continue
      if(ji.eq.jji) s(l+1)=s(l+1)+hh(3)
   78 continue
      l=(i8+lpp)*(i8+lpp+1)/2
      s(l)=s(l)+hh(15)
      go to 98
   80 call XBETA(x,vv(1,1),s,iin,jjn,rn,gg(1),hh(1),xdata(1,jj),loe(1,i7
     1),joa(i),jon(i),lq,2)
      call XBETA(x,vv(1,3),s,iin,jjn,rn,gg(3),hh(6),xdata(1,jj),loe(1,i7
     1),joa(j),jon(j),lq,2)
      if(nl.gt.1) go to 86
      if(joe(i).ge.1) call XBETA(x,vv(1,2),s,iin,jjn,rn,gg(2),hh(3),
     1xdata(1,jj),loe(1,i7),jol(i),jon(i),lq,2)
      if(joe(j).ge.1) call XBETA(x,vv(1,4),s,iin,jjn,rn,gg(4),hh(10),
     1xdata(1,jj),loe(1,i7),jol(j),jon(j),lq,2)
      call XBETA(x,vv(1,5),s,iin,jjn,rn,gg(5),hh(15),xdata(1,jj),
     1loe(1,i7),m8,lpq,le,2)
      do 84 i9=1,5
      do 84 j9=1,5
      l=IYYM(i9,j9)
      if(i9.eq.j9.or.hh(l).eq.0.) go to 84
      m9=lq
      if(i9.eq.5) m9=le
      do 82 ji=1,m9
      k9=min0(ji,lq)
      do 82 kj=1,k9
      i2=IYYM(ji,kj)
   82 s(i2)=s(i2)+vv(ji,i9)*vv(kj,j9)*hh(l)
   84 continue
      go to 98
   86 do 94 i9=1,5
      do 94 j9=1,5
      l=IYYM(i9,j9)
      if(((i9.eq.1.or.i9.eq.3).and.i9.eq.j9).or.hh(l).eq.0.) go to 94
      m9=jol(i)
      if(i9.eq.4) m9=jol(j)
      if(i9.eq.5) m9=i8+lpp
      ji=jol(i)
      if(j9.eq.4) ji=jol(j)
      if(j9.eq.5) ji=i8+lpp
      if(i9.ne.1.and.i9.ne.3) go to 90
      if(j9.eq.1.or.j9.eq.3) go to 88
      do 87 k9=1,lq
      i2=IYYM(ji,k9)
   87 s(i2)=s(i2)+vv(k9,i9)*hh(l)
      go to 94
   88 do 89 k9=1,lq
      do 89 jji=1,k9
      i2=IYYM(k9,jji)
   89 s(i2)=s(i2)+vv(k9,i9)*vv(jji,j9)*hh(l)
      go to 94
   90 if(j9.eq.1.or.j9.eq.3.or.j9.gt.i9) go to 94
      i2=IYYM(ji,m9)
      s(i2)=s(i2)+hh(l)
   94 continue
   98 continue
      if(ind.gt.0) go to 102
c   Calculate cross-products matrix of first derivatives
c   Change made by Jacob Klerman 10/6/85
c   If(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,2)
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,le,2)
      if(jnd.eq.1.or.(jnd.eq.2.and.(la.eq.1.or.(la.eq.0.and.i7.eq.nt))))
     1 call ARLING(s,g,le,0)
  100 continue
  102 if(iqz.gt.0) rewind inz
      if(ind.gt.0) return
c   Add gradients/second derivatives from moments
  105 if(lg.gt.0.and.jnd.eq.0) call RANDAL(x,f,g,s,1,1,joe,moe,xx,ff,
     1joa,job,jod,jol,joh,6,ind)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FCJOEY        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes IV or O.C. estmators.
c   Jnd=0 is orthog function minimization; jnd=1 is orthog deriv's
c   Cross-products for FLEPOW; jnd=2 is cross-products of time summed
c   Orthogs; jnd=3 is derivatives only of orthogs.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CATCH  XBETA  PITTSB  CLEVE  MOVING  BOSTON  ARLING  RANDAL  
c
c   This subroutine is called by the following subroutines:
C   FCTGR  SECDRV  STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FCJOEY(x,f,g,s,xdata,joe,loe,moe,a,bb,hh,p,pd,br,bs,
     1iin,jjn,rn,xx,joa,job,jod,jol,jon,joh,stor,xm,jnd,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),s(1),f,f1,f2,p(1),pd(lz,le),xm(31,me),
     1a(1),br(1),bs(1),rn(1),bb(5,nt,me),hh(1),xx(1),vrs,fetol,stor(1),
     2wt,sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),job(1),jod(1),jol(1),jon(1),joh(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(12),nl,ir,ln,a4(3),iwo,a5(13),kvrs,jwt,ifxi,
     1kfetol,dumc(2)
      common /c2/ vrs
      common /c3/ fetol
      common /d/ k,n,jb,kobs,lv,a2(2),le,igmm,lz,a3(5),lg,lh,ms,iqz,inz,
     1lq,a6(2),la
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
c$$$$$$$$$$$$$$$$$$$$$$$
      if(JOFunc.gt.0) then
          call cprint(26)
          stop
      endif
c$$$$$$$$$$$$$$$$$$$$$$$
      lgs=2
      if(jnd.eq.3) lgs=3
      wt=1.d0
      do 2 i=1,lz
    2 p(i)=0.d0
    3 if(jnd.eq.2) go to 7
      do 4 i=1,lz
      do 4 j=1,le
    4 pd(i,j)=0.d0
      if(nl.eq.1) go to 6
      do 5 i6=1,me
      i9=jol(i6)
    5 if(joe(i6).ge.1) call CATCH(0,0,i6,x(i9),1,ind)
    6 if(lh.gt.0.and.jnd.eq.0) go to 105
    7 jj=1
      do 100 ii=1,n
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
      i5=0
c   Loop over equations
      do 19 i6=1,me
c   Loop over time periods
      ij=0
      do 10 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.or.(lg.gt.0.and.job(i6).lt.0.and.jnd.eq.
     10.and.xdata(lv+i5+j,jj).ge.2..and.i6.gt.jeff)) go to 10
      ij=1
c   Calculate x'b and sigma
      if(nl.eq.0) go to 8
      call XBETA(x,g,s,iin,jjn,rn,br(2*j-1),f1,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,0)
      if(nl.gt.1) go to 8
      br(2*j)=1.d0
      if(joe(i6).ge.1) call XBETA(x,g,s,iin,jjn,rn,br(2*j),f1,
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,0)
      call CATCH(ii,j,i6,br(2*j),1,ind)
      go to 9
    8 call PITTSB(br(2*j-1),br(2*j),joa(i6),moe(1,i6),loe(1,j),xdata(1,
     1jj),x,k,joe(i6),jol(i6),i6,sc,iscal,nl)
    9 if(jod(i6).eq.2.or.jod(i6).eq.4) br(2*j)=dsqrt(br(2*j))
   10 continue
      if(ij.eq.0) go to 18
      if(job(i6).le.0) go to 15
      ji=0
   11 f1=0.d0
      f2=0.d0
      do 13 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.) go to 13
      if(jwt.eq.0) go to 12
      l=loe(jwt,j)
      wt=dble(xdata(l,jj))/vrs
c   Calculate function/derivative for fixed effect
   12 call CLEVE(bb(1,j,i6),joe(i6),job(i6),jod(i6),br(2*j-1),xdata(lv+
     1i5+j,jj),xdata(lv+i5+nt+j,jj),xdata(lv-me+i6,jj),ii,j,i6,bb,f1,wt,
     24,ind)
      f1=f1+bb(1,j,i6)
      f2=f2+bb(3,j,i6)
   13 continue
c   Check fixed effect gradient for tolerance & adjust
      call CATCH(ii,ji,i6,f1,6,ind)
      if(dabs(f1).lt.fetol) go to 14
      xdata(lv-me+i6,jj)=xdata(lv-me+i6,jj)+f1/f2
      go to 11
   14 if(jnd.ne.3) go to 15
      xm(8,i6)=xm(8,i6)+1.d0
      xm(9,i6)=xm(9,i6)+dble(xdata(lv-me+i6,jj))
      xm(10,i6)=xm(10,i6)+dble(xdata(lv-me+i6,jj))**2
   15 do 17 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.or.(lg.gt.0.and.job(i6).lt.0.and.jnd.eq.
     10.and.xdata(lv+i5+j,jj).ge.2..and.i6.gt.jeff)) go to 17
      if(jwt.eq.0) go to 16
      i8=loe(jwt,j)
      wt=dble(xdata(i8,jj))/vrs
c   Calculate function/gradient for regular equations
   16 call CLEVE(bb(1,j,i6),joe(i6),job(i6),jod(i6),br(2*j-1),xdata(lv+
     1i5+j,jj),xdata(lv+i5+nt+j,jj),xdata(lv-me+i6,jj),ii,j,i6,xm(1,i6),
     2f1,wt,lgs,ind)
   17 continue
   18 if(joe(i6).ge.2) i5=i5+nt
   19 i5=i5+nt
      if(ind.gt.0) go to 102
      do 100 j=1,nt
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,p,s,la,lc,lz,1)
      i5=0
      do 50 i6=1,me
      if(xdata(lv+i5+j,jj).lt.0.or.(lg.gt.0.and.job(i6).lt.0.and.jnd.eq.
     10.and.xdata(lv+i5+j,jj).ge.2..and.i6.gt.jeff)) go to 48
      if(jnd.ge.3) go to 24
      ij=joh(i6)
      do 23 i=1,k
      if(moe(i,i6).eq.4.or.moe(i,i6).ge.15) go to 23
      if((moe(i,i6).ge.5.and.moe(i,i6).le.7).or.(moe(i,i6).ge.12.and.moe
     1(i,i6).le.14)) go to 20
      ij=ij+1
      ji=loe(i,j)
c   Calculate & store contemporaneous orthogonality conditions
      p(ij)=p(ij)+bb(1,j,i6)*dble(xdata(ji,jj))
   20 if(moe(i,i6).eq.0.or.moe(i,i6).eq.8) go to 23
      do 22 l=2,ln
      if(moe(i,i6).eq.3.or.moe(i,i6).eq.7.or.moe(i,i6).eq.11.or.moe(i,i6
     1).eq.14) go to 21
      ij=ij+1
      if(j+l-1.gt.nt) go to 21
      ji=loe(i,j+l-1)
c   Calculate lead orthogonality conditions
      p(ij)=p(ij)+bb(1,j,i6)*dble(xdata(ji,jj))
   21 if(moe(i,i6).eq.2.or.moe(i,i6).eq.6.or.moe(i,i6).eq.10.or.moe(i,i6
     1).eq.13) go to 22
      ij=ij+1
      if(j.lt.l) go to 22
      ji=loe(i,j-l+1)
c   Calculate lag orthogonality conditions
      p(ij)=p(ij)+bb(1,j,i6)*dble(xdata(ji,jj))
   22 continue
   23 continue
      if(joe(i6).le.1.or.jod(i6).gt.2) go to 24
      ij=ij+1
      p(ij)=p(ij)+bb(2,j,i6)
   24 if(jnd.eq.2) go to 48
      i9=0
      if(nl.eq.0) go to 27
      do 25 i=1,le
      br(i)=0.d0
   25 bs(i)=0.d0
      ji=le
c   Determine derivative of x'b for non-linear for beta then sigma
      f1=-1.d0
      call XBETA(x,br,g,iin,jjn,rn,f1,f2,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,1)
      if(joe(i6).ge.1.and.nl.eq.1) call XBETA(x,bs,g,iin,jjn,rn,f1,f2,
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,1)
      do 26 i=1,le
      f1=0.d0
      if(nl.eq.1) f1=bs(i)
      if(nl.gt.1.and.i.eq.jol(i6)) f1=1.d0
      if(joe(i6).ge.2.and.jod(i6).le.2) bs(i)=-bb(4,j,i6)*br(i)-bb(5,j,i
     16)*f1
   26 br(i)=-bb(3,j,i6)*br(i)-bb(4,j,i6)*f1
      go to 29
c   Determine derivative of x'b for beta then sigma & put in br/bs
   27 call BOSTON(bb(3,j,i6),f1,f1,i9,moe(1,i6),loe(1,j),xdata(1,jj),
     1 br,k,joe(i6),jol(i6),0,x,i6,1,sc,iscal,nl)
      do 28 i=1,k   
      if(moe(i,i6).gt.7) go to 28
      i9=i9+1
      if(joe(i6).ge.2.and.jod(i6).le.2) bs(i9)=-bb(4,j,i6)*br(i9)/
     1 bb(3,j,i6)
   28 continue
      if(joe(i6).ge.1) br(i9+1)=-bb(4,j,i6)
      if(joe(i6).ge.2.and.jod(i6).le.2) bs(i9+1)=-bb(5,j,i6)
      ji=jol(i6)-joa(i6)
      i9=joa(i6)
   29 ij=joh(i6)
c   Calculate derivatives of each o.c. condition with respect to beta
      do 41 i=1,k
      if(moe(i,i6).eq.4.or.moe(i,i6).ge.15) go to 41
      if((moe(i,i6).ge.5.and.moe(i,i6).le.7).or.(moe(i,i6).ge.12.and.moe
     1(i,i6).le.14)) go to 31
      jk=loe(i,j)
      ij=ij+1
      do 30 i1=1,ji
   30 pd(ij,i9+i1)=pd(ij,i9+i1)+br(i1)*dble(xdata(jk,jj))
   31 if(moe(i,i6).eq.0.or.moe(i,i6).eq.8) go to 41
      do 40 l=2,ln
      if(moe(i,i6).eq.3.or.moe(i,i6).eq.7.or.moe(i,i6).eq.11.or.moe(i,i6
     1).eq.14) go to 35
      ij=ij+1
      if(l+j-1.gt.nt) go to 35
      jk=loe(i,j+l-1)
      do 32 i1=1,ji
   32 pd(ij,i9+i1)=pd(ij,i9+i1)+br(i1)*dble(xdata(jk,jj))
   35 if(moe(i,i6).eq.2.or.moe(i,i6).eq.6.or.moe(i,i6).eq.10.or.moe(i,i6
     1).eq.13) go to 40
      ij=ij+1
      if(j.lt.l) go to 40
      jk=loe(i,j-l+1)
      do 37 i1=1,ji
   37 pd(ij,i9+i1)=pd(ij,i9+i1)+br(i1)*dble(xdata(jk,jj))
   40 continue
   41 continue
      if(joe(i6).le.1.or.jod(i6).gt.2) go to 48
      ij=ij+1
      do 43 i1=1,ji
   43 pd(ij,i9+i1)=pd(ij,i9+i1)+bs(i1)
   48 if(joe(i6).ge.2) i5=i5+nt
   50 i5=i5+nt
      if(jnd.eq.2) go to 60
      if(jnd.ne.1) go to 100
c   Calculate cross-products of function first derivatives
      do 54 i=1,le
      g(i)=0.d0
      i1=0
      do 54 ij=1,lz
      if(iwo.eq.0) go to 52
      g(i)=g(i)+pd(ij,i)*p(ij)
      go to 54
   52 do 53 l=1,ij
      i1=i1+1
      if(l.ne.ij) g(i)=g(i)+pd(l,i)*a(i1)*p(ij)
   53 g(i)=g(i)+pd(ij,i)*a(i1)*p(l)
   54 continue
      do 55 i=1,lz
      p(i)=0.d0
      do 55 ij=1,le
   55 pd(i,ij)=0.d0
      call ARLING(s,g,le,3)
      go to 100
   60 if(la.gt.1) call MOVING(stor,p,s,la,lc,lz,2)
      if(la.gt.1.or.(la.eq.0.and.j.lt.nt)) go to 100
      do 70 i=1,lz
   70 g(i)=g(i)+p(i)
      call ARLING(s,p,lz,0)
  100 continue
  102 if(iqz.gt.0) rewind inz
      if(ind.gt.0) return
c   Add gradients/second derivatives from moments
  105 if(lg.gt.0.and.jnd.eq.0) call RANDAL(x,f,p,pd,lz,le,joe,moe,xx,
     1br,joa,job,jod,jol,joh,5,ind)
      if(jnd.ne.0.and.jnd.ne.2) return
c   Branch if identity weighting matrix used
      if(iwo.gt.0) go to 120
      do 107 j=1,lz
      hh(j)=0.d0
      do 107 l=1,lz
      i1=IYYM(l,j)
  107 hh(j)=hh(j)+p(l)*a(i1)
c   Calculate summed Weighted function and put derivatives in g.
      do 112 j=1,lz
      f=f+hh(j)*p(j)
      if(jnd.eq.2) go to 112
      do 110 i=1,le
  110 g(i)=g(i)+pd(j,i)*hh(j)*2.d0
  112 continue
      return
  120 do 130 j=1,lz
      f=f+p(j)*p(j)
      if(jnd.eq.2) go to 130
      do 125 i=1,le
  125 g(i)=g(i)+pd(j,i)*p(j)*2.d0
  130 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FCLARS        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes single equation/single time period ML estimates.
c   Jnd=0 is no time max. like; jnd=1 is cross-products of 1st deriv's
c   Jnd=2 is time summed cross-products of 1st deriv's; jnd=3 is ex-
c   pectation of 2nd derivatives.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CATCH  XBETA  PITTSB  CLEVE  MOVING  BOSTON  ARLING  RANDAL  
c
c   This subroutine is called by the following subroutines:
C   FCTGR  SECDRV  STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FCLARS(x,f,g,s,xdata,joe,loe,moe,ff,iin,jjn,rn,xx,bb,
     1vv,joa,job,jod,jol,jon,joh,joi,stor,xm,jnd,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),s(1),f,f1,f2,bb(5,nt,me),rn(1),
     1xx(1),ff(2,nt),vv(1),vrs,fetol,stor(1),xm(31,me),wt,sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),job(1),jod(1),jol(1),jon(1),joh(1),joi(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,igm,a1(11),nl,a5(19),kvrs,jwt,ifxi,kfetol,dumc(2)
      common /c2/ vrs
      common /c3/ fetol
      common /d/ k,n,jb,kobs,lv,a2(2),le,a3(3),my,a4(3),lg,lh,mobs,iqz,
     1inz,lq,a6(2),la
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      if(JOFunc.gt.0) then
          call OWNFUN(x,f,g,s,xdata,joe,loe,moe,ff,iin,jjn,rn,xx,bb,
     1vv,joa,job,jod,jol,jon,joh,joi,stor,xm,jnd,sc,iscal,ind)
          return
      endif
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      lgs=1
      if(jnd.eq.3) lgs=3
      wt=1.d0
      jw=lq+1
      if(lh.gt.0.and.jnd.eq.0) go to 105
      if(nl.eq.1) go to 7
      do 6 i6=1,me
      i9=jol(i6)
    6 if(joe(i6).ge.1) call CATCH(0,0,i6,x(i9),1,ind)
    7 jj=1
      do 100 ii=1,n
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
      i5=0
c   Loop over equations
      do 30 i6=1,me
      i9=0
c   Loop over time periods
      do 15 j=1,nt
c   Branch if observation not wanted
      if(xdata(lv+i5+j,jj).lt.0.or.(lg.gt.0.and.job(i6).lt.0.and.jnd.eq.
     10.and.xdata(lv+i5+j,jj).ge.2..and.i6.gt.jeff)) go to 15
      i9=1
c   Calculate x'b and sigma
      if(nl.eq.0) go to 10
      call XBETA(x,g,s,iin,jjn,rn,ff(1,j),f1,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,0)
      if(nl.gt.1) go to 10
      ff(2,j)=1.d0
      if(joe(i6).ge.1) call XBETA(x,g,s,iin,jjn,rn,ff(2,j),f1,
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,0)
      call CATCH(ii,j,i6,ff(2,j),1,ind)
      go to 12
   10 call PITTSB(ff(1,j),ff(2,j),joa(i6),moe(1,i6),loe(1,j),xdata(1,jj)
     1,x,k,joe(i6),jol(i6),i6,sc,iscal,nl)
   12 if(jod(i6).eq.2) ff(2,j)=dsqrt(ff(2,j))
   15 continue
      if(i9.eq.0) go to 28
      if(job(i6).le.0) go to 24
      i7=0
   17 f1=0.d0
      f2=0.d0
      do 20 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.) go to 20
      if(jwt.eq.0) go to 18
      i8=loe(jwt,j)
      wt=dble(xdata(i8,jj))/vrs
c   Calculate function/derivative for fixed effect
   18 call CLEVE(bb(1,j,i6),joe(i6),job(i6),jod(i6),ff(1,j),xdata(lv+i5+
     1j,jj),xdata(lv+i5+nt+j,jj),xdata(lv-me+i6,jj),ii,j,i6,xm,f1,wt,4,
     2ind)
      f1=f1+bb(1,j,i6)
      f2=f2+bb(3,j,i6)
   20 continue
c   Check gradient tolerance for fixed effect & adjust
      call CATCH(ii,i7,i6,f1,6,ind)
      if(dabs(f1).lt.fetol) go to 22
      xdata(lv-me+i6,jj)=xdata(lv-me+i6,jj)+f1/f2
      go to 17
   22 if(jnd.ne.3) go to 24
      xm(8,i6)=xm(8,i6)+1.d0
      xm(9,i6)=xm(9,i6)+dble(xdata(lv-me+i6,jj))
      xm(10,i6)=xm(10,i6)+dble(xdata(lv-me+i6,jj))**2
   24 f1=0.d0
      do 26 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.or.(lg.gt.0.and.job(i6).lt.0.and.jnd.eq.
     10.and.xdata(lv+i5+j,jj).ge.2..and.i6.gt.jeff)) go to 26
      if(jwt.eq.0) go to 25
      i8=loe(jwt,j)
      wt=dble(xdata(i8,jj))/vrs
c   Calculate function/derivative for regular equations
   25 call CLEVE(bb(1,j,i6),joe(i6),job(i6),jod(i6),ff(1,j),xdata(lv+i5+
     1j,jj),xdata(lv+i5+nt+j,jj),xdata(lv-me+i6,jj),ii,j,i6,xm(1,i6),f1,
     2wt,lgs,ind)
   26 continue
      if(jnd.ne.1) f=f-f1
   28 if(joe(i6).ge.2) i5=i5+nt
   30 i5=i5+nt
      if(ind.gt.0) go to 102
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,le,1)
      do 100 j=1,nt
      i5=0
      do 60 i6=1,me
      if(xdata(lv+i5+j,jj).lt.0.or.(lg.gt.0.and.job(i6).lt.0.and.jnd.eq.
     10.and.xdata(lv+i5+j,jj).ge.2..and.i6.gt.jeff)) go to 58
      if(jnd.lt.3) go to 55
      if(nl.gt.0) go to 48
c   Put beta second derivatives in matrix
      i9=joa(i6)
      i7=0
      do 40 i=1,k
      if(moe(i,i6).gt.7) go to 40
      i7=i7+1
      i3=loe(i,j)
      i8=0
      l=(i9+i7)*(i9+i7-1)/2+i9
      do 35 i2=1,k
      if(moe(i2,i6).gt.7) go to 35
      i8=i8+1
      i4=loe(i2,j)
      s(l+i8)=s(l+i8)+bb(3,j,i6)*dble(xdata(i3,jj))*dble(xdata(i4,jj))
      if(i8.eq.i7) go to 40
   35 continue
   40 continue
      if(joe(i6).le.0) go to 52
c   Put sigma second derivatives in matrix
      i7=i7+1
      l=(i9+i7)*(i9+i7-1)/2+i9
      i8=0
      do 45 i2=1,k
      if(moe(i2,i6).gt.7) go to 45
      i8=i8+1
      i4=loe(i2,j)
      s(l+i8)=s(l+i8)+bb(4,j,i6)*dble(xdata(i4,jj))
   45 continue
      s(l+i8+1)=s(l+i8+1)+bb(5,j,i6)
      go to 52
c   Put second derivatives in matrix for non-linear
   48 call XBETA(x,vv,s,iin,jjn,rn,bb(1,j,i6),bb(3,j,i6),xdata(1,jj),
     1loe(1,j),joa(i6),jon(i6),lq,2)
      if(joe(i6).le.0) go to 52
      if(nl.gt.1) go to 50
      call XBETA(x,vv(jw),s,iin,jjn,rn,bb(2,j,i6),bb(5,j,i6),
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,2)
      i7=joh(i6)
      i8=joi(i6)
      do 49 i2=i7,i8
      do 49 i3=1,lq
      l=IYYM(i2,i3)
   49 s(l)=s(l)+vv(lq+i2)*vv(i3)*bb(4,j,i6)
      go to 52
   50 do 51 i3=1,lq
      l=IYYM(jol(i6),i3)
   51 s(l)=s(l)+vv(i3)*bb(4,j,i6)
      l=IYYM(jol(i6),jol(i6))
      s(l)=s(l)+bb(5,j,i6)
   52 if(my.eq.0) go to 58
c   Put first derivatives in vector
   55 if(nl.eq.0) go to 57
      call XBETA(x,g,g,iin,jjn,rn,bb(1,j,i6),f1,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,1)
      if(joe(i6).le.0) go to 58
      if(nl.gt.1) go to 57
      call XBETA(x,g,g,iin,jjn,rn,bb(2,j,i6),f1,xdata(1,jj),
     1loe(1,i7),jol(i6),jon(i6),lq,1)
      go to 58
   57 call BOSTON(bb(1,j,i6),bb(2,j,i6),f1,joa(i6),moe(1,i6),loe(1,j),
     1xdata(1,jj),g,k,joe(i6),jol(i6),0,x,i6,0,sc,iscal,nl)
   58 if(joe(i6).ge.2) i5=i5+nt
   60 i5=i5+nt
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,le,2)
c   Calculate cross-products matrix of first derivatives
      if(jnd.eq.1.or.(jnd.eq.2.and.(la.eq.1.or.(la.eq.0.and.j.eq.nt))))
     1 call ARLING(s,g,le,0)
  100 continue
  102 if(iqz.gt.0) rewind inz
      if(ind.gt.0) return
c   Add gradients/second derivatives from moments
  105 if(lg.gt.0.and.jnd.eq.0) call RANDAL(x,f,g,s,1,1,joe,moe,xx,bb,
     1joa,job,jod,jol,joh,1,ind)
      if(igm.ne.2.or.jnd.eq.0.or.nl.eq.1) return
      do 110 i=1,me
      j=jol(i6)+1
      j=IYYM(j,j)
  110 s(j)=1.d0
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FCMOFF        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes function/gradient for single factor ML.
c   Jnd=0 is no time max. like; jnd=1 is cross-products of 1st deriv's
c   Jnd=2 is time summed cross-products of 1st deriv's
c   Joe(i6) =0,1 (probit); =2,3 (tobit); =4,5 (dble. tobit); =8 (regr)
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CATCH  XBETA  PITTSB  CLEVE  MOVING  BOSTON  ARLING  RANDAL  
C   FUNCTM  
c
c   This subroutine is called by the following subroutines:
C   FCTGR  SECDRV  STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FCMOFF(x,f,g,s,xdata,joe,loe,moe,bx,pdfp,pdfn,vd,sig,
     1rss,rst,sst,ff,iin,jjn,rn,xx,joa,job,jod,jol,jom,jon,stor,xm,jnd,
     2sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),s(1),f,bx(1),ddfp(9),ddfn(9),vd(1),
     1ru,cx,pdfp(9,1),pdfn(9,1),FSTAT,xh,wh,sig(1),rss(1),rst(1),sst(1),
     2br(3),rn(1),ff(6,nt),FUNCTM,ex,fx,ax,wt,vrs,xm(31,me),stor(1),
     3xx(1),sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),job(1),jod(1),jol(1),jom(1),jon(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(11),mm,nl,a3(6),ira,a4(12),kvrs,jwt,dum(4)
      common /c2/ vrs
      common /d/ k,n,jb,kobs,lv,a2(2),le,a5(7),lg,lh,mobs,iqz,inz,lq,
     1a6(2),la
      common /e/ xh(9),wh(9),dume(30)
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
c$$$$$$$$$$$$$$$$$$$$$$$
      if(JOFunc.gt.0) then
          call cprint(26)
          stop
      endif
c$$$$$$$$$$$$$$$$$$$$$$$
      lgs=5
      if(jnd.eq.3) lgs=7
      wt=1.d0
      i6=0
      ru=dsqrt(2.d0)
      if(nl.eq.1) go to 25
      do 20 i=1,me
      i9=jom(i)
c   Branch if between-equation single factor
      call CATCH(0,0,i,x(i9),2,ind)
      if(ira.ge.1) go to 10
      call CATCH(0,0,i,x(i9),3,ind)
      br(1)=x(i9)
      rst(i)=dsqrt(br(1))
      go to 15
   10 if(ira.eq.1) go to 20
      br(1)=x(i9)**2
      rst(i)=x(i9)
c   Determine conditional sigma and rho
   15 sig(i)=dsqrt(1.d0-br(1))
      i9=jol(i)
      if(joe(i).ge.1) call CATCH(0,0,i,x(i9),1,ind)
      rst(i)=rst(i)/sig(i)
      if(joe(i).ge.1) sig(i)=sig(i)*x(i9)
      if(jod(i).eq.2) sig(i)=sig(i)/dsqrt(x(i9))
      sst(i)=2.d0*(1.d0-br(1))
      rss(i)=2.d0*br(1)*(1.d0-br(1))
   20 continue
      if(ind.gt.0) return
   25 jj=1
      if(jnd.eq.0.and.lh.gt.0) go to 255
      do 250 ii=1,n
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
      if(ira.le.1) go to 42
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,le,1)
      i7=0
   30 i7=i7+1
      do 40 i=1,mm
      ddfp(i)=1.d0/1.7724538509055160273d0
   40 ddfn(i)=ddfp(i)
      j9=0
   42 i5=-nt
      i6=0
   45 i6=i6+1
      i5=i5+nt
      j=i6
      jra=ira
      if(ira.eq.2) go to 55
      if(job(i6).ge.0.and.ira.eq.1) go to 51
      l=0
      j=0
      if(joe(i6).le.1) go to 48
      do 47 i=1,nt
      if(xdata(lv+i5+i,jj).ge.2.) l=l+1
      if(xdata(lv+i5+i,jj).lt.0.) j=j+1
   47 continue
      if(jnd.eq.0.and.lg.gt.0.and.l.eq.nt.and.job(i6).lt.0.and.i6.gt.
     1 jeff) go to 245
   48 if(joe(i6).lt.8.and.l+j.lt.nt.and.ira.eq.0) go to 49
      jra=1
      go to 51
   49 do 50 i=1,mm
      ddfp(i)=1.d0/1.7724538509055160273d0
   50 ddfn(i)=ddfp(i)
      go to 52
   51 if(nl.eq.1) go to 52
      i9=jom(i6)
      ru=x(i9)
   52 i7=0
      j9=0
   53 i7=i7+1
      j=i7
   55 if(jra.eq.1) ff(6,i7)=-1.d0
      if(xdata(lv+i5+i7,jj).lt.0.) go to 85
      j9=j9+1
      if(jwt.gt.0) l=loe(jwt,i7)
      if(jwt.gt.0.and.j9.eq.1) wt=dble(xdata(l,jj))/vrs
      if(nl.eq.0) go to 57
c   Calculate x'b and sigma, rho for non-linear
      call XBETA(x,g,g,iin,jjn,rn,br(1),cx,xdata(1,jj),loe(1,i7),
     1joa(i6),jon(i6),lq,0)
      if(jra.eq.1) ff(1,i7)=br(1)
      if(nl.gt.1) go to 57
      br(2)=1.d0
      if(joe(i6).ge.1) call XBETA(x,g,g,iin,jjn,rn,br(2),cx,xdata(1,jj),
     1loe(1,i7),jol(i6),jon(i6),lq,0)
      call CATCH(ii,i7,i6,br(2),1,ind)
      call XBETA(x,g,g,iin,jjn,rn,br(3),cx,xdata(1,jj),loe(1,i7),
     1jom(i6),jon(i6),lq,0)
      call CATCH(ii,i7,i6,br(3),2,ind)
      if(jra.eq.1) go to 58
      bx(j)=br(1)
      if(jra.eq.0.and.j9.gt.1) go to 65
      sig(i6)=br(2)
      if(jod(i6).eq.2) sig(i6)=dsqrt(sig(i6))
      rst(i6)=br(3)
      call CATCH(ii,i7,i6,br(3),2,ind)
      if(jra.eq.0) call CATCH(ii,i7,i6,br(3),3,ind)
      if(jra.eq.0.and.rst(i6).gt.0.) rst(i6)=dsqrt(rst(i6))
      br(1)=rst(i6)**2
      sig(i6)=dsqrt(1.d0-br(1))*sig(i6)
      rst(i6)=rst(i6)/sig(i6)
      sst(i6)=2.d0*(1.d0-br(1))
      rss(i6)=2.d0*br(1)*(1.d0-br(1))
      go to 65
   57 if(jra.ne.1) go to 61
c   Calculate autoregressive function values
      call PITTSB(ff(1,i7),ff(2,i7),joa(i6),moe(1,i6),loe(1,i7),xdata(1,
     1jj),x,k,joe(i6),jol(i6),i6,sc,iscal,nl)
      go to 60
   58 ff(2,i7)=br(2)
      ru=br(3)
   60 if(jod(i6).eq.2) ff(2,i7)=dsqrt(ff(2,i7))
      call CLEVE(br,joe(i6),0,0,ff(1,i7),xdata(lv+i5+i7,jj),
     1xdata(lv+i5+nt+i7,jj),0.0,ii,i7,i6,xm(1,i6),ru,wt,lgs,ind)
      go to 85
c   Calculate x'b
   61 if(nl.eq.0) go to 62
      bx(j)=br(1)
      go to 64
   62 call PITTSB(bx(j),cx,joa(i6),moe(1,i6),loe(1,i7),xdata(1,jj),
     1x,k,joe(i6),jol(i6),i6,sc,iscal,-1)
   64 if(jnd.ne.3) go to 65
      br(1)=bx(j)
      br(2)=sig(i6)
      call CLEVE(br,joe(i6),0,0,br,xdata(lv+i5+i7,jj),xdata(lv+i5+nt+i7,
     1jj),0.0,ii,i7,i6,xm(1,i6),ru,wt,8,ind)
c   Joe(i6) =0,1 (probit); =2,3 (tobit); =4,5 (dble. tobit); =8 (regr)
   65 if(xdata(lv+i5+i7,jj).ge.2.) go to 75
      if(joe(i6).eq.2.or.joe(i6).eq.3.or.(joe(i6).eq.4.and.xdata(lv+i5+i
     17,jj).eq.1.).or.(joe(i6).eq.5.and.xdata(lv+i5+i7,jj).eq.0.)) bx(j)
     2=bx(j)-dble(xdata(lv+i5+nt+i7,jj))
      bx(j)=(bx(j)/sig(i6))*(2.d0*dble(xdata(lv+i5+i7,jj))-1.d0)
      vd(j)=ru*rst(i6)*(2.d0*dble(xdata(lv+i5+i7,jj))-1.d0)
c   Loop over hermite points accumulating condtional densities & deriv
      do 70 l=1,mm
      cx=bx(j)+vd(j)*xh(l)
      call CATCH(ii,i7,i6,cx,4,ind)
      pdfp(l,j)=FSTAT(cx,0.,0.,0.,7)/sig(i6)
      cx=1.d0-FSTAT(cx,0.,0.,0.,3)
      ddfp(l)=ddfp(l)*cx
      pdfp(l,j)=pdfp(l,j)/cx
      cx=bx(j)-vd(j)*xh(l)
      call CATCH(ii,i7,i6,cx,4,ind)
      pdfn(l,j)=FSTAT(cx,0.,0.,0.,7)/sig(i6)
      cx=1.d0-FSTAT(cx,0.,0.,0.,3)
      ddfn(l)=ddfn(l)*cx
      pdfn(l,j)=pdfn(l,j)/cx
   70 continue
      go to 85
   75 bx(j)=(dble(xdata(lv+i5+nt+i7,jj))-bx(j))/sig(i6)
      vd(j)=-ru*rst(i6)
      do 80 l=1,mm
      cx=bx(j)+vd(j)*xh(l)
      pdfp(l,j)=cx/sig(i6)
      ddfp(l)=ddfp(l)*FSTAT(cx,0.,0.,0.,7)/sig(i6)
      cx=bx(j)-vd(j)*xh(l)
      pdfn(l,j)=cx/sig(i6)
   80 ddfn(l)=ddfn(l)*FSTAT(cx,0.,0.,0.,7)/sig(i6)
   85 if(jra.le.1.and.i7.lt.nt) go to 53
      if(ira.eq.2.and.joe(i6).ge.2) i5=i5+nt
      if(ira.eq.2.and.i6.lt.me) go to 45
      if(ind.gt.0) go to 252
      if(j9.eq.0) go to 245
      if(ira.eq.1) go to 144
      if(jra.eq.1) go to 200
      cx=0.d0
c   Add up log-likelihood summing over hermites
      do 90 l=1,mm
   90 cx=cx+wh(l)*(ddfp(l)+ddfn(l))
      f=f-dlog(cx)*wt
      if(ira.eq.0) go to 100
      i5=-nt
      i6=0
   95 i6=i6+1
      i5=i5+nt
      j=i6
      go to 110
  100 i7=0
  105 i7=i7+1
      j=i7
  110 br(1)=0.d0
      if(xdata(lv+i5+i7,jj).lt.0.) go to 140
c   Calculate first derivatives of beta,sigma,rho
      do 115 l=1,mm
      pdfp(l,j)=pdfp(l,j)*ddfp(l)/cx
      pdfn(l,j)=pdfn(l,j)*ddfn(l)/cx
  115 br(1)=br(1)+(pdfp(l,j)+pdfn(l,j))*wh(l)
      br(3)=0.d0
      if(xdata(lv+i5+i7,jj).ge.2.) go to 125
      br(1)=br(1)*(2.d0*dble(xdata(lv+i5+i7,jj))-1.d0)
      if(joe(i6).ge.1) br(2)=br(1)*bx(j)*dsqrt(sst(i6)/2.d0)
      do 120 l=1,mm
  120 br(3)=br(3)+wh(l)*sig(i6)*(pdfp(l,j)*(bx(j)/sst(i6)+vd(j)*xh(l)/rs
     1s(i6))+pdfn(l,j)*(bx(j)/sst(i6)-vd(j)*xh(l)/rss(i6)))
      go to 135
  125 br(2)=0.d0
      do 130 l=1,mm
      br(2)=br(2)+wh(l)*(pdfp(l,j)*(bx(j)-1.d0/(bx(j)+vd(j)*xh(l)))+pdfn
     1(l,j)*(bx(j)-1.d0/(bx(j)-vd(j)*xh(l))))*dsqrt(sst(i6)/2.d0)
  130 br(3)=br(3)-wh(l)*sig(i6)*(pdfp(l,j)*(bx(j)/sst(i6)+vd(j)*xh(l)/rs
     1s(i6)-1.d0/((bx(j)+vd(j)*xh(l))*sst(i6)))+pdfn(l,j)*(bx(j)/sst(i6)
     2-vd(j)*xh(l)/rss(i6)-1.d0/((bx(j)-vd(j)*xh(l))*sst(i6))))
c   Adjust derivatives for between-equation single factor
  135 if(ira.eq.2) br(3)=2.d0*br(3)*rst(i6)*sig(i6)
      if(jod(i6).eq.2) br(2)=br(2)*dsqrt(sst(i6)/2.d0)/(2.d0*sig(
     1i6))
      do 137 l=1,3
  137 br(l)=br(l)*wt
c   Put first derivatives in vector
      if(nl.eq.0) go to 138
      call XBETA(x,g,g,iin,jjn,rn,br(1),cx,xdata(1,jj),loe(1,i7),
     1joa(i6),jon(i6),lq,1)
      if(nl.gt.1) go to 138
      if(joe(i6).ge.1) call XBETA(x,g,g,iin,jjn,rn,br(2),cx,xdata(1,jj),
     1loe(1,i7),jol(i6),jon(i6),lq,1)
      call XBETA(x,g,g,iin,jjn,rn,br(3),cx,xdata(1,jj),loe(1,i7),
     1jom(i6),jon(i6),lq,1)
      go to 140
  138 call BOSTON(br(1),br(2),br(3),joa(i6),moe(1,i6),loe(1,i7),
     1xdata(1,jj),g,k,joe(i6),jol(i6),jom(i6),x,i6,0,sc,iscal,nl)
  140 if(ira.eq.0.and.i7.lt.nt) go to 105
      if(ira.eq.2.and.joe(i6).ge.2) i5=i5+nt
      if(ira.eq.2.and.i6.lt.me) go to 95
      go to 245
c   Autoregressive error Calculation of function/gradients
  144 do 146 i=1,3
  146 br(i)=0.d0
      l=0
      do 194 i=1,nt
      if(ff(6,i).lt.0.) go to 194
      l=l+1
      if(l.eq.1.and.j9.eq.1) go to 176
      if(l.eq.1) go to 192
      ax=ru**(i-j)
      ex=dsqrt(1.d0-ax**2)
      if(ff(6,i).eq.0..and.ff(6,j).eq.0.) go to 168
      if(ff(6,i).eq.0.) go to 156
      if(ff(6,j).eq.0.) go to 160
c   Calculate function/first derivatives if both equations continuous
      fx=(ff(3,j)-ax*ff(3,i))/ex
      f=f+wt*((ff(3,i)**2)/2.d0+(fx**2)/2.d0+dlog(ff(2,i))+dlog(ff(2,j)*
     1ex)+1.8378770641d0)
      bx(1)=(ff(3,i)-fx*ax/ex)/ff(2,i)
      bx(2)=bx(1)*ff(3,i)-1.d0/ff(2,i)
      bx(3)=fx/(ex*ff(2,j))
      bx(4)=bx(3)*ff(3,j)-1.d0/ff(2,j)
      bx(5)=-(fx*(ff(3,j)*ax-ff(3,i))/ex-ax)/(ex**2)
      go to 172
  156 i9=j
      i2=i
      ij=3
      ji=1
      go to 164
  160 i9=i
      i2=j
      ij=1
      ji=3
c   Calculate func./1st derivs if one eq. continuous & other censored
  164 fx=-((-ff(1,i2)*ff(5,i2)+ax*ff(3,i9))/ex)*ff(5,i2)
      call CATCH(ii,i,i6,fx,4,ind)
      bx(6)=FSTAT(fx,0.,0.,0.,7)/(ex*ff(2,i2))
      cx=FSTAT(fx,0.,0.,0.,3)
      f=f+wt*((ff(3,i9)**2)/2.d0+dlog(ff(2,i9))+.91893853205d0-dlog(cx))
      bx(ij)=ff(3,i9)/ff(2,i9)-bx(6)*ax*ff(5,i2)*ff(2,i2)/(cx*ff(2,i9))
      bx(ij+1)=ff(3,i9)*bx(ij)-1.d0/ff(2,i9)
      bx(ji)=bx(6)*ff(5,i2)/cx
      if(joe(i6).ge.1) bx(ji+1)=ff(1,i2)*ff(5,i2)*bx(ji)
      bx(5)=bx(6)*(ff(3,i9)-ff(1,i2)*ff(5,i2)*ax)*ff(5,i2)*ff(2,i2)/(ex*
     1*2*cx)
      go to 172
c   Calculate function/first derivatives if both equations censored
  168 if(ff(5,j).ne.ff(5,i)) ax=-ax
      fx=FUNCTM(ff(1,i),ff(1,j),ax,ff(3,i),ff(3,j),1)
      call CATCH(ii,i,i6,fx,7,ind)
      bx(5)=FUNCTM(ff(1,i),ff(1,j),ax,ff(3,i),ff(3,j),0)/fx
      if(ff(5,j).ne.ff(5,i)) bx(5)=-bx(5)
      f=f-dlog(fx)*wt
      cx=-(ff(1,i)*ax-ff(1,j))/ex
      call CATCH(ii,i,i6,cx,4,ind)
      bx(1)=ff(5,i)*ff(4,i)*FSTAT(cx,0.,0.,0.,3)/fx
      cx=-(ff(1,j)*ax-ff(1,i))/ex
      call CATCH(ii,i,i6,cx,4,ind)
      bx(3)=ff(5,j)*ff(4,j)*FSTAT(cx,0.,0.,0.,3)/fx
      if(joe(i6).ge.1) bx(2)=ff(5,i)*bx(1)*ff(1,i)
      if(joe(i6).ge.1) bx(4)=ff(5,j)*bx(3)*ff(1,j)
  172 if(i.ne.j+1) bx(5)=dble(i-j)*ru**(i-j-1)*bx(5)
      br(3)=br(3)+bx(5)
      if(l.eq.2) go to 184
      cx=-1.d0
      go to 180
  176 j=i
      bx(3)=0.d0
      bx(4)=0.d0
      cx=1.d0
  180 if(ff(6,j).gt.0.) go to 182
      f=f-cx*dlog(ff(3,j))
      bx(3)=bx(3)+cx*ff(5,j)*ff(4,j)/ff(3,j)
      bx(4)=bx(4)+cx*ff(4,j)*ff(1,j)/ff(3,j)
      go to 184
  182 f=f+wt*(cx*((ff(3,j)**2)/2.d0+dlog(ff(2,j))+.91893853205d0))
      bx(3)=bx(3)+cx*ff(3,j)/ff(2,j)
      bx(4)=bx(4)+cx*((ff(3,j)**2)-1.d0)/ff(2,j)
  184 br(1)=br(1)+bx(3)
      br(2)=br(2)+bx(4)
      i7=2
  186 if(jod(i6).eq.2) br(2)=br(2)/(2.d0*ff(2,j))
      do 187 ji=1,i7
  187 br(ji)=br(ji)*wt
      if(nl.eq.0) go to 189
      call XBETA(x,g,g,iin,jjn,rn,br(1),cx,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,1)
      if(nl.gt.1) go to 189
      if(joe(i6).ge.1) call XBETA(x,g,g,iin,jjn,rn,br(2),cx,
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,1)
      if(i7.eq.3) call XBETA(x,g,g,iin,jjn,rn,br(3),cx,xdata(1,jj),
     1loe(1,j),jom(i6),jon(i6),lq,1)
      go to 190
  189 ji=jom(i6)
      if(i7.eq.2) ji=0
      call BOSTON(br(1),br(2),br(3),joa(i6),moe(1,i6),loe(1,j),
     1xdata(1,jj),g,k,joe(i6),jol(i6),ji,x,i6,0,sc,iscal,nl)
  190 br(1)=bx(1)
      br(2)=bx(2)
      if(j.eq.i) go to 194
  192 j=i
      i7=3
      if(l.eq.j9) go to 186
  194 continue
      go to 245
c   Calculate random effect model for regression/ tobit non-mass
  200 cx=0.d0
      ex=0.d0
      ax=0.d0
      do 205 j=1,nt
      if(ff(6,j).lt.0.) go to 205
      ddfp(3)=ff(2,j)
      cx=cx+ff(3,j)
      ex=ex+ff(3,j)**2
      ax=ax+1.d0
  205 continue
      ddfp(1)=1.d0/(1.d0-ru+ru*ax)
      ddfp(2)=1.d0/(1.d0-ru)
      ddfp(4)=-(((ddfp(1)-ddfp(2))*cx**2)/ax+ddfp(2)*ex)/2.d0
c   Compute function value
      f=f-wt*(-ax*(dlog(ddfp(3))+.91893853205d0)-.5d0*((ax-1.d0)*dlog(1.
     1d0-ru)+dlog(1.d0-ru+ru*ax))+ddfp(4))
      br(2)=wt*(-2.d0*ddfp(4)-ax)/ddfp(3)
      if(jod(i6).eq.2) br(2)=br(2)/(2.d0*ddfp(3))
      br(3)=wt*.5d0*((ax-1.d0)*(ddfp(2)-ddfp(1))+((ax-1.d0)*ddfp(1)**2*c
     1x**2/ax-(ex-cx**2/ax)*ddfp(2)**2))
      ddfp(4)=(ddfp(1)-ddfp(2))*cx/ax
      i=0
      do 240 j=1,nt
      if(ff(6,j).lt.0.) go to 240
      i=i+1
      br(1)=wt*(ddfp(4)+ddfp(2)*ff(3,j))/ddfp(3)
      if(nl.eq.0) go to 235
      call XBETA(x,g,g,iin,jjn,rn,br(1),cx,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,1)
      if(i.gt.1) go to 240
      if(nl.gt.1) go to 235
      if(joe(i6).ge.1) call XBETA(x,g,g,iin,jjn,rn,br(2),cx,
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,1)
      if(j9.eq.1) go to 240
      call XBETA(x,g,g,iin,jjn,rn,br(3),cx,xdata(1,jj),loe(1,j),
     1jom(i6),jon(i6),lq,1)
      go to 240
  235 ji=jom(i6)
      if(i.gt.1.or.j9.eq.1) ji=0
      i7=joe(i6)
      if(i.gt.1) i7=0
      call BOSTON(br(1),br(2),br(3),joa(i6),moe(1,i6),loe(1,j),
     1xdata(1,jj),g,k,i7,jol(i6),ji,x,i6,0,sc,iscal,nl)
  240 continue
  245 if(ira.le.1.and.joe(i6).ge.2) i5=i5+nt
      if(jnd.eq.1.or.(jnd.eq.3.and.(ira.ne.2.or.i6.eq.me))) call ARLING(
     1s,g,le,0)
      if(ind.gt.0) go to 252
      if(ira.le.1.and.i6.lt.me) go to 45
c   Calculate cross-products matrix of first derivatives
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,le,2)
      if(jnd.eq.2.and.(ira.ne.2.or.la.eq.1.or.(la.eq.0.and.i7.eq.nt))) c
     1all ARLING(s,g,le,0)
      if(ira.eq.2.and.i7.lt.nt) go to 30
  250 continue
  252 if(iqz.gt.0) rewind inz
      if(ind.gt.0) return
  255 i=ira+3
      if(lg.gt.0.and.jnd.eq.0) call RANDAL(x,f,g,s,1,1,joe,moe,xx,bx,
     1joa,job,jod,jol,joa,i,ind)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FCPELD        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes correlation matrix estimates. jnd=0 is rho pseudo ML;
c   Jnd=1 is cross products of 1st deriv's; jnd=2 is 2nd deriv's.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CATCH  XBETA  PITTSB  CLEVE  MOVING  BOSTON  ARLING 
c
c   This subroutine is called by the following subroutines:
C   FCTGR  SECDRV  STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FCPELD(w,f,g,s,xdata,joe,loe,moe,ff,x,s12,d11,d12,p,
     1andrew,iin,jjn,rn,joa,jod,jol,jon,joh,jnd,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),s(1),f,FSTAT,bx,ff(6,nt),w(1),cx,FUNCTM
     1,s12(l1,lz),d12(l1,le),p(1),d11(1),ax,dx,ex,fx,rn(1),gg(2),hh(5),
     2yx,andrew(1),vrs,wt,f3,f4,sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),jod(1),jol(1),jon(1),joh(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,igm,a1(11),nl,ir,ln,a4(17),kvrs,jwt,dum(4)
      common /c2/ vrs
      common /d/ k,n,jb,kobs,lv,lw,lr,le,igmm,lz,a2(3),l1,a3(4),iqz,inz,
     1lq,dumd(3)
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
c$$$$$$$$$$$$$$$$$$$$$$$
      if(JOFunc.gt.0) then
          call cprint(26)
          stop
      endif
c$$$$$$$$$$$$$$$$$$$$$$$
      lgs=5
      if(jnd.eq.2) lgs=6
      wt=1.d0
      i10=nt
      if(igmm.eq.6) i10=me
      if(jnd.lt.2) go to 5
      j=l1*(l1+1)/2
      do 1 i=1,j
    1 s(i)=0.d0
      do 3 i=1,l1
      d11(i)=0.d0
      do 2 j=1,lz
    2 s12(i,j)=0.d0
      do 3 j=1,le
    3 d12(i,j)=0.d0
      do 4 i=1,lz
    4 p(i)=0.d0
    5 do 6 i=1,l1
      call CATCH(0,0,i,w(i),2,ind)
    6 continue
      jj=1
      do 100 ii=1,n
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
      if(igmm.eq.6) go to 10
    8 i8=0
      j9=0
      i5=-nt
      i6=0
    9 i6=i6+1
      i5=i5+nt
      if(igmm.eq.5) go to 10
      j=i6
      go to 12
   10 i7=0
      j9=0
   11 i7=i7+1
      if(igmm.eq.6) go to 8
      j=i7
   12 ff(6,j)=-1.d0
c   Branch if observation not wanted
      if(xdata(lv+i5+i7,jj).lt.0.) go to 24
      j9=j9+1
      if(jwt.gt.0.and.j9.eq.1) i=loe(jwt,i7)
      if(jwt.gt.0.and.j9.eq.1) wt=dble(xdata(i,jj))/vrs
      if(nl.eq.0) go to 13
c   Calculate x'b and sigma
      call XBETA(x,g,s,iin,jjn,rn,ff(1,j),f3,xdata(1,jj),loe(1,i7),
     2joa(i6),jon(i6),lq,0)
      if(nl.gt.1) go to 13
      ff(2,j)=1.d0
      if(joe(i6).ge.1) call XBETA(x,g,s,iin,jjn,rn,ff(2,j),f3,
     1xdata(1,jj),loe(1,i7),jol(i6),jon(i6),lq,0)
      go to 14
   13 call PITTSB(ff(1,j),ff(2,j),joa(i6),moe(1,i6),loe(1,i7),xdata(1,
     1jj),x,k,joe(i6),jol(i6),i6,sc,iscal,nl)
c   Calculate single equation function/gradient values
   14 if(jod(i6).eq.2.or.jod(i6).eq.4) ff(2,j)=dsqrt(ff(2,j))
      call CLEVE(gg,joe(i6),0,jod(i6),ff(1,j),xdata(lv+i5+i7,jj),
     1xdata(lv+i5+nt+i7,jj),0.0,ii,i7,i6,gg,ax,wt,lgs,ind)
      if(jnd.lt.2) go to 24
      if(igm.gt.1) go to 16
      if(nl.eq.0) go to 15
      call XBETA(x,p,p,iin,jjn,rn,gg(1),f3,xdata(1,jj),loe(1,i7),
     1joa(i6),jon(i6),lq,1)
      if(nl.gt.1) go to 15
      if(joe(i6).ge.1) call XBETA(x,p,p,iin,jjn,rn,gg(2),f3,xdata(1,jj),
     1loe(1,i7),jol(i6),jon(i6),lq,1)
      go to 24
   15 call BOSTON(gg(1),gg(2),f3,joa(i6),moe(1,i6),loe(1,i7),
     1xdata(1,jj),p,k,joe(i6),jol(i6),0,x,i6,0,sc,iscal,nl)
      go to 24
   16 ij=joh(i6)
c   Calculate vector of equation first derivatives/orthog. conditions
      do 22 i=1,k
      if(moe(i,i6).eq.4.or.moe(i,i6).ge.15) go to 22
      if((moe(i,i6).ge.5.and.moe(i,i6).le.7).or.(moe(i,i6).ge.12.and.moe
     1(i,i6).le.14)) go to 17
      ij=ij+1
      ji=loe(i,i7)
      p(ij)=p(ij)-gg(1)*dble(xdata(ji,jj))
   17 if(moe(i,i6).eq.0.or.moe(i,i6).eq.4.or.moe(i,i6).eq.8) go to 22
      do 20 l=2,ln
      if(moe(i,i6).eq.3.or.moe(i,i6).eq.7.or.moe(i,i6).eq.11.or.moe(i,i6
     1).eq.14) go to 18
      ij=ij+1
      if(l+i7-1.gt.nt) go to 18
      ji=loe(i,i7+l-1)
      p(ij)=p(ij)-gg(1)*dble(xdata(ji,jj))
   18 if(moe(i,i6).eq.2.or.moe(i,i6).eq.6.or.moe(i,i6).eq.10.or.moe(i,i6
     1).eq.13) go to 20
      ij=ij+1
      if(i7.lt.l) go to 20
      ji=loe(i,i7-l+1)
      p(ij)=p(ij)-gg(1)*dble(xdata(ji,jj))
   20 continue
   22 continue
      if(joe(i6).eq.0.or.(joe(i6).eq.1.and.igm.eq.3)) go to 24
      ij=ij+1
      p(ij)=p(ij)-gg(2)
   24 if(igmm.eq.6) go to 25
      if(i7.lt.nt) go to 11
      go to 26
   25 if(joe(i6).ge.2) i5=i5+nt
      if(i6.lt.me) go to 9
c   Loop over pairs of equations/time periods
   26 do 60 i=2,i10
      i1=i-1
      do 60 j=1,i1
      i8=i8+1
c   Branch if either Observation missing
      if(ff(6,i).lt.0..or.ff(6,j).lt.0.) go to 60
      ax=w(i8)
      dx=(1.d0-ax**2)
      if(dx.le.0.) go to 60
      ex=dsqrt(dx)
      if(ff(6,i).eq.0..and.ff(6,j).eq.0.) go to 40
      if(ff(6,i).eq.0.) go to 28
      if(ff(6,j).eq.0.) go to 30
c   Calculate function/rho 1st deriv/rho 2nd deriv both pairs continus
      fx=(ff(3,j)-ax*ff(3,i))/ex
      f=f+wt*((ff(3,i)**2)/2.d0+(fx**2)/2.d0+dlog(ff(2,i))+dlog(ff(2,j)*
     1ex)+1.8378770641d0)
      gg(1)=-(fx*(ff(3,j)*ax-ff(3,i))/ex-ax)/dx
      if(jnd.ne.2) go to 42
      hh(1)=((ff(3,j)*ax-ff(3,i))*ax+fx*ex)/(dx**2*ff(2,i))
      hh(2)=ff(3,i)*hh(1)
      hh(3)=-(ff(3,j)*ax-ff(3,i)+fx*ax*ex)/(dx**2*ff(2,j))
      hh(4)=ff(3,j)*hh(3)
      hh(5)=((ff(3,j)*ax-ff(3,i))/(ex*dx))**2+fx*(fx*ex+2.d0*ax*(ff(3,j)
     1*ax-ff(3,i)))/(ex*dx**2)+(1.d0+ax**2)/(dx**2)
      go to 42
   28 i9=j
      j9=i
      ij=3
      ji=1
      go to 32
   30 i9=i
      j9=j
      ij=1
      ji=3
c   CALC. func/rho 1st deriv/rho 2nd deriv one continuous other censor
   32 fx=-((-ff(1,j9)*ff(5,j9)+ax*ff(3,i9))/ex)*ff(5,j9)
      call CATCH(ii,i7,i6,fx,4,ind)
      bx=FSTAT(fx,0.,0.,0.,7)/(ex*ff(2,j9))
      cx=FSTAT(fx,0.,0.,0.,3)
      f=f+wt*((ff(3,i9)**2)/2.d0+dlog(ff(2,i9))+.91893853205d0-dlog(cx))
      gg(1)=bx*(ff(3,i9)-ff(1,j9)*ff(5,j9)*ax)*ff(5,j9)*ff(2,j9)/(dx*cx)
      if(jnd.ne.2) go to 42
      fx=-gg(1)*(bx/cx-fx/(ex*ff(2,j9)))+bx*ax/(dx*cx)
      hh(ij)=ff(5,j9)*ff(2,j9)*(bx/cx+fx*ax)/ff(2,i9)
      hh(1+ij)=ff(3,i9)*hh(ij)
      hh(ji)=-ff(5,j9)*fx
      if(joe(j9).ge.1) hh(1+ji)=ff(1,j9)*ff(5,j9)*hh(ji)
      hh(5)=-gg(1)*(fx*cx/bx+2.d0*ax/dx)+bx*ff(2,j9)*ff(1,j9)/(cx*dx)
      go to 42
c   Calculate function/rho 1st deriv/rho 2nd deriv both pairs censored
   40 yx=1.d0
      if(ff(5,j).ne.ff(5,i)) yx=-yx
      ax=ax*yx
      fx=FUNCTM(ff(1,i),ff(1,j),ax,ff(3,i),ff(3,j),1)
      call CATCH(ii,i7,i6,fx,7,ind)
      gg(1)=yx*FUNCTM(ff(1,i),ff(1,j),ax,ff(3,i),ff(3,j),0)/fx
      f=f-dlog(fx)*wt
      if(jnd.ne.2) go to 42
      bx=-(ff(1,i)*ax-ff(1,j))/ex
      cx=-(ff(1,j)*ax-ff(1,i))/ex
      call CATCH(ii,i7,i6,bx,4,ind)
      f3=FSTAT(bx,0.,0.,0.,3)
      call CATCH(ii,i7,i6,cx,4,ind)
      f4=FSTAT(cx,0.,0.,0.,3)
      hh(5)=-gg(1)*(yx*(dx*(ff(1,i)*ff(1,j)+ax)-ax*(ff(1,i)*(ff(1,i)-ax*
     1ff(1,j))+ff(1,j)**2))/(dx**2)-gg(1))
      hh(1)=-gg(1)*(cx*ff(5,i)/(ex*ff(2,i))-ff(5,i)*ff(4,i)*f3/fx)
      hh(3)=-gg(1)*(bx*ff(5,j)/(ex*ff(2,j))-ff(5,j)*ff(4,j)*f4/fx)
      if(joe(i).ge.1) hh(2)=ff(1,i)*ff(5,i)*hh(1)
      if(joe(j).ge.1) hh(4)=ff(1,j)*ff(5,j)*hh(3)
c   Put rho first derivatives in vector
   42 g(i8)=g(i8)-gg(1)*wt
      if(jnd.le.1) go to 60
      if(igmm.eq.5) go to 43
      if(jod(i).eq.2.or.jod(i).eq.4) hh(2)=hh(2)/(2.d0*ff(2,i))
      if(jod(j).eq.2.or.jod(j).eq.4) hh(4)=hh(4)/(2.d0*ff(2,j))
      go to 44
   43 if(jod(i6).ne.2.and.jod(i6).ne.4) go to 44
      hh(2)=hh(2)/(2.d0*ff(2,i6))
      hh(4)=hh(4)/(2.d0*ff(2,i6))
c   Put rho second derivatives in matrix
   44 do 45 ji=1,5
   45 hh(ji)=hh(ji)*wt
      d11(i8)=d11(i8)+hh(5)
      if(nl.eq.0) go to 51
      do 47 ji=1,lq
   47 andrew(ji)=0.d0
      if(igmm.eq.6) go to 48
      call XBETA(x,andrew,g,iin,jjn,rn,hh(1),f3,xdata(1,jj),loe(1,i),
     1joa(i6),jon(i6),lq,1)
      call XBETA(x,andrew,g,iin,jjn,rn,hh(3),f3,xdata(1,jj),loe(1,j),
     1joa(i6),jon(i6),lq,1)
      if(nl.gt.1) go to 49
      if(joe(i6).ge.1) call XBETA(x,andrew,g,iin,jjn,rn,hh(2),f3,
     1xdata(1,jj),loe(1,i),jol(i6),jon(i6),lq,1)
      if(joe(i6).ge.1) call XBETA(x,andrew,g,iin,jjn,rn,hh(4),f3,
     1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,1)
      go to 49
   48 call XBETA(x,andrew,g,iin,jjn,rn,hh(1),f3,xdata(1,jj),loe(1,i7),
     1joa(i),jon(i),lq,1)
      call XBETA(x,andrew,g,iin,jjn,rn,hh(3),f3,xdata(1,jj),loe(1,i7),
     1joa(j),jon(j),lq,1)
      if(nl.gt.1) go to 49
      if(joe(i).ge.1) call XBETA(x,andrew,g,iin,jjn,rn,hh(2),f3,
     1xdata(1,jj),loe(1,i7),jol(i),jon(i),lq,1)
      if(joe(j).ge.1) call XBETA(x,andrew,g,iin,jjn,rn,hh(4),f3,
     1xdata(1,jj),loe(1,i7),jol(j),jon(j),lq,1)
   49 do 50 ji=1,le
   50 d12(i8,ji)=d12(i8,ji)+andrew(ji)
      if(nl.eq.1) go to 60
   51 if(igmm.eq.6) go to 54
c   Put second derivatives rho with beta/sigma in matrix
      if(nl.gt.0) go to 53
      i9=joa(i6)
      do 52 ji=1,k
      if(moe(ji,i6).gt.7) go to 52
      i9=i9+1
      if(moe(ji,i6).gt.3) go to 52
      ij=loe(ji,i)
      j9=loe(ji,j)
      d12(i8,i9)=d12(i8,i9)+hh(1)*dble(xdata(ij,jj))+hh(3)*dble(xdata(j9
     1,jj))
   52 continue
   53 i9=jol(i6)
      if(joe(i6).ge.1) d12(i8,i9)=d12(i8,i9)+hh(2)+hh(4)
      go to 60
   54 if(nl.gt.0) go to 59
      i9=joa(i)
      j9=joa(j)
      do 58 ji=1,k
      ij=loe(ji,i7)
      if(moe(ji,i).gt.7) go to 56
      i9=i9+1
      if(moe(ji,i).gt.3) go to 56
      d12(i8,i9)=d12(i8,i9)+hh(1)*dble(xdata(ij,jj))
   56 if(moe(ji,j).gt.7) go to 58
      j9=j9+1
      if(moe(ji,j).gt.3) go to 58
      d12(i8,j9)=d12(i8,j9)+hh(3)*dble(xdata(ij,jj))
   58 continue
   59 i9=jol(i)
      if(joe(i).ge.1) d12(i8,i9)=d12(i8,i9)+hh(2)
      i9=jol(j)
      if(joe(j).ge.1) d12(i8,i9)=d12(i8,i9)+hh(4)
   60 continue
      if(ind.gt.0) go to 102
      if(igmm.eq.6) go to 70
      if(joe(i6).ge.2) i5=i5+nt
      if(i6.lt.me) go to 9
   70 if(jnd.eq.0) go to 97
c   Calculate cross-products of rho first derivatives
      call ARLING(s,g,l1,1)
      if(jnd.eq.1) go to 90
c   Calculate cross-products of rho & beta/sigma first derivatives
      do 85 i=1,lz
      do 80 j=1,l1
   80 s12(j,i)=s12(j,i)-g(j)*p(i)
   85 p(i)=0.d0
   90 do 95 i=1,l1
   95 g(i)=0.d0
   97 if(igmm.eq.6.and.i7.lt.nt) go to 11
  100 continue
  102 if(iqz.gt.0) rewind inz
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FCTGR        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates gradients and function values.
c
c   This subroutine calls the following subroutines:
C   RESTRN  FCLARS  FCMOFF  FCJOEY  FCHOTZ  FCPELD  COMPUT  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  SEARCH  CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FCTGR(x,f,g,xdata,joe,r,iii,rn,iin,vb,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),f,vb(1),r(1),rn(1),sc(1)
      dimension xdata(1),joe(me,9),iii(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,igm,a0(4),nfun,nsta,nfre,a4(5),ir,a1(4),iwo,
     1a5(11),ix0,ix2,ix4,dum(5)
      common /d/ k,a2(6),le,igmm,lz,a3(2),ny,l1,lee,lg,dumd(8)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 1 i=1,l1
    1 g(i)=0.d0
      f=0.d0
c   Adjust beta vector for restrictions on coefficients
      if(igmm.lt.5.and.ir.gt.0) call RESTRN(x,g,g,r,iii,0)
      if(igmm.eq.0) go to 40
      j1=2*me+1
      if(igm.eq.4) j1=me*(me-1)/2+1
      j2=j1+k*nt
      i1=lg+1
      go to(5,10,20,25,35,35),igmm
c   Calculate function/gradient for type=1
    5 i2=i1+2*nt
c** change *** comment out the following if CONTIM/MINREG used alone.
      call FCLARS(x,f,g,x,xdata,joe,joe(j1,9),joe(j2,9),vb(i1),iin,
     1iin(ny),rn,vb,vb(i2),vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),
     2joe(1,8),joe,joe,vb,vb,0,sc,iscal,ind)
      go to 32
   10 i6=max0(me,nt)
      i0=i1+i6
      i2=i0+i6*9
      i3=i2+i6*9
      i4=i3+i6
      i5=i4+me
      i7=i5+me
      i8=i7+me
c   Calculate function/gradient for type=2
c** change *** comment out the following if CONTIM/MINREG used alone.
      call FCMOFF(x,f,g,x,xdata,joe,joe(j1,9),joe(j2,9),vb(i1),vb(i0),
     1vb(i2),vb(i3),vb(i4),vb(i5),vb(i7),vb(i8),vb(i2),iin,iin(ny),rn,
     2vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,8),vb,vb,0,
     3sc,iscal,ind)
      go to 32
   20 i2=(1-iwo)*lz*(lz+1)/2+i1
      i3=i2+max0(lz,nt*5*me)
      i4=i3+lz
      i5=i4+lz*le
      i7=i5+le
c   Calculate function/gradient for type=3
c** change *** comment out the following if CONTIM/MINREG used alone.
      call FCJOEY(x,f,g,x,xdata,joe,joe(j1,9),joe(j2,9),vb(i1),vb(i2),
     1vb(i2),vb(i3),vb(i4),vb(i5),vb(i7),iin,iin(ny),rn,vb,joe(1,2),
     2joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb,vb,0,sc,
     3iscal,ind)
      go to 32
   25 continue
c   Calculate function/gradient for type=4
c** change *** comment out the following if CONTIM/MINREG used alone.
      call FCHOTZ(x,f,g,x,xdata,joe,joe(j1,9),joe(j2,9),vb(i1),iin,
     1iin(ny),rn,vb,vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),
     2joe(1,9),vb,vb,0,sc,iscal,ind)
c   Adjust gradient for restrictions on coefficients
   32 if(ir.gt.0) call RESTRN(x,g,g,r,iii,1)
      return
   35 i1=le+2
c   Calculate function/gradient for between eq./time correlations
c** change *** comment out the following if CONTIM/MINREG used alone.
      call FCPELD(x,f,g,x,xdata,joe,joe(j1,9),joe(j2,9),vb(i1),vb,vb,vb,
     1vb,vb,vb,iin,iin(ny),rn,joe(1,2),joe(1,5),joe(1,6),joe(1,8),
     2joe(1,9),0,sc,iscal,ind)
      return
   40 i1=nfre+1
      i2=i1+1
      i3=i2+1
      i4=i3+1
      i5=i4+1
c   Call COMPUT for function/gradiant for CONTIM
c** change *** comment out the following if HOTZTRan/MINREG used alone.
      call COMPUT(x,f,g,g,xdata,joe(ix4,1),joe(ix2,1),joe,joe(ix0,1),
     1vb,vb(i1),vb(i2),vb(i3),vb(i4),vb(i5),rn,iin,iin(ny),vb,0,ind)
      go to 32
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FEINIT        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FEINIT(ind)

c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(ind.gt.1) x=0.
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FLEPOW        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Performs fletcher-powell iterations.
c
c   This subroutine calls the following subroutines:
C   CPRINT  SEARCH  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FLEPOW(n,x,y,g,h,d,e,f0,ii,xdata,joe,r,iii,rn,iin,vb,
     1sc,isc,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),y(1),g(1),h(1),d(1),trial,fact,aa,bb,pr,
     1e(1),c1,c2,v1,v2,f,f0,egr,epa,egf,epsg,epsp,epsf,trial1,vb(1),
     2r(1),rn(1),sc(1)
      dimension xdata(1),joe(1),iii(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a1(11),icon,dum(28)
      common /f/ trial,egr,epa,egf,trial1,fact,aa,bb,maxtry,iter,pr,
     1epsg,epsp,epsf,maxite,iv1,iv2,na1,na2,dumf(5)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      trial=trial1
      if(ii.eq.0) call CPRINT(20)
  180 egr=0.d0
      iv1=1
      do 190 i=1,n
      if(dabs(g(i)).gt.egr) iv1=i
      if(dabs(g(i)).gt.egr) egr=dabs(g(i))
  190 continue
      if((icon.eq.1.or.icon.eq.2.).and.egr.le.epsg) return
      if(iter.eq.0.or.epa.gt.epsp) na1=0
      if(iter.eq.0.or.egf.gt.epsf) na2=0
      if(iter.eq.0) go to 200
      if(epa.le.epsp) na1=na1+1
      if(egf.le.epsf) na2=na2+1
      if((egr.le.epsg.and.na1.ge.2.and.na2.ge.2).or.((icon.eq.1.or.icon.
     1eq.3).and.na2.ge.2).or.((icon.eq.1.or.icon.eq.4).and.na1.ge.2)) re
     2turn
  200 if(iter.ge.maxite) go to 300
      iter=iter+1
      l=0
      do 205 i=1,n
      d(i)=0.d0
      do 205 j=1,i
      l=l+1
      if(j.lt.i) d(j)=d(j)-e(l)*g(i)
  205 d(i)=d(i)-e(l)*g(j)
      call SEARCH(n,x,y,g,h,d,f0,f,xdata,joe,r,iii,rn,iin,vb,ii,sc,isc,
     1ind)
      if(ind.gt.0) go to 240
      if(f.ne.0.) egf=dabs((f0-f)/f)
      f0=f
      epa=0.d0
      iv2=1
      do 210 i=1,n
      if(y(i).eq.0.) go to 208
      if(dabs((x(i)-y(i))/y(i)).gt.epa) iv2=i
      if(dabs((x(i)-y(i))/y(i)).gt.epa) epa=dabs((x(i)-y(i))/y(i))
  208 x(i)=y(i)
      y(i)=trial*d(i)
      c2=h(i)
      h(i)=h(i)-g(i)
  210 g(i)=c2
      l=0
      do 215 i=1,n
      d(i)=0.d0
      do 215 j=1,i
      l=l+1
      if(j.lt.i) d(j)=d(j)-e(l)*h(i)
  215 d(i)=d(i)-e(l)*h(j)
      c1=0.d0
      c2=0.d0
      do 220 i=1,n
      c1=c1+h(i)*y(i)
  220 c2=c2-h(i)*d(i)
      l=0
      v1=0.d0
      v2=0.d0
      do 230 i=1,n
      if(c1.ne.0.) v1=y(i)/c1
      if(c2.ne.0.) v2=d(i)/c2
      do 230 j=1,i
      l=l+1
  230 e(l)=e(l)+v1*y(j)-v2*d(j)
      go to 180
  240 if(ind.gt.2.or.ind.eq.1) return
      ind=0
      if(f.le.f0) go to 275
      do 270 i=1,n
  270 d(i)=-g(i)
      call SEARCH(n,x,y,g,h,d,f0,f,xdata,joe,r,iii,rn,iin,vb,ii,sc,isc,
     1ind)
      if(ind.gt.0) return
  275 if(f.ne.0.) egf=dabs((f0-f)/f)
      f0=f
      epa=0.d0
      iv2=1
      do 280 i=1,n
      if(y(i).eq.0.) go to 277
      if(dabs((x(i)-y(i))/y(i)).gt.epa) iv2=i
      if(dabs((x(i)-y(i))/y(i)).gt.epa) epa=dabs((x(i)-y(i))/y(i))
  277 x(i)=y(i)
  280 g(i)=h(i)
      go to 180
  300 ind=4
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FSTAT              (DOUBLE PRECISION FUNCTION)
c   Computes the significance of an f,chi-square,student's t or
c   Normal statistic.  The following inputs are used:
c      fb=statistic whose significance is desired (double precision)
c      f6=first degree of freedom (greater mean square) 0 for normal
c      f7=second degree of freedom (0 for all but f statistic)
c      f8=non-centrality parameter (0 if imst lt 4)
c      imst=code for statistic. 0=f statistic, 1=chi-square, 2=student
c           t statistic, 3=normal variable, 4=non-central f, 5=non-
c           central chi-square, and 6=non-central t. f and chi-square
c           must be positive. 7=normal density function at fb.
c   The significance level of fb is returned as FSTAT, the d.p. func.
c   Value.  It should be noted that the significance level Computed is
c   The probability that the given distribution exceeds the input
c   Statistic (absolute value of the input statistic for the t).
c   The significance level may be so small that it is rounded to zero.
c   Comparison of significance levels of statistics with different
c   Degrees of freedom is only accurate to about 10 to the -12.  Note
c   That the program often produces overflows and underflows which
c   Should not be allowed to stop execution.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      double precision function FSTAT(fb,f6,f7,f8,imst)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision fa,fb,f1,f2,x,z,theta,a,b,si,co,tot,w
      integer v1,v2,v
c--------------------BEGINNING OF FUNCTION-------------------------------
      if(imst.eq.7) go to 690
      m12=0
      if((imst.le.1.or.imst.eq.4.or.imst.eq.5).and.fb.le.0.) go to 920
      i1=imst+1
      go to (130,400,120,600,130,110,110),i1
  110 f1=dble(ifix(f6))
      go to 150
  120 fa=fb**2
      v1=1
      v2=ifix(f6)
      go to 140
  130 fa=fb
      v1=ifix(f6)
      v2=ifix(f7)
  140 f1=dble(v1)
      f2=dble(v2)
  150 go to (160,400,170,600,620,610,605),i1
  160 if(v1.gt.100.and.v2.gt.100) go to 630
      if(v1.gt.450) go to 430
  170 if(v2.gt.450) go to 450
      if(mod(v1,2).eq.0) go to 300
      if(mod(v2,2).eq.0) go to 320
c   F statistic
      theta=datan(dsqrt(f1*fa/f2))
      si=dsin(theta)
      co=dcos(theta)
      tot=0.d0
      if(v2.eq.1) go to 204
      tot=co
      if(v2.eq.3) go to 204
      w=co
      z=co**2
      i1=(v2-3)
      do 202 i=2,i1,2
      w=w*z*dble(i)/(dble(i)+1.d0)
  202 tot=tot+w
  204 a=.63661977277d0*(theta+(si*tot))
      b=0.d0
      if(v1.eq.1) go to 240
      w=1.d0
      if(v2.le.3) go to 232
      i1=v2-1
      do 230 i=2,i1,2
  230 w=w*(dble(i)/(dble(i)-1.d0))
  232 b=w*.63661977277d0*si*(co**f2)
      if(v2.eq.1) b=b*2.d0
      if(v1.eq.3) go to 240
      tot=1.d0
      w=1.d0
      z=si**2
      i1=(v1-2)
      do 235 i=3,i1,2
      w=w*z*(f2+dble(i)-2.d0)/dble(i)
  235 tot=tot+w
      b=b*tot
  240 FSTAT=1.d0-a+b
      go to 950
  300 x=1.d0-f2/(f2+f1*fa)
      b=f2
      v=v1
      go to 330
  320 x=f2/(f2+f1*fa)
      b=f1
      v=v2
      m12=1
  330 tot=1.d0
      if(v.eq.2) go to 350
      i1=v-2
      w=1.d0
      do 340 i=2,i1,2
      w=w*((b+dble(i)-2.d0)/dble(i))*x
  340 tot=tot+w
  350 FSTAT=(1.d0-x)**(b/2.d0)*tot
c  350 if((1.d0-x).lt.0.d0)FSTAT=(1.d0-x)**(b/2.d0)*tot
      go to 950
c   Chi square
  400 x=dsqrt(fb)
      v=ifix(f6)
      go to 470
  430 x=dsqrt(f2/fa)
      v=v2
      m12=1
      go to 470
  450 x=dsqrt(f1*fa)
      v=v1
  470 if(mod(v,2).eq.0) go to 520
      i1=1
      go to 680
  490 FSTAT=2.d0*FSTAT
      if(v.eq.1) go to 950
      tot=x
      if(v.eq.3) go to 515
      i1=(v-1)/2
      w=x
      b=x**2
      do 510 i=2,i1
      w=w*b/(2.d0*dble(i)-1.d0)
  510 tot=tot+w
  515 FSTAT=FSTAT+(z*2.d0*tot)
      go to 950
  520 z=dexp(-(x**2)/2.d0)
      tot=1.d0
      i1=v-2
      if(v.eq.2) go to 540
      w=1.d0
      b=x**2
      do 530 i=2,i1,2
      w=w*b/dble(i)
  530 tot=tot+w
  540 FSTAT=z*tot
      go to 950
c   Normal probability density
  600 x=fb
      go to 640
  605 x=(fb*(1.d0-1.d0/(4.d0*f1))-dble(f8))/dsqrt(1.d0+((fb**2)/(2.d0*f1
     1)))
      go to 640
  610 f1=dble(f8)+f1
      f2=2.d0*(1.d0+dble(f8)/f1)/(9.d0*f1)
      x=((fb/f1)**.33333333333d0-1.d0+f2)/dsqrt(f2)
      go to 640
  620 w=2.d0*(f1+2.d0*dble(f8))/(9.d0*((f1+dble(f8))**2))
      z=f1*fa/(f1+dble(f8))
      x=((z**.33333333333d0)*(1.d0-2.d0/(9.d0*f2))-1.d0+w)/dsqrt(w+(2.d0
     1/(9.d0*f2))*(z**.66666666667d0))
      go to 640
  630 x=(fa-(f2/(f2-2.d0)))/((f2/(f2-2.d0))*dsqrt(2.d0*(f1+f2-2.d0)/(f1*
     1(f2-4.d0))))
  640 if(x) 650,660,670
  650 m12=1
      x=-x
      go to 670
  660 FSTAT=.5d0
      go to 950
  670 i1=0
  680 z=.398942280401d0*dexp(-.5d0*x**2)
      a=1.d0/(1.d0+.2316419d0*x)
      FSTAT=z*(.319381530d0*a-.356563782d0*(a**2)+1.781477937d0*(a**3)-1
     1.821255978d0*(a**4)+1.330274429d0*(a**5))
      if(i1.eq.1) go to 490
      go to 950
  690 FSTAT=.398942280401d0*dexp(-.5d0*fb**2)
      return
  920 FSTAT=1.d0
  950 if(m12.eq.1) FSTAT=1.d0-FSTAT
      if(FSTAT.lt.0.) FSTAT=0.d0
      if(FSTAT.gt.1.) FSTAT=1.d0
      return
      end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   FUNCTM            (DOUBLE PRECISION FUNCTION)
c   Evaluates probabilty or density of standard bivarite normal.
c       x1 normalized lower bound (or value if density) of var. 1
c       x2 normalized lower bound (or value if density) of var. 2
c       rho is correlation of x1 and x2
c       imst=0 implies density. imst=1 implies probability.
c   Probability is probability of exceeding x1 and x2. value returned
c   As FUNCTM. s1 and s2 are univariate lower bound cumulative normals.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      double precision function FUNCTM(x1,x2,rho,s1,s2,imst)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x1,x2,rho,q1,q2,q3,a1,a2,a3,r1,r2,r1a,r1b,r2a,r2b
     1,s1,s2
c      double precision FSTAT
c--------------------BEGINNING OF FUNCTION-------------------------------
      if(imst.eq.0) go to 60
      q1=rho
      if(rho.eq.0.) go to 15
      k=200
      if(x1.eq.0..or.x2.eq.0.) k=1
      j=0
      q2=0.d0
      a1=dsign(1.d0,rho)
      a2=1.d0
      a3=dlog(dabs(rho))
      q3=a3
      r1a=1.d0
      r2a=1.d0
      r1b=0.d0
      r2b=0.d0
      do 10 i=1,100
      q3=q3+a3
      q2=q2-dlog(dble(i+1))
      r1=-x1*r1a-dble(i-1)*r1b
      r2=-x2*r2a-dble(i-1)*r2b
      if(k.eq.i) go to 5
      k=k+2
      if(r1.eq.0..or.r2.eq.0.) go to 5
      r1b=dlog(dabs(r1))+dlog(dabs(r2))+q2+q3
      if(r1b.lt.-15.) go to 3
      j=0
      q1=q1+dexp(r1b)*dsign(1.d0,r1)*dsign(1.d0,r2)*a2
      go to 5
    3 j=j+1
      if(j.ge.2) go to 15
    5 r1b=r1a
      r2b=r2a
      r1a=r1
      r2a=r2
   10 a2=a2*a1
   15 if(s1.le.0..or.s2.le.0.) go to 50
      r1b=-100.d0
      if(q1.eq.0.) go to 20
      r1a=dsign(1.d0,q1)
      r1b=-1.837877066410d0-.5d0*x1**2-.5d0*x2**2+dlog(dabs(q1))
   20 q1=dlog(s1)+dlog(s2)
      if(q1.lt.-20.) go to 25
      q1=dexp(q1)
      go to 30
   25 q1=0.d0
   30 if(r1b.lt.-20.) go to 35
      r1b=dexp(r1b)*r1a
      go to 40
   35 r1b=0.d0
   40 FUNCTM=q1+r1b
      if(FUNCTM.lt.0.) FUNCTM=0.d0
      if(FUNCTM.gt.1.) FUNCTM=1.d0
      return
   50 FUNCTM=0.d0
      return
   60 q1=(x1**2-2.d0*rho*x1*x2+x2**2)/(1.d0-rho**2)
      FUNCTM=(.159154943092d0/dsqrt(1.d0-rho**2))*dexp(-q1/2.d0)
      return
      end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   HEADNG        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Prints convergence results.
c
c   This subroutine calls the following subroutines:
C   CPRINT  
c
c   This subroutine is called by the following subroutines:
C   PRINTA  PRINTC  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine HEADNG(ind1,ind2,ind3,ind4,f1,f,iter1,iter,mb)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision f,f1,tri,egr,epa,egf,epsg
      dimension aq(6,7),fz(2),bw(10)
c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,tim1,tim2,dum
      common /c/ me,nt,igm,istan,istar,irho,irhp,lt,iscal,ivcb,jc,a4(3),
     1nl,ir,ln,igs,ifs,lm,iwo,ira,ires,jres,irip,dumc(15)
      common /b/ ip,a8(39),lwi,dumb(3)
      common /f/ tri,egr,epa,egf,a0(12),epsg,a6(5),iv1,iv2,na1,na2,
     *dumf(5)
      common /hess/ ll1,ihhh,lle
c------------------------DATA STATEMENTS---------------------------------
      data aq/4HConv,4Herge,4Hnce ,4HAchi,4Heved,1H ,4HPara,4Hmete,
     *4Hr Er
     1,4Hror ,4Hin F,4HCTGR,4HNo C,4Honve,4Hrgen,4Hce i,4Hn Se,4Harch,
     *4HDire
     2,4Hctio,4Hn Se,4Harch,4H Uph,3Hill,4HNo C,4Honve,4Hrg C,4Honti
     3,4Hnue ,4HF.P.,4Hno C,4Honve,4Hrgen,4Hce i,4Hn FL,4HEPOW,4HRan ,
     44HOut ,4Hof T,3Hime,1H ,1H /
      data bw/4HStee,4Hpest,4H Des,4Hcent,4HFlet,4Hcher,4H  Po,4Hwell,
     14H Not,4H Run/
      data fz/4H Yes,4H  No/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      call CPRINT(1)
      if(lwi.eq.0) write(ip,2)
    2 format(/49x,'Summary Statistics of Optimizer Performance ',
     & 'and Convergence')
      if(lwi.eq.1) write(ip,3)
    3 format(/11x,'Summary Statistics of Optimizer Performance ',
     & 'and Convergence')
      if(ind1.lt.0.or.jc.eq.8.or.jc.eq.9) go to 8
      if(lwi.eq.0) write(ip,4) (bw(i),i=1,4)
    4 format(//52x,'---- ',4a4,' ----')
      if(lwi.eq.1) write(ip,5) (bw(i),i=1,4)
    5 format(//28x,'---- ',4a4,' ----')
      i=ind1+1
      if(i.eq.6) i=7
      if(lwi.eq.0) write(ip,6) ind1,(aq(j,i),j=1,6),iter1,tim2,ind2,f1
    6 format(/40x,'Stop Code =',i2,1x, 13('.'),1x,6a4,/40x,'Number of It
     1erations =',i4,2x,'Time in Seconds',f9.3,/40x,'Hessian Code =',i2,
     23x,'Function Value =',g17.7)
      if(lwi.eq.1) write(ip,7) ind1,(aq(j,i),j=1,6),iter1,tim2,ind2,f1
    7 format(15x,'Stop Code =',i2,1x,13('.'),1x,6a4,/15x,'Number of Iter
     1ations =',i4,2x,'Time in Seconds',f9.3,/15x,'Hessian Code =',i2,3x
     2,'Function Value =',g17.7)
      go to 11
    8 if(lwi.eq.0) write(ip,9) (bw(i),i=1,4),bw(9),bw(10)
    9 format(//52x,'- ',6a4,' -')
      if(lwi.eq.1) write(ip,10) (bw(i),i=1,4),bw(9),bw(10)
   10 format(/27x,'- ',6a4,' -')
   11 if(ind3.lt.0.or.jc.eq.8) go to 14
      i=ind3+1
      if(i.ge.5) i=i+1
      if(ind1.ge.0) tim1=tim1-tim2
      if(lwi.eq.0) write(ip,4) (bw(j),j=5,8)
      if(lwi.eq.1) write(ip,5) (bw(j),j=5,8)
      if(lwi.eq.0) write(ip,6) ind3,(aq(j,i),j=1,6),iter,tim1,ind4,f
      if(lwi.eq.1) write(ip,7) ind3,(aq(j,i),j=1,6),iter,tim1,ind4,f
      go to 17
   14 if(lwi.eq.0) write(ip,9) (bw(i),i=5,10)
      if(lwi.eq.1) write(ip,10) (bw(i),i=5,10)
      if(jc.eq.8) then
         if(lwi.eq.0) write(ip,1898) ihhh,mb
1898     format(/40x,'Hessian Condition of Covariance Matrix ',
     &          8('.'),i5,/40x,'Number of Unused Words of Core '
     &         ,12('.'),i9)
         if(lwi.eq.1) write(ip,1899) ihhh,mb
1899     format(/15x,'Hessian Condition of Covariance Matrix ',
     &          8('.'),i5,/15x,'Number of Unused Words of Core '
     &         ,12('.'),i9)
         return
      endif
   17 i=2
      if(egr.le.epsg) i=1
      l=2
      if(na2.ge.2) l=1
      m=2
      if(na1.ge.2) m=1
      j=2
      if(ind4.ne.1) j=1
      if(lwi.eq.0) write(ip,18) egf,fz(l),egr,iv1,fz(i),epa,iv2,fz(m),
     1tri,fz(j),ihhh,mb
   18 format(//52x,'---- Convergence Values ----',//40x,'Function Propor
     1tional Change ',5('.'),g14.7,a4,/40x,'Maximum Gradient Element ',3
     2('.'),g14.7,' (',i3,')',a4,/40x,'Max. Parameter Prop. Change ',g14
     3.7,' (',i3,')',a4,/40x,'2nd Derivatives Determinant ',6('.'),g14.7
     4,a4,//40x,'Hessian Condition of Covariance Matrix ',8('.'),i5,/40x
     5,'Number of Unused Words of Core ',12('.'),i9)
      if(lwi.eq.1) write(ip,19) egf,fz(l),egr,iv1,fz(i),epa,iv2,fz(m),
     1tri,fz(j),ihhh,mb
   19 format(/27x,'---- Convergence Values ----',/15x,'Function Proporti
     1onal Change ',5('.'),g14.7,a4,/15x,'Maximum Gradient Element ',3('
     2.'),g14.7,' (',i3,')',a4,/15x,'Max. Parameter Prop. Change ',g14.7
     3,' (',i3,')',a4,/15x,'2nd Derivatives Determinant ',6('.'),g14.7,a
     44,//15x,'Hessian Condition of Covariance Matrix ',8('.'),i5,/15x,
     5'Number of Unused Words of Core ',12('.'),i9)
      if(ind3.lt.0) f=f1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   IHESSN              (FUNCTION)
c
c   Provided to V. Joseph Hotz by George Yates.
c
c   Computes hessian condition from npin x npin cholesky factor, h.
c
c   The form of this function is ihhh = IHESSN(h,npin), where:
c   h      is the cholesky factor, consisting of the lower triangular
c          n(n+1)/2 elements stored in the vector h.
c   npin   is its rank.  
c   It should be the case that the hessian condition is an integer < 10; 
c   otherwise, the matrix is essentially singular.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      function IHESSN(h,npin)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision h(1),amx,amn,atm
c--------------------BEGINNING OF FUNCTION-------------------------------
      mm=1
      amx=h(1)*h(1)
      amn=amx
      if(npin.lt.2) go to 65
      do 60 i=2,npin
      mm=mm+i
      atm=h(mm)*h(mm)
      if(atm.gt.amx) amx=atm
      if(atm.lt.amn) amn=atm
   60 continue
   65   if(amx*amn.le.0.0d0) ihessn=20
        if(amx*amn.gt.0.0d0) ihessn=dlog10(amx/amn)+0.5d0
        return
        end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   INTPOL         (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Interpolates distance along gradient.
c
c   This subroutine is called by the following subroutines:
C   SEARCH  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine INTPOL (p1,p2,p3)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision p1(1),p2(1),p3(1),w,z
c-------------------BEGINNING OF SUBROUTINE------------------------------
      z=(3.d0/(p2(1)-p1(1)))*(p1(3)-p2(3))+p1(2)+p2(2)
      if(dabs(p1(2)+p2(2)+2.d0*z).lt..0000005) go to 200
      w=z**2-p1(2)*p2(2)
      if(w.le.0.) go to 200
      w=dsqrt(w)
      p3(1)=p1(1)+(1.d0-((p2(2)+w-z)/(p2(2)-p1(2)+2.d0*w)))*(p2(1)-p1(1)
     1)
      return
  200 p3(1)=p1(1)-p1(2)*((p2(1)-p1(1))/(p2(2)-p1(2)))
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   INVS            (SUBROUTINE OF MAIN PART OF HOTZTRAN)         
c
c   Provided to V. Joseph Hotz by George Yates.  CURRENTLY NOT USED BY
c   HotzTRan.
c
c   Inverts a symmetric matrix (ms=1) in place and calculates
c   its determinant.
c
c   The arguments are:
c   a      is the matrix to be inverted.  It consists of the lower triangular
c          n(n+1)/2 elements stored in a vector.
c   n      is the rank of the a matrix.
c   c      is the determinant of the matrix.
c   w      is an n x 1 vector of workspace.
c         
c   This subroutine calls the following subroutines:
c   
c
c   This subroutine is called by the following subroutines:
c   
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine INVS(a,n,c,w)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
	double precision u,x,y,z,d,a(1),c,w(1)
c	dimension a(1),w(1)
	integer diagmk
	integer diag,diag2,rowno,rowcol
	integer colno
c-------------------------COMMON BLOCKS----------------------------------
        common /b/ ip,inp,ipc,a2(5),kcore,a1(31),lwi,dumb(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
	d=a(1)
	if(d)10,20,10
   10	a(1)=1.0d0/d
	if(n-1)20,20,200
  200	diag=1
	do 140 k=2,n
	km1=k-1
	diagmk=diag
	diag=diag+k
	u=a(diag)
	colno=diagmk
	diag2=0
	do 90 i=1,km1
	x=0.0d0
	colno=colno+1
	rowno=diagmk
	j=1
	rowcol=diag2
  300	if(j-i)310,320,320
  310	rowcol=rowcol+1
	rowno=rowno+1
	y=a(rowcol)
	z=a(rowno)
	x=x+y*z
	j=j+1
	go to 300
  320	rowcol=rowcol+1
   60	rowno=rowno+1
	y=a(rowcol)
	z=a(rowno)
	x=x+y*z
	rowcol=rowcol+j
	j=j+1
	if(j-k)60,70,70
   70	w(i)=-x
	y=a(colno)
	u=u-x*y
	diag2=diag2+i
   90	continue
	d=d*u
	if(u)100,20,100
  100	a(diag)=1.0d0/u
	rowno=diagmk
	diag2=0
	do 140 i=1,km1
	rowno=rowno+1
	diag2=diag2+i
	x=w(i)
	x=x/u
	a(rowno)=x
	rowcol=diag2
	do 140 j=i,km1
	y=w(j)
	z=a(rowcol)
	a(rowcol)=z+x*y
	rowcol=rowcol+j
  140	continue
   20	c=d
	if(c)6665,99,6665
   99	write(ip,97)
   97   format(10x,'******** Matrix Inversion Error:',
     $      '  Matrix is Singular ********')
	stop
 6665	return
	end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   IOBS              (FUNCTION)
c   Evaluates inequalities for observation selection.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      function IOBS(a,b,id)

c--------------------BEGINNING OF FUNCTION-------------------------------
      IOBS=0
      go to(1,2,3,4,5,6),id
    1 if(a.gt.b) IOBS=1
      return
    2 if(a.lt.b) IOBS=1
      return
    3 if(a.ge.b) IOBS=1
      return
    4 if(a.le.b) IOBS=1
      return
    5 if(a.eq.b) IOBS=1
      return
    6 if(a.ne.b) IOBS=1
      return
      end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   IYYM        (FUNCTION)
c   Selects variables from lower triangular matrix.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      function IYYM(i1,i2)

c--------------------BEGINNING OF FUNCTION-------------------------------
      IYYM=(i1*(i1-1))/2+i2
      if(i2.gt.i1) IYYM=(i2*(i2-1))/2+i1
      return
      end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   KIMBAL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine allows the user to directly program regression
c   or index functions, g(x,beta), and the gradients (first derivatives)
c   of this function with respect to beta, i.e., dg(x,beta)/dbeta, for 
c   the different Models and Estimation Types within HotzTran.  It is 
c   particularly useful when doing large data problems on systems of
c   equations when the regression or index function is nonlinear and 
c   when the user is willing to program the function and derivatives.
c   Using this subroutine will tend to greatly speed up estimation as
c   compared to using the nonlin=1 or 2 options within HotzTran.
c
c   This subroutine below will need to be replaced by the user created 
c   version of KIMBAL if this option is to be used. 
c
c   To INVOKE this feature of HotzTran, an option has been created
c   to include on the MASTER CONTROL CARD.  In particular, the user can
c   set
c
c   nfunc = 0,1,...
c          where the INTEGER used is the number of the equations which 
c          are specified with the BASIC EQUATION CARD(s) for which the
c          user-supplied KIMBAL routine is to be used to calculate the
c          regression or index function and the first derivatives of 
c          these functions instead of having the program do these 
c          calculations.  Note that nfunc=K will mean that KIMBAL will
c          be used for the first K equations; the remaining equations,
c          if any, will be handled by the regular methods in HotzTran.
c          The DEFAULT setting for nf is 0.  
c          To use this feature, you will need to always estimate the 
c          single model or system of models (multiple equations) using
c          the nonlin=0 and pstan=3 options.  With respect to the first
c          option, you will need to "trick" HotzTran into thinking it
c          will be estimating models for which the regression or index
c          functions are linear in variables X when using the nfunc= K
c          (K > 0) option.  You will then have EQUATION VARIABLE CARD(s)
c          which list as many variables on this list as parameters you
c          will need to estimate in your regression or index function,
c          g(x,beta), i.e., you will have to have at least L x's in the 
c          kth equation (in the set of K equations) if beta is of
c          dimensionality L.  By doing this, you will make sure that
c          the program allocates an parameter vector which is long
c          enough.  Then you can write a KIMBAL routine (using the 
c          following shell) to use some or all of those variables (x's) 
c          and parameters (beta's) to construct the particular regression
c          or index function you want for each equation and program the 
c          derivatives of this function with respect to the parameters, 
c          i.e., dg(x,beta)/dbeta.  
c         
c   The parameters called below (or held in a Common block) are as 
c   follows:
c   jeff = number of equations for which the user-supplied subroutine
c          applies.  This variable is read in on the MASTER CONTROL CARD
c          as option nf=jeff.  The equations using this subroutine must
c          be placed first in the system of equations being estimated.
c   vd = if id = 0 : value of X'b = f(X,b)
c        if id = 1 : g1 = value of dF/d(Xb), that is the first part
c                    of the chain rule derivative.  F is whatever
c                    function is being max'ed or min'ed as part of
c                    constructing the estimator.  Note that the value
c                    of this piece is calculated elsewhere and passed
c                    to this subroutine.
c   g = value of gradient
c   x = vector of betas (highly intuitive name...)
c   z = vector of data  (The data is stored as single precision but
c       should be entered as double precision [using dble(z(.))]
c       in the computation of the function or the gradient.
c   joe1 = position in the x (beta) vector which is ONE BEFORE
c          the string of coefficients applicable to the current
c          equation entering this subroutine.
c   loe(.) = a vector of indices into the data, i.e. loe(I) is the 
c            index in the data vector of the ith variable for the 
c            current time period.
c   moe(.) = a vector of indices for the data which determines for I.V.
c            estimation whether the variable appears in the equation or
c            is an instrument which does not appear in the equation.  
c            (This is not generally a very important variable, but it should
c            always be the case that moe(I) > 7 for the variable to enter
c            an equation directly.)
c   gx = a 0/1 code which indicates whether the gradients should be
c        cumulated across calls to this subroutine or not.  If gx = 1,
c        they should be and if gx = 0 they should not be.  In calculating
c        the gradients the form should be g(i) = g(i) * gx - contribution
c        for current equation.
c   jcode = number of the equation in the system currently entering this
c           user defined subroutine. Such equations must appear first 
c           in the input deck system.
c   lbeta = the length of the parameter vector which has been set to use
c           for the equation currently called by this routine.  
c   sc( ) = the vector of parameter scaling factors.  These are set in
c           the subroutine RESCL if iscal=0
c   iscal = indicator for whether scaling of parameters should be used.  
c           If iscal = 0 use scaling, if iscal /= 0 then don't use
c           scaling.
c   id = which derivative is being calculated:
c        0 = actual function value
c        1 = gradient
c        2 = second derivatives (This should never be needed.  When
c            using a version of KIMBAL.F, the second derivatives 
c            should always be approximated by the outer product of
c            first derivatives.  To insure this set pstan=3,4 on the
c            MASTER CONTROL CARD).
c
c   This subroutine is called by the following subroutines:
C   BOSTON  PITTSB  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine kimbal(vd,g,x,z,joe1,loe,moe,gx,jcode,lbeta,sc,
     $  iscal,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision vd,g(1),x(1),gx,sc(1)
      dimension loe(1),moe(1),z(1)
c    dimension idatusd(120)
      character*14 knam(300)
c-------------------------COMMON BLOCKS----------------------------------
      common /k/ jeff
      common /label/ knam
      common /simp1/ last,istsim,ipb,jcc,NUMER
c------------------------DATA STATEMENTS---------------------------------
c   One needs to set up index function to figure out correct position of 
c   data variables in the array.  This is necessary because the loe function
c   needs as an argument not the variable's index in the entire data set,
c   but rather its index in the subset of the entire data set consisting
c   of all those variables used as independent variables somewhere in  
c   the system of equations currently under consideration.  The matrix
c   idatusd holds an index variable for each variable in the original
c   data matrix indicating whether or not it is used as an independent
c   variable in the current system of equations.  The array idtndx(X)
c   holds the index, in the temporary data set, of the variable whose
c   index in the complete data set is X.
c
c    data idatusd / 0,0,0,0,1,1,1,1,1,1,
c   $               1,1,1,1,0,0,0,0,0,0,
c   $               0,0,0,0,0,1,1,1,1,0,
c   $               0,0,1,1,1,1,1,1,0,0, 
c   $               1,1,1,1,1,1,1,1,1,1,
c   $               1,0,1,1,1,1,1,1,1,1,
c   $               1,1,1,1,1,1,1,1,1,1,
c   $               1,1,1,1,1,1,1,1,0,1,
c   $               1,1,1,1,1,1,1,1,1,1,
c   $               1,1,1,1,1,1,1,1,1,1,
c   $               1,1,1,1,1,1,1,1,1,1,
c   $               1,1,1,1,1,1,1,1,1,0 /
c
c-------------------BEGINNING OF SUBROUTINE------------------------------
c
      write (*,24) 
 24   format('  Dummy call to KIMBAL.  Relink with User-Supplied'/,
     &  '  KIMBAL Subroutine in order to proceed.')
       stop
       end
c
c    if (jcode.gt.jeff) RETURN
c      if(g(1).eq.0.d0) then
c      do 3022 kv=1,300
c      knam(kv) = '              '
c 3022   continue
c      endif
c
c   Need to include the following type of code so that the program handles
c   scaling correctly.
c
c    if(iscal.eq.0) then
c      do 2 kk = 1,20
c        x(kk) = sc(kk) * x(kk)
c2       continue
c      endif
c   Initialize index matrix for data.
c
c    jcount = 0
c    do 10 icount = 1,120 
c      if (idatusd(icount).gt.0) then
c        jcount = jcount + 1
c        idtndx(icount) = jcount
c      endif
c10    continue
c      if (id.eq.0) then
c        if (jcode.eq.1) then
c       
c       
c        elseif (jcode.eq.2) then
c
c          endif
c      elseif (id.eq.1) then
c
c     Increment gradient vector.
c     If scaling-of-parameters is on, scale the gradients so that
c     the gradients are in terms of the scaled parameters.  If not,
c     do not scale the gradients.
c
c        if (jcode.eq.1) then
c      if(iscal.ne.0) then
c
c       Increment gradient vector without scaling.
c
c          g(1) = g(1) * gx - vd * derivative term
c          g(2) = g(2) * gx - vd * derivative term
c
c       Increment gradient vector with scaling.
c
c          g(1) = g(1) * gx - vd * derivative term * sc(igc)
c          g(2) = g(2) * gx - vd * derivative term * sc(igc)
c      endif
c
c        elseif (jcode.eq.2) then
c
c      if(iscal.ne.0) then
c
c       Increment gradient vector without scaling.
c
c          g(1) = g(1) * gx - vd * derivative term
c          g(2) = g(2) * gx - vd * derivative term
c
c       Increment gradient vector with scaling.
c
c          g(1) = g(1) * gx - vd * derivative term * sc(igc)
c          g(2) = g(2) * gx - vd * derivative term * sc(igc)
c          endif
c        endif
c
c   Before returning to main program, if iscal = 0, reset parameters
c   back to scaled form.
c
c    if(iscal.eq.0) then
c      do 85 kk2 = 1,20
c        x(kk2) = x(kk2) / sc(kk2)
c85      continue
c    endif
c    return
c    end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   KWAST        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decomposes each section of an element into  r1*(beta(i1)**r2).
c
c   This subroutine calls the following subroutines:
C   MYRON  DAVID  
c
c   This subroutine is called by the following subroutines:
C   RDREST  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine KWAST(a,j1,r1,r2,i1,k,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision r1,r2,v2
      dimension a(1),i1(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      r1=1.d0
      r2=1.d0
      do 3 i2=1,6
    3 i1(i2)=0
      i2=0
      i3=0
      i5=1
      j1=j1-1
c   Bypass first character which is +,-,*,/,b,=
    5 j1=j1+1
      call MYRON(a(j1),k)
      if(k.eq.18.or.k.eq.19) go to 52
      if(k.ne.22) go to 7
c   Check for log/exponent
      call DAVID(a(j1),k1)
      call DAVID(a(j1+1),k2)
      if((k1.ne.12.and.k1.ne.5).or.(k2.ne.14.and.k2.ne.24)) go to 65
      j1=j1+1
      if(k1.eq.5) j1=j1+1
      i1(3)=1
      if(k1.eq.5) i1(3)=2
      go to 5
    7 if(k.ge.20.or.(k.ge.16.and.j1.eq.1)) go to 65
      if(k.eq.15) r1=-r1
      if(k.eq.17) i2=1
      if(k.ge.14) go to 5
      if(k.eq.12.or.k.eq.13) go to 23
      v2=0.d0
c   Accumulate r1 term
   10 if(k.eq.11) go to 15
      if(i3.eq.0) v2=v2*10.d0+dble(k-1)
      if(i3.gt.0) v2=v2+dble(k-1)/(10.d0**i3)
      if(i3.gt.0) i3=i3+1
      go to 20
   15 if(i3.gt.0) go to 65
      i3=1
   20 j1=j1+1
      call MYRON(a(j1),k)
      if(k.le.11) go to 10
      if(k.eq.12.or.k.eq.13) go to 65
      i3=0
      if(i2.eq.1) v2=1.d0/v2
      i2=0
      r1=r1*v2
      if(i1(3).eq.1) r1=dlog(dabs(r1))
      if(i1(3).eq.2) r1=dexp(r1)
      if(i1(3).gt.0) i1(3)=0
      if(k.eq.14.or.k.eq.15.or.k.ge.18) go to 60
      if(k.eq.17) i2=1
      j1=j1+1
c   Check for log/exponent
      call DAVID(a(j1),k1)
      call DAVID(a(j1+1),k2)
      if((k1.ne.12.and.k1.ne.5).or.(k2.ne.14.and.k2.ne.24)) go to 21
      j1=j1+2
      if(k1.eq.5) j1=j1+1
      i1(3)=1
      if(k1.eq.5) i1(3)=2
c   Bypass b or v
   21 call MYRON(a(j1),k1)
      if(k1.eq.12.or.k1.eq.13) go to 22
      if(k1.eq.16) go to 35
      j1=j1-1
      go to 60
c   Accumulate i1 or i2 term
   22 k=k1
c   Check if b or v
   23 k2=1
      if(k.eq.13) k2=2
c   Check for vt term denoting trend or seasonal
      call DAVID(a(j1+1),k)
      if(k.ne.20) go to 25
      k2=3
      j1=j1+1
   25 j1=j1+1
      call MYRON(a(j1),k)
      if(k.ge.11.and.k.le.13) go to 65
      if(k.gt.10) go to 27
      i1(i5)=i1(i5)*10+k-1
      go to 25
   27 if(k2.eq.2) i1(i5)=-i1(i5)
      if(k2.eq.3) i1(i5)=i1(i5)+1
      if(k.ne.18) go to 32
      if(i1(i5).eq.0.or.k2.ne.2) go to 65
      k2=0
c   Check for lagged or lead terms  e.g.  v21(-1)
      call MYRON(a(j1+1),k)
      if(k.lt.14.or.k.gt.15) go to 28
      if(k.eq.15) k2=1
      j1=j1+1
      go to 29
   28 if(k.gt.10) go to 65
   29 j1=j1+1
      call MYRON(a(j1),k)
      if(k.gt.10) go to 30
      i1(4+i5)=i1(4+i5)*10+k-1
      go to 29
   30 if(k.ne.19) go to 65
      if(k2.eq.1) i1(4+i5)=-i1(4+i5)
      j1=j1+1
      call MYRON(a(j1),k)
   32 if(k.ne.16.or.i5.gt.1) go to 57
      j1=j1+1
c   Identify ** term
      call MYRON(a(j1),k1)
      if(k1.eq.16) go to 35
      j1=j1-1
      go to 57
c   Accumulate r2 term
   35 v2=0.d0
   40 j1=j1+1
      i5=i5+1
      call MYRON(a(j1),k)
      if(k-11) 43,45,50
   43 if(i3.eq.0) v2=v2*10.d0+dble(k-1)
      if(i3.gt.0) v2=v2+dble(k-1)/(10.d0**i3)
      if(i3.gt.0) i3=i3+1
      go to 40
   45 if(i3.gt.0) go to 65
      i3=1
      go to 40
   50 if(i5.gt.2) go to 55
      if(k.eq.12.or.k.eq.13) go to 23
      if(k.ne.14.and.k.ne.15) go to 65
      if(k.eq.15) i2=-i2+1
      i5=1
      go to 40
c   Evaluate ( or )
   52 if(i2.eq.1.and.k.eq.18) k=17
      i1(4)=k
      if(k.le.18) return
      j1=j1+1
      call MYRON(a(j1),k)
      go to 32
c   Evaluate b's as exponents
   55 r2=v2
   57 if(i2.gt.0) r2=-r2
   60 return
   65 ind=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MALLAR        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decodes variable names/numbers when brackets not used.
c
c   This subroutine calls the following subroutines:
C   MYRON  MATCH  
c
c   This subroutine is called by the following subroutines:
C   CONBAS  CONTRL  MINREG  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MALLAR(a,j1,id,ab,ntar,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension ab(9,ntar),a(1),id(4),vb(6)
c------------------------DATA STATEMENTS---------------------------------
      data vb/1Hn,1Hv,1H=,1H ,1H-,1Ht/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(ierror.gt.0) go to 55
      do 5 k=1,4
    5 id(k)=0
      if(a(j1+1).eq.vb(4)) return
      k1=1
      if(a(j1+1).ne.vb(1).and.a(j1+2).ne.vb(2)) go to 10
      call MYRON(a(j1+3),k)
      if(k.gt.10) go to 25
      id(3)=1
      j1=j1+2
      go to 15
   10 if(a(j1+1).ne.vb(2)) go to 25
      call MYRON(a(j1+2),k)
      if(k.gt.10) go to 25
      j1=j1+1
   15 call MYRON(a(j1+1),k)
      if(k.gt.10) go to 40
      j1=j1+1
      id(k1)=id(k1)*10+k-1
      go to 15
   25 l=0
   30 if(a(j1+l+1).eq.vb(3).or.a(j1+l+1).eq.vb(4).or.a(j1+l+1).eq.vb(5))
     1go to 35
      l=l+1
      if(l.gt.8) go to 100
      go to 30
   35 call MATCH(-1,ab,ntar,l,j1,id(1),a,ierror)
      if(ierror.gt.0) return
      j1=j1+1
   40 if(id(1).eq.0) id(1)=ntar
      j1=j1+1
      if(a(j1).ne.vb(3)) go to 45
      if(a(j1+1).eq.vb(6)) j1=j1+1
      k1=2
      go to 15
   45 if(a(j1).eq.vb(4).and.a(j1+1).eq.vb(5)) j1=j1+1
      if(a(j1).ne.vb(4).and.a(j1).ne.vb(5)) go to 100
      if(a(j1).eq.vb(5)) id(4)=1
      if(a(j1).eq.vb(5).and.a(j1+1).eq.vb(4)) j1=j1+1
      return
   55 do 60 i=1,j1
   60 a(ierror+8+j1+i)=a(ierror-1+i)
      k=j1
      j1=0
      i=0
   65 i=i+1
      if(a(ierror+8+k+i).ne.vb(2)) go to 85
      j=0
   70 call MYRON(a(ierror+9+k+i),k1)
      if(k1.gt.10) go to 75
      i=i+1
      j=j*10+k1-1
      go to 70
   75 if(j.eq.0) j=ntar
      l=ab(9,j)
      do 80 k1=1,l
      j1=j1+1
   80 a(ierror-1+j1)=ab(k1,j)
      go to 90
   85 j1=j1+1
      a(ierror-1+j1)=a(ierror+8+k+i)
   90 if(i.lt.k) go to 65
      return
  100 ierror=14
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MARKY        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads unformatted alphanumeric control cards and removes blanks.
c
c   This subroutine calls the following subroutines:
C   MATCH  
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  CARDRD  CONBAS  CONDAT  VARNAM  CONTRL  MINREG  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MARKY(a,id,iz,ab,ntar,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension a(1),vb(11),ab(1),vc(2,10)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,inp,a1(8),ipk,a2(29),lwi,dum(3)
c** change *** this contains code settings $ ( )      [   ]
c------------------------DATA STATEMENTS---------------------------------
      data vb/4H    ,1H,,1H$,1H=,1Ht,1Ho,1H.,1H(,1H),1H[,1H]/
      DATA VC/4HDATA,1H ,4HVAR_,4HNAME,4HTRAN,4HFORM,4HMAST,2HER,4HBASI,
     11HC,4HVARI,4HABLE,4HTEST,3HING,4HO_C_,4HTEST,4HNON-,3HLIN,4HREST,
     24HRICT/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l=0
      k=0
      n=1
      ierror=0
c** change *** set 80 index to 72 for 72 column input file.
   10 do 12 i=1,72
   12 a(i+l)=vb(1)
c** change *** set 80 index to 72 for 72 column input file.
      read(inp,15,err=60,end=60) (a(i+l),i=1,72)
   15 format(80a1)
c   Change made by Jacob Klerman 10/6/85 - moved comment from between 
c   continuation line
c** change *** set 80 index to 72 for 72 column input file.
      if(ipk.eq.0.and.l.eq.0.and.lwi.eq.0) write(ip,16) (vc(i,iz),i=1,2)
     1,(a(i),i=1,72)
   16 format(41x,2a4,2x,80a1)
      if(ipk.eq.0.and.l.eq.0.and.lwi.eq.1) write(ip,17) (vc(i,iz),i=1,2)
     1,(a(i),i=1,70)
   17 format(2a4,1x,70a1)
c** change *** set 80 index to 72 for 72 column input file.
      if(ipk.eq.0.and.l.gt.0.and.lwi.eq.0) write(ip,18) (a(i+l),i=1,72)
   18 format(51x,80a1)
      if(ipk.eq.0.and.l.gt.0.and.lwi.eq.1) write(ip,19) (a(i+l),i=1,70)
   19 format(8x,1x,70a1)
      j=0
      i=0
   21 i=i+1
      if(a(i+l).eq.vb(1).or.a(i+l).eq.vb(2)) go to 27
      if(a(i+l).eq.vb(10)) go to 23
      if(id.eq.2) go to 22
      if(a(i+l).eq.vb(3)) go to 35
      if(a(i+l).eq.vb(8)) k=k+1
      if(a(i+l).eq.vb(9)) k=k-1
   22 n=0
      j=j+1
      a(j+l)=a(i+l)
      go to 30
   23 if(iz.lt.3.or.iz.eq.8.or.iz.eq.10) go to 65
      i1=0
   24 if(a(i+l+i1+1).eq.vb(11)) go to 25
      i1=i1+1
      if(i1.lt.9) go to 24
   25 if(i1.ge.9.or.i1.le.0) go to 65
      i2=i+l
      i3=j+l
c   MATCH variable names
      call MATCH(iz,ab,ntar,i1,i2,i3,a,ierror)
      if(ierror.gt.0) return
      i=i+i1+1
      j=i3-l
      n=0
      go to 30
   27 if(id.eq.1) go to 30
      if(a(i+l).eq.vb(2).and.k.gt.0) go to 22
      if(a(i+l).eq.vb(1).and.k.gt.0) go to 30
      n=n+1
      if(j.eq.0.or.n.gt.1) go to 30
      j=j+1
      a(j+l)=vb(1)
c** change *** set to (i.lt.72) for 72 column input file.
   30 if(i.lt.72) go to 21
      go to 45
   35 if(id.eq.1.or.n.gt.0.or.k.eq.1) go to 40
      j=j+1
      a(j+l)=vb(1)
      n=1
   40 l=l+j
      go to 10
   45 a(j+l+1)=vb(1)
      if(n.eq.0) a(j+l+2)=vb(1)
      if(id.ge.1) return
      l=j+l
      j=0
      do 55 i=1,l
      if(a(i).ne.vb(1)) go to 50
      if(i.eq.1.or.a(i-1).eq.vb(4).or.a(i+1).eq.vb(4)) go to 55
      if((a(i+1).eq.vb(7).and.a(i+4).eq.vb(7)).or.(a(i+1).eq.vb(5).and.a
     1(i+2).eq.vb(6)).or.(a(i-1).eq.vb(6).and.a(i-2).eq.vb(5))) go to 55
   50 j=j+1
      a(j)=a(i)
   55 continue
      a(j+1)=vb(1)
      a(j+2)=vb(1)
      return
   60 ierror=1
      return
   65 ierror=14
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MATCH        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Match variable names to variable numbers.
c
c   This subroutine calls the following subroutines:
C   ERRWRT  
c
c   This subroutine is called by the following subroutines:
C   MALLAR  MARKY  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MATCH(iz,ab,ntar,i1,i2,i3,a,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision r1
      dimension a(1),ab(9,1),vb(12)
c------------------------DATA STATEMENTS---------------------------------
      data vb/1H ,1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1Hv/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(ntar.eq.0) go to 15
      do 10 i=1,ntar
      i4=ab(9,i)
      if(i4.ne.i1) go to 10
      do 5 j=1,i4
      if(ab(j,i).ne.a(i2+j)) go to 10
    5 continue
      go to 25
   10 continue
   15 if(iz.ne.3) go to 30
      ntar=ntar+1
      i=ntar
      ab(9,ntar)=i1
      do 20 j=1,8
      if(j.le.i1) ab(j,ntar)=a(i2+j)
      if(j.gt.i1) ab(j,ntar)=vb(1)
   20 continue
   25 if(iz.lt.0) go to 27
      i3=i3+2
      a(i3-1)=vb(12)
      i4=i/100
      j=(i-i4*100)/10
      if(i.ge.100) i3=i3+1
      if(i.ge.100) a(i3-1)=vb(i4+2)
      if(i.ge.10) i3=i3+1
      if(i.ge.10) a(i3-1)=vb(j+2)
      i4=i-i4*100-j*10
      a(i3)=vb(i4+2)
      return
   27 i3=i
      return
   30 call ERRWRT(0,a(i2+1),i1,0,0,r1)
      ierror=14
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MATIN5        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c       Inverts symmetric matrix stored linearly.  Prints message about
c       colinearity, if encountered.
c       n    order of matrix
c       a    matrix to be inverted. must be symetric and stored lower
c            triangular (a(1,1),a(2,1),a(2,2),a(3,1),,, etc.)
c       b    a inverse,stored as a vector
c       y    working array. must be dimensioned (n) in calling prog.
c       d    determinant(a)
c       jfix if=1 then fixup for colinear rows. otherwise no fixup.
c       ierr if =0 then a non-singular.  If larger than zero then
c            first row which caused singularity.
c       eps is set as tolerance from zero. determines singularity
c       If b is to replace a, then use same array for both in call-
c       ing program.
c
c   This subroutine is called by the following subroutines:
C   DANNYP  SECDRV  STANER  START  WEPETE  SECDRS  STARS  LESQAR  
c------------------------------------------------------------------------
      subroutine MATIN5(n,a,b,y,d,jfix,ierr)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision a(1),b(1),y(1),d,eps,f
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(39),lwi,dum(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
c************************
      eps=.5d-10
c      eps=1.0d-12
c************************
      ierr=0
      nn=(n*(n+1))/2
      do 205 i=1,nn
  205 b(i)=a(i)
      d=1.d0
      l=1
  208 f=b(1)
c   Change made by Jacob Klerman 7/85 - take out this determinant accumulation
c              we don't need it and it overflows
c   D=d*f
      if(n.eq.1) go to 255
      na=1
      do 210 i=2,n
      na=na+i-1
  210 y(i)=b(na)
      if(f.lt.eps) go to 260
  215 na=0
      nb=1
      do 220 i=2,n
      nb=nb+1
      y(1)=y(i)/f
      do 220 j=2,i
      nb=nb+1
      na=na+1
  220 b(na)=b(nb)-y(j)*y(1)
      do 230 j=2,n
      na=na+1
  230 b(na)=-y(j)/f
      b(nn)=-1.d0/f
      l=l+1
      if(l.le.n) go to 208
      do 250 i=1,nn
  250 b(i)=-b(i)
      return
  255 if(f.lt.eps) go to 260
      b(1)=1.d0/f
      return
  260 if(lwi.eq.0) write(ip,270) d,l
  270 format(/36x,12('*'),' Matrix Not Positive Definite ',12('*'),/3
     16x,'Determinant = ',g12.5,' Row (',i3,') Colinear.  Equals')
      if(lwi.eq.1) write(ip,275) d,l
  275 format(/12x,12('*'),' Matrix Not Positive Definite ',12('*'),/
     112x,'Determinant = ',g12.5,' Row (',i3,') Colinear.  Equals')
      na=0
      if(l.eq.1.or.dabs(b(1)).gt.eps) go to 300
      j=n-l+2
      do 290 i=j,n
      if(dabs(y(i)).le.eps) go to 290
      f=-y(i)
      na=i-j+1
      if(lwi.eq.0) write(ip,280) na,f
  280 format(47x,'Row (',i3,') Times',g12.4,' Plus')
      if(lwi.eq.1) write(ip,285) na,f
  285 format(23x,'Row (',i3,') Times',g12.4,' Plus')
  290 continue
      if(na.gt.0) go to 320
  300 if(lwi.eq.0) write(ip,310)
  310 format(52x,'Non-Positive Diagonal')
      if(lwi.eq.1) write(ip,315)
  315 format(28x,'Non-Positive Diagonal')
  320 ierr=l
      if(n.eq.1) b(1)=1.d0
      if(n.eq.1.or.jfix.ne.1) return
      f=1.d0
      d=1.d0
      do 330 i=1,n
  330 y(i)=0.d0
      go to 215
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MISS      (FUNCTION)
c   Evaluates observations for missing variable code.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      function MISS(x)

c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a1(34),mi1,mi2,gl,dum(7)
c--------------------BEGINNING OF FUNCTION-------------------------------
      MISS=0
      if(mi1.eq.0) return
      if(mi1-2) 5,10,15
    5 if(x.le.gl) MISS=1
      return
   10 if(x.eq.gl) MISS=1
      return
   15 if(x.ge.gl) MISS=1
      return
      end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   MOFSTR        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
C   Fills in hermite points for single factor ML.
c   Xh are the evaluation points (symetric about zero). wh are weights
c   The weight of xh equals weight of -xh. mm is # hermite points.
c   Values from "Handbook of Mathematical Functions" Abramowitz &
c   Stegun eds., p.924.
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MOFSTR

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xh,wh
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ as(13),mm,dum(26)
      common /e/ xh(9),wh(9),dume(30)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(mm.le.1) mm=1
      if(mm.eq.5) mm=4
      if(mm.gt.6.and.mm.lt.9) mm=6
      if(mm.ge.9) mm=9
      go to(1,2,3,4,4,6,6,6,9),mm
    1 xh(1)=0.7071067811865480d0
      wh(1)=8.862269254528000d-1
      return
    2 xh(1)=0.5246476232752900d0
      xh(2)=1.6506801238857850d0
      wh(1)=8.049140900055000d-1
      wh(2)=8.131283544725000d-2
      return
    3 xh(1)=0.436077411927617d0
      xh(2)=1.335849074013697d0
      xh(3)=2.350604973674492d0
      wh(1)=7.246295952244000d-1
      wh(2)=1.570673203229000d-1
      wh(3)=4.530009905509000d-3
      return
    4 xh(1)=0.3811869902073221d0
      xh(2)=1.1571937124467802d0
      xh(3)=1.9816567566958429d0
      xh(4)=2.9306374202572440d0
      wh(1)=6.611470125582413d-1
      wh(2)=2.078023258148919d-1
      wh(3)=1.707798300741347d-2
      wh(4)=1.996040722113676d-4
      return
    6 xh(1)=0.314240376254359d0
      xh(2)=0.947788391240164d0
      xh(3)=1.597682635152605d0
      xh(4)=2.279507080501060d0
      xh(5)=3.020637025120890d0
      xh(6)=3.889724897869782d0
      wh(1)=5.701352362625000d-1
      wh(2)=2.604923102642000d-1
      wh(3)=5.160798561588000d-2
      wh(4)=3.905390584629000d-3
      wh(5)=8.573687043588000d-5
      wh(6)=2.658551684356000d-7
      return
    9 xh(1)=0.d0
      xh(2)=0.5316330013426547d0
      xh(3)=1.0676487257434506d0
      xh(4)=1.6129243142212313d0
      xh(5)=2.1735028266666208d0
      xh(6)=2.7577629157038887d0
      xh(7)=3.3789320911414941d0
      xh(8)=4.0619466758754743d0
      xh(9)=4.8713451936744031d0
      wh(1)=2.654589688124318d-1
      wh(2)=4.018264694704120d-1
      wh(3)=1.726482976700971d-1
      wh(4)=4.092003414975628d-2
      wh(5)=5.067349957627538d-3
      wh(6)=2.986432866977530d-4
      wh(7)=7.112289140021310d-6
      wh(8)=4.977078981630794d-8
      wh(9)=4.58057893079863d-11
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MOVING        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes MOVING average cross products of orthogonality conditions.
c
c   This subroutine is called by the following subroutines:
C   FCHOTZ - FCPELD  COMPUT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MOVING(stor,p,s,la,lc,lz,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision stor(lz,la),p(1),s(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(id.gt.1) go to 10
      do 5 j=1,lz
      stor(j,1)=0.d0
    5 stor(j,2)=0.d0
      lc=1
      return
   10 l=0
      do 15 i=1,lz
      do 15 j=1,i
      l=l+1
   15 s(l)=s(l)+p(i)*p(j)+stor(i,1)*p(j)+stor(j,1)*p(i)
      lc=lc+1
      if(lc.gt.la) lc=2
      do 20 i=1,lz
      stor(i,1)=stor(i,1)+p(i)-stor(i,lc)
      stor(i,lc)=p(i)
   20 p(i)=0.d0
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MULTIP        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Multiplies matrices.
c
c   This subroutine is called by the following subroutines:
C   SECDRV  STANER  START  WEPETE  COMPUT  SECDRS  STARS  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MULTIP(x1,x2,x3,x4,x5,l1,l2,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x1(1),x2(1),x3(l1,l1),x4(l2,l1),x5(l2,l1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      go to (1,11,21,31,24,1,11),id
    1 i1=l1*(l1+1)/2
      do 2 i=1,l1
    2 x1(i)=0.d0
      do 3 i=1,i1
    3 x2(i)=0.d0
      if(id.eq.1) return
      i1=0
      do 5 i=1,l1
      i1=i1+i
    5 x2(i1)=1.d0
      return
   11 do 12 i=1,l1
      do 12 j=1,l1
      x3(i,j)=0.d0
      do 12 k=1,l1
      i1=IYYM(i,k)
      i2=IYYM(j,k)
   12 x3(i,j)=x3(i,j)+x1(i1)*x2(i2)
      i1=0
      do 13 i=1,l1
      do 13 j=1,i
      i1=i1+1
      x2(i1)=0.d0
      do 13 k=1,l1
      i2=IYYM(j,k)
   13 x2(i1)=x2(i1)+x3(i,k)*x1(i2)
      if(id.ne.7) return
      i1=l1*(l1+1)/2
      do 15 i=1,l1
   15 x1(i)=x2(i)
      return
   21 do 22 i=1,l1
      do 22 j=1,l2
      x5(j,i)=0.d0
      do 22 k=1,l2
      i2=IYYM(j,k)
   22 x5(j,i)=x5(j,i)+x4(k,i)*x2(i2)
      go to 27
   24 do 25 i=1,l1
      do 25 j=1,l2
   25 x5(j,i)=x4(j,i)
   27 i1=0
      do 29 i=1,l1
      do 29 j=1,i
      i1=i1+1
      x1(i1)=0.d0
      do 29 k=1,l2
   29 x1(i1)=x1(i1)+x5(k,i)*x4(k,j)
      return
   31 do 32 i=1,l1
      do 32 j=1,l2
      x5(j,i)=0.d0
      do 32 k=1,l1
      i2=IYYM(i,k)
   32 x5(j,i)=x5(j,i)+x4(j,k)*x2(i2)
      i1=0
      do 36 i=1,l2
      do 36 j=1,i
      i1=i1+1
      x1(i1)=0.d0
      do 36 k=1,l1
   36 x1(i1)=x1(i1)+x5(i,k)*x4(j,k)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MULTIS        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Multiplies matrices.
c
c   This subroutine is called by the following subroutines:
C   STANER  START  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MULTIS(x1,x2,x3,x4,x5,y,l1,l2,l3,l4,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x1(l1,l2),x2(l2,l3),x3(l1,l2),x4(l4,l2),x5(l1,l4)
     1,y(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      go to (1,10,20,30,40,50),id
    1 do 3 i=1,l1
      do 2 j=1,l3
      y(j)=0.d0
      do 2 l=1,l2
    2 y(j)=y(j)+x1(i,l)*x2(l,j)
      do 3 j=1,l3
    3 x1(i,j)=y(j)
      return
   10 do 15 i=1,l2
      do 15 j=1,l3
   15 x2(i,j)=x2(i,j)/x1(1,i)
      return
   20 l=0
      do 25 i=1,l2
      do 25 j=1,i
      l=l+1
   25 x2(l,1)=(x2(l,1)/x1(1,i))/x1(1,j)
      return
   30 do 33 i=1,l1
      do 31 j=1,l2
      y(j)=0.d0
      do 31 l=1,l2
      i1=IYYM(j,l)
   31 y(j)=y(j)+x1(i,l)*x2(i1,1)
      do 33 j=1,l2
   33 x1(i,j)=y(j)
      return
   40 l=0
      do 45 i=1,l1
      do 45 j=1,i
      l=l+1
      do 45 i1=1,l2
   45 x2(l,1)=x2(l,1)-x1(i,i1)*x3(j,i1)-x1(j,i1)*x3(i,i1)
      return
   50 do 60 j=1,l1
      do 55 i=1,l2
      y(i)=0.d0
      do 55 l=1,l2
      i1=IYYM(i,l)
   55 y(i)=y(i)+x1(j,l)*x2(i1,1)
      do 60 i=1,l2
   60 x1(j,i)=y(i)
      do 65 i=1,l1
      do 65 j=1,l4
      x5(i,j)=0.d0
      do 65 l=1,l2
   65 x5(i,j)=x5(i,j)+x1(i,l)*x4(j,l)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MYRON        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decodes alphanumeric restriction codes.  
c
c   This subroutine is called by the following subroutines:
C   CONBAS  CONDAT  DECODS  KWAST  MALLAR  TRANSI  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MYRON(a,k)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension b(21)
c------------------------DATA STATEMENTS---------------------------------
      data b/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H.,1Hb,1Hv,1H+,1H-
     1,1H*,1H/,1H(,1H),1H ,1H=/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 10 k=1,21
      if(a.eq.b(k)) return
   10 continue
      k=22
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   NLSCL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
C   Does scaling for non-linear regression or index functions.
c
c   This subroutine is called by the following subroutines:
C   RESCL  RESCS  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine NLSCL(scal,beta,rn,iin,jjn,le,lee,lq)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision scal(1),beta(1),POW,rn(1)
      dimension iin(1),jjn(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 11 i=1,le
      scal(i)=0.d0
      if(beta(i).eq.0.or.i.gt.lq) scal(i)=1.d0
   11 continue
      j1=0
      do 12 l=1,lee
      j1=j1+2
      i2=iin(j1-1)
      do 12 i1=2,i2
      j1=j1+1
      if(iin(j1).le.0) go to 12
      if(iin(j1).lt.1000.and.jjn(j1).eq.0) go to 12
      j=iin(j1)
      if(j.gt.1000) j=j-1000
      if(iin(j1).ge.2000) j=jjn(j1)
      if(j.gt.0) scal(j)=1.d0
   12 continue
      do 13 i=1,le
      if(scal(i).ne.0.) go to 13
      scal(i)=beta(i)
      beta(i)=1.d0
   13 continue
      j1=1
      do 28 l=1,lee
      i2=iin(j1)
      do 26 i1=1,i2
      j1=j1+1
      j=j1
      j2=iin(j1)+j1-1
   17 if(j1.eq.j2) go to 26
      j1=j1+1
      if(iin(j1).le.-2000) go to 19
      if((iin(j1).le.0.and.jjn(j1).le.0).or.iin(j1).ge.2000) go to 17
      j4=iin(j1)
      j5=jjn(j1)
      if(j5.le.0.and.j4.gt.0.and.j4.lt.1000) rn(j)=rn(j)*POW(scal(j4),rn
     1(j1))
      if(j5.gt.0.and.j4.gt.0.and.j4.lt.1000) rn(j)=rn(j)*(scal(j4)**rn(j
     11))
      if(j5.gt.0) rn(j1)=rn(j1)*scal(j5)
      go to 17
   19 j3=-iin(j1)-2000
      if(iin(j1).lt.-3000) j3=j3-1000
      j4=jjn(j1)
      if(j4.gt.0) rn(j1)=rn(j1)*scal(j4)
      do 24 i3=1,j3
      j1=j1+1
      j9=j1
      j6=iin(j1)+j1-1
   20 if(j1.eq.j6) go to 24
      j1=j1+1
      if((iin(j1).le.0.and.jjn(j1).le.0).or.iin(j1).ge.2000) go to 20
      j4=iin(j1)
      j5=jjn(j1)
      if(j5.le.0.and.j4.gt.0.and.j4.lt.1000) rn(j9)=rn(j9)*POW(scal(j4),
     1rn(j1))
      if(j5.gt.0.and.j4.gt.0.and.j4.lt.1000) rn(j9)=rn(j9)*(scal(j4)**rn
     1(j1))
      if(j5.gt.0) rn(j1)=rn(j1)*scal(j5)
      go to 20
   24 continue
      go to 17
   26 continue
   28 j1=j1+1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   OWNFUN        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Customized version of FC-Routine.  It is called from FCLARS.
c   
c   To use this routine, you need to tell HotzTran in the input setup that
c   you are doing so.  You need to include the following options on the
c   MASTER CONTROL CARD(s) in HotzTran:
c
c   ofunc = 0,1
c           This option stands for "own function".  If you set ofunc=0, 
c           HotzTran assumes that you are NOT supplying your own subroutine
c           which will calculate the objective function to be estimated.
c           If ofunc=1, then HotzTran assumes that you are supplying your
c           own function in the subroutine called OWNFUN.  The Default 
c           setting for this parameter is ofunc=0.
c           NOTE that you should use the ofunc=1 option with type=1 (set
c           on the MASTER CONTROL CARD(s) ONLY.  DO NOT use it with any
c           of the other type=? options.
c
c   Note that jnd=0 is when you want to only calculate function and parameter 
c   gradients.  The remaining codes determine what the way the variance-
c   covariance matrix is calculated.  If jnd=1 is cross-products of 1st 
c   deriv's jnd=2 is time summed cross-products of 1st deriv's; jnd=3 
c   is expectation of 2nd derivatives.
c
c   The following are the definitions of the various variables, vectors,
c   and matrices used in this routine:
c
c   n   is the number of individuals in the data.
c
c   nt  is the number of time periods.
c
c   me  is the number of equations.
c
c   xdata(jb,n) is the data matrix (stored in single precision) for the
c                 n-th observation, where jb is the total number of variables
c                 in the column vector for the n-th individual.  The order
c                 of the variables is as follows: 
c                 * lv elements are the variables (lv of them) used in one 
c                   (or more) of the equations.  These are variables are 
c                   contained in descending order in which they appeared in 
c                   the original data set.
c                 * nt elements are index variables which indicate whether
c                   the FIRST EQUATION should be estimated for the nt-th
c                   time period for the n-th observation.  If the variable is
c                   < 0, it should not be used; otherwise, it is = 0.
c                 * nt elements which are the dependent variables for each 
c                   time period for the FIRST EQUATION.
c                 * nt elements are index variables which indicate whether
c                   the SECOND EQUATION (if there is more than 1 equation)
c                   should be estimated for the nt-th time period for the 
c                   n-th observation.  If the variable is < 0, it should not 
c                   be used; otherwise, it is = 0.
c                 * nt elements which are the dependent variables for each 
c                   time period for the SECOND EQUATION.
c                      .
c                      .
c                      .
c                 * nt elements are index variables which indicate whether
c                   the ME-TH EQUATION (if there is more than me-1 equations)
c                   should be estimated for the nt-th time period for the 
c                   n-th observation.  If the variable is < 0, it should not 
c                   be used; otherwise, it is = 0.  (NOTE THAT THESE VARIABLES
c                   HAVE MORE INFORMATION IN THEM IF one is ESTIMATING TOBIT
c                   EQUATIONS.)
c                 * nt elements which are the dependent variables for each 
c                   time period for the ME-TH EQUATION.
c
c   x   is the vector of all parameters in the estimation.
c       *** NOTE THIS SUBROUTINE ASSUMES THAT IN EACH EQUATION THERE WILL BE
C       *** A TOTAL OF LX BETA COEFFICIENTS SO THAT THE TOTAL NUMBER OF 
C       *** BETA COEFFICIENTS SPECIFIED IS me*LX.  USING RESTRICTION CARDS
C       *** IN HotzTran, SOME OF THESE COEFFICIENTS CAN BE RESTRICTED TO BE
C       *** ZERO (when one wants to drop out variables from one or more of
c       *** the equations or to NORMALIZE the COEFFICIENTS in ONE of the 
c       *** EQUATIONS).
c
c   g   is the vector of all gradients (first derivatives of the criterion
c       function) in estimation.
c
c   gg  is the vector of the contributions of the i-th individual observation
c       to the gradients (first derivatives of the criterion
c       function) in estimation.
c
c   f   is the function value.
c
c   s  is vector containing the lower triangular elements of the covariance 
c       matrix of the parameter estimates.
c
c   vv(  )  is a work array.
c
c   loe(.) = a vector of indices into the data, i.e. loe(I) is the 
c            index in the data vector of the ith variable for the 
c            current time period.
c
c   moe(.) = a vector of indices for the data which determines for I.V.
c            estimation whether the variable appears in the equation or
c            is an instrument which does not appear in the equation.  
c            (This is not generally a very important variable, but it should
c            always be the case that moe(I) > 7 for the variable to enter
c            an equation directly.)
c
c   LX = the maximum number of coefficients which appears in each equation.
c        NOTE that the user must set the value of the parameter below.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 2/13/91.
c
c   This subroutine calls the following subroutines:
C   CATCH  XBETA  PITTSB  CLEVE  MOVING  BOSTON  ARLING  RANDAL  
c
c   This subroutine is called by the following subroutines:
C   FCTGR  SECDRV  STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine OWNFUN(x,f,g,s,xdata,joe,loe,moe,ff,iin,jjn,rn,xx,bb,
     1vv,joa,job,jod,jol,jon,joh,joi,stor,xm,jnd,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),s(1),f,bb(5,nt,me),rn(1),
     1xx(1),ff(2,nt),vv(1),vrs,fetol,stor(1),xm(31,me),sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),job(1),jod(1),jol(1),jon(1),joh(1),joi(1)

c       DOUBLE PRECISION B(10,10,12), BK(10,10,12),
c     * XH(10,506,12), XI(506,12), DBE(506,12),
c     * DT(10,10), DH(10), XL1(10,12), XAT(10,10),
c     * XL2(10,10), DQ(10,10,12), DS(10,10,12), DM(10,10,12), 
c     * XBSUM(10,12), D(10,12), AL(12),DAL(12),
c     * XHAL(10,12),XIAL(12), TH(10),DTH(10), XLTH(10,10), XITH(10),
c     * P(10), PT(10), DP(10),gg(506), DI

c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,igm,a1(11),nl,a5(19),kvrs,jwt,ifxi,kfetol,dum3(2)
      common /c2/ vrs
      common /c3/ fetol
      common /d/ k,n,jb,kobs,lv,a2(2),le,a3(3),my,a4(3),lg,lh,mobs,iqz,
     1inz,lq,a6(2),la
      common /k/ jeff,JOFunc
      common /simp1/ last,istsim,ipb,jcc,NUMER
c-------------------BEGINNING OF SUBROUTINE------------------------------
c    THIS IS AN INOPERATIVE VERSION OF OWNFUN
        return
        end
c-------------------------END OF SUBROUTINE------------------------------
c************************************************************************
c************************************************************************
c   PAREM        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates restriction or its gradient within parenthesis.
c
c   This subroutine is called by the following subroutines:
C   RESTRN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PAREM(ii,r,xx,g,x,j1,vd,vr,vu,k4,kd,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),xx(1),vr,vu,y,vd,r(1),vb,vt,vv,POW
      dimension ii(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i0=0
    2 vr=0.d0
      j0=j1
      i1=0
    4 i1=i1+1
      j1=j1+1
c   Calculate value within parenthesis
      y=r(j1)
      j2=ii(j1)+j1-1
    6 if(j1.eq.j2) go to 12
      j1=j1+1
      j4=ii(j1)
      y=y*POW(x(j4),r(j1))
      go to 6
   12 vr=vr+y
      if(i1.lt.-ii(j0)) go to 4
      j4=ii(j0)
      if(id.gt.0) go to 24
      vr=POW(vr,r(j0))
      return
   24 if(vr.ne.0.) vr=r(j0)/vr
      j1=j0
      i1=0
   26 i1=i1+1
      j1=j1+1
      y=r(j1)
      j6=ii(j1)
      j2=ii(j1)+j1-1
   27 if(j1.eq.j2) go to 30
      j1=j1+1
      j4=ii(j1)
      y=y*POW(x(j4),r(j1))
      go to 27
   30 j1=j2-j6+1
      go to 88
   32 j1=j1+1
c   Differentiate within parenthetical expression
      j4=ii(j1)
      if(x(j4).eq.0.) go to 88
      if(i0.eq.1) go to 49
      if(id.eq.4) go to 60
      if(id-2) 45,48,50
   45 g(j4)=g(j4)+vd*vr*y*vu*r(j1)/x(j4)
      go to 88
   48 j12=IYYM(k4,j4)
      xx(j12)=xx(j12)-vd*vr*vu*y*r(j1)/x(j4)
      go to 88
   49 j12=IYYM(j13,j4)
      xx(j12)=xx(j12)-vd*vr*vv*y*r(j1)/x(j4)
      if(j0.ne.j11) go to 88
      xx(j12)=xx(j12)+vd*vr*vv*y*r(j1)/(x(j4)*r(j0))
      if(i1.ne.k1) go to 88
      xx(j12)=xx(j12)-vd*vv*r(j1)/x(j4)
      if(j1.ne.j7) go to 88
      xx(j12)=xx(j12)+vd*vv/x(j4)
      go to 86
   50 vb=vd*vr*y*r(j1)/x(j4)
      k5=k4*(k4+1)/2
      do 56 j8=1,kd
      if(j8.eq.k4) go to 56
      j12=IYYM(j4,j8)
      j14=IYYM(k4,j8)
      if(j8.eq.j4) go to 54
      xx(j12)=xx(j12)+xx(j14)*vb
      go to 56
   54 xx(j12)=xx(j12)+2.d0*xx(j14)*vb+xx(k5)*vb**2
   56 continue
      j12=IYYM(j4,k4)
      xx(j12)=xx(j12)+xx(k5)*vb
      go to 88
   60 j8=k4
      vv=vr*vu*y*r(j1)/x(j4)
   80 if(j8.ge.j1) go to 88
      j8=j8+1
      if(ii(j8).lt.0) go to 84
      j14=ii(j8)
      if(x(j14).eq.0.) go to 80
      j12=IYYM(j4,j14)
      xx(j12)=xx(j12)-vd*vv*r(j8)/x(j14)
      go to 80
   84 k1=i1
      j7=j1
      j11=j0
      i0=1
      j13=j4
      vt=y
      vb=vr
      j1=j8
      j30=j2
      j31=j6
      go to 2
   86 j8=j1
      j1=j7
      j0=j11
      i0=0
      i1=k1
      j4=j13
      y=vt
      vr=vb
      j2=j30
      j6=j31
      go to 80
   88 if(j1.ne.j2) go to 32
      if(i1.lt.-ii(j0)) go to 26
      if(i0.ne.0) go to 86
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PAREN        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates g(x,b) (or associated gradients) for non-linear functions
c   With parentheses.
c
c   This subroutine calls the following subroutines:
C   CALC  
c
c   This subroutine is called by the following subroutines:
C   XBETA  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PAREN(iin,jjn,rn,g,s,x,loe,z,j1,vd,ve,vr,vu,k4,jd,kd,
     1id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),ve,vr,vu,y,vd,rn(1),vb,vt,vv,va,vx,vw,
     1v1,v2,v3,v4,POW,s(1)
      dimension z(1),iin(1),jjn(1),loe(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i0=0
    2 vr=0.d0
      j0=j1
      j5=-iin(j0)-2000
      if(iin(j0).lt.-3000) j5=j5-1000
      i1=0
    4 i1=i1+1
      j1=j1+1
c   Calculate value within parenthesis
      y=rn(j1)
      j2=iin(j1)+j1-1
    6 if(j1.eq.j2) go to 12
      j1=j1+1
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,y,v1,v1,g,s,i,0,1)
      go to 6
   12 vr=vr+y
      if(i1.lt.j5) go to 4
      j4=jjn(j0)
      va=vr
      if(iin(j0).lt.-3000.and.vr.ne.0.) vr=dlog(dabs(vr))
      if(id.gt.0) go to 16
      if(j4) 15,14,13
c   Raise parenthesis expression to power
   13 if(vr.ne.0.) vr=dabs(vr)**(rn(j0)*x(j4))
      return
   14 vr=POW(vr,rn(j0))
      return
   15 j4=loe(-j4)
      if(vr.ne.0.) vr=dabs(vr)**(rn(j0)*dble(z(j4)))
      return
   16 if(j4.le.0.or.vr.eq.0) go to 29
c   Differentiate parenthetical expression
      if(i0.eq.1) go to 25
      if(id-2) 17,19,21
   17 if(jd.gt.1) go to 18
      g(j4)=g(j4)-vd*vu*dlog(dabs(vr))*rn(j0)
      go to 27
   18 g(j4)=g(j4)+vu*dlog(dabs(vr))*rn(j0)
      go to 27
   19 if(j4.gt.k4) go to 27
      j12=IYYM(k4,j4)
      s(j12)=s(j12)+vd*vu*dlog(dabs(vr))*rn(j0)
      go to 27
   21 do 23 j8=1,j4
      j12=IYYM(j4,j8)
   23 s(j12)=s(j12)+ve*vu*dlog(dabs(vr))*rn(j0)*g(j8)
      vv=vu*dlog(dabs(vr))*rn(j0)
      j8=jd
      k10=3
      j13=j4
      go to 70
   25 if(j4.gt.j13) go to 27
      j12=IYYM(j13,j4)
      s(j12)=s(j12)+vv*dlog(dabs(vr))*rn(j0)
   27 vr=rn(j0)*x(j4)/vr
      go to 32
   29 if(vr.ne.0.) vr=rn(j0)/vr
   32 if(iin(j0).lt.-3000.and.vr.ne.0.) vr=vr/va
      j1=j0
      i1=0
      j19=-iin(j0)-2000
      if(iin(j0).lt.-3000) j19=j19-1000
   35 i1=i1+1
      j1=j1+1
      y=rn(j1)
      j6=iin(j1)
      j2=iin(j1)+j1-1
   40 if(j1.eq.j2) go to 45
      j1=j1+1
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,y,v1,v1,g,s,i,0,1)
      go to 40
   45 j1=j2-j6+1
      if(i0.eq.1) go to 95
      j12=5
      if(id.eq.2) j12=2
      if(id.ge.3) j12=3
      vw=-vd*vr*vu*y
      if(id.eq.1.and.jd.gt.1) vw=vr*vu*y
      if(id.eq.2) vw=-vw
      if(id.ge.3) vw=vu*vr*y*ve
      go to 95
   50 j1=j1+1
c   Differentiate within parenthetical expression
      if(i0.eq.1) go to 55
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,v1,v2,vw,g,s,j5,k4,j12)
      if(id.eq.3) go to 60
      go to 95
c   Calculate second derivatives
   55 v4=vr*y*vv
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,v1,v3,v4,g,s,i,j13,2)
      if(j0.ne.j11) go to 95
      v4=-vv*y/va
      if(iin(j0).lt.-3000) v4=v4*(1.d0+1.d0/dlog(dabs(va)))
      if(k10.eq.3) v4=vu*rn(j0)/va
      if(k10.eq.3.and.iin(j0).lt.-3000) v4=v4/dlog(dabs(va))
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,v1,v3,v4,g,s,i,j13,2)
      if(k10.eq.3.or.i1.ne.k1) go to 95
      v4=vv
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,v1,v3,v4,g,s,i,j13,2)
      if(k10.eq.2.or.j1.ne.j7) go to 95
      v4=vd*vu*vr*y
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,v1,v3,v4,g,s,i,0,4)
      go to 95
   60 if(v1.eq.0..and.v2.eq.0.) go to 95
      j8=jd
      vv=v1*vd/ve
      j13=j5
      k10=1
   70 if(j8.eq.kd.or.vv.eq.0.) go to 90
      j8=j8+1
      if(iin(j8).lt.-2000) go to 80
      call CALC(iin(j8),jjn(j8),rn(j8),loe,z,x,v1,v3,vv,g,s,i,j13,2)
      go to 70
   75 j4=j13
      vr=rn(j0)*x(j4)/va
      if(iin(j0).lt.-3000) vr=rn(j0)*x(j4)/dlog(dabs(va))
      go to 32
   80 k1=i1
      j7=j1
      j11=j0
      i0=1
      vx=va
      j20=j19
      vt=y
      vb=vr
      j1=j8
      j30=j2
      j31=j6
      go to 2
   85 j8=j1
      j1=j7
      j0=j11
      i0=0
      i1=k1
      va=vx
      j19=j20
      y=vt
      vr=vb
      j2=j30
      j6=j31
      go to 70
   90 k10=k10+1
      if(k10.gt.3) go to 75
      if(k10.gt.2.or.v2.eq.0.) go to 95
      vv=v2*vd/ve
      j8=jd
      j13=jjn(j0)
      go to 70
   95 if(j1.ne.j2) go to 50
      if(i1.lt.j19) go to 35
      if(i0.ne.0) go to 85
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PHOENX        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates cross-products of first derivatives.
c
c   This subroutine is called by the following subroutines:
C   START  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PHOENX(s,g,y,wt,de,rde,le,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision s(1),g(1),y(1),de,wt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(id.eq.1) de=dble(rde)
      l=0
      do 5 i=1,le
      y(i)=y(i)+wt*g(i)*de
      do 5 j=1,i
      l=l+1
    5 s(l)=s(l)+g(i)*g(j)*wt
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PITTSB        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes linear x'b which enters regression or index functions in
c   Various models.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   KIMBAL
c
c   This subroutine is called by the following subroutines:
C   FCHOTZ - FCPELD  RESIDL  START  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PITTSB(xb,sig,joe1,moe,loe,z,x,k,joe2,joe3,i6,sc,
     1iscal,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xb,sig,x(1),sc(1)
      dimension z(1),loe(1),moe(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i9=joe1
      if(i6.le.jeff) call KIMBAL(xb,x,x,z,i9,loe,moe,xb,i6,k,sc,
     1iscal,0)
      if(id.gt.0.or.i6.le.jeff) go to 10
      xb=0.d0
c   Accumulate x'b
      do 5 i=1,k
      if(moe(i).gt.7) go to 5
      i9=i9+1
      l=loe(i)
      xb=xb+dble(z(l))*x(i9)
    5 continue
   10 if(id.lt.0) return
c   Set sigma
      sig=1.d0
      if(joe2.ge.1) sig=x(joe3)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   POW         (DOUBLE PRECISION FUNCTION)
c   Raises x's (or functions of x) to power in transformations or
c   Non-linear parts of HotzTran.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      double precision function POW(x1,x2)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x1,x2
c--------------------BEGINNING OF FUNCTION-------------------------------
      if(dabs(x2).lt.1.) go to 10
      POW=x1**ifix(sngl(x2))
      return
   10 POW=0.d0
      if(x1.ne.0.) POW=dabs(x1)**x2
      return
      end
c----------------------END OF FUNCTION-----------------------------------

c************************************************************************
c************************************************************************
c   PRINTA        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Prints estimated parameters and standard errors.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   HEADNG  CPRINT  COEFFC  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PRINTA(x,w,z,xx,ind1,ind2,ind3,ind4,f,f1,iter,iter1,
     1vnam,joe,moe,noe,koe,abn,abr,lar,joa,job,joc,jod,jol,jom,joh,xm,
     2id,ist,maxcor)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),xx(1),f,f1,d1,d2,d3,FSTAT,d4,w(1),z(1),
     1xm(31,me),ter(7)
      dimension bv(47),fz(51),joe(1),moe(k,me),noe(k,me),koe(3,me),
     1abn(1),abr(1),iiy(20),vnam(9,nvar),vb(5),lar(1),job(1),joc(1),
     1jod(1),joh(1),jol(1),joa(1),jom(1)
      character*14 knam(300)
      character*3  zsign
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a23(1),ipc,a8(3),nvar,isd,kcore,a7(22),m8,a1(8),lwi,
     &   dum(3)
      common /c/ me,nt,igm,istan,istar,a3(5),jc,a4(2),mm,nl,ir,ln,igs,
     1ifs,lm,iwo,ira,a10(3),iut1,iut2,a2(6),iwt,dumc(6)
      common /d/ k,n,a9(4),lr,le,igmm,lz,lp,my,ny,l1,lee,lg,lh,mobs,
     1a5(2),lq,lpp,ldf,la
      common /k/ jeff,JOFunc,izprt
      common /label/ knam
c------------------------DATA STATEMENTS---------------------------------
      data fz/4H Yes,4H  No,4HCont,4HAll ,4HForw,4HBack,1H ,1H+,1H-,
     *4H P r,
     14H o b,4H i t,4H T o,4H b i,4H t  ,4H Reg,4Hress,4Hion ,1Hr,4HNone
     2,1Hv,4HBeta,4HSigm,2Ha ,3HRho,4H# Ma,4Hss P,4Ht Ob,4HAve ,4HProb
     3,4H Trn,4Ha Sq,4HCovr,4H L o,4H g i,4H t  ,4HDoub,4Hle T,4Hobit,
     44HTrun,4Hcate,4Hd   ,4Hful*,4Hfor*,4Hbac*,4HCons,4Htant,1H ,4HImpl
     5,4Hcit ,4HFunc/
      data bv/4HTime,4H Per,4Hiod ,4HRand,4Hom  ,4HEffe,2Hct,4H1st ,
     *4HOrde
     1,4Hr  A,4Huto ,4Hregr,4Hessi,2Hve,4HEqua,4Htion,1H ,4HRand,4Hom  ,
     24HEffe,2Hct,4HStat,4Hiona,4Hrity,4HFixe,4Hd Ef,4Hfect,3HNot,4HRead
     3,4H in ,4H0/1 ,4HRegr,4H1st ,4H Run,4HMaxi,4Hmum ,4HLike,4Hliho,
     42Hod,4HI.V.,4H (OC,4H)  E,4Hstim,4Hates,4H Wei,4Hghte,2H s/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i6=kcore-maxcor
c*****************************
      if(id.ne.2.and.jc.lt.4.or.jc.eq.8.or.jc.eq.9) call HEADNG(ind1,
     $  ind2,ind3,ind4,f1,f,iter1,iter,i6)
      if(izprt.eq.1) write(ipc,7332)
 7332 format(/,'**********BEGIN RESULTS**********')
c*****************************
      df=float(mobs-l1-ir)
      if((igmm.le.2.or.igmm.eq.4).and.id.ne.2) f=-f
      j9=0
      if(igmm.ge.5.or.ist.eq.5) j9=1
      call CPRINT(5)
      m8=17
      if(lwi.eq.0) write(ip,23) k,me,n,nt
   23 format(//47x,'P A R A M E T E R    E S T I M A T E S',//38x,'# of 
     1Variables ',7('.'),i4,3x,'# of Equations ',7('.'),i4,/38x,'# of Cr
     2oss-Sections',i7,3x,'# of Time Periods ....',i4)
      if(lwi.eq.1) write(ip,24) k,me,n,nt
   24 format(/ 22x,'P A R A M E T E R    E S T I M A T E S',//13x,'# of 
     1Variables ',7('.'),i4,3x,'# of Equations ',7('.'),i4,/13x,'# of Cr
     2oss-Sections',i7,3x,'# of Time Periods ....',i4)
      if(lwi.eq.0.and.iwt.gt.0) write(ip,25) (vnam(j7,iwt),j7=1,8),iwt
   25 format(38x,'Observations Weighted by Variable ',8('.'),8a1,'(',i3,
     1')')
      if(lwi.eq.1.and.iwt.gt.0) write(ip,26) (vnam(j7,iwt),j7=1,8),iwt
   26 format(13x,'Observations Weighted by Variable ',8('.'),8a1,'(',i3,
     1')')
      if(ist.eq.5) go to 101
      if(igmm.ge.5) go to 60
      if(igmm.eq.3) go to 46
      if(lwi.eq.0.and.id.ne.2) write(ip,30) (bv(i),i=37,39),f
   30 format(38x,'Log-',2a4,a3,'is ',23('.'),g17.5)
      if(lwi.eq.1.and.id.ne.2) write(ip,31) (bv(i),i=37,39),f
      if(lwi.eq.1.and.id.ne.2.and.izprt.eq.1) write(ipc,31) 
     &  (bv(i),i=37,39),f
   31 format(13x,'Log-',2a4,a3,'is ',23('.'),g17.5)
      if(igmm-2) 32,36,43
   32 if(lwi.eq.0) write(ip,34) (bv(i),i=35,39)
   34 format(/45x,'** Single Equation  ',4a4,a3,'**')
      if(lwi.eq.1) write(ip,35) (bv(i),i=35,39)
   35 format(/20x,'** Single Equation  ',4a4,a3,'**')
      go to 78
   36 if(ira.ne.1.and.lwi.eq.0) write(ip,37) mm
   37 format(38x,'Number of Hermite Points is ',21('.'),i6)
      if(ira.ne.1.and.lwi.eq.1) write(ip,38) mm
   38 format(13x,'Number of Hermite Points is ',21('.'),i6)
      if(lwi.eq.0) write(ip,39) (bv(i),i=35,39)
   39 format(/45x,'**  Factor Loading ',4a4,a3,' **')
      if(lwi.eq.1) write(ip,40) (bv(i),i=35,39)
   40 format(/20x,'**  Factor Loading ',4a4,a3,' **')
      if(lwi.eq.0) write(ip,41) (bv(ira*7+i),i=1,7)
   41 format(45x,'*** Rho is ',6a4,a2,' ***')
      if(lwi.eq.1) write(ip,42) (bv(ira*7+i),i=1,7)
   42 format(20x,'*** Rho is ',6a4,a2,' ***')
      go to 78
   43 if(lwi.eq.0) write(ip,44) (bv(i),i=35,39)
   44 format(/45x,'***    Bivariate ',4a4,a3,'  ***')
      if(lwi.eq.1) write(ip,45) (bv(i),i=35,39)
   45 format(/20x,'***    Bivariate ',4a4,a3,'  ***')
      go to 78
   46 if(iwo.gt.0) go to 49
      i=lz-le-ir
      if(i.le.0) go to 49
      dp=float(i)
      d1=FSTAT(f,dp,0.,0.,1)*100.d0
      if(lwi.eq.0) write(ip,47) f,i,d1
   47 format(38x,'Rstr Chi-Sq. ',g12.5,' with',i4,' d.f. Sig%',g11.3)
      if(lwi.eq.1) write(ip,48) f,i,d1
   48 format(13x,'Rstr Chi-Sq. ',g12.5,' with',i4,' d.f. Sig%',g11.3)
   49 if(iwo.eq.0.and.lwi.eq.0) write(ip,50) (bv(i),i=40,46)
   50 format(/45x,'*',7a4,'d Optimally*')
      if(iwo.eq.0.and.lwi.eq.1) write(ip,51) (bv(i),i=40,46)
   51 format(/20x,'*',7a4,'d Optimally*')
      if(iwo.gt.0.and.lwi.eq.0) write(ip,56) (bv(i),i=40,46)
   56 format(/45x,'* ',7a4,'d Equally *')
      if(iwo.gt.0.and.lwi.eq.1) write(ip,57) (bv(i),i=40,46)
   57 format(/20x,'* ',7a4,'d Equally *')
      m=ln-1
      if(ln.ne.nt.and.lwi.eq.0) write(ip,58) m
   58 format(45x,'***  Conditions for Only',i3,' Leads/Lags **')
      if(ln.ne.nt.and.lwi.eq.1) write(ip,59) m
   59 format(20x,'***  Conditions for Only',i3,' Leads/Lags **')
      go to 78
   60 if(igmm.eq.5.and.lwi.eq.0) write(ip,63) (bv(i),i=1,3)
   63 format(/45x,'*** ',3a4,'Correlation Estimates ***')
      if(igmm.eq.5.and.lwi.eq.1) write(ip,64) (bv(i),i=1,3)
   64 format(/20x,'*** ',3a4,'Correlation Estimates ***')
      if(igmm.eq.6.and.lwi.eq.0) write(ip,63) (bv(i),i=8,10)
      if(igmm.eq.6.and.lwi.eq.1) write(ip,64) (bv(i),i=8,10)
      if(igm.eq.1.and.lwi.eq.0) write(ip,34) (bv(i),i=35,39)
      if(igm.eq.1.and.lwi.eq.1) write(ip,35) (bv(i),i=35,39)
      if(igm.eq.3.and.iwo.eq.0.and.lwi.eq.0) write(ip,50) (bv(i),i=40,46
     1)
      if(igm.eq.3.and.iwo.eq.0.and.lwi.eq.1) write(ip,51) (bv(i),i=40,46
     1)
      if(igm.eq.3.and.iwo.eq.1.and.lwi.eq.0) write(ip,56) (bv(i),i=40,46
     1)
      if(igm.eq.3.and.iwo.eq.1.and.lwi.eq.1) write(ip,57) (bv(i),i=40,46
     1)
      if(lwi.eq.0) write(ip,67)
   67 format(49x,'Assumed for Coefficient Estimates')
      if(lwi.eq.1) write(ip,68)
   68 format(24x,'Assumed for Coefficient Estimates')
      if(nt.le.2.or.igmm.eq.6) go to 124
      m=lr*me*(lr*me+1)/2+1
      i=lr-nt+1
      dp=float(i)
      m8=m8+2
      if(lwi.eq.0) write(ip,69) (bv(i),i=22,24)
   69 format(/45x,'*********  Test of ',3a4,' *********')
      if(lwi.eq.1) write(ip,70) (bv(i),i=22,24)
   70 format(/20x,'*********  Test of ',3a4,' *********')
      do 73 j=1,me
      d1=FSTAT(xx(m),dp,0.,0.,1)*100.d0
      if(lwi.eq.0) write(ip,47) xx(m),i,d1
      if(lwi.eq.1) write(ip,48) xx(m),i,d1
      m8=m8+1
   73 m=m+2
      m=lr*me*(lr*me+1)/2+2
      i=lr-1
      dp=float(i)
      m8=m8+2
      if(lwi.eq.0) write(ip,69) (bv(i),i=25,27)
      if(lwi.eq.1) write(ip,70) (bv(i),i=25,27)
      do 77 j=1,me
      m8=m8+1
      d1=FSTAT(xx(m),dp,0.,0.,1)*100.d0
      if(lwi.eq.0) write(ip,47) xx(m),i,d1
      if(lwi.eq.1) write(ip,48) xx(m),i,d1
   77 m=m+2
      go to 124
   78 if(ist.eq.0.and.igmm.le.4.and.igmm.ne.3.and.lwi.eq.0) write(ip,81)
     1 bv(28)
   81 format(45x,'*** Standard Errors ',a4,'Time Adjusted ***')
      if(ist.eq.0.and.igmm.le.4.and.igmm.ne.3.and.lwi.eq.1) write(ip,82)
     1 bv(28)
   82 format(20x,'*** Standard Errors ',a4,'Time Adjusted ***')
      i=la-1
      if(i.lt.0) i=nt-1
      if((ist.eq.1.or.ist.eq.2).and.lwi.eq.0) write(ip,83) i
   83 format(45x,5('*'),' Standard Errors Time Adjusted ',5('*'),/45x,'*
     1*** Moving Average of',i4,' Lead/Lags ****')
      if((ist.eq.1.or.ist.eq.2).and.lwi.eq.1) write(ip,84) i
   84 format(20x,5('*'),' Standard Errors Time Adjusted ',5('*'),/20x,'*
     1*** Moving Average of',i4,' Lead/Lags ****')
      if(igmm.eq.3.and.ist.eq.0.and.lwi.eq.0) write(ip,85)
   85 format(45x,'*** Standard Errors assume opt. wghts ***')
      if(igmm.eq.3.and.ist.eq.0.and.lwi.eq.1) write(ip,86)
   86 format(20x,'*** Standard Errors Assume Opt. Wghts ***')
      if(ist.eq.3.and.lwi.eq.1) write(ip,87)
   87 format(20x,'*** Std. Error Gradient Crossproducts ***')
      if(ist.eq.3.and.lwi.eq.0) write(ip,88)
   88 format(45x,'*** Std. Error Gradient Crossproducts ***')
      if(jeff.gt.0.and.lwi.eq.0)write(ip,1888)
 1888 format(45x,'******** Subroutine KIMBAL Used  ********')
      if(JOFunc.gt.0.and.lwi.eq.0)write(ip,1887)
 1887 format(45x,'******** Subroutine OWNFUNC Used ********')
      if(jeff.gt.0.and.lwi.eq.1)write(ip,1889)
 1889 format(20x,'******** Subroutine KIMBAL Used  ********')
      if(JOFunc.gt.0.and.lwi.eq.1)write(ip,1885)
 1885 format(20x,'******** Subroutine OWNFUNC Used ********')
      if((istar.le.1.or.(igm.ne.igmm.and.istar.eq.3)).and.lwi.eq.0) writ
     1e(ip,93) bv(29),bv(30)
   93 format(45x,'******** Starting Values ',2a4,' *******')
      if((istar.le.1.or.(igm.ne.igmm.and.istar.eq.3)).and.lwi.eq.1) writ
     1e(ip,94) bv(29),bv(30)
   94 format(20x,'******** Starting Values ',2a4,' *******')
      if((istar.eq.2.or.(igm.ne.igmm.and.istar.eq.4)).and.lwi.eq.0) writ
     1e(ip,93) bv(31),bv(32)
      if((istar.eq.2.or.(igm.ne.igmm.and.istar.eq.4)).and.lwi.eq.1) writ
     1e(ip,94) bv(31),bv(32)
      if(igm.eq.igmm.and.istar.ge.3.and.lwi.eq.0) write(ip,93) bv(33),bv
     1(34)
      if(igm.eq.igmm.and.istar.ge.3.and.lwi.eq.1) write(ip,94) bv(33),bv
     1(34)
      go to 124
  101 if(iwo.eq.0.and.lwi.eq.0) write(ip,50) (bv(i),i=40,46)
      if(iwo.eq.0.and.lwi.eq.1) write(ip,51) (bv(i),i=40,46)
      if(iwo.eq.1.and.lwi.eq.0) write(ip,56) (bv(i),i=40,46)
      if(iwo.eq.1.and.lwi.eq.1) write(ip,57) (bv(i),i=40,46)
      if(lwi.eq.0) write(ip,102)
  102 format(45x,'Estimates of the Orthogonality Conditions')
      if(lwi.eq.1) write(ip,103)
  103 format(20x,'Estimates of the Orthogonality Conditions')
      if(ifs.eq.0) go to 124
      m8=m8+3
      if(lwi.eq.0) write(ip,106)
  106 format(/45x,'**** Orthogonality Restriction Tests ****')
      if(lwi.eq.1) write(ip,108)
  108 format(/20x,'**** Orthogonality Restriction Tests ****')
      m=lm-1
      if(lm.ne.ln.and.m.ne.0.and.lwi.eq.0) write(ip,110) m
  110 format(45x,'** Tests Imposed for Only',i3,' Leads/Lags **')
      if(lm.ne.ln.and.m.ne.0.and.lwi.eq.1) write(ip,112) m
  112 format(20x,'** Tests Imposed for Only',i3,' Leads/Lags **')
      m=10*me+k*nt+2*me*k+1
      j=lp*(lp+1)/2
      do 122 l=1,ifs
      i=xx(j+2)
      dp=float(i)
      d1=FSTAT(xx(j+1),dp,0.,0.,1)*100.d0
      m8=m8+2+i/14
      if(lwi.eq.0) write(ip,47) xx(j+1),i,d1
      if(lwi.eq.1) write(ip,48) xx(j+1),i,d1
      if(lwi.eq.0) write(ip,118) (joe(m+j1),j1=1,i)
  118 format(44x,14i3)
      if(lwi.eq.1) write(ip,120) (joe(m+j1),j1=1,i)
  120 format(19x,14i3)
      m=m+i+1
  122 j=j+2
  124 if(j9.eq.1) go to 175
      if(ir.eq.0) go to 136
      m8=m8+2
      if(lwi.eq.0) write(ip,126) ir
  126 format(/45x,'Number of Restrictions ',12('.'),i6)
      if(lwi.eq.1) write(ip,128) ir
  128 format(/20x,'Number of Restrictions ',12('.'),i6)
      m=1
      do 134 j1=1,ir
      l=abr(m)
      m8=m8+1+l/55
      if(lwi.eq.0) write(ip,130) (abr(m+j),j=1,l)
  130 format(38x,55a1)
      if(lwi.eq.1) write(ip,132) (abr(m+j),j=1,l)
  132 format(13x,55a1)
  134 m=m+l+1
  136 if(nl.eq.0) go to 175
      m8=m8+2
      if(lwi.eq.0) write(ip,139)
  139 format(/45x,9('*'),' Non-Linear Equations ',10('*'))
      if(lwi.eq.1) write(ip,142)
  142 format(/20x,9('*'),' Non-Linear Equations ',10('*'))
      m=1
      do 145 i3=1,lee
      l=abn(m)
      m8=m8+1+l/55
      if(lwi.eq.0) write(ip,130) (abn(m+j),j=1,l)
      if(lwi.eq.1) write(ip,132) (abn(m+j),j=1,l)
  145 m=m+l+1
      if(nl.eq.2.and.igmm.ne.3) go to 175
      j1=0
      do 172 i6=1,me
      i1=0
      if(joe(i6).lt.0) i1=8
      if(joe(i6).eq.2.or.joe(i6).eq.3) i1=1
      if(joe(i6).eq.4.or.joe(i6).eq.5) i1=9
      if(joe(i6).eq.6.or.joe(i6).eq.7) i1=10
      if(joe(i6).eq.8) i1=2
      if(joe(i6).eq.9) i1=13
      i=joc(i6)
      m8=m8+1
      if(nl.ne.1) go to 154
      if(lwi.eq.0) write(ip,148) i6,(fz(3*i1+9+m),m=1,3),(vnam(j7,i),j7=
     11,8),i
  148 format(34x,'Equation',i3,2x,3a4,1x,'Dep Var ',8a1,'(',i3,')')
      if(lwi.eq.1) write(ip,151) i6,(fz(3*i1+9+m),m=1,3),(vnam(j7,i),j7=
     11,8),i
      if(lwi.eq.1.and.izprt.eq.1) write(ipc,151)i6,
     1(fz(3*i1+9+m),m=1,3),(vnam(j7,i),j7=1,8),i
  151 format(/10x,'----- Equation',i3,':',1x,'(',3a4,')'1x,
     &'Dep Var = ',8a1,'(',i3,') -----',/)
      if(igmm.ne.3) go to 172
      go to 157
  154 if(lwi.eq.0) write(ip,148) i6,bv(40),bv(47)
      if(lwi.eq.1) write(ip,151) i6,bv(40),bv(47)
  157 m=0
      do 169 i=1,k
      if(moe(i,i6).ge.15) go to 160
      m=m+1
      iiy(m)=lar(i)
      if(lar(i).eq.nvar+1) iiy(m)=0
      l=moe(i,i6)+3
      if(l.ge.15) l=l+1
      if(l.ge.11) l=l-8
      if(l.eq.7) l=20
      if(l.ge.8) l=35+l
      vb(m)=fz(l)
  160 if((m.lt.5.and.i.ne.k).or.(m.eq.0.and.i.eq.k)) go to 169
      m8=m8+1+m/5
      if(lwi.eq.0) write(ip,163) (fz(21),iiy(j),vb(j),j=1,m)
  163 format(38x,5(a1,i2,'(',a4,') '))
      if(lwi.eq.1) write(ip,166) (fz(21),iiy(j),vb(j),j=1,m)
  166 format(13x,5(a1,i2,'(',a4,') '))
      m=0
  169 continue
  172 continue
  175 j1=k+2
      if(igm.ne.2) j1=k+1
      j0=1
      if(nl.gt.1) j0=k+1
      i8=0
      if(lwi.eq.0) write(ip,180)
  180 format(//31x,'Variable     Coefficient   Standard Error    t ',
     1 'Statistic   %Significance',/)
      m8=m8+3
      if(lwi.eq.1) write(ip,182)
  182 format(/9x,'Variable       Coefficient   Stand. Error  ',
     &  't Statistic  %Significance')
      if(nl.gt.0.and.j9.eq.0) go to 575
      if(igmm.eq.6) go to 605
  184 do 450 i6=1,me
      i1=0
      if(joe(i6).lt.0) i1=8
      if(joe(i6).eq.2.or.joe(i6).eq.3) i1=1
      if(joe(i6).eq.4.or.joe(i6).eq.5) i1=9
      if(joe(i6).eq.6.or.joe(i6).eq.7) i1=10
      if(joe(i6).eq.8) i1=2
      if(joe(i6).eq.9) i1=13
      i=joc(i6)
      if(lwi.eq.1) go to 197
      if(m8.ge.55) call CPRINT(15)
      if(m8.eq.4) write(ip,180)
      m8=m8+3
      write(ip,185) i6,(fz(3*i1+9+m),m=1,3),(vnam(j7,i),j7=1,8),i
  185 format(/30x,'Equation',i3,2x,3a4,2x,'Dep Var ',8a1,'(',i3,')',/)
      go to 202
  197 write(ip,151) i6,(fz(3*i1+9+m),m=1,3),(vnam(j7,i),j7=1,8),i
      if(izprt.eq.1) write(ipc,151) i6,(fz(3*i1+9+m),m=1,3),
     &     (vnam(j7,i),j7=1,8),i
  202 if(ist.eq.5) go to 362
      if(igmm.eq.5) go to 350
c   Print regular coefficients
      i8=joa(i6)
      do 300 i=j0,j1
      l=7
      j4=0
      if(i-k-1) 203,210,215
  203 if(moe(i,i6).ge.15) go to 300
      j4=lar(i)
      if(j4.ne.nvar+1) go to 205
      j4=0
      vb(1)=fz(46)
      vb(2)=fz(47)
  205 if(igmm.eq.3) l=moe(i,i6)+3
      if(moe(i,i6).eq.4) l=20
      if(moe(i,i6).ge.5) l=38+moe(i,i6)
      if(moe(i,i6).gt.7) go to 240
      i8=i8+1
      go to 220
  210 if(joe(i6).le.0) go to 300
      i8=jol(i6)
      vb(1)=fz(23)
      vb(2)=fz(24)
      if(jod(i6).eq.2.or.jod(i6).eq.4) vb(2)=fz(32)
      go to 220
  215 if(igm.ne.igmm) go to 300
      i8=jom(i6)
      vb(1)=fz(25)
      vb(2)=fz(7)
  220 j=i8*(i8+1)/2
      if(lwi.eq.1) go to 260
      m8=m8+1
      if(m8.ge.58) call CPRINT(15)
      if(m8.eq.4) write(ip,180)
      call COEFFC(d1,d2,d3,df,x(i8),xx(j))
      if(izprt.eq.1) then
         zsign='   '
         if(d3.le.10.d0.and.d3.gt.5.d0)zsign='*  '
         if(d3.le.5.d0.and.d3.gt.1.d0)zsign='** '
         if(d3.le.1.d0.and.d3.ge.0.d0)zsign='***'
      endif
      if(ir.eq.0.or.d1.gt.0.) go to 225
      if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0)) write(ip,230) i8,
     1fz(19),(vnam(j7,j4),j7=1,8),j4,fz(l),x(i8)
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0)) write(ip,1230) i8,
     1fz(19),knam(i8),fz(l),x(i8)
      if(j4.eq.0) write(ip,235) i8,fz(19),vb(1),vb(2),fz(l),x(i8)
      go to 300
 225  if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0)) write(ip,230) i8,
     1fz(7),(vnam(j7,j4),j7=1,8),j4,fz(l),x(i8),d1,d2,d3
      if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0).and.izprt.eq.1) 
     & write(ipc,7330) (vnam(j7,j4),j7=1,8),x(i8),zsign,d1
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0)) write(ip,1230) i8,
     1fz(7),knam(i8),fz(l),x(i8),d1,d2,d3
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0).and.izprt.eq.1) 
     & write(ipc,7331) knam(i8),x(i8),zsign,d1
      if(j4.eq.0) write(ip,235) i8,fz(7),vb(1),vb(2),fz(l),x(i8),d1,
     1d2,d3
      if(j4.eq.0.and.izprt.eq.1) write(ipc,7334) vb(1),vb(2),x(i8),
     & zsign,d1
      if(j4.eq.0) write(ip,235) i8,fz(7),vb(1),vb(2),fz(l),x(i8),d1,
     1d2,d3
 230  format(21x,i3,'.',a1,1x,8a1,'(',i3,')',1x,a1,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
 1230 format(18x,'b(',i3,')',1x,a1,1x,a14,1x,a1,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
  235 format(21x,i3,'.',a1,1x,2a4,6x,a1,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
 7330 format(8a1,1x,f11.4,A3,/9x,'(',f10.4,')',5x)
 7331 format(a14,1x,f11.4,a3,/15x,'(',f10.4,')',5x)
 7333 format(a3,2i2,2x,f11.4,a3,/9x,'(',f10.4,')',5x)
 7334 format(2a4,1x,f11.4,A3,/9x,'(',f10.4,')',5x)
      go to 300
  240 l=moe(i,i6)-5
      if(moe(i,i6).ge.12) l=31+moe(i,i6)
      if(lwi.eq.1) go to 250
      if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0)) write(ip,230) i8,
     1fz(7),(vnam(j7,j4),j7=1,8),j4,fz(l)
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0)) write(ip,1230) i8,
     1fz(7),knam(i8),fz(l)
      if(j4.eq.0) write(ip,235) i8,fz(7),vb(1),vb(2),fz(l)
      go to 300
  250 if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0)) write(ip,270) i8,
     1fz(7),(vnam(j7,j4),j7=1,8),j4,fz(l)
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0)) write(ip,1270) i8,
     1fz(7),knam(i8),fz(l)
      if(j4.eq.0) write(ip,275) i8,fz(7),vb(1),vb(2),fz(l)
      go to 300
  260 call COEFFC(d1,d2,d3,df,x(i8),xx(j))
      if(izprt.eq.1) then
         zsign='   '
         if(d3.le.10.d0.and.d3.gt.5.d0)zsign='*  '
         if(d3.le.5.d0.and.d3.gt.1.d0)zsign='** '
         if(d3.le.1.d0.and.d3.ge.0.d0)zsign='***'
      endif
      if(ir.eq.0.or.d1.gt.0.) go to 265
      if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0)) write(ip,270) 
     1i8,fz(19),(vnam(j7,j4),j7=1,8),j4,fz(l),x(i8)
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0)) write(ip,1270) 
     4i8,fz(19),knam(i8),fz(l),x(i8)
      if(j4.eq.0) write(ip,275) i8,fz(19),vb(1),vb(2),fz(l),x(i8)
      go to 300
  265 if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0)) write(ip,270) 
     1i8,fz(7),(vnam(j7,j4),j7=1,8),j4,fz(l),x(i8),d1,d2,d3
      if(j4.ne.0.and.(jeff.le.0.and.JOFunc.le.0).and.izprt.eq.1) 
     & write(ipc,7330) (vnam(j7,j4),j7=1,8),x(i8),zsign,d1
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0)) write(ip,1270)
     4 i8,fz(7),knam(i8),fz(l),x(i8),d1,d2,d3
      if(j4.ne.0.and.(jeff.gt.0.or.JOFunc.gt.0).and.izprt.eq.1) 
     & write(ipc,7331) knam(i8),x(i8),zsign,d1
  270 format(1x,i3,'.',a1,1x,8a1,'(',i3,')',1x,a1,2x,3g14.7,
     &  g12.5)
 1270 format(1x,'b(',i3,')',1x,a1,1x,a14,1x,a1,1x,3g13.6,g11.4)
      if(j4.eq.0) write(ip,275) i8,fz(7),vb(1),vb(2),fz(l),x(i8),
     4d1,d2,d3
      if(j4.eq.0.and.izprt.eq.1) write(ipc,7334) vb(1),vb(2),x(i8),
     & zsign,d1
  275 format(1x,i3,'.',a1,1x,2a4,5x,1x,a1,2x,3g14.7,g12.5)
  300 continue
      go to 450
c   Print time period epsilon correlations
  350 do 360 i=2,nt
      l=i-1
      ia1=i+iut1-1
      if(iut1.gt.iut2.and.i.ge.iut2) ia1=i+(iut1-iut2)
      do 360 m=1,l
      ia2=m+iut1-1
      if(iut1.gt.iut2.and.m.ge.iut2) ia2=m+(iut1-iut2)
      i8=i8+1
      j=i8*(i8+1)/2
      call COEFFC(d1,d2,d3,df,w(i8),xx(j))
      if(izprt.eq.1) then
         zsign='   '
         if(d3.le.10.d0.and.d3.gt.5.d0)zsign='*  '
         if(d3.le.5.d0.and.d3.gt.1.d0)zsign='** '
         if(d3.le.1.d0.and.d3.ge.0.d0)zsign='***'
      endif
      if(lwi.eq.1) go to 355
      m8=m8+1
      if(m8.ge.58) call CPRINT(15)
      if(m8.eq.4) write(ip,180)
      write(ip,352) i8,fz(7),fz(25),ia1,ia2,w(i8),d1,d2,d3
  352 format(21x,i3,'.',a1,1x,a3,2i3,6x,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
      go to 360
  355 write(ip,358) i8,fz(7),fz(25),ia1,ia2,w(i8),d1,d2,d3
      if(izprt.eq.1)write(ipc,7333) fz(25),ia1,ia2,w(i8),zsign,d1
  358 format(1x,i3,'.',a1,1x,a3,2i3,8x,3g14.7,g12.5)
  360 continue
      go to 450
c   Print orthogonality conditions
  362 do 405 l=1,j1
      if((l.eq.j1.and.(joe(i6).le.1.or.jod(i6).gt.2)).or.(l.lt.j1.and.(n
     1oe(l,i6).eq.4.or.noe(l,i6).ge.15))) go to 405
      do 400 m=1,lm
      i1=7
      do 398 i2=1,2
      if(l.gt.k) go to 365
      if((m.eq.1.and.(i2.eq.2.or.noe(l,i6).ge.12.or.(noe(l,i6).ge.4.and.
     1noe(l,i6).le.7))).or.(i2.eq.2.and.m.gt.1.and.(noe(l,i6).eq.2.or.no
     2e(l,i6).eq.6.or.noe(l,i6).eq.10.or.noe(l,i6).eq.13)).or.(i2.eq.1.a
     3nd.m.gt.1.and.(noe(l,i6).eq.3.or.noe(l,i6).eq.7.or.noe(l,i6).eq.11
     4.or.noe(l,i6).eq.14))) go to 398
      if(m.ne.1) i1=7+i2
  365 i3=m-1
      i8=i8+1
      j=i8*(i8+1)/2
      call COEFFC(d1,d2,d3,df,x(i8),xx(j))
      if(izprt.eq.1) then
         zsign='   '
         if(d3.le.10.d0.and.d3.gt.5.d0)zsign='*  '
         if(d3.le.5.d0.and.d3.gt.1.d0)zsign='** '
         if(d3.le.1.d0.and.d3.ge.0.d0)zsign='***'
      endif
      if(l.le.k) j4=lar(l)
      if(l.le.k.and.j4.ne.nvar+1) go to 370
      j4=0
      vb(1)=fz(46)
      vb(2)=fz(47)
      if(l.eq.k+1) vb(1)=fz(23)
      if(l.eq.k+1) vb(2)=fz(24)
      if(l.eq.k+2) vb(1)=fz(25)
      if(l.eq.k+2) vb(2)=fz(7)
  370 if(lwi.eq.1) go to 385
      m8=m8+1
      if(m8.ge.58) call CPRINT(15)
      if(m8.eq.4) write(ip,180)
      if(j4.ne.0) write(ip,375) i8,j4,fz(i1),i3,x(i8),d1,d2,d3
  375 format(21x,i3,'.',2x,'var(',i3,')',a1,i2,4x,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
      if(j4.eq.0) write(ip,380) i8,vb(1),vb(2),fz(i1),i3,x(i8),d1,d2
     1,d3
  380 format(21x,i3,'.',2x,2a4,a1,i2,4x,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
      if(l.gt.k) go to 405
      go to 398
  385 if(j4.ne.0) write(ip,390) i8,j4,fz(i1),i3,x(i8),d1,d2,d3
  390 format(1x,i3,'.',2x,'var(',i3,')',a1,i2,6x,3g14.7,g12.5)
      if(j4.eq.0) write(ip,395) i8,vb(1),vb(2),fz(i1),i3,x(i8),d1,d2
     4,d3
  395 format(1x,i3,'.',2x,2a4,a1,i2,6x,3g14.7,g12.5)
      if(l.gt.k) go to 405
  398 continue
      if(noe(l,i6).eq.0.or.noe(l,i6).eq.8) go to 405
  400 continue
  405 continue
  450 continue
      if(igmm.ne.4) go to 675
      write(ip,380)
      go to 600
  575 l=lq
      if(nl.eq.1) l=le
      do 590 i8=1,l
      j=i8*(i8+1)/2
      m8=m8+1
      if(lwi.eq.0.and.m8.ge.58) call CPRINT(15)
      if(m8.eq.4) write(ip,180)
      call COEFFC(d1,d2,d3,df,x(i8),xx(j))
      if(izprt.eq.1) then
         zsign='   '
         if(d3.le.10.d0.and.d3.gt.5.d0)zsign='*  '
         if(d3.le.5.d0.and.d3.gt.1.d0)zsign='** '
         if(d3.le.1.d0.and.d3.ge.0.d0)zsign='***'
      endif
      if(ir.eq.0.or.d1.gt.0.) go to 585
      if(lwi.eq.0) write(ip,577) i8,fz(19),fz(22),i8,x(i8)
  577 format(21x,i3,'.',a1,1x,a4,i4,7x,3(1x,g14.7,1x),
     &     1x,g12.5,1x)
      if(lwi.eq.1) write(ip,580) i8,fz(19),fz(22),i8,x(i8)
  580 format(1x,i3,'.',a1,1x,a4,i4,9x,3g14.7,g12.5)
      go to 590
  585 if(lwi.eq.0) write(ip,577) i8,fz(7),fz(22),i8,x(i8),d1,d2,d3
      if(lwi.eq.1) write(ip,580) i8,fz(7),fz(22),i8,x(i8),d1,d2,d3
      if(izprt.eq.1) write(ipc,7833) fz(22),i8,x(i8),zsign,d1
 7833 format(a4,i4,1x,f11.4,A3,/9x,'(',f10.4,')',5x)
  590 continue
      if(nl.eq.1) go to 675
      write(ip,380)
      go to 184
c   Print equation epsilon correlations
  600 i8=lpp
  605 do 650 i=2,me
      l=i-1
      do 650 m=1,l
      i8=i8+1
      j=i8*(i8+1)/2
      d4=x(i8)
      if(igmm.ne.4) d4=z(i8)
      call COEFFC(d1,d2,d3,df,d4,xx(j))
      if(izprt.eq.1) then
         zsign='   '
         if(d3.le.10.d0.and.d3.gt.5.d0)zsign='*  '
         if(d3.le.5.d0.and.d3.gt.1.d0)zsign='** '
         if(d3.le.1.d0.and.d3.ge.0.d0)zsign='***'
      endif
      i1=25
      if(igmm.eq.4.and.joh(i8-lpp).lt.0) i1=33
      m8=m8+1
      if(lwi.eq.0.and.m8.ge.58) call CPRINT(15)
      if(m8.eq.4) write(ip,180)
      if(ir.eq.0.or.igmm.ne.4.or.d1.gt.0.) go to 625
      if(lwi.eq.0) write(ip,352) i8,fz(19),fz(i1),i,m,d4
      if(lwi.eq.1) write(ip,358) i8,fz(19),fz(i1),i,m,d4
      go to 650
  625 if(lwi.eq.0) write(ip,352) i8,fz(7),fz(i1),i,m,d4,d1,d2,d3
      if(lwi.eq.1) write(ip,358) i8,fz(7),fz(i1),i,m,d4,d1,d2,d3
      if(lwi.eq.1.and.izprt.eq.1) write(ipc,7333) fz(i1),i,m,d4,
     & zsign,d1
  650 continue
  675 if(izprt.eq.1) write(ipc,7335) f
 7335 format('Log-Like. ',g15.5,/'***********END RESULTS***********',/)
      if(igmm.ge.5.or.ist.eq.3.or.ist.eq.5.or.id.eq.2) return
      if(m8.ge.45.and.lwi.eq.0) call CPRINT(15)
      if(lwi.eq.0) write(ip,680)
  680 format(//54x,'--- Measures of Fit ---',/)
      if(lwi.eq.1) write(ip,685)
  685 format(//29x,'--- Measures of Fit ---',/)
      do 750 i6=1,me
      if(xm(1,i6).le.0.) go to 750
      i1=1
      if(joe(i6).lt.0) i1=9
      if(joe(i6).eq.2.or.joe(i6).eq.3) i1=2
      if(joe(i6).eq.4.or.joe(i6).eq.5) i1=10
      if(joe(i6).eq.6.or.joe(i6).eq.7) i1=11
      if(joe(i6).eq.8) i1=3
      if(joe(i6).eq.9) i1=14
      i=joc(i6)
      if(lwi.eq.1) go to 687
      if(m8.ge.45) call CPRINT(15)
      m8=m8+15
      if(job(i6).gt.0) m8=m8+2
      write(ip,185) i6,(fz(3*i1+6+m),m=1,3),(vnam(j7,i),j7=1,8),i
      go to 688
  687 write(ip,151) i6,(fz(3*i1+6+m),m=1,3),(vnam(j7,i),j7=1,8),i
  688 xm(2,i6)=xm(2,i6)/xm(1,i6)
      if(i1.eq.14) i1=3
      if(job(i6).gt.0) xm(9,i6)=xm(9,i6)/xm(8,i6)
      if(job(i6).gt.0) xm(10,i6)=xm(10,i6)-xm(9,i6)*xm(9,i6)*xm(8,i6)
      if(job(i6).gt.0.and.xm(10,i6).gt.0.) xm(10,i6)=dsqrt(xm(10,i6)/
     1(xm(8,i6)-1.d0))
      go to (690,733,715,750,750,750,750,750,690,733,733),i1
  690 d2=xm(4,i6)+xm(3,i6)
      d3=xm(1,i6)*xm(2,i6)
      d4=xm(7,i6)/xm(1,i6)
      if(xm(2,i6).gt.0.) xm(4,i6)=xm(4,i6)/d3
      if(xm(2,i6).lt.1.) xm(3,i6)=xm(3,i6)/(xm(1,i6)-d3)
      d1=1.d0-(xm(5,i6)/xm(1,i6))/((1.d0-xm(2,i6))*xm(2,i6))
      xm(5,i6)=d2/xm(1,i6)
      d2=d3*dlog(xm(2,i6))+(xm(1,i6)-d3)*dlog(1.d0-xm(2,i6))
      if(lwi.eq.1) write(ip,692) xm(1,i6),d1,xm(2,i6),d4,xm(3,i6),
     1xm(4,i6),xm(5,i6),d3,xm(6,i6),d2
  692 format(4x,'Weighted # Obs ....',g15.7,5x,'Log-Like R Sq .....',
     1g15.7,/4x,'Mean Dep Var ......',g15.7,5x,'Mean Y Hat ........',
     2g15.7,/4x,'Mean Prob for Y=0  ',g15.7,5x,'Mean Prob for Y=1  ',
     3g15.7,/4x,'Mean Probability ..',g15.7,5x,'# Obs Where Y=1 ...',
     4g15.7,/4x,'Equa. Log-Likehd ..',g15.7,5x,'Naive Log-Likehd ..',
     5g15.7)
      if(lwi.eq.0) write(ip,693) xm(1,i6),d1,xm(2,i6),d4,xm(3,i6),
     1xm(4,i6),xm(5,i6),d3,xm(6,i6),d2
  693 format(29x,'Weighted # Obs ....',g15.7,5x,'Log-Like R Sq .....',
     1g15.7,/29x,'Mean Dep Var ......',g15.7,5x,'Mean Y Hat ........',
     2g15.7,/29x,'Mean Prob for Y=0  ',g15.7,5x,'Mean Prob for Y=1  ',
     3g15.7,/29x,'Mean Probability ..',g15.7,5x,'# Obs Where Y=1 ...',
     4g15.7,/29x,'Equa. Log-Likehd ..',g15.7,5x,'Naive Log-Likehd ..',
     5g15.7)
      if(job(i6).gt.0.and.lwi.eq.1) write(ip,694) xm(9,i6),xm(10,i6)
  694 format(/4x,'Mean Fixed Effect  ',g15.7,5x,'Std Dev Fixed Eff  ',
     1g15.7)
      if(job(i6).gt.0.and.lwi.eq.0) write(ip,695) xm(9,i6),xm(10,i6)
  695 format(/29x,'Mean Fixed Effect  ',g15.7,5x,'Std Dev Fixed Eff  ',
     1g15.7)
      do 696 m=11,30
  696 iiy(m-10)=xm(m,i6)
c jak make the (m,m) -> m,m   5/9/84
c   If(lwi.eq.1) write(ip,697) ((m,m),m=1,9),(iiy(m),m=1,20)
      if(lwi.eq.1) write(ip,697) ( m,m ,m=1,9),(iiy(m),m=1,20)
  697 format(/23x,'Predicted Probabilities by Deciles',/10x,'0-',9('.',
     1i1,2x,'.',i1,'-'),'1.',/3x,'y=1 ',10i7,/3x,'y=0 ',10i7,/)
c jak 5/9/84  (m,m) -> m,m
c   If(lwi.eq.0) write(ip,698) ((m,m),m=1,9),(iiy(m),m=1,20)
      if(lwi.eq.0) write(ip,698) ( m,m ,m=1,9),(iiy(m),m=1,20)
  698 format(//48x,'Predicted Probabilities by Deciles',/35x,'0-',9('.',
     1i1,2x,'.',i1,'-'),'1.',/28x,'y=1 ',10i7,/28x,'y=0 ',10i7,//)
      if(nl.gt.0) go to 750
      d1=1.d0
      if(joe(i6).lt.1) go to 700
      i=jol(i6)
      d1=x(i)
      if(jod(i6).eq.2.or.jod(i6).eq.4) d1=dsqrt(d1)
  700 d4=d4/d1
      if(joe(i6).lt.0) d3=1.d0/(1.d0+dexp(-d4))
      if(joe(i6).ge.0) d3=1.d0-FSTAT(d4,0.,0.,0.,3)
      if(lwi.eq.0) write(ip,701) d3
  701 format(//29x,'Change in Prob. for a 1 Unit Change in X at the '
     1'Mean Y Hat (Pr =',f8.6,')',/)
      if(lwi.eq.1) write(ip,702) d3
  702 format(/4x,'Change in Prob. for a 1 Unit Change in X at '
     1'the Mean Y Hat (Pr =',f8.6,')',/)
      m=joa(i6)
      i3=jom(i6)-m
      if(moe(k,i6).le.7.and.lar(k).eq.nvar+1.and.i3.ne.1) i3=i3-1
      j=0
  705 i=j+1
      j=i+6
      if(j.gt.i3) j=i3
      do 707 l=i,j
      d2=d4+x(m+l)/d1
      if(joe(i6).lt.0) ter(l-i+1)=1.d0/(1.d0+dexp(-d2))-d3
      if(joe(i6).ge.0) ter(l-i+1)=1.d0-FSTAT(d2,0.,0.,0.,3)-d3
  707 continue
      if(lwi.eq.0) write(ip,709) (fz(22),l,l=i,j)
  709 format(27x,7(1x,a4,'(',i2,')',2x))
      if(lwi.eq.1) write(ip,710) (fz(22),l,l=i,j)
  710 format(3x,6(1x,a4,'(',i2,')',2x),
     &     1x,a4,'(',i2,')')
      if(lwi.eq.0) write(ip,711) (ter(l-i+1),l=i,j)
  711 format(26x,7(1x,e10.3),/)
      if(lwi.eq.1) write(ip,712) (ter(l-i+1),l=i,j)
  712 format(2x,7(1x,e10.3),/)
      if(j.lt.i3) go to 705
      go to 750
  715 xm(4,i6)=xm(4,i6)-xm(2,i6)*xm(2,i6)*xm(1,i6)
      xm(3,i6)=xm(3,i6)/xm(1,i6)
      d1=0.
      d2=0.d0
      if(joe(i6).eq.9) go to 717
      d1=1.d0-xm(5,i6)/xm(4,i6)
      d2=-xm(1,i6)*(.5+dlog(xm(4,i6)/xm(1,i6))*.5+.91893853205d0)
  717 if(lwi.eq.1) write(ip,719) xm(1,i6),d1,(xm(m,i6),m=2,6),d2
  719 format(4x,'Weighted # Obs ....',g15.7,5x,'R Squared .........',
     1g15.7,/4x,'Mean Dep Var ......',g15.7,5x,'Mean Y Hat ........',
     2g15.7,/4x,'Total Devia. SS ...',g15.7,5x,'Residual Sum Q ....',
     3g15.7,/4x,'Equa. Log-Likehd ..',g15.7,5x,'Naive Log-Likehd ..',
     4g15.7)
      if(lwi.eq.0) write(ip,722) xm(1,i6),d1,(xm(m,i6),m=2,6),d2
  722 format(29x,'weighted # obs ....',g15.7,5x,'R Squared .........',
     1g15.7,/29x,'Mean Dep Var ......',g15.7,5x,'Mean Y Hat ........',
     2g15.7,/29x,'Total Devia. SS ...',g15.7,5x,'Residual Sum Q ....',
     3g15.7,/29x,'Equa. Log-Likehd ..',g15.7,5x,'Naive Log-Likehd ..',
     4g15.7)
  725 if(job(i6).gt.0.and.lwi.eq.1) write(ip,694) xm(9,i6),xm(10,i6)
      if(job(i6).gt.0.and.lwi.eq.0) write(ip,695) xm(9,i6),xm(10,i6)
      do 726 m=1,10
      l=xm(m+20,i6)
      iiy(2*m-1)=l/1000
      iiy(2*m)=l-iiy(2*m-1)*1000
      if(iut1.le.iut2) iiy(2*m)=iiy(2*m)+iut1-1
      if(iut1.gt.iut2.and.iiy(2*m).ge.iut2) iiy(2*m)=iiy(2*m)+iut1-iut2
  726 continue
      if(lwi.eq.1) write(ip,728) (xm(m,i6),m=11,15),(iiy(m),m=1,10),(xm(
     1m,i6),m=16,20),(iiy(m),m=11,20)
  728 format(/22x,'..... Largest/Smallest Residuals .....',/8x,5g13.5,
     1/8x,5(' (',i4,',',i3,')  '),/8x,5g13.5,/8x,5(' (',i4,',',i3,')  '
     2),//)
      if(lwi.eq.0) write(ip,730) (xm(m,i6),m=11,15),(iiy(m),m=1,10),(xm(
     1m,i6),m=16,20),(iiy(m),m=11,20)
  730 format(/47x,'..... Largest/Smallest Residuals .....',/33x,5g13.5,
     1/33x,5(' (',i4,',',i3,')  '),/33x,5g13.5,/33x,5(' (',i4,',',i3,')
     2 '),//)
      go to 750
  733 xm(3,i6)=xm(3,i6)/xm(1,i6)
      xm(4,i6)=xm(4,i6)-xm(3,i6)*xm(3,i6)*xm(1,i6)
      d1=0.d0
      d2=0.d0
      if(nl.eq.1) go to 735
      i8=jol(i6)
      d2=x(i8)
      if(jod(i6).eq.1.or.jod(i6).eq.3) d2=d2**2
      d1=1.d0-d2/(xm(4,i6)/xm(1,i6)+d2)
      d2=-xm(1,i6)*(.5+dlog(d2)*.5+.91893853205d0)
  735 if(joe(i6).eq.6.or.joe(i6).eq.7) xm(5,i6)=xm(5,i6)/xm(1,i6)
      xm(7,i6)=xm(7,i6)/xm(1,i6)
      if(joe(i6).eq.4.or.joe(i6).eq.5) xm(31,i6)=xm(31,i6)/xm(1,i6)
      i8=25
      if(joe(i6).eq.6.or.joe(i6).eq.7) i8=28
      if(lwi.eq.1) write(ip,742) xm(1,i6),d1,xm(2,i6),xm(3,i6),(fz(l+i8)
     1,l=1,3),xm(5,i6),xm(7,i6),xm(6,i6),d2
  742 format(4x,'Weighted # Obs ....',g15.7,5x,'Latent R Squared ..',
     1g15.7,/4x,'Mean Dep Var ......',g15.7,5x,'Mean Y Hat ........',
     2g15.7,/4x,3a4,' ......',g15.7,5x,'Mean Mass Pt Value ',
     3g15.7,/4x,'Equa. Log-Likehd ..',g15.7,5x,'Naive Log-Likehd ..',
     4g15.7)
      if(lwi.eq.0) write(ip,744) xm(1,i6),d1,xm(2,i6),xm(3,i6),(fz(l+i8)
     1,l=1,3),xm(5,i6),xm(7,i6),xm(6,i6),d2
  744 format(29x,'Weighted # Obs ....',g15.7,5x,'Latent R Squared ..',
     1g15.7,/29x,'Mean Dep Var ......',g15.7,5x,'Mean Y Hat ........',
     2g15.7,/29x,3a4,' ......',g15.7,5x,'Mean Mass Pt Value ',
     3g15.7,/29x,'Equa. Log-Likehd ..',g15.7,5x,'Naive Log-Likehd ..',
     4g15.7)
      if(lwi.eq.1.and.(joe(i6).eq.4.or.joe(i6).eq.5)) write(ip,746)
     1xm(31,i6)
  746 format(4x,'# Zero Mass Pt Obs ',g15.7)
      if(lwi.eq.0.and.(joe(i6).eq.4.or.joe(i6).eq.5)) write(ip,748)
     1xm(31,i6)
  748 format(29x,'# Zero Mass Pt Obs ',g15.7)
      go to 725
  750 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PRINTB        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Prints coefficient covariance matrix.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CPRINT  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PRINTB(xx,isz,igmm,ist)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1)
      dimension vs(3),bv(46)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(1),ipc,a2(28),m8,a4(8),lwi,dum(3)
      common /c/ a3(20),iwo,ira,dumc(18)
      common /k/ jeff,JOFunc,izprt
c------------------------DATA STATEMENTS---------------------------------
      data vs/3Hrho,4HBeta,4HCons/
      data bv/4HTime,4H Per,4Hiod ,4HRand,4Hom  ,4HEffe,2Hct,3H1st ,
     *4HOrde
     1,4Hr  A,4Huto ,4Hregr,4Hessi,2Hve,4HEqua,4Htion,1H ,4HRand,4Hom  ,
     24HEffe,2Hct,4HStat,4Hiona,4Hrity,4HFixe,4Hd Ef,4Hfect,3HNot,4HRead
     3,4H in ,4H0/1 ,4HRegr,4H1st ,4H Run,4HMaxi,4Hmum ,4HLike,4Hliho,
     42Hod,4HI.V.,4H (OC,4H)  E,4Hstim,4Hates,4H Wei,4Hghte/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      call CPRINT(1)
      if(igmm.le.6.and.ist.ne.5.and.lwi.eq.0) write(ip,2)
    2 format(/47x,'Estimated Parameter Covariance Matrix')
      if(igmm.le.6.and.ist.ne.5.and.lwi.eq.1) write(ip,3)
    3 format(/22x,'Estimated Parameter Covariance Matrix')
      if(ist.eq.5.and.lwi.eq.0) write(ip,4)
    4 format(/47x,'Covariance Matrix of the Constraints')
      if(ist.eq.5.and.lwi.eq.1) write(ip,5)
    5 format(/22x,'Covariance Matrix of the Constraints')
      if(igmm.eq.0) go to 78
      if(igmm.ge.5) go to 60
      if(igmm.eq.3) go to 49
      if(igmm-2) 32,36,43
   32 if(lwi.eq.0) write(ip,34) (bv(i),i=35,39)
   34 format(/45x,'** Single Equation  ',4a4,a3,'**')
      if(lwi.eq.1) write(ip,35) (bv(i),i=35,39)
   35 format(/20x,'** Single Equation  ',4a4,a3,'**')
      go to 78
   36 if(lwi.eq.0) write(ip,39) (bv(i),i=35,39)
   39 format(/45x,'**  Factor Loading ',4a4,a3,' **')
      if(lwi.eq.1) write(ip,40) (bv(i),i=35,39)
   40 format(/20x,'**  Factor Loading ',4a4,a3,' **')
      if(lwi.eq.0) write(ip,41) (bv(ira*7+i),i=1,7)
   41 format(/45x,'*** Rho is ',6a4,a2,' ***')
      if(lwi.eq.1) write(ip,42) (bv(ira*7+i),i=1,7)
   42 format(/20x,'*** Rho is ',6a4,a2,' ***')
      go to 78
   43 if(lwi.eq.0) write(ip,44) (bv(i),i=35,39)
   44 format(/45x,'***    Bivariate ',4a4,a3,'  ***')
      if(lwi.eq.1) write(ip,45) (bv(i),i=35,39)
   45 format(/20x,'***    Bivariate ',4a4,a3,'  ***')
      go to 78
   49 if(iwo.eq.0.and.lwi.eq.0) write(ip,50) (bv(i),i=40,46)
   50 format(/45x,'*',7a4,'d Optimally*')
      if(iwo.eq.0.and.lwi.eq.1) write(ip,51) (bv(i),i=40,46)
   51 format(/20x,'*',7a4,'d Optimally*')
      if(iwo.gt.0.and.lwi.eq.0) write(ip,56) (bv(i),i=40,46)
   56 format(/45x,'* ',7a4,'d Equally *')
      if(iwo.gt.0.and.lwi.eq.1) write(ip,57) (bv(i),i=40,46)
   57 format(/20x,'* ',7a4,'d Equally *')
      go to 78
   60 if(igmm.eq.5.and.lwi.eq.0) write(ip,63) (bv(i),i=1,3)
   63 format(/45x,'*** ',3a4,'Correlation Estimates ***')
      if(igmm.eq.5.and.lwi.eq.1) write(ip,64) (bv(i),i=1,3)
   64 format(/20x,'*** ',3a4,'Correlation Estimates ***')
      if(igmm.eq.6.and.lwi.eq.0) write(ip,63) (bv(i),i=8,10)
      if(igmm.eq.6.and.lwi.eq.1) write(ip,64) (bv(i),i=8,10)
   78 if(ist.eq.0.and.igmm.le.4.and.igmm.ne.3.and.lwi.eq.0) write(ip,81)
     1 bv(28)
   81 format(45x,'*** Standard Errors ',a4,'Time Adjusted ***')
      if(ist.eq.0.and.igmm.le.4.and.igmm.ne.3.and.lwi.eq.1) write(ip,82)
     1 bv(28)
   82 format(20x,'*** Standard Errors ',a4,'Time Adjusted ***')
      if((ist.eq.1.or.ist.eq.2).and.lwi.eq.0) write(ip,81) bv(17)
      if((ist.eq.1.or.ist.eq.2).and.lwi.eq.1) write(ip,82) bv(17)
      if(igmm.eq.3.and.ist.eq.0.and.lwi.eq.0) write(ip,85)
   85 format(45x,'*** Standard Errors Assume Opt. Wghts ***')
      if(igmm.eq.3.and.ist.eq.0.and.lwi.eq.1) write(ip,86)
   86 format(20x,'*** Standard Errors Assume Opt. Wghts ***')
      if(ist.eq.3.and.lwi.eq.1) write(ip,87)
   87 format(20x,'*** Std. Error Gradient Crossproducts ***')
      if(ist.eq.3.and.lwi.eq.0) write(ip,88)
   88 format(45x,'*** Std. Error Gradient Crossproducts ***')
      if(jeff.gt.0.and.lwi.eq.0)write(ip,1888)
 1888 format(45x,'******** Subroutine KIMBAL Used  ********')
      if(JOFunc.gt.0.and.lwi.eq.0)write(ip,1887)
 1887 format(45x,'******** Subroutine OWNFUNC Used ********')
      if(jeff.gt.0.and.lwi.eq.1)write(ip,1889)
 1889 format(20x,'******** Subroutine KIMBAL Used  ********')
      if(JOFunc.gt.0.and.lwi.eq.1)write(ip,1885)
 1885 format(20x,'******** Subroutine OWNFUNC Used ********')
      i6=1
      if(igmm.le.4) i6=2
      if(ist.eq.5) i6=3
      i1=0
      i2=0
  105 i1=i2+1
      if(i1.gt.1) call CPRINT(22)
      i2=i1+6
      if(lwi.eq.1) i2=i1+4
      if(i2.gt.isz) i2=isz
      if(lwi.eq.0) write(ip,118) (vs(i6),i,i=i1,i2)
  118 format(//18x,7(4x,a4,i3,5x),/)
      if(lwi.eq.1) write(ip,120) (vs(i6),i,i=i1,i2)
  120 format(//10x,5(5x,a4,i3,2x),/)
      i5=0
      do 145 i3=i1,isz
      i5=i5+1
      if(lwi.eq.1.and.i5.ge.5) i5=5
      if(i5.ge.7) i5=7
      i4=(i3*(i3-1))/2+i1-1
      m8=m8+1
      if(m8.ge.58.and.lwi.eq.0) call CPRINT(22)
      if(lwi.eq.0) write(ip,137) vs(i6),i3,(xx(i4+i),i=1,i5)
  137 format(3x,a4,i3,5x,7g16.7)
      if(lwi.eq.1) write(ip,138) vs(i6),i3,(xx(i4+i),i=1,i5)
  138 format(1x,a4,i3,2x,5g14.7)
  145 continue
      if(i2.lt.isz) go to 105
c****************
      write(ipc,1144)
 1144 format(1x,'**** Estimated Parameter Covariance Matrix Follows'
     & ' ****')
      do 1150 kd1=1,isz
      ktot=kd1*(kd1-1)/2      
      write(ipc,1146) (xx(ktot+i),i=1,kd1)
 1146 format(5d16.9)
 1150 continue
      write(ipc,1145)
 1145 format(1x,'**** End of Estimated Parameter Covariance'
     & '  Matrix ****')
c****************
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RANDAL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes gradients/second derivatives from moments.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   CATCH  
c
c   This subroutine is called by the following subroutines:
C   FCHOTZ - FCPELD  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RANDAL(x,f,g,s,id1,id2,joe,moe,gg,ff,joa,job,jod,jol,
     2joh,id,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),f,g(1),s(id1,id2),gg(1),bx(5),yx,zx,vx,b5,b6
     1,ff(1)
      dimension joe(1),moe(k,me),joa(1),job(1),jod(1),jol(1),joh(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(14),ln,dum(23)
      common /d/ k,a2(8),lz,a3(11),lpp,dumd(2)
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i3=0
      do 100 i6=1,me
c$$$$$$$$$$$$$$$$$$$$$$$
      if(job(i6).ge.0.or.i6.le.jeff) go to 100
c$$$$$$$$$$$$$$$$$$$$$$$
      yx=0.d0
      i7=joa(i6)
      i9=jol(i6)-i7-1
      bx(2)=x(i9+i7+1)
      call CATCH(0,0,i6,x(i9+i7+1),1,ind)
      if(jod(i6).eq.2.or.jod(i6).eq.4) bx(2)=dsqrt(bx(2))
      bx(1)=bx(2)**2
      if(id.eq.5) go to 26
      if(id.ge.6) go to 65
      do 10 i=1,i9
c   I4=(i7+i-1)*(i7+i)/2+i7
      ff(i)=0.d0
      do 10 j=1,i
c   I4=i4+1
      i3=i3+1
c   If(id.eq.2) s(1,i4)=s(1,i4)+gg(i3)/bx(1)
      ff(i)=ff(i)+x(i7+j)*gg(i3)/bx(1)
      if(i.ne.j) ff(j)=ff(j)+x(i7+i)*gg(i3)/bx(1)
      if(i.ne.j) yx=yx+x(i7+i)*x(i7+j)*gg(i3)
   10 yx=yx+x(i7+i)*x(i7+j)*gg(i3)
      do 15 j=1,i9
      i3=i3+1
      ff(j)=ff(j)-gg(i3)/bx(1)
      if(id.le.2) g(i7+j)=g(i7+j)+ff(j)
   15 yx=yx-2.d0*x(i7+j)*gg(i3)
      yx=(yx+gg(i3+1))/bx(1)
      i3=i3+2
      if(id.gt.2) go to 50
c   If(id.eq.1) go to 25
c   I4=(i9+i7)*(i9+i7+1)/2+i7
c   Do 20 j=1,i9
c   I4=i4+1
c   S(1,i4)=s(1,i4)-2.d0*ff(j)/bx(2)
c   If(jod(i6).eq.2) s(1,i4)=s(1,i4)/(2.d0*bx(2))
c  20 continue
   25 if(id.eq.1) f=f+yx/2.d0+gg(i3)*(dlog(bx(2))+.91893853205d0)
      if(jod(i6).eq.1) g(i9+i7+1)=g(i9+i7+1)-(yx-gg(i3))/bx(2)
      if(jod(i6).eq.2) g(i9+i7+1)=g(i9+i7+1)-(yx-gg(i3))/(2.d0*bx(1))
c   If(id.eq.1) go to 100
c   If(jod(i6).eq.1) s(1,i4+1)=s(1,i4+1)+(3.d0*yx-gg(i3))/bx(1)
c   If(jod(i6).eq.2) s(1,i4+1)=s(1,i4+1)+(3.d0*yx-gg(i3))/(4.d0*bx(1)*
c    1*2)-(yx-gg(i3))/(2.d0*bx(1)*bx(2))
      go to 100
   26 do 27 i=1,lz
   27 ff(i)=0.d0
      do 40 i=1,i9
      ij=joh(i6)
      ji=0
      zx=0.d0
      do 38 j=1,k
      if(moe(j,i6).ge.15) go to 38
      i3=i3+1
      if(moe(j,i6).gt.7) go to 29
      ji=ji+1
      yx=yx+x(i7+i)*x(i7+ji)*gg(i3)
      zx=zx+x(i7+ji)*gg(i3)
      if(moe(j,i6).eq.4) go to 38
   29 if((moe(j,i6).ge.5.and.moe(j,i6).le.7).or.(moe(j,i6).ge.12.and.moe
     1(j,i6).le.14)) go to 31
      ij=ij+1
      s(ij,i7+i)=s(ij,i7+i)-gg(i3)/bx(1)
      ff(ij)=ff(ij)-x(i7+i)*gg(i3)/bx(1)
   31 if(moe(j,i6).eq.0.or.moe(j,i6).eq.4.or.moe(j,i6).eq.8) go to 38
      do 35 l=2,ln
      if(moe(j,i6).eq.3.or.moe(j,i6).eq.7.or.moe(j,i6).eq.11.or.moe(j,i6
     1).eq.14) go to 30
      ij=ij+1
      i3=i3+1
      s(ij,i7+i)=s(ij,i7+i)-gg(i3)/bx(1)
      ff(ij)=ff(ij)-x(i7+i)*gg(i3)/bx(1)
   30 if(moe(j,i6).eq.2.or.moe(j,i6).eq.6.or.moe(j,i6).eq.10.or.moe(j,i6
     1).eq.13) go to 35
      ij=ij+1
      i3=i3+1
      s(ij,i7+i)=s(ij,i7+i)-gg(i3)/bx(1)
      ff(ij)=ff(ij)-x(i7+i)*gg(i3)/bx(1)
   35 continue
   38 continue
      if(jod(i6).eq.2) zx=zx/(2.d0*bx(2))
      if(jod(i6).eq.1) s(ij+1,i7+i)=s(ij+1,i7+i)+2.d0*zx/(bx(1)*bx(2))
   40 continue
      i=ij+1
      ij=joh(i6)
      ji=0
      do 47 j=1,k
      if(moe(j,i6).ge.15) go to 47
      i3=i3+1
      if(moe(j,i6).gt.7) go to 42
      ji=ji+1
      yx=yx-2.d0*x(i7+ji)*gg(i3)
      if(jod(i6).eq.1) s(i,i7+ji)=s(i,i7+ji)-2.d0*gg(i3)/(bx(1)*bx(2))
      if(jod(i6).eq.2) s(i,i7+ji)=s(i,i7+ji)-gg(i3)/(bx(1)*bx(1))
      if(moe(j,i6).eq.4) go to 47
   42 if((moe(j,i6).ge.5.and.moe(j,i6).le.7).or.(moe(j,i6).ge.12.and.moe
     1(j,i6).le.14)) go to 43
      ij=ij+1
      ff(ij)=ff(ij)+gg(i3)/bx(1)
   43 if(moe(j,i6).eq.0.or.moe(j,i6).eq.4.or.moe(j,i6).eq.8) go to 47
      do 46 l=2,ln
      if(moe(j,i6).eq.3.or.moe(j,i6).eq.7.or.moe(j,i6).eq.11.or.moe(j,i6
     1).eq.14) go to 45
      ij=ij+1
      i3=i3+1
      ff(ij)=ff(ij)+gg(i3)/bx(1)
   45 if(moe(j,i6).eq.2.or.moe(j,i6).eq.6.or.moe(j,i6).eq.10.or.moe(j,i6
     1).eq.13) go to 46
      ij=ij+1
      i3=i3+1
      ff(ij)=ff(ij)+gg(i3)/bx(1)
   46 continue
   47 continue
      yx=(yx+gg(i3+1))/bx(1)
      i3=i3+2
      if(jod(i6).eq.1) g(i)=g(i)+(yx-gg(i3))/bx(2)
      if(jod(i6).eq.2) g(i)=g(i)+(yx-gg(i3))/(2.d0*bx(1))
      ji=joh(i6)+1
      do 48 j=ji,ij
      g(j)=g(j)+ff(j)
      if(jod(i6).eq.2.or.jod(i6).eq.4) ff(j)=ff(j)/(2.d0*bx(2))
   48 s(j,i7+i9+1)=s(j,i7+i9+1)-2.d0*ff(j)/bx(2)
      if(jod(i6).eq.1) s(i,i7+i9+1)=s(i,i7+i9+1)-(3.d0*yx-gg(i3))/bx(1)
      if(jod(i6).eq.2) s(i,i7+i9+1)=s(i,i7+i9+1)-((3.d0*yx-gg(i3))/(4.d0
     1*bx(1)*bx(2))-(yx-gg(i3))/(2.d0*bx(1)))/bx(2)
      go to 100
   50 bx(5)=gg(i3)
      j6=jol(i6)+1
      bx(3)=x(j6)**2
      bx(4)=1.d0-bx(3)
      if(id.eq.3) b5=(1.d0/(1.d0-x(j6)+dble(nt)*x(j6))-1.d0/(1.d0-x(j6
     1)))/bx(1)
      if(id.eq.4) b5=(-bx(3)/bx(4))/bx(1)
      zx=0.d0
      if(id.eq.3) vx=1.d0/(1.d0-x(j6))
      if(id.eq.4) vx=(1.d0+bx(3))/bx(4)
      do 52 i=1,i9
      g(i7+i)=g(i7+i)+ff(i)*vx
      do 52 j=1,i
      i3=i3+1
      g(i7+i)=g(i7+i)+x(i7+j)*gg(i3)*b5
      if(i.ne.j) g(i7+j)=g(i7+j)+x(i7+i)*gg(i3)*b5
      if(i.ne.j) zx=zx+x(i7+i)*x(i7+j)*gg(i3)
   52 zx=zx+x(i7+i)*x(i7+j)*gg(i3)
      do 54 j=1,i9
      i3=i3+1
      g(i7+j)=g(i7+j)-gg(i3)*b5
   54 zx=zx-2.d0*x(i7+j)*gg(i3)
      zx=(zx+gg(i3+1))/bx(1)
      i3=i3+1
      if(id.eq.3) go to 60
      vx=0.d0
      b5=(-x(j6)/bx(4))/bx(1)
      do 56 i=1,i9
      do 56 j=1,i
      i3=i3+1
      g(i7+i)=g(i7+i)+x(i7+j)*gg(i3)*b5
      if(i.ne.j) g(i7+j)=g(i7+j)+x(i7+i)*gg(i3)*b5
      if(i.eq.j) vx=vx-x(i7+i)*x(i7+j)*gg(i3)/2.d0
   56 vx=vx+x(i7+i)*x(i7+j)*gg(i3)
      do 58 j=1,i9
      i3=i3+1
      g(i7+j)=g(i7+j)-gg(i3)*b5
   58 vx=vx-x(i7+j)*gg(i3)
      vx=(vx+gg(i3+1))/bx(1)
      i3=i3+1
      b6=((1.d0+bx(3))*yx-2.d0*x(j6)*vx-bx(3)*zx)/(2.d0*bx(4))
      f=f+b6+bx(5)*(dlog(bx(2))+.91893853205d0)+.5d0*bx(5)*(dble(nt-1)
     1*dlog(bx(4))/dble(nt))
      if(jod(i6).eq.1) g(i9+i7+1)=g(i9+i7+1)-(2.d0*b6-bx(5))/bx(2)
      if(jod(i6).eq.2) g(i9+i7+1)=g(i9+i7+1)-(2.d0*b6-bx(5))/(2.d0*bx(1)
     1)
      g(j6)=g(j6)+b6*2.d0*x(j6)/bx(4)+(x(j6)*(yx-zx)-vx)/bx(4)-bx(5)*
     1dble(nt-1)*x(j6)/(bx(4)*dble(nt))
      go to 100
   60 b5=1.d0/(1.d0-x(j6)+dble(nt)*x(j6))
      b6=(yx*vx+zx*(b5-vx))/2.d0
      f=f+b6+bx(5)*(dlog(bx(2))+.91893853205d0)-.5d0*bx(5)*(dble(nt-1)
     1*dlog(vx)+dlog(b5))/dble(nt)
      if(jod(i6).eq.1) g(i9+i7+1)=g(i9+i7+1)-(2.d0*b6-bx(5))/bx(2)
      if(jod(i6).eq.2) g(i9+i7+1)=g(i9+i7+1)-(2.d0*b6-bx(5))/(2.d0*bx(1)
     1)
      g(j6)=g(j6)-.5*bx(5)*dble(nt-1)*(vx-b5)/dble(nt)+.5*(yx*(vx**2
     1)+zx*((1.d0-dble(nt))*(b5**2)-vx**2))
      go to 100
   65 if(i6.eq.1) go to 100
      do 95 j6=1,i6
c$$$$$$$$$$$$$$$$$$$$$$$
      if(job(j6).ge.0.or.j6.eq.i6.or.j6.le.jeff) go to 95
c$$$$$$$$$$$$$$$$$$$$$$$
      i8=(i6-1)*(i6-2)/2+j6
      i2=i8+lpp
      j7=joa(j6)
      j9=jol(j6)-j7-1
      bx(4)=x(j9+j7+1)
      if(jod(j6).eq.2) bx(4)=dsqrt(bx(4))
      bx(3)=bx(4)**2
      b5=x(i2)
      if(joh(i8).lt.0) b5=b5/(bx(2)*bx(4))
      call CATCH(0,0,i6,b5,2,ind)
      b6=(1.d0+b5**2)/(1.d0-b5**2)
      yx=0.d0
      zx=1.d0/((1.d0-b5**2)*bx(2)*bx(4))
      do 68 j=1,j9
   68 ff(j)=0.d0
      do 75 i=1,i9
c   I4=(i+i7)*(i7+i-1)/2+j7
      vx=0.d0
      do 70 j=1,j9
      i3=i3+1
c   I4=i4+1
c   If(id.eq.7) s(1,i4)=s(1,i4)-b5*gg(i3)*zx
      yx=yx+x(i7+i)*x(j7+j)*gg(i3)
      vx=vx-x(j7+j)*gg(i3)
   70 ff(j)=ff(j)-x(i7+i)*gg(i3)
      i3=i3+1
      vx=(vx+gg(i3))*zx
      g(i7+i)=g(i7+i)+b5*vx
      yx=yx-x(i7+i)*gg(i3)
c   If(id.ne.7) go to 75
c   I4=i4+1
c   S(1,i4)=s(1,i4)-b5*vx/bx(4)
c   J4=i2*(i2-1)/2+i7+i
c   S(1,j4)=s(1,j4)+b6*vx
c   J4=(i7+i9+1)*(i7+i9)/2+i7+i
c   S(1,j4)=s(1,j4)-b5*vx/bx(2)
   75 continue
c   I4=(i7+i9+1)*(i7+i9)/2+j7
      do 77 j=1,j9
      i3=i3+1
      ff(j)=(ff(j)+gg(i3))*zx
      g(j7+j)=g(j7+j)+b5*ff(j)
      yx=yx-x(j7+j)*gg(i3)
c   If(id.ne.7) go to 77
c   I4=i4+1
c   S(1,i4)=s(1,i4)-b5*ff(j)/bx(2)
c   J4=i2*(i2-1)/2+j7+j
c   S(1,j4)=s(1,j4)+b6*ff(j)
c   J4=(j7+j9+1)*(j7+j9)/2+j7+j
c   S(1,j4)=s(1,j4)-b5*ff(j)/bx(4)
   77 continue
      yx=(yx+gg(i3+1))/(bx(2)*bx(4))
      i3=i3+2
      if(id.eq.6) f=f-b5*yx/(1.d0-b5**2)+gg(i3)*(dlog(bx(2))+dlog(bx(4))
     1+dlog(1.d0-b5**2)/2.d0+1.83787706410d0)
      g(i7+i9+1)=g(i7+i9+1)+b5*yx*zx*bx(4)+gg(i3)/bx(2)
      g(j7+j9+1)=g(j7+j9+1)+b5*yx*zx*bx(2)+gg(i3)/bx(4)
      g(i2)=g(i2)-(b6*yx+b5*gg(i3))/(1.d0-b5**2)
c   If(id.ne.7) go to 79
c   Yx=yx/(1.d0-b5**2)
c   J4=(i7+i9+1)*(i7+i9+2)/2
c   S(1,j4)=s(1,j4)-(2.d0*b5*yx+gg(i3))/bx(1)
c   J4=(j7+j9+1)*(j7+j9+2)/2
c   S(1,j4)=s(1,j4)-(2.d0*b5*yx+gg(i3))/bx(3)
c   J4=(i7+i9+1)*(i7+i9)/2+j7+j9+1
c   S(1,j4)=s(1,j4)-b5*yx/(bx(2)*bx(4))
c   J4=i2*(i2-1)/2
c   S(1,j4+i7+i9+1)=s(1,j4+i7+i9+1)+b6*yx/bx(2)
c   S(1,j4+j7+j9+1)=s(1,j4+j7+j9+1)+b6*yx/bx(4)
c   S(1,j4+i2)=s(1,j4+i2)+(-2.d0*(b5**3+3.d0*b5)*yx/(1.d0-b5**2)+b6*gg
c    1(i3))/(1.d0-b5**2)
   79 vx=bx(2)
      l=0
      zx=1.d0-b5**2
   81 j4=gg(i3+1)
      j8=j4
      i3=i3+1
      yx=0.d0
      do 83 i=1,j9
   83 ff(i)=0.d0
      do 85 i=1,j9
c   I4=(j7+i-1)*(j7+i)/2+j7
      do 85 j=1,i
c   I4=i4+1
      j4=j4+1
c   If(id.eq.7) s(1,i4)=s(1,i4)+gg(j4)/(bx(3)*zx)
      ff(i)=ff(i)+x(j7+j)*gg(j4)
      if(i.ne.j) ff(j)=ff(j)+x(j7+i)*gg(j4)
      if(i.ne.j) yx=yx+x(j7+i)*x(j7+j)*gg(j4)
   85 yx=yx+x(j7+i)*x(j7+j)*gg(j4)
      do 87 j=1,j9
      j4=j4+1
      ff(j)=ff(j)-gg(j4)
   87 yx=yx-2.d0*x(j7+j)*gg(j4)
      yx=(yx+gg(j4+1))/bx(3)
      j4=j4+2
      if(j8.eq.i3) i3=j4
c   I4=(j9+j7)*(j9+j7+1)/2+j7
      j3=i2*(i2-1)/2+j7
      do 89 j=1,j9
      ff(j)=ff(j)/(bx(3)*zx)
      g(j7+j)=g(j7+j)+ff(j)
c   If(id.ne.7) go to 89
c   s(1,i4+j)=s(1,i4+j)-2.d0*ff(j)/bx(4)
c   s(1,j3+j)=s(1,j3+j)+2.d0*b5*ff(j)/zx
c   if(joh(i8).ge.0) go to 89
c   s(1,i4+j)=s(1,i4+j)-s(1,j3+j)*b5/bx(4)
c   j8=(i7+i9+1)*(i7+j9)/2+j+j7
c   if(l.eq.1) j8=(j+j7)*(j+j7-1)/2+joe(j6+me+1)
c   s(1,j8)=s(1,j8)-s(1,j3+j)*b5/vx
c   s(1,j3+j)=s(1,j3+j)/(bx(4)*vx)
   89 continue
      if(id.eq.6) f=f+yx/(2.d0*zx)
      g(j7+j9+1)=g(j7+j9+1)-yx/(bx(4)*zx)
      g(i2)=g(i2)+b5*yx/(zx**2)
c   If(id.ne.7) go to 91
c   I4=(j7+j9+1)*(j7+j9+2)/2
c   S(1,i4)=s(1,i4)+3.d0*yx/(zx*bx(3))
c   I4=i2*(i2-1)/2+j7+j9+1
c   S(1,i4)=s(1,i4)-2.d0*b5*yx/(bx(4)*zx**2)
c   I4=i2*(i2+1)/2
c   S(1,i4)=s(1,i4)+(1.d0+3.d0*b5**2)*yx/(zx**3)
   91 l=l+1
      if(l.eq.2) go to 93
      j7=i7
      j9=i9
      vx=bx(4)
      bx(4)=bx(2)
      bx(3)=bx(1)
      go to 81
   93 if(joh(i8).ge.0) go to 95
      j9=jol(j6)
      g(i7+i9+1)=g(i7+i9+1)-b5*g(i2)/bx(2)
      g(j9)=g(j9)-b5*g(i2)/vx
      g(i2)=g(i2)/(bx(2)*vx)
c   If(id.ne.7) go to 95
c   J8=i2*(i2-1)/2
c   I4=(i7+i9+1)*(i7+i9)/2+j9
c   S(1,i4)=s(1,i4)-b5*(s(1,j8+i7+i9+1)/vx+s(1,j8+j9)/bx(2)-b5*s(1,j8+
c    1i2)/(bx(2)*vx)+g(i2))
c   I4=(i7+i9+1)*(i7+i9+2)/2
c   S(1,i4)=s(1,i4)-b5*(2.d0*g(i2)*vx+2.d0*s(1,j8+i7+i9+1)-b5*s(1,j8+i
c    12)/bx(2))/bx(2)
c   I4=(j9)*(j9+1)/2
c   S(1,i4)=s(1,i4)-b5*(2.d0*g(i2)*bx(2)+2.d0*s(1,j8+j9)-b5*s(1,j8+i2)
c    1/vx)/vx
c   S(1,j8+i7+i9+1)=(s(1,j8+i7+i9+1)-b5*s(1,j8+i2)/bx(2)+g(i2)*vx)/(vx
c    1*bx(2))
c   S(1,j8+j9)=(s(1,j8+j9)-b5*s(1,j8+i2)/vx+g(i2)*bx(2))/(vx*bx(2))
c   S(1,j8+i2)=s(1,j8+i2)/(vx*bx(2))
   95 continue
  100 continue
      if(id.lt.6) return
      do 130 i6=1,me
      if(jod(i6).eq.1.or.joe(i6).le.0) go to 130
      i9=jol(i6)
      call CATCH(0,0,i6,x(i9),1,ind)
      bx(1)=dsqrt(x(i9))
      g(i9)=g(i9)/(2.d0*bx(1))
c   If(id.ne.7) go to 130
c   Do 127 j6=1,me
c   J9=joe(me+j6+1)-joa(j6)
c   If(j6.gt.i6) go to 117
c   I4=i9*(i9-1)/2+joa(j6)
c   Do 110 j=1,j9
c 110 s(1,i4+j)=s(1,i4+j)/(2.d0*bx(1))
c   If(j6.ne.i6) go to 125
c   S(1,i4+j9)=(s(1,i4+j9)/2.d0-g(i9))/bx(1)
c   Go to 130
c 117 do 122 j=1,j9
c   I4=(j+joa(j6))*(j+joa(j6)+1)/2+i9
c 122 s(1,i4)=s(1,i4)/(2.d0*bx(1))
c 125 i4=((i6-1)*(i6-2)/2+j6+lpp)*((i6-1)*(i6-2)/2+j6+lpp-1)/2+i9
c   S(1,i4)=s(1,i4)/(2.d0*bx(1))
c 127 continue
  130 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RDREST        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decomposes restrictions on coefficients into a form usable.
c   This subroutine calls the following subroutines:
C   KWAST  ERRWRT  
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  CONBAS  CONDAT  CONTRL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RDREST(iii,jjj,r,j2,a,rr,rs,rt,ls,le,lar,kk,j1,id,my,
     1ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision r(1),rr(1),rs(1),rt(1),v2,r1,r2,v3
      dimension a(1),iii(1),jjj(1),i1(6),lar(1),ls(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a2(7),imin,imax,dum(31)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      k0=0
c   Branch if reading non-linear equation
      if(id.eq.1) go to 4
      j1=1
      j0=j2-1
      v2=1.d0
c   Decompose left hand side of restriction/transformation equation
    1 call KWAST(a,j1,r1,r2,i1,k,ind)
      if((k.ne.16.and.k.ne.17.and.k.ne.21).or.i1(4).ne.0.or.i1(5).ne.0.o
     1r.(i1(1).ne.0.and.j0.eq.j2).or.(id.eq.0.and.(i1(3).ne.0.or.i1(6).n
     2e.0.or.i1(2).ne.0.or.i1(1).lt.0.or.i1(1).gt.le)).or.(id.eq.2.and.i
     31(1).gt.0)) go to 45
      if(i1(1).eq.0) r1=dsign(1.d0,r1)*dabs(r1)**r2
      v2=v2*r1
      if(i1(1).eq.0) go to 2
      j0=j2
      iii(j0+2)=i1(1)
      r(j0+1)=0.d0
      r(j0+2)=1.d0/r2
      if(id.eq.0.and.r2.ne.1.) my=1
      if(id.ne.2) go to 2
      if(i1(3).ne.0) iii(j0+2)=iii(j0+2)-1000*i1(3)
      jjj(j0+2)=i1(2)
      if(i1(2).ge.0) go to 2
      i2=i1(2)
      if(i2.lt.0.and.lar(-i2).eq.0) go to 45
      jjj(j0+1)=i1(6)
      imax=max0(imax,i1(6))
      imin=min0(imin,i1(6))
c   Continue to accumulate element if separation is a * or /
    2 if(k.ne.21) go to 1
      if(iii(j0+2).eq.0) go to 45
      i=iii(j0+2)
      if(id.eq.0.and.lar(i).ne.0) go to 45
      if(id.eq.0) lar(i)=1
      j1=j1+1
      j2=j2+3
      if(v2.ne.1..or.r(j0+2).ne.1..or.(id.eq.2.and.jjj(j0+2).lt.0)) r(j0
     1+1)=v2
      go to 6
    4 j0=j2
      j2=j2+1
      do 5 i=1,kk
    5 rs(i)=0.d0
    6 iii(j0+1)=0
      if(id.eq.2.or.le.eq.0) go to 10
      do 8 i=1,le
    8 rr(i)=0.d0
c   Decompose elements of r.h.s.  each element separated by + or -
   10 v2=1.d0
      j4=1
   11 call KWAST(a,j1,r1,r2,i1,k,ind)
c   Separate if parenthesis detected
      if(i1(4).eq.0) go to 28
      if((i1(4).eq.19.and.k0.eq.0).or.(i1(4).le.18.and.k0.eq.1)) go to
     1 45
      if(i1(4).eq.19) go to 18
c   Store if (
      if(id.ne.2) my=1
      v2=v2*r1
      k2=0
      if(i1(4).eq.17) k2=1
      if(id.eq.0) go to 14
      do 12 i=1,kk
      rs(i+kk)=rs(i)
   12 rs(i)=0.d0
   14 if(id.eq.2.or.le.eq.0) go to 17
      do 16 i=1,le
      rt(i)=rr(i)
   16 rr(i)=0.d0
   17 k3=le
      v3=v2
      k0=1
      j1=j1+1
      iii(j2+j4+1)=0
      if(id.ne.0) iii(j2+j4+1)=-2000-i1(3)*1000
      if(id.eq.2) iii(j2+j4+1)=iii(j2+j4+1)-1000
      k4=j2
      k5=j4+1
      j2=j2+j4+1
      go to 10
c   Code if )
   18 k0=0
      if(k2.eq.1) r2=-r2
      if(i1(2).eq.0.and.dabs(r2).ge.1.) r2=ifix(sngl(r2))
      r(k4+k5)=r2
      if(id.eq.0.and.i1(2).ne.0) go to 45
      if(id.eq.0) go to 22
      jjj(k4+k5)=i1(2)
      k1=i1(2)
      if(id.eq.2) go to 20
      if(k1.lt.0.and.lar(-k1).le.2) lar(-k1)=lar(-k1)+10
      if(k1.gt.0) ls(k1)=1
      if(k1.lt.0.and.lar(-k1).le.2) lar(-k1)=lar(-k1)+10
      if(k1.le.le) go to 20
      le=le+1
      do 19 i=le,k1
   19 rr(i)=0.d0
      le=k1
   20 do 21 i=1,kk
   21 rs(i)=rs(i+kk)
      if(id.ne.2) go to 22
      if(k1.lt.0.and.lar(-k1).ne.1) go to 45
      ls(k4+k5)=i1(6)
      imax=max0(imax,i1(5),i1(6))
      imin=min0(imin,i1(5),i1(6))
      go to 26
   22 if(k3.eq.0) go to 26
      do 24 i=1,k3
   24 rr(i)=rt(i)
   26 v2=v3
      j4=j2-k4
      j2=k4
      go to 34
   28 if(i1(1).lt.-kk.or.i1(2).lt.-kk.or.k.ge.21.or.k.le.13.or.(id.eq.0.
     1and.(i1(1).gt.le.or.i1(2).ne.0.or.i1(3).ne.0.or.i1(1).lt.0)).or.(i
     2d.eq.2.and.i1(2).gt.0)) go to 45
      if(i1(1).eq.0.and.i1(2).eq.0) r1=dsign(1.d0,r1)*dabs(r1)**r2
      v2=v2*r1
      if(i1(1).eq.0.and.i1(2).eq.0) go to 34
      k1=i1(1)
      if((id.eq.2.and.k1.lt.0.and.lar(-k1).ne.1).or.(id.eq.0.and.lar(k1)
     1.eq.1)) go to 45
      if(id.eq.0) lar(k1)=2
      if(id.ne.1) go to 30
      if(k1.gt.0) ls(k1)=1
      if(k1.lt.0.and.lar(-k1).le.2) lar(-k1)=lar(-k1)+10
      i2=i1(2)
      if(i2.gt.0) ls(i2)=1
      if(i2.ne.0) my=1
      if(i2.lt.0.and.lar(-i2).le.2) lar(-i2)=lar(-i2)+10
      i2=max0(k1,i2)
      if(i2.le.le) go to 30
      le=le+1
      do 29 i=le,i2
   29 rr(i)=0.d0
      le=i2
   30 if(i1(3).ne.0.or.i1(2).ne.0.or.i1(5).ne.0.or.i1(6).ne.0.or.(id.eq.
     12.and.k1.gt.0)) go to 32
      if(k1.lt.0) rs(-k1)=rs(-k1)+r2
      if(k1.gt.0) rr(k1)=rr(k1)+r2
      go to 34
   32 j4=j4+1
      if(i1(3).eq.1.and.i1(1).lt.0) i1(1)=i1(1)-1000
      if(i1(3).eq.1.and.i1(1).gt.0) i1(1)=i1(1)+1000
      if(i1(3).eq.2.and.i1(1).lt.0) i1(1)=i1(1)-2000
      if(i1(3).eq.2.and.i1(1).gt.0) i1(1)=i1(1)+2000
      iii(j2+j4)=i1(1)
      if(id.ne.0) jjj(j2+j4)=i1(2)
      if(i1(2).eq.0.and.dabs(r2).ge.1.) r2=ifix(sngl(r2))
      r(j2+j4)=r2
      if(id.eq.0.or.i1(1).ne.0) go to 33
      iii(j2+j4)=2001
      if(r2.lt.0.) iii(j2+j4)=2003
      r(j2+j4)=r1
      v2=v2/r1
      if(id.eq.2) iii(j2+j4)=iii(j2+j4)+1000
   33 if(id.ne.2) go to 34
      i2=i1(2)
      if(i2.lt.0.and.lar(-i2).ne.1) go to 45
      ls(j2+j4)=i1(5)*1000+i1(6)
      imax=max0(imax,i1(5),i1(6))
      imin=min0(imin,i1(5),i1(6))
   34 if(k.eq.16.or.k.eq.17) go to 11
      if(k0.eq.0) iii(j0+1)=iii(j0+1)+1
      if(k0.gt.0) iii(k4+k5)=iii(k4+k5)-1
      r(j2+1)=v2
      if(id.eq.2.or.le.eq.0) go to 37
      i2=j4
      do 36 i=1,le
      if(rr(i).eq.0.) go to 36
      j4=j4+1
      iii(j2+j4)=i
      if(dabs(rr(i)).ge.1.) rr(i)=ifix(sngl(rr(i)))
      r(j2+j4)=rr(i)
      if(j4-i2.gt.1.or.rr(i).ne.1.) my=1
   36 rr(i)=0.d0
      if(id.eq.0) go to 40
   37 do 38 i=1,kk
      if(rs(i).eq.0) go to 38
      j4=j4+1
      iii(j2+j4)=-i
      if(dabs(rs(i)).ge.1.) rs(i)=ifix(sngl(rs(i)))
      r(j2+j4)=rs(i)
   38 rs(i)=0.d0
   40 iii(j2+1)=j4
      j2=j2+j4
      if(k.ne.20) go to 10
      if(k0.ne.0) go to 45
      i2=-iii(j0+2)
      if(id.eq.2) kk=max0(kk,i2)
      if(id.eq.2) lar(i2)=1
      if(id.ne.1) iii(j0+3)=j2-j0
      if(id.eq.1) jjj(j0+1)=j2-j0
      return
   45 ind=7
      k0=max0(1,j1-4)
      i2=j1-k0+1
      call ERRWRT(0,a(k0),i2,0,0,r1)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   READCF        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads input coefficients.
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  CONTRL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine READCF(fmt,aa,le,l1)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension fmt(20)
      double precision aa(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,inp,a1(38),lwi,dum(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(l1) 70,30,10
   10 read(inp,15) (fmt(i),i=1,20)
c** change *** set format to (17a4,a2,2a1) for 72 column input file.
   15 format(17a4,a2,2a1)
      if(lwi.eq.0) write(ip,20) (fmt(i),i=1,20)
   20 format(41x,'Format',4x,20a4)
      if(lwi.eq.1) write(ip,25) (fmt(i),i=1,18)
   25 format(' Format ',18a4)
      read(inp,fmt,end=70,err=70) (aa(i),i=1,le)
      go to 50
   30 read(inp,40,end=70,err=70) (aa(i),i=1,le)
c** change *** reset coeffi. input format if new punch format set below.
   40 format(5d16.9)
   50 if(lwi.eq.0) write(ip,60) (aa(i),i=1,le)
   60 format(41x,'COEFFI',4x,5g12.5)
      if(lwi.eq.1) write(ip,65) (aa(i),i=1,le)
   65 format('COEFFI ',6g12.5)
      return
   70 l1=-1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   READOM        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads observation matrix.
c
c   This subroutine calls the following subroutines:
C   USEO  USEM  CPRINT  USER  TRANSE  APRINT  
c
c   This subroutine is called by the following subroutines:
C   DATAON  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine READOM(vnam,xbata,fmt,x,c,a,xx,rn,iin,jjn,kkn,tar,imy,
     1ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension xbata(1),x(1),vnam(9,nvar),fmt(480),imy(1),tar(1),
     1c(nvar,3),iin(1),jjn(1),kkn(1)
      double precision a(nvar,2),xx(1),fa,ca,ba,rn(1)
      character*20 filep
c    character*9 datex
c    character*8 timex
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,inp,ipc,int,iqv,nobs,nvar,ntime,a1(23),m8,a2(2),mi1,
     1a3(3),mtime,jobs,lwi,dum(3)
      common /c/ inn,ipr,ifm,isz,jcore,itran,ntar,imin,imax,lcore,
     *dumc(30)
      common /punch/ filep
c------------------------DATA STATEMENTS---------------------------------
      data vd/1H /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      idd=0
      n5=(nvar+1)*(nvar+2)/2
      if(ifm.lt.3) go to 9
      if(ifm-4) 2,4,6
c   Read observation matrix from subroutine USEO
    2 call USEO(xbata,jcore,ntar,nobs,inn,idd)
      if(mtime.eq.0) jobs=nobs*ntime
      if(mtime.gt.0) jobs=nobs
      lcore=jobs
      if(idd.ne.0) go to 90
      if(itran.eq.0.and.ipr.eq.0.and.iqv.eq.0.and.mtime.eq.0) go to 54
      go to 9
c   Read moment matrix from subroutine USEM
    4 call USEM(xx,nvar,inn,idd)
      if(idd.gt.0) go to 90
      go to 7
c   Read moment matrix from double precision binary read
    6 read(inn,end=90,err=90) (xx(l),l=1,n5)
    7 if(jobs.eq.0) nobs=xx(n5)/dble(ntime)
      if(jobs.eq.0) jobs=xx(n5)
c   Change made by Jacob Klerman 7/85 - added one line on instruction from joe hotz
      fa=dble(jobs)
      mi1=0
      if(iqv.eq.3.and.ipr.eq.0) return
      if(ipr.eq.0) go to 80
      j=0
      do 8 l=1,nvar
      j=j+l
      a(l,1)=xx(n5-nvar-1+l)
      a(l,2)=xx(j)
      do 8 n4=1,3
    8 c(l,n4)=0.
      go to 56
    9 if(ipr.le.1.or.ipr.eq.3.or.ipr.eq.5.or.ipr.eq.6) go to 14
      call CPRINT(1)
      m7=(nvar-1)/9+1
      m8=m8+m7-1
      if(lwi.eq.0) write(ip,10)
   10 format(45x,10('-'),' Observation Vectors ',10('-'),/)
      if(lwi.eq.1) write(ip,11)
   11 format(19x,10('-'),' Observation Vectors ',10('-'),/)
      if(lwi.eq.0) write(ip,12) (vd,vd,vd,(vnam(nm,i),nm=1,8),vd,vd,i=1,
     1nvar)
   12 format(' Observ ',117a1,/,(8x,117a1))
      if(lwi.eq.1) write(ip,13) (vd,vd,(vnam(nm,i),nm=1,8),vd,vd,i=1,
     1nvar)
   13 format(' Observ ',72a1,/,(8x,72a1))
   14 if(ipr.eq.0) go to 16
      do 15 i=1,nvar
      a(i,1)=0.d0
      a(i,2)=0.d0
      c(i,3)=0.
      c(i,1)=10.0**30
   15 c(i,2)=-c(i,1)
   16 if(ipr.lt.3.and.iqv.lt.3) go to 18
      do 17 i=1,n5
   17 xx(i)=0.d0
   18 nm=0
      n0=0
      n1=0
      n3=0
      n4=0
      n7=imax-imin+1
      jtime=1
      n2=100000
   21 idd=0
      nm=nm+1
      if(nobs.ne.0.and.nm.gt.lcore) go to 53
      if(ifm.eq.3) go to 22
      if(ifm-1) 24,25,26
   22 do 23 j=1,ntar
   23 x(j)=xbata(j*jcore-jcore+nm)
      go to 27
c   Read observations with binary read
   24 read(inn,end=53,err=90) (x(j),j=1,ntar)
      go to 27
c   Read observations with formatted read
   25 read(inn,fmt,end=53,err=90) (x(j),j=1,ntar)
      go to 27
c   Read observations from subroutine USER
   26 call USER(x,ntar,nm,inn,idd)
      if(idd.eq.1) go to 21
      if(idd-3) 27,53,90
   27 n4=n4+1
      if(mtime.eq.0.or.itran.gt.0) go to 28
      j=ifix(x(mtime))
      if(iabs(j).gt.jtime) jtime=iabs(j)
      if(iabs(j).le.0.or.iabs(j).gt.ntime) go to 90
      if(j.le.n2) n3=n3+1
      n2=iabs(j)
   28 if(n4.gt.jcore+n1.and.iqv.eq.0) go to 88
      jobs=n4
      if(itran.eq.0.and.iqv.gt.0) go to 40
      n0=n0+1
      if(n0.gt.jcore) n0=1
      if(n1.gt.0.or.ifm.eq.3) go to 30
      do 29 j=1,ntar
   29 xbata(j*jcore-jcore+n0)=x(j)
   30 if(itran.eq.0.and.ifm.eq.3) go to 38
      if(itran.eq.0) go to 40
      if(n4.lt.1+imax) go to 21
      jobs=n4-imax
      i=n0-imax
      if(i.lt.1) i=jcore+i
      if(mtime.gt.0) go to 31
      n2=n2+1
      if(n2.gt.ntime) n2=1
      if(n2.eq.1) n3=n3+1
      j=ntime
      if(ntime.eq.1) n2=min0(jobs-1,-imin)+1
      if(ntime.eq.1) j=n2+imax-n1
      go to 37
   31 j=ifix(xbata(mtime*jcore-jcore+i))
      if(iabs(j).gt.jtime) jtime=iabs(j)
      if(iabs(j).le.0.or.iabs(j).gt.ntime) go to 90
      if(j.le.n2) n3=n3+1
      n2=iabs(j)
      do 32 j=1,n7
   32 imy(j)=0
      imy(1-imin)=i
      if(imax.eq.0) go to 34
      n8=n2
      do 33 j=1,imax
      if(j.gt.imax-n1) go to 34
      l=i+j
      if(l.gt.jcore) l=l-jcore
      if(xbata(mtime*jcore-jcore+l).gt.n2+imax.or.xbata(mtime*jcore-jcor
     1e+l).le.n8) go to 34
      n8=iabs(ifix(xbata(mtime*jcore-jcore+l)))
   33 imy(1-imin+n8-n2)=l
   34 if(imin.eq.0) go to 37
      n8=n2
      n9=-imin
      do 35 j=1,n9
      l=i-j
      if(l.lt.1) l=jcore+l
      if(xbata(mtime*jcore-jcore+l).lt.0.or.xbata(mtime*jcore-jcore+l).g
     1e.n8.or.xbata(mtime*jcore-jcore+l).lt.n2+imin) go to 37
      n8=iabs(ifix(xbata(mtime*jcore-jcore+l)))
   35 imy(1-imin-n2+n8)=l
   37 if(n1.gt.0) n1=n1+1
c   Call TRANSE which Calculates transformed x's
      call TRANSE(xbata,jcore,nvar,rn,iin,jjn,kkn,tar,i,n2,n3,j,imy)
   38 do 39 j=1,nvar
   39 x(j)=xbata(j*jcore-jcore+i)
   40 if(ipr.le.1.or.ipr.eq.3.or.ipr.eq.5.or.ipr.eq.6) go to 43
      m8=m8+m7
      if(m8.gt.58.and.lwi.eq.0) call CPRINT(11)
      if(lwi.eq.0) write(ip,41) jobs,(x(l),l=1,nvar)
   41 format(i5,3x,9g13.5,/,(8x,9g13.5))
      if(lwi.eq.1) write(ip,42) jobs,(x(l),l=1,nvar)
   42 format(i5,3x,6g12.5,/,(8x,6g12.5))
   43 if(iqv.eq.2) write(int) (x(j),j=1,nvar)
      if(ipr.eq.0) go to 46
      do 45 j=1,nvar
      if(MISS(x(j)).eq.0) go to 44
      c(j,3)=c(j,3)+1.
      x(j)=0.
      go to 45
   44 a(j,1)=a(j,1)+dble(x(j))
      a(j,2)=a(j,2)+dble(x(j))*dble(x(j))
      c(j,1)=amin1(c(j,1),x(j))
      c(j,2)=amax1(c(j,2),x(j))
   45 continue
   46 if(ipr.lt.3.and.iqv.lt.3) go to 50
      l=0
      do 47 i=1,nvar
      do 47 j=1,i
      l=l+1
   47 xx(l)=xx(l)+dble(x(i))*dble(x(j))
      do 48 i=1,nvar
   48 xx(l+i)=xx(l+i)+dble(x(i))
      xx(l+nvar+1)=xx(l+nvar+1)+1.d0
   50 if(n1.eq.0) go to 51
      if(n1.gt.imax) go to 54
      go to 27
   51 if(idd.gt.0) go to 53
      if(nobs.eq.0.or.nm.lt.lcore) go to 21
   53 if(imax.eq.0) go to 54
      n1=1
      go to 27
   54 if(mtime.eq.0) nobs=jobs/ntime
      if(mtime.gt.0) nobs=n3
      if(mtime.gt.0) ntime=jtime
      fa=dble(jobs)
      if((iqv.ne.0.and.iqv.ne.4).or.jobs.eq.jcore) go to 56
      i=-jcore
      l=-jobs
      do 55 n1=1,nvar
      i=i+jcore
      l=l+jobs
      do 55 n2=1,jobs
   55 xbata(l+n2)=xbata(i+n2)
   56 if(ipr.eq.0) go to 80
      call CPRINT(2)
      if(lwi.eq.0) write(ip,57)
   57 format(45x,10('-'),' Variable Statistics ',10('-'),/)
      if(lwi.eq.1) write(ip,58) 
   58 format(3x,16x,10('-'),' Variable Statistics ',10('-'),7x/)
      do 66 i=1,nvar
      ca=fa-c(i,3)
      n4=ca
      if(n4.gt.0) a(i,1)=a(i,1)/ca
      ba=0.d0
      if(ca.gt.1.) ba=(a(i,2)-a(i,1)*a(i,1)*ca)/(ca-1.d0)
      if(ba.gt.0.) ba=dsqrt(ba)
      ca=a(i,1)*dble(n4)
      if(m8.eq.58.and.lwi.eq.0) call CPRINT(12)
      m8=m8+1
      if(lwi.eq.1) go to 62
      if(m8.eq.7) write(ip,59)
   59 format(6x,'Variable Count   Mean',7x,'Standard Deviation',7x,'Sum
     1s',9x,'Sums of Squares',7x,'Minimum',11x,'Maximum',/)
      write(ip,61) i,(vnam(nm,i),nm=1,8),n4,a(i,1),ba,ca,a(i,2),c(i,1),
     1c(i,2)
   61 format(i5,1x,8a1,i5,6(2x,g14.7,2x))
      go to 65
   62 if(m8.eq.7) write(ip,63)
   63 format(5x,'Variable Count',3x,'Mean',5x,'Stand. Dev.',4x,'Sums',5
     1x,'Minimum',5x,'Maximum',/)
      write(ip,64) i,(vnam(nm,i),nm=1,8),n4,a(i,1),ba,ca,c(i,1),c(i,2)
   64 format(i4,1x,8a1,i5,5g12.5)
   65 if(n4.eq.jobs) go to 66
      a(i,1)=a(i,1)*dble(n4)/fa
      if(ba.gt.0.) ba=dsqrt((a(i,2)-a(i,1)**2*fa)/(fa-1.d0))
   66 a(i,2)=ba
      if(lwi.eq.0) write(ip,67) nobs,ntime,jobs
   67 format(/48x,'Number of Cross-Section Units',i6,/48x,'Number of Tim
     1e Periods ......',i6,/48x,'Total Observations ',10('.'),i6)
      if(lwi.eq.1) write(ip,68) nobs,ntime,jobs
   68 format(/23x,'Number of Cross-Section Units',i6,/23x,'Number of Tim
     1e Periods ......',i6,/23x,'Total Observations ',10('.'),i6)
      if(ipr.lt.3) go to 80
      if(ipr.eq.5) go to 70
c   Print moment matrix
      call APRINT(xx,vnam,nvar,x,a(1,1),a(1,2),jobs,0)
   70 if(ipr.eq.3.or.ipr.eq.4) go to 80
c   Print correlation matrix
      call APRINT(xx,vnam,nvar,x,a(1,1),a(1,2),jobs,1)
   80 if(iqv.eq.0.or.iqv.eq.3) return
      if(iqv.ge.4) write(int) (xx(l),l=1,n5)
      if(iqv.ne.1) end file int
      rewind int
      return
   88 ierror=5
      go to 92
   90 ierror=6
   92 inn=jobs
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RESCL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Scales (and unscales) parameters, data, and parameter covariance 
c   Matrix.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   NLSCL  RTSCL  
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RESCL(scal,beta,xx,xdata,joa,loe,moe,r,iii,rn,iin,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision scal(1),beta(1),xx(1),r(1),rn(1)
      dimension xdata(jb,kobs),joa(1),loe(k,nt),moe(k,me),iii(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,igm,a0(11),nl,ir,dum(24)
      common /d/ k,n,jb,kobs,a1(3),le,a4(4),ny,l1,lee,
     *a2(3),iqz,inz,lq,dumd(3)
      common /k/ jeff,JOFunc,izprt
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(id-2) 1,50,80
    1 if(nl.gt.0) go to 10
c$$$$$$$$$$$$$$$$$$$$$$$
      if((jeff.gt.0.or.JOFunc.gt.0).and.id.eq.0) return
c$$$$$$$$$$$$$$$$$$$$$$$
      if(jeff.gt.0) go to 11
      do 2 i=1,k
    2 xx(i)=0.d0
      do 4 l=1,me
      j2=joa(l)
      do 3 i=1,k
      if(moe(i,l).gt.7) go to 3
      j2=j2+1
c   Determine scaling factor for each variable as the factor which set
c   The coefficient of variable to 1. if variable is in many equations
c   Determine scaling by first occurance. sigma, correlations not scal
      if(xx(i).eq.0.d0) xx(i)=beta(j2)
    3 continue
    4 continue
      do 5 i=1,k
      if(xx(i).eq.0.d0) xx(i)=1.d0
    5 continue
      if(id.eq.0) return
      if(iqz.gt.0) go to 7
      do 6 i=1,n
      l=0
      do 6 j=1,k
      i1=1
      if(nt.gt.1.and.loe(j,1).ne.loe(j,2)) i1=nt
      do 6 j1=1,i1
      l=l+1
c   Multiply data by scaling factor
    6 xdata(l,i)=xdata(l,i)*xx(j)
    7 do 8 i=1,le
    8 scal(i)=1.d0
      do 9 l=1,me
      j2=joa(l)
      do 9 i=1,k
      if(moe(i,l).gt.7) go to 9
      j2=j2+1
c   Vector scal contains scaling factor for each parameter.
      scal(j2)=xx(i)
c   Scale parameter vector, dividing by scaling factor. sets most to 1
      beta(j2)=beta(j2)/xx(i)
    9 continue
      go to 30
c*******************************
c   Code for scaling with nf > 0 option using KIMBAL

   11 continue
      do 138 i=1,le
  138 scal(i)=1.d0
      do 134 l=1,me
      j2=joa(l)
      do 133 i=1,k
      if(moe(i,l).gt.7) go to 133
      j2=j2+1
      scal(j2)=beta(j2)
      if(beta(j2).ne.0) then
          beta(j2)=1.d0
        else
          scal(j2)=1.d0
      endif
  133 continue
  134 continue
      go to 30
c***********************************
c   Scale for non-linear equations
   10 call NLSCL(scal,beta,rn,iin,iin(ny),le,lee,lq)
c   Adjust restrictions to account for scaling
   30 if(ir.gt.0) call RTSCL(scal,beta,r,iii,ir)
      return
   50 l=0
c   Rescale parameters and covariance matrix back to original scale
      do 52 i=1,le
      beta(i)=beta(i)*scal(i)
      do 52 j=1,i
      l=l+1
   52 xx(l)=xx(l)*scal(i)*scal(j)
      return
   80 if(id.eq.4) go to 90
      do 85 i=1,le
   85 beta(i)=beta(i)/scal(i)
      if(id.eq.3) return
      l=0
      do 87 i=1,le
      do 87 j=1,i
      l=l+1
   87 xx(l)=(xx(l)/scal(i))/scal(j)
      return
   90 do 95 i=1,le
   95 beta(i)=beta(i)*scal(i)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RESIDL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes and writes residual vectors.
c
c   This subroutine calls the following subroutines:
C   XBETA  PITTSB  CLEVE  CATCH  CPRINT  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RESIDL(x,xdata,joe,loe,moe,bb,iin,jjn,rn,joa,job,jod,
     1jol,jon,sc,iscal)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),FSTAT,bb(2,nt,me),rn(1),bx(5),f1,f2,f3,vrs,
     1fetol,sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),iin(1),jjn(1),
     1joa(1),job(1),jod(1),jol(1),jon(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a6(1),ipc,a4(37),lwi,dum(3)
      common /c/ me,nt,a1(12),nl,a2(7),ires,jres,irip,iut1,iut2,a5(7),
     1kvrs,jwt,ifxi,kfetol,dum1(2)
      common /c2/ vrs
      common /c3/ fetol
      common /d/ k,n,jb,kobs,lv,a3(13),iqz,inz,lq,dumd(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
C**********************
      if(jres.gt.0) then
         jres=ipc
         write(jres,1144)
 1144    format(1x,'**** Estimated Residuals &/or Predicted Values'
     & ' Follow ****')
      endif
C**********************
      ind=0
      i8=4+ifxi
      do 5 i6=1,me
      if(joe(i6).eq.4.or.joe(i6).eq.5) i8=5
    5 continue
      i3=50
      jj=1
      do 150 ii=1,n
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(iqz.eq.0) jj=ii
      i5=0
      do 40 i6=1,me
      do 14 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.) go to 14
      if(nl.eq.0) go to 10
c   Change made by Jacob Klerman 10/6/85
c   Call XBETA(x,g,s,iin,jjn,rn,bb(1,j,i6),f1,xdata(1,jj),loe(1,j),
c    1joa(i6),jon(i6),lq,0)
      call XBETA(x,x,x,iin,jjn,rn,bb(1,j,16),f1,xdata(1,jj),loe(1,j),
     *joa(i6),jon(i6),lq,0)
      if(nl.gt.1) go to 10
      bb(2,j,i6)=1.d0
c   Change made by Jacob Klerman 10/6/85
      if(joe(i6).ge.1) call XBETA(x,x,x,iin,jjn,rn,bb(2,j,i6),f1,
     *xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,0)
c   If(joe(i6).ge.1) call XBETA(x,g,s,iin,jjn,rn,bb(2,j,i6),f1,
c    1xdata(1,jj),loe(1,j),jol(i6),jon(i6),lq,0)
      go to 12
   10 call PITTSB(bb(1,j,i6),bb(2,j,i6),joa(i6),moe(1,i6),loe(1,j),
     1xdata(1,jj),x,k,joe(i6),jol(i6),i6,sc,iscal,nl)
   12 if(jod(i6).eq.2) bb(2,j,i6)=dsqrt(bb(2,j,i6))
   14 continue
      if(job(i6).le.0) go to 35
   15 f1=0.d0
      f2=0.d0
      f3=1.d0
      do 20 j=1,nt
      if(xdata(lv+i5+j,jj).lt.0.) go to 20
      if(jwt.eq.0) go to 17
      i2=loe(jwt,j)
      f3=dble(xdata(i2,jj))/vrs
   17 call CLEVE(bx,joe(i6),job(i6),jod(i6),bb(1,j,i6),xdata(lv+i5+j,jj)
     1,xdata(lv+i5+nt+j,jj),xdata(lv-me+i6,jj),ii,j,i6,bx,f3,f3,4,ind)
c   Calculate value of fixed effect & check tolerance
      f1=f1+bx(1)
      f2=f2+bx(3)
   20 continue
      call CATCH(ii,i2,i6,f1,6,ind)
      if(dabs(f1).lt.fetol) go to 35
      xdata(lv-me+i6,jj)=xdata(lv-me+i6,jj)+f1/f2
      go to 15
   35 if(joe(i6).ge.2) i5=i5+nt
   40 i5=i5+nt
      do 150 j=1,nt
      i5=0
      do 140 i6=1,me
      i2=0
      if(xdata(lv+i5+j,jj).lt.0.) go to 75
      bx(5)=0.d0
      if(job(i6).gt.0) bx(5)=dble(xdata(lv-me+i6,jj))
      bx(1)=dble(xdata(lv+i5+j,jj))
      if(joe(i6).ge.2) bx(1)=dble(xdata(lv+i5+nt+j,jj))
      bx(2)=bb(1,j,i6)+bx(5)
      if(joe(i6).lt.0) go to 60
      if(joe(i6).ge.8) go to 65
      f2=0.d0
      if(joe(i6).le.1) go to 45
      f2=dble(xdata(lv+i5+nt+j,jj))
      if(joe(i6).eq.3.or.joe(i6).eq.5.or.joe(i6).eq.7) go to 50
      if(xdata(lv+i5+j,jj).ge.2.) f2=f2-dble(xdata(lv+i5+j,jj))+2.d0
   45 f1=(f2-bx(2))/bb(2,j,i6)
      go to 55
   50 if(xdata(lv+i5+j,jj).ge.2.) f2=f2+dble(xdata(lv+i5+j,jj))-2.d0
      f1=(bx(2)-f2)/bb(2,j,i6)
   55 call CATCH(ii,j,i6,f1,4,ind)
      bx(3)=FSTAT(f1,0.,0.,0.,3)
      bx(4)=dabs(f1)*bb(2,j,i6)
      if(bx(3).gt.0.) bx(4)=FSTAT(f1,0.,0.,0.,7)*bb(2,j,i6)/bx(3)
      if(joe(i6).eq.3.or.joe(i6).eq.5.or.joe(i6).eq.7) bx(4)=-bx(4)
      if(joe(i6).lt.4.or.joe(i6).gt.5) go to 85
      if(ifix(xdata(lv+i5+j,jj)).eq.joe(i6)-5) bx(1)=0.d0
      f2=-bx(2)/bb(2,j,i6)
      call CATCH(ii,j,i6,f2,4,ind)
      f1=FSTAT(f2,0.,0.,0.,3)
      if(joe(i6).eq.4) f1=1.d0-f1
      if(job(i6).le.0) bx(5)=1.d0-bx(3)-f1
      bx(3)=bx(3)-f1
      f3=dabs(bx(2))
      if(f1.gt.0.) f3=FSTAT(f2,0.,0.,0.,7)*bb(2,j,i6)/f1
      if(joe(i6).eq.4) f3=-f3
      bx(4)=bx(4)-f3
      go to 85
   60 call CATCH(ii,j,i6,bx(2),5,ind)
      bx(3)=1.d0/(1.d0+dexp(-bx(2)))
      bx(4)=0.d0
      go to 85
   65 bx(3)=bx(1)-bx(2)
      if(joe(i6).eq.9) bx(3)=bx(2)
      bx(4)=bx(3)/bb(2,j,i6)
      go to 85
   75 do 80 i=1,i8
   80 bx(i)=0.d0
      i2=1
   85 if(ind.gt.0) return
      if(jres.gt.0) write(jres,90) (bx(i),i=1,i8)
 90   format(5d16.9)
      if(ires.eq.0) go to 135
      j1=xdata(jb,jj)
      j2=j+iut1-1
      if(iut1.gt.iut2.and.j.gt.iut2) j2=j+(iut1-iut2)
      i3=i3+1
      if(i3.le.50) go to 110
      call CPRINT(1)
      if(i8.eq.4.and.lwi.eq.0) write(ip,100)
  100 format(/46x,'Dependent',7x,'Predicted',6x,'Probability',5x,'E(Erro
     1r/Y=1)',/28x,'Obsv Time Equa',5x,'Variable',9x,'Y Hat',9x,'(Residu
     2al)',4x,'(Std.Residual)',/27x,79('-'),/)
      if(i8.eq.4.and.lwi.eq.1) write(ip,102)
  102 format(/20x,'Dependent',7x,'Predicted',6x,'Probability',5x,'E(Erro
     1r/Y=1)',/2x ,'Obsv Time Equa',5x,'Variable',9x,'Y Hat',9x,'(Residu
     2al)',4x,'(Std.Residual)',/1x,79('-'),/)
      if(i8.eq.5.and.lwi.eq.1) write(ip,105)
  105 format(/38x,'Dependent',7x,'Predicted',6x,'Probability',5x,'E(Erro
     1r/Y=1)',7x,'Fixed',/20x,'Obsv Time Equa',5x,'Variable',9x,'Y Hat',
     29x,'(Residual)',4x,'(Std.Residual)',6x,'Effect',/19x,95('-'),/)
      if(i8.eq.5.and.lwi.eq.1) write(ip,107)
  107 format(/17x,'Dependent',5x,'Predicted',4x,'Probability',3x,'E(Erro
     1r/Y=1)',5x,'Fixed',/1x ,'Obsv Time Equa',2x,'Variable',7x,'Y Hat',
     27x,'(Residual)',2x,'(Std.Residual)',4x,'Effect',/1x,79('-'),/)
      i3=1
  110 if(i2.eq.1) go to 125
      if(lwi.eq.0.and.i8.eq.4) write(ip,115) j1,j2,i6,(bx(i),i=1,4)
  115 format(27x,3i5,4(1x,g14.6,1x))
      if(lwi.eq.1.and.i8.eq.4) write(ip,118) j1,j2,i6,(bx(i),i=1,4)
  118 format(1x,i4,2i5,1x,4(1x,g14.6,1x))
      if(lwi.eq.0.and.i8.eq.5) write(ip,120) j1,j2,i6,(bx(i),i=1,5)
  120 format(19x,3i5,5(1x,g14.6,1x))
      if(lwi.eq.1.and.i8.eq.5) write(ip,122) j1,j2,i6,(bx(i),i=1,5)
  122 format(1x,i4,2i5,5g13.6)
      go to 135
  125 if(lwi.eq.0.and.i8.eq.4) write(ip,130) j1,j2,i6
  130 format(27x,3i5,21x,'Observation missing')
      if(lwi.eq.0.and.i8.eq.5) write(ip,132) j1,j2,i6
  132 format(19x,3i5,29x,'Observation missing')
      if(lwi.eq.1) write(ip,134)
  134 format(1x,i4,2i5,21x,'Observation missing')
  135 if(joe(i6).ge.2) i5=i5+nt
  140 i5=i5+nt
  150 continue
C**********************
      if(jres.gt.0) write(jres,1145)
 1145 format(1x,'**** End of Estimated Residuals &/or Predicted'
     & '  Values ****')
C**********************
      if(iqz.gt.0) rewind inz
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RESTRN        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Adjusts coefficients, gradients, std. errors for restrictions.
c
c   This subroutine calls the following subroutines:
C   PAREM  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  FCTGR  SECDRV  STANER  START  CONTIM  SECDRS  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RESTRN(x,g,xx,r,ii,ic)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),xx(1),r(1),vd,vs,vr,POW
      dimension ii(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a1(15),ir,dum(24)
      common /d/ a2(7),le,a3(3),my,dumd(12)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      j1=0
      if(ic-1) 5,20,39
c   Map restricted to unrestricted coefficients
    5 do 15 i1=1,ir
      i2=ii(j1+1)
      j5=j1
      i3=ii(j1+2)
      j1=j1+3
      vs=x(i3)
      x(i3)=0.d0
      do 10 i4=1,i2
      j1=j1+1
      vd=r(j1)
      j2=ii(j1)+j1-1
      go to 8
    6 j1=j1+1
      i=ii(j1)
      if(i.lt.0) go to 7
      vd=vd*POW(x(i),r(j1))
      go to 8
    7 call PAREM(ii,r,xx,g,x,j1,vd,vr,vd,i,0,0)
      vd=vd*vr
    8 if(j1.lt.j2) go to 6
   10 x(i3)=x(i3)+vd
      if(r(j5+1).eq.0..or.x(i3).eq.0.) go to 13
      if(dabs(r(j5+2)).ne.1.) x(i3)=dabs(x(i3)/r(j5+1))**r(j5+2)
      if(dabs(r(j5+2)).eq.1.) x(i3)=(x(i3)/r(j5+1))**ifix(sngl(r(j5+2)))
   13 if(ic.ne.6) go to 15
      g(i1)=vs-x(i3)
      x(i3)=vs
   15 continue
      return
c   Map unrestricted 1st derivatives to restricted
   20 do 38 i1=1,ir
      i2=ii(j1+1)
      i3=ii(j1+2)
      if(ic.eq.7) g(i3)=1.d0
      if(r(j1+1).eq.0.) go to 21
      if(r(j1+2).ne.1.) g(i3)=g(i3)*dabs(x(i3))**(1.d0-1.d0/r(j1+2))*r(j
     11+2)/r(j1+1)
      if(r(j1+2).eq.1.) g(i3)=g(i3)/r(j1+1)
   21 j1=j1+3
      do 35 i4=1,i2
      j1=j1+1
      vd=r(j1)
      j4=ii(j1)
      j2=j4+j1-1
      go to 25
   23 j1=j1+1
      i=ii(j1)
      if(i.lt.0) go to 24
      vd=vd*POW(x(i),r(j1))
      go to 25
   24 call PAREM(ii,r,xx,g,x,j1,vd,vr,vd,i,0,0)
      vd=vd*vr
   25 if(j1.lt.j2) go to 23
      j1=j2-j4+1
      go to 33
   26 j1=j1+1
      i=ii(j1)
      if(i.lt.0) go to 30
      if(x(i).eq.0.) go to 33
      if(ic.eq.1.or.ic.eq.7) go to 32
      vs=r(j1)*vd/x(i)
      j5=j2-j4+1
   27 j5=j5+1
      j7=ii(j5)
      if(j7.lt.0) go to 28
      if(x(j7).eq.0) go to 27
      j6=IYYM(i,j7)
      xx(j6)=xx(j6)-g(i3)*r(j5)*vs/x(j7)
      if(j5.lt.j1) go to 27
      xx(j6)=xx(j6)+g(i3)*vs/x(j7)
      go to 33
   28 call PAREM(ii,r,xx,g,x,j5,g(i3),vr,vs,i,j7,2)
      go to 27
   30 if(ic.eq.1.or.ic.eq.7) go to 31
      i=j2-j4+1
      call PAREM(ii,r,xx,g,x,j1,g(i3),vr,vd,i,j2,4)
      go to 33
   31 call PAREM(ii,r,xx,g,x,j1,g(i3),vr,vd,i,0,1)
      go to 33
   32 g(i)=g(i)+r(j1)*vd*g(i3)/x(i)
   33 if(j1.lt.j2) go to 26
   35 continue
      if(ic.ne.3.and.ic.ne.7) g(i3)=0.d0
      if(ic.ne.7) go to 38
      vs=g(i3)
      g(i3)=-g(i3)
      j4=(i1-1)*le
      do 36 i=1,le
      xx(j4+i)=g(i)/vs
   36 g(i)=0.d0
   38 continue
      j1=0
      if(ic.eq.3) go to 70
      return
   39 if(ic-6) 40,5,20
   40 if(ic.eq.5) go to 70
c   Map unrestricted 2nd derivatives to restricted
      do 42 i1=1,ir
      i3=ii(j1+2)
      if(r(j1+1).eq.0.) go to 42
      if(r(j1+2).ne.1.) vd=dabs(x(i3))**(1.d0-1.d0/r(j1+2))*r(j1+2)/r(j1
     1+1)
      if(r(j1+2).eq.1.) vd=1.d0/r(j1+1)
      do 41 i2=1,le
      i=IYYM(i3,i2)
      xx(i)=xx(i)*vd
      if(i2.ne.i3) go to 41
      xx(i)=xx(i)*vd
      if(ic.eq.3.and.r(j1+2).ne.1..and.x(i3).ne.0.) xx(i)=xx(i)-g(i3)*vd
     1*(r(j1+2)-1.d0)/(dabs(x(i3))**(1.d0/r(j1+2))*r(j1+1))
   41 continue
   42 j1=ii(j1+3)+j1
      j1=0
      do 55 i1=1,ir
      i2=ii(j1+1)
      i3=ii(j1+2)
      j5=i3*(i3+1)/2
      j1=j1+3
      do 55 i4=1,i2
      j1=j1+1
      vd=r(j1)
      j4=ii(j1)
      j2=j4+j1-1
      if(j4.eq.1) go to 55
   43 j1=j1+1
      i=ii(j1)
      if(i.lt.0) go to 44
      vd=vd*POW(x(i),r(j1))
      go to 45
   44 call PAREM(ii,r,xx,g,x,j1,vd,vr,vd,i,0,0)
      vd=vd*vr
   45 if(j1.lt.j2) go to 43
      j1=j2-j4+1
   47 j1=j1+1
      i=ii(j1)
      if(i.lt.0) go to 51
      if(x(i).eq.0.) go to 53
      vs=r(j1)*vd/x(i)
      do 49 i5=1,le
      if(i5.eq.i3) go to 49
      j6=IYYM(i,i5)
      j7=IYYM(i3,i5)
      if(i.eq.i5) go to 48
      xx(j6)=xx(j6)+xx(j7)*vs
      go to 49
   48 xx(j6)=xx(j6)+2.d0*xx(j7)*vs+xx(j5)*vs**2
   49 continue
      j6=IYYM(i,i3)
      xx(j6)=xx(j6)+xx(j5)*vs
      go to 53
   51 call PAREM(ii,r,xx,g,x,j1,vd,vr,vs,i3,le,3)
   53 if(j1.lt.j2) go to 47
   55 continue
      j1=0
      if(ic.eq.3.and.my.gt.0) go to 20
   70 do 95 i1=1,ir
      i3=ii(j1+2)
      j1=ii(j1+3)+j1
      do 95 j6=1,le
      j4=IYYM(i3,j6)
      if(i3.eq.j6) go to 90
      xx(j4)=0.d0
      go to 95
   90 if(ic.ge.4) xx(j4)=0.d0
      if(ic.lt.4) xx(j4)=1.d0
   95 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RTSCL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Sets scaling for restrictions.
c
c   This subroutine is called by the following subroutines:
C   RESCL  RESCS  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RTSCL(scal,beta,r,iii,ir)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision scal(1),beta(1),POW,r(1),vd,ve
      dimension iii(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Adjust restrictions to account for scaling
      j1=0
      do 32 i=1,ir
      l=iii(j1+2)
      if(r(j1+1).eq.0.) go to 32
      if(dabs(r(j1+2)).ne.1.) r(j1+1)=r(j1+1)*dabs(scal(l))**(1.d0/r(j1+
     12))
      if(dabs(r(j1+2)).eq.1.) r(j1+1)=r(j1+1)*scal(l)**ifix(sngl(r(j1+2)
     1))
   32 j1=iii(j1+3)+j1
      j1=0
      do 40 i=1,ir
      l=iii(j1+1)
      j=iii(j1+2)
      j0=j1+1
      j1=j1+3
      do 40 j3=1,l
      j1=j1+1
      j4=iii(j1)
      vd=1.d0
      j2=j4+j1-1
      go to 39
   34 j1=j1+1
      if(iii(j1).ge.0) go to 38
      i3=-iii(j1)
      do 37 j5=1,i3
      j1=j1+1
      ve=r(j1)
      j6=j1
      j8=iii(j1)+j1-1
      go to 36
   35 j1=j1+1
      j9=iii(j1)
      ve=ve*POW(scal(j9),r(j1))
   36 if(j1.lt.j8) go to 35
      r(j6)=ve
   37 continue
      go to 39
   38 j5=iii(j1)
      vd=vd*POW(scal(j5),r(j1))
   39 if(j1.lt.j2) go to 34
      if(r(j0).eq.0.) r(j2-j4+1)=r(j2-j4+1)/scal(j)
   40 r(j2-j4+1)=r(j2-j4+1)*vd
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SCHNBL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   This subroutine is an alternative optimizer.  It is currently
c   Inoperative.
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SCHNBL(n,x,gpls,wrk,a,f0,ii,xdata,jo,lo,mo,r,iii,rn,
     *iin,vb,sh,isc,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(n),gpls(n),wrk(n,10),a(n,n),f0,r(1),
     *rn(1),vb(1),sh(1)
      dimension xdata(1),jo(1),lo(1),mo(1),iii(1),iin(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      write (*,24) 
 24   format('  Dummy call to SCHNBL.  Relink with User-Supplied'/,
     &  '  SCHNBL Subroutine in order to proceed.')
      stop
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SEARCH        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes distance along gradient in optimization part of program. 
c
c   This subroutine calls the following subroutines:
C   CPRINT  PUNCHA  FCTGR  CKTIME  INTPOL  
c
c   This subroutine is called by the following subroutines:
C   FLEPOW  STEDE  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SEARCH(n,x,y,g,h,d,f0,f,xdata,joe,r,iii,rn,iin,vb,ii,
     1sc,isc,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),y(1),g(1),h(1),d(1),p0(3),p1(3),p2(3),p3(3),
     1p4(3),f,f0,trial,fact,aa,bb,sx,pr,trial1,epsg,epsp,epsf,egr,egf,
     2epa,vb(1),r(1),rn(1),sc(1)
      dimension xdata(1),joe(1),iii(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a2(30),m8,a3(8),lwi,dum(3)
      common /c/ a1(12),ipun,dumc(27)
      common /f/ trial,egr,epa,egf,trial1,fact,aa,bb,maxtry,iter,pr,
     1epsg,epsp,epsf,maxite,iv1,iv2,na1,na2,dumf(5)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      idf=0
      p0(2)=0.d0
      do 210 i=1,n
  210 p0(2)=p0(2)+d(i)**2
      p0(2)=dsqrt(p0(2))
      do 220 i=1,n
  220 d(i)=d(i)/p0(2)
      p0(2)=0.d0
      do 230 i=1,n
  230 p0(2)=p0(2)+g(i)*d(i)
      if(p0(2).lt.0.) go to 240
      ind=3
      return
  240 p0(1)=0.d0
      p0(3)=f0
      do 250 i=1,3
      p2(i)=p0(i)
  250 p1(i)=p0(i)
      p4(1)=trial
      ips=0
      if(ii.ne.0) go to 256
      m8=m8+2
      if(m8.ge.58.and.lwi.eq.0) call CPRINT(21)
      if(lwi.eq.0) write(ip,252) iter,ips,(p0(i),i=1,3),egf,egr,iv1,epa,
     1iv2
  252 format(/9x,i6,i7,4(2x,g14.7),2(2x,g10.3,' (',i3,')'))
      if(lwi.eq.1) write(ip,254) iter,(p0(i),i=1,3),egf,egr,iv1,epa,iv2
  254 format(/i4,5g11.4,'(',i3,')',g10.3,'(',i3,')')
  256 if(ipun.eq.2) call PUNCHA(x,n,sc,isc,h)
      do 310 icount=1,maxtry
      do 260 i=1,n
  260 y(i)=x(i)+p4(1)*d(i)
      call FCTGR(y,f,h,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)
      call CKTIME(ind,1)
      if(ind-1) 265,280,320
  265 sx=p4(1)
      idf=1
      p4(3)=f
      p4(2)=0.d0
      do 267 i=1,n
  267 p4(2)=p4(2)+h(i)*d(i)
      if(ii.ne.0) go to 270
      m8=m8+1
      if(m8.ge.58.and.lwi.eq.0) call CPRINT(21)
      if(lwi.eq.0) write(ip,268) icount,(p4(i),i=1,3)
  268 format(15x,i7,3(2x,g14.7))
      if(lwi.eq.1) write(ip,269) (p4(i),i=1,3)
  269 format(4x,3g11.4)
c********************************
c   *(1.d0+sx*.1d0) added to the following line
c  270 if(p4(3).le.p0(3)*(1.d0+sx*.1d0).or.
c   1  (dabs(p4(2)).ge.fact*dabs(p0(2)).and.p4(2).gt.0.)) go to 272
  270 if(p4(3).le.p0(3).or.(dabs(p4(2)).ge.fact*dabs(p0(2)).
     *and.p4(2).gt.0.)) go to 272
c********************************
      ips=0
      p4(1)=bb*p4(1)
      do 271 i=1,3
      p1(i)=p0(i)
  271 p2(i)=p0(i)
      go to 310
  272 if(dabs(p4(2)).ge.fact*dabs(p0(2))) go to 273
      trial=p4(1)
      return
  273 if(p4(2).le.0.) go to 275
      ips=1
      do 274 i=1,3
  274 p3(i)=p4(i)
      call INTPOL(p2,p3,p4)
      go to 310
  275 j=0
c***************************
      if(p4(2).le.p2(2).or.p2(2).lt.p1(2)) j=1
c    if(p4(2).le.p2(2)*.999d0.or.p2(2).lt.p1(2)) j=1
c***************************
      do 276 i=1,3
      p1(i)=p2(i)
  276 p2(i)=p4(i)
      if(ips.ne.1) go to 277
      call INTPOL(p2,p3,p4)
      go to 310
  277 if(j.eq.1) go to 278
      call INTPOL(p1,p2,p4)
      go to 310
  278 p4(1)=aa*p4(1)
      go to 310
  280 ind=0
      if(ii.ne.0) go to 285
      m8=m8+1
      if(m8.ge.58.and.lwi.eq.0) call CPRINT(21)
      if(lwi.eq.0) write(ip,268) icount,p4(1)
      if(lwi.eq.1) write(ip,269) p4(1)
  285 if(idf.gt.0) go to 290
      p4(1)=.5d0*p4(1)
      go to 310
  290 do 300 i=1,n
  300 y(i)=x(i)+sx*d(i)
      call FCTGR(y,f,h,xdata,joe,r,iii,rn,iin,vb,sc,isc,ind)
      return
  310 continue
      ind=2
      if(idf.eq.0) ind=1
  320 return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SECDRV        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes cross products of gradients for initial estimate of 
c   Hessian in FLEPOW.
c
c   This subroutine calls the following subroutines:
C   MULTIP  FCLARS  FCMOFF  FCJOEY  FCHOTZ  FCPELD  RESTRN  MATIN5  
C   SQHESS  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SECDRV(xx,x,y,xdata,joe,loe,moe,r,iii,rn,iin,vb,
     1sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),x(1),y(1),det,vb(1),r(1),rn(1),sc(1)
      dimension xdata(1),joe(me,10),iii(1),iin(1),loe(1),moe(1)
      double precision zzz(50000)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a0(8),jc,a4(4),ir,a1(4),iwo,dum(19)
      common /d/ k,a2(6),le,igmm,lz,a3(2),ny,l1,lee,lg,dumd(8)
      common /hess/ ll1,ihhh,lle
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(ind.lt.-1.or.(jc.ge.3.and.jc.lt.10)) go to 60
      call MULTIP(y,xx,xx,xx,xx,l1,l1,1)
      ind=0
      i1=lg+1
      go to(5,10,20,25,35,35),igmm
c   Calculate cross-products for type=1
    5 i2=i1+2*nt
      call FCLARS(x,det,y,xx,xdata,joe,loe,moe,vb(i1),iin,iin(ny),rn,
     1vb,vb(i2),vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe,
     2joe,vb,vb,1,sc,iscal,ind)
      go to 50
   10 i6=max0(me,nt)
      i0=i1+i6
      i2=i0+i6*9
      i3=i2+i6*9
      i4=i3+i6
      i5=i4+me
      i7=i5+me
      i8=i7+me
c   Calculate cross-products for type=2
      call FCMOFF(x,det,y,xx,xdata,joe,loe,moe,vb(i1),vb(i0),vb(i2),
     1vb(i3),vb(i4),vb(i5),vb(i7),vb(i8),vb(i2),iin,iin(ny),rn,vb,
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,8),vb,vb,1,
     2sc,iscal,ind)
      go to 50
   20 i2=(1-iwo)*lz*(lz+1)/2+i1
      i3=i2+max0(lz,nt*5*me)
      i4=i3+lz
      i5=i4+lz*le
      i7=i5+le
c   Calculate cross-products for type=3
      call FCJOEY(x,det,y,xx,xdata,joe,loe,moe,vb(i1),vb(i2),vb(i2),
     1vb(i3),vb(i4),vb(i5),vb(i7),iin,iin(ny),rn,vb,joe(1,2),joe(1,3),
     2joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb,vb,1,sc,iscal,ind)
      go to 50
c   Calculate cross-products for type=4
   25 call FCHOTZ(x,det,y,xx,xdata,joe,loe,moe,vb(i1),iin,iin(ny),rn,vb,
     1vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb,vb,1,
     1sc,iscal,ind)
      go to 50
   35 i1=le+2
c   Calculate cross-products for between eq./time correlations
      if(igmm.eq.5) call FCPELD(x,det,y,xx,xdata,joe,loe,moe,vb(i1),vb,
     1vb,vb,vb,vb,vb,iin,iin(ny),rn,joe(1,2),joe(1,5),joe(1,6),joe(1,8),
     2joe(1,9),1,sc,iscal,ind)
      if(igmm.eq.6) call FCPELD(x,det,y,xx,xdata,joe,loe,moe,vb(i1),vb,
     1vb,vb,vb,vb,vb,iin,iin(ny),rn,joe(1,2),joe(1,5),joe(1,6),joe(1,8),
     2joe(1,9),1,sc,iscal,ind)
      go to 55
   50 if(ir.gt.0) call RESTRN(x,x,xx,r,iii,2)
   55 if(ind.gt.0) return
c   Check Hessian Condition of Cross-Products Matrix and then Invert it.
c*******************************
      if(jc.lt.10) then
              nonpos=1
              call CHSKY(xx,zzz,l1,nonpos)
              if(nonpos.eq.0) then
                   call CPRINT(24)
              else
                   ihhh = IHESSN(zzz,l1)
                   if(nonpos.eq.0) ihhh=99
                   if(ihhh.gt.7) call CPRINT(25)
               endif
               call MATIN5(l1,xx,xx,y,det,1,ind)
      endif
c*******************************
      if(jc.ge.10) call SQHESS(l1,xx,xx)
      if(ind.eq.0) return
      go to 70
   60 call MULTIP(y,xx,xx,xx,xx,l1,l1,6)
      return
   70 if(ind.ge.-1) ind=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SQHESS            (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   This routine takes hessian stored in the triangle t and puts it into
c   The square n x n matrix, s.  t and s may occupy the same space.
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SQHESS(n,t,s)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision t(1),s(n,n)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l = n*(n+1)/2
      do 20 i=n,1,-1
         do 10 j=i,1,-1
            s(j,i) = t(l)
            l = l - 1
   10    continue
   20 continue
      do 40 i=1,n
         do 30 j=1,i-1
            s(i,j) = s(j,i)
   30    continue
   40 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   STANER        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes Standard Errors.
c
c   This subroutine calls the following subroutines:
C   RESTRN  MULTIP  FCLARS  MATIN5  FCMOFF  FCJOEY  FCHOTZ  WEIMAT  
C   DANNYP  FCPELD  MULTIS  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine STANER(xx,xs,w,x,y,xdata,joe,loe,moe,noe,r,iii,rn,iin,
     1vb,ff,xm,igmm,ist,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),x(1),y(1),det,vb(1),xs(1),w(1),r(1),rn(1),
     1ff,xm(31,me),sc(1)
      double precision zzz(50000)
      dimension xdata(1),joe(me,10),loe(1),moe(1),noe(1),iii(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(13),ir,ln,igs,ifs,lm,iwo,dum(19)
      common /d/ k,n,a2(4),lr,le,igm,lz,lp,my,ny,l1,lee,lg,lh,a3(6),la
      common /f/ det,dumf(34)
      common /hess/ ll1, ihhh,lle
c-------------------BEGINNING OF SUBROUTINE------------------------------
      lg=0
      lh=0
      ind=0
      ipw=4
      if(ist.eq.3) ipw=2
      if(ir.gt.0) call RESTRN(x,y,y,r,iii,0)
      if(ist.eq.2.or.ist.ge.4) go to 6
      do 5 j=1,me
      do 3 i=1,31
    3 xm(i,j)=0.d0
      if(joe(j,1).le.1) go to 5
      do 4 i=11,15
c   Change made by Jacob Klerman 10/6/85
      xm(i,j)=-1.d0*10.0**20
c   Xm(i,j)=-1.d0*10**20
    4 xm(i+5,j)=-xm(i,j)
    5 continue
    6 i1=lg+1
      go to (8,16,28,40),igmm
    8 if(ist.ge.1) go to 9
      i2=i1+2*nt
      i3=i2+5*nt*me
      call MULTIP(y,xx,xx,xx,xx,le,le,1)
c   Calculate matrix of second derivatives for type=1
      call FCLARS(x,ff,y,xx,xdata,joe,loe,moe,vb(i1),iin,iin(ny),rn,
     1vb,vb(i2),vb(i3),joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),
     2joe(1,9),joe(1,10),vb,xm,3,sc,iscal,ind)
      go to 17
    9 i2=le*(le+1)/2+le+i1
      i3=i2+2*nt
      i2a=i3+5*nt*me
      i4=i2a
      if(la.gt.1) i4=i2a+la*le
      if(ist.eq.3) go to 12
      if(ist.eq.2) go to 10
      call MULTIP(y,vb(i1),vb(i1),vb(i1),vb(i1),le,le,1)
      call FCLARS(x,ff,y,vb(i1),xdata,joe,loe,moe,vb(i2),iin,iin(ny),
     1rn,vb,vb(i3),vb(i4),joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),
     2joe(1,9),joe(1,10),vb,xm,3,sc,iscal,ind)
      if(ir.gt.0) call RESTRN(x,y,vb(i1),r,iii,3)
      if(ind.gt.0) go to 20
c*******************************
c   Invert matrix of second derivatives for type=1
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(vb(i1),zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0) ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
               call MATIN5(le,vb(i1),vb(i1),y,det,1,ind)
c*******************************
      if(ir.gt.0) call RESTRN(x,x,vb(i1),r,iii,5)
      if(ind.gt.0) go to 20
      go to 12
   10 i7=le*(le+1)/2
      do 11 i8=1,i7
   11 vb(i1+i8-1)=xx(i8)
   12 call MULTIP(y,xx,xx,xx,xx,le,le,1)
c   Calculate cross-products (time-summed) of first derivatives type=1
      call FCLARS(x,ff,y,xx,xdata,joe,loe,moe,vb(i2),iin,iin(ny),rn,
     1vb,vb(i3),vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9)
     2,joe(1,10),vb(i2a),xm,2,sc,iscal,ind)
      if(ir.gt.0) call RESTRN(x,x,xx,r,iii,ipw)
      if(ist.eq.3) go to 18
      if(ist.eq.4) go to 75
   14 call MULTIP(vb(i1),xx,vb(i2),xx,xx,le,le,2)
      return
   16 i6=max0(me,nt)
      i11=1
      if(ist.ge.1) i11=le*(le+1)/2+1
      i2a=i11+i6
      i1=i2a
      if(la.gt.1) i1=i2a+la*le
      i2=i1+i6*9
      i3=i2+i6*9
      i4=i3+i6
      i5=i4+me
      i7=i5+me
      i8=i7+me
      if(ist.ge.1) go to 21
      call MULTIP(y,xx,xx,xx,xx,le,le,1)
c   Calculate cross-products (non time-summed) of 1st deriv for type=2
      call FCMOFF(x,ff,y,xx,xdata,joe,loe,moe,vb(i11),vb(i1),vb(i2),
     1vb(i3),vb(i4),vb(i5),vb(i7),vb(i8),vb(i2),iin,iin(ny),rn,vb,
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,8),vb,xm,3,
     3sc,iscal,ind)
   17 if(ir.gt.0) call RESTRN(x,y,xx,r,iii,3)
   18 if(ind.gt.0) go to 20
c*******************************
c   Invert matrix for Std. Errors
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(xx,zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0)ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
              call MATIN5(le,xx,xx,y,det,1,ind)
c*******************************
   19 if(ir.gt.0) call RESTRN(x,x,xx,r,iii,5)
   20 if(ind.gt.0) ind=11
      return
   21 if(ist.eq.1) go to 22
      call MULTIP(y,vb,vb,vb,vb,le,le,1)
      call FCMOFF(x,ff,y,vb,xdata,joe,loe,moe,vb(i11),vb(i1),vb(i2),
     1vb(i3),vb(i4),vb(i5),vb(i7),vb(i8),vb(i2),iin,iin(ny),rn,vb,
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,8),vb,xm,3,
     3sc,iscal,ind)
      if(ir.gt.0) call RESTRN(x,y,vb,r,iii,3)
      if(ind.gt.0) go to 20
c*******************************
c   Invert non time-summed matrix
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(vb,zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0)ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
              call MATIN5(le,vb,vb,y,det,1,ind)
c*******************************
      if(ir.gt.0) call RESTRN(x,x,vb,r,iii,5)
      if(ind.gt.0) go to 20
      go to 24
   22 do 23 i13=1,i11
   23 vb(i13)=xx(i13)
   24 call MULTIP(y,xx,xx,xx,xx,le,le,1)
c   Calculate cross-products (time-summed) of first derivatives type=2
      call FCMOFF(x,det,y,xx,xdata,joe,loe,moe,vb(i11),vb(i1),vb(i2),
     1vb(i3),vb(i4),vb(i5),vb(i7),vb(i8),vb(i2),iin,iin(ny),rn,vb,
     2joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,7),joe(1,8),vb(i2a),xm,
     32,sc,iscal,ind)
      if(ir.gt.0) call RESTRN(x,x,xx,r,iii,4)
      i1=le*(le+1)/2+1
      call MULTIP(vb,xx,vb(i1),xx,xx,le,le,2)
      return
   28 i2=lz*(lz+1)/2+i1
      i2a=i2+nt*5*me
      i3=i2a
      if(la.gt.1) i3=i2a+la*lz
      i4=i3+lz
      i5=i4+le*lz
      if(ist.lt.2.or.iwo.gt.0) go to 30
      call MULTIP(vb(i3),vb,vb,vb,vb,lz,lz,1)
c   Calculate weighting matrix for testing/ between eq. or time
      call FCJOEY(xs,det,vb(i3),vb,xdata,joe,loe,moe,vb(i3),vb(i2),
     1vb(i2),vb(i3),vb(i4),vb(i5),vb(i5),iin,iin(ny),rn,vb,joe(1,2),
     2joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb(i2a),xm,2,
     3sc,iscal,ind)
      if(ind.gt.0) go to 20
      call MATIN5(lz,vb,vb,vb(i3),ff,0,ind)
      if(ind.gt.0) go to 20
   30 i7=i5+le
c   Calculate matrix of function first derivatives for type=3
      call FCJOEY(x,det,y,xx,xdata,joe,loe,moe,vb(i1),vb(i2),vb(i2),
     1vb(i3),vb(i4),vb(i5),vb(i7),iin,iin(ny),rn,vb,joe(1,2),joe(1,3),
     2joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb,xm,3,sc,iscal,ind)
      if(ind.gt.0) go to 20
      if(ist.eq.4) i5=max0(i5,le*le/2+le/2+l1*l1/2+l1/2+le+4+l1*le+l1+lz
     1*l1+max0(nt,me)*6+lz)*2
      if(ist.eq.5) i5=max0(i5,lp*le+1+nt*5*me+2*le,lp*le+lp*lz+1+2*le)
      i7=i5+le*lz
      if(ist.ne.0.and.iwo.gt.0) call MULTIP(xx,vb(i1),xx,vb(i4),vb(i5),l
     1e,lz,5)
      if(ist.ne.0.and.iwo.eq.0) call MULTIP(xx,vb(i1),xx,vb(i4),vb(i5),l
     1e,lz,3)
      if(ist.eq.5) go to 34
      call MULTIP(y,vb(i1),vb(i1),vb(i1),vb(i1),lz,lz,1)
c   Calculate matrix of cross-pro. of time-summed orthog. cond. type=3
      call FCJOEY(x,ff,y,vb(i1),xdata,joe,loe,moe,vb(i4),vb(i2),vb(i2),
     1vb(i3),vb(i4),vb(i7),vb(i7),iin,iin(ny),rn,vb,joe(1,2),joe(1,3),
     2joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb(i2a),xm,2,sc,iscal,ind)
      if(ist.eq.0) go to 38
      if(ist.eq.4) go to 65
c   Compute Std. Errors which are always correct type=3
      call MULTIP(vb(i1),vb(i1),vb(i1),vb(i5),vb(i4),le,lz,3)
      if(ir.gt.0) call RESTRN(x,x,vb(i1),r,iii,4)
   34 if(ir.gt.0) call RESTRN(x,x,xx,r,iii,2)
c*******************************
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(xx,zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0)ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
               call MATIN5(le,xx,xx,y,det,1,ind)
c*******************************
      if(ir.gt.0) call RESTRN(x,x,xx,r,iii,5)
      if(ind.gt.0) go to 20
      if(ist.eq.5) go to 48
      call MULTIP(xx,vb(i1),vb(i4),xx,xx,le,le,2)
      i4=le*(le+1)/2
      do 36 i5=1,i4
   36 xx(i5)=vb(i5+i1-1)
      return
c   Compute optimal Std. Errors type=3
   38 call MATIN5(lz,vb(i1),vb(i1),vb(i3),det,1,ind)
      call MULTIP(xx,vb(i1),xx,vb(i4),vb(i5),le,lz,3)
      if(ir.gt.0) call RESTRN(x,x,xx,r,iii,2)
c*******************************
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(xx,zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0)ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
              call MATIN5(le,xx,xx,vb(i3),det,1,ind)
c*******************************
      go to 19
   40 if(ist.ge.1) go to 42
      i2=i1+6*me
      call MULTIP(y,xx,xx,xx,xx,le,le,1)
c   Calculate matrix of second derivatives for type=4
      call FCHOTZ(x,ff,y,xx,xdata,joe,loe,moe,vb(i1),iin,iin(ny),rn,
     1vb,vb(i2),joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9),
     2vb,xm,3,sc,iscal,ind)
      go to 17
   42 i2=i1+le*(le+1)/2+le
      i2a=i2+6*me
      i3=i2a
      if(la.gt.1) i3=i2a+la*le
      if(ist-2) 44,45,47
   44 call MULTIP(y,vb(i1),vb(i1),vb(i1),vb(i1),le,le,1)
      call FCHOTZ(x,ff,y,vb(i1),xdata,joe,loe,moe,vb(i2),iin,iin(ny),
     1rn,vb,vb(i3),joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9)
     2,vb,xm,3,sc,iscal,ind)
      if(ind.gt.0) go to 20
      if(ir.gt.0) call RESTRN(x,y,vb(i1),r,iii,3)
c*******************************
c   Invert matrix of second derivatives type=4
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(vb(i1),zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0)ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
              call MATIN5(le,vb(i1),vb(i1),y,det,1,ind)
c*******************************
      if(ir.gt.0) call RESTRN(x,x,vb(i1),r,iii,5)
      if(ind.gt.0) go to 20
      go to 47
   45 i7=le*(le+1)/2
      do 46 i8=1,i7
   46 vb(i1+i8-1)=xx(i8)
   47 call MULTIP(y,xx,xx,xx,xx,le,le,1)
c   Compute matrix of cross-pro. of time-summed 1st derivs for type=4
      call FCHOTZ(x,det,y,xx,xdata,joe,loe,moe,vb(i2),iin,iin(ny),rn,
     1vb,vb,joe(1,2),joe(1,3),joe(1,5),joe(1,6),joe(1,8),joe(1,9),
     2vb(i2a),xm,2,sc,iscal,ind)
      if(ir.gt.0) call RESTRN(x,x,xx,r,iii,ipw)
      if(ist-3) 14,18,14
   48 i6=lz
      lz=lp
      i8=ln
      ln=lm
      i4=max0(5*me*nt,lp*i6)+1
      i7=i4+lp*le
      i11=i7+le
c   Compute matrix of function 1st derivatives using exog.rest. type=3
      call FCJOEY(x,det,y,y,xdata,joe,loe,noe,y,vb,vb,y,vb(i4),
     1vb(i7),vb(i11),iin,iin(ny),rn,vb,joe(1,2),joe(1,3),joe(1,5),
     2joe(1,6),joe(1,8),joe(1,10),vb,xm,4,sc,iscal,ind)
      if(ind.gt.0) go to 20
      if(ir.eq.0) go to 52
      do 50 i=1,lp
      do 49 j=1,le
      i11=i4+(j-1)*lp+i-1
   49 y(j)=vb(i11)
      call RESTRN(x,y,y,r,iii,1)
      do 50 j=1,le
      i11=i4+(j-1)*lp+i-1
   50 vb(i11)=y(j)
   52 call MULTIS(vb(i4),xx,xx,vb(i5),vb,y,lp,le,1,i6,6)
      i5=lp*i6
      i4=lp*lp+1
      do 54 i2=1,i5
   54 vb(i4+i2-1)=vb(i2)
      i1=lp*lp+1
      i2=i1+lp*i6
c   Set-up matrix for exogeneity testing type=3
      call WEIMAT(vb,vb(i1),joe,moe,noe,joe(1,5),vb(i2))
      i2=i1+lp*(lp+1)/2+1
      i2a=i2+nt*5*me
      i3=i2a
      if(la.gt.1) i3=i2a+la*lp
      i4=i3+lp
      call MULTIP(y,vb(i1),vb,vb,vb,lp,lp,1)
c   Compute orthog. cond. time-summed cross-products with exog.rest
      call FCJOEY(x,det,y,vb(i1),xdata,joe,loe,noe,vb(i2),vb(i2),vb(i2),
     1vb(i3),vb(i3),vb(i4),vb(i4),iin,iin(ny),rn,vb,joe(1,2),joe(1,3),
     2joe(1,5),joe(1,6),joe(1,8),joe(1,10),vb(i2a),xm,2,sc,iscal,ind)
      if(ind.gt.0) go to 20
      call MULTIP(vb(i1),vb(i1),vb,vb,vb(i2),lp,lp,3)
      i4=lp*(lp+1)/2
      do 60 i3=1,i4
   60 vb(i3)=vb(i1+i3-1)
      lz=i6
      ln=i8
      if(ifs.eq.0) return
c   Calculate chi-square tests on subsets of exog. restri. type=3
      i2=i4+ifs*2+1
      i3=i2+lp
      i6=i4+1
      i7=me*k+2
      do 64 i5=1,ifs
      call DANNYP(vb(i6),noe(i7-1),noe(i7),y,vb,vb(i2),vb(i3))
      vb(i6+1)=float(noe(i7-1))
      i6=i6+2
   64 i7=i7+noe(i7-1)+1
      return
c   Compute Standard Errors for between-eq./time period correlations
   65 if(ir.gt.0) call RESTRN(x,x,xx,r,iii,2)
c*******************************
c   Check Hessian Condition and Invert Covariance Matrix.
              nonpos=1
              call CHSKY(xx,zzz,le,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              ihhh = IHESSN(zzz,le)
              if(nonpos.eq.0)ihhh=99
              if(ihhh.gt.7) call CPRINT(25)
              call MATIN5(le,xx,vb(i2),y,det,1,ind)
c*******************************
      if(ir.gt.0) call RESTRN(x,x,vb(i2),r,iii,5)
      if(ind.gt.0) go to 20
      call MULTIP(xx,vb,vb,vb(i5),vb(i4),le,lz,3)
      if(ir.gt.0) call RESTRN(x,x,xx,r,iii,4)
      i4=le*(le+1)/2
      do 70 i1=1,i4
   70 vb(i1)=vb(i2+i1-1)
   75 i2=le*(le+1)/2+1
      i3=i2+l1*(l1+1)/2
      i1=i3+l1*le
      i4=i1+l1*lz
      i6=i4+l1
      i7=i6+max0(nt,me)*6
      i11=i7+lz
      ff=0.d0
      call FCPELD(w,ff,y,vb(i2),xdata,joe,loe,moe,vb(i6),x,vb(i1),
     1vb(i4),vb(i3),vb(i7),vb(i11),iin,iin(ny),rn,joe(1,2),joe(1,5),
     2joe(1,6),joe(1,8),joe(1,9),2,sc,iscal,ind)
      if(ind.gt.0) go to 20
      if(ir.eq.0) go to 81
      do 80 i=1,l1
      do 76 j=1,le
      i11=i3+(j-1)*lz+i-1
   76 y(j)=vb(i11)
      call RESTRN(x,y,y,r,iii,1)
      do 77 j=1,le
      i11=i3+(j-1)*lz+i-1
   77 vb(i11)=y(j)
      if(igmm.ne.1) go to 80
      do 78 j=1,lz
      i11=i1+(j-1)*lz+i-1
   78 y(j)=vb(i11)
      call RESTRN(x,y,y,r,iii,1)
      do 79 j=1,lz
      i11=i1+(j-1)*lz+i-1
   79 vb(i11)=y(j)
   80 continue
   81 if(igmm.ne.1) call MULTIS(vb(i1),vb(i5),y,y,y,y,l1,lz,le,le,1)
      call MULTIS(vb(i4),vb(i3),y,y,y,y,1,l1,le,le,2)
      call MULTIS(vb(i4),vb(i1),y,y,y,y,1,l1,le,le,2)
      call MULTIS(vb(i4),vb(i2),y,y,y,y,1,l1,1,le,3)
      i4=i1+l1*le
      call MULTIS(vb(i3),vb,vb(i4),vb(i4),y,y,l1,le,1,le,4)
      call MULTIS(vb(i3),vb(i2),vb(i1),y,y,vb(i4),l1,le,1,le,5)
      call MULTIP(xx,xx,xx,vb(i3),vb(i4),le,l1,4)
      i11=l1*(l1+1)/2
      do 83 i4=1,i11
   83 xx(i4)=xx(i4)+vb(i2+i4-1)
      if(igm.eq.6.or.nt.le.2) return
      i13=0
      do 100 i14=1,me
      i0=nt-2
      i12=lr-1
      i1=0
c   Sum up chi-square to test correlation matrix stationary
      do 90 i2=1,i0
      do 90 i3=1,i2
      i1=i1+1
      vb(i1)=w(i1+i13)-w(lr-i2+i3+i13)
      i4=0
      do 85 i5=1,i0
      do 85 i6=1,i5
      i4=i4+1
      if(i4.gt.i1) go to 90
      i7=(i1+i13)*(i1+i13-1)/2+i4+i13
      i8=(lr-i2+i3+i13)*(lr-i2+i3+i13-1)/2+lr-i5+i6+i13
      if(i6-i5.gt.i3-i2) i8=(lr-i5+i6+i13)*(lr-i5+i6+i13-1)/2+lr-i2+i3+i
     113
      i9=(lr-i5+i6+i13)*(lr-i5+i6+i13-1)/2+i1+i13
      i10=(lr-i2+i3+i13)*(lr-i2+i3+i13-1)/2+i4+i13
      i12=i12+1
   85 vb(i12)=xx(i7)+xx(i8)-xx(i9)-xx(i10)
   90 continue
      call MATIN5(i1,vb(lr),vb(lr),y(2),y(1),1,ind)
      xx(i11+1)=0.d0
      i2=0
c   Sum up chi-square to test between eq./time errors equi-correlated
      do 92 i3=1,i1
      do 92 i4=1,i3
      i2=i2+1
      if(i3.ne.i4) xx(i11+1)=xx(i11+1)+vb(i3)*vb(i4)*vb(lr+i2-1)
   92 xx(i11+1)=xx(i11+1)+vb(i3)*vb(i4)*vb(lr+i2-1)
      i1=0
      i10=(lr+i13)*(lr+i13+1)/2
      i0=lr-1
      do 95 i2=1,i0
      vb(i2)=w(i2+i13)-w(lr+i13)
      do 95 i3=1,i2
      i1=i1+1
      i4=(i2+i13)*(i2+i13-1)/2+i3+i13
   95 vb(lr+i1-1)=xx(i4)+xx(i10)-xx(i10-lr+i3)-xx(i10-lr+i2)
      call MATIN5(i0,vb(lr),vb(lr),y(2),y(1),1,ind)
      xx(i11+2)=0.d0
      i2=0
      do 97 i3=1,i0
      do 97 i4=1,i3
      i2=i2+1
      if(i3.ne.i4) xx(i11+2)=xx(i11+2)+vb(i3)*vb(i4)*vb(lr+i2-1)
   97 xx(i11+2)=xx(i11+2)+vb(i3)*vb(i4)*vb(lr+i2-1)
      i11=i11+2
  100 i13=i10
      if(ind.gt.0) ind=0
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   START        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes starting values from  regressions.  Does 0/1 for probit,
c   And y against x for tobit/linear regression for starting values.
c   For equation or time period epsilon correlations it computes corr-
c   elations of observed residuals.  For single factor ML also Computes
c   Correlation of observed residuals (or square roots).
C
c   This subroutine calls the following subroutines:
C   MULTIP  PHOENX  MATIN5  MULTIS  PITTSB  ARLING  RESTRN  MULTIS  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine START(beta,xx,y,w,xg,xdata,joe,loe,moe,koe,lar,rn,iii,
     1zz,vv,zg,joa,job,jod,jol,jom,joh,id,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision beta(1),xx(1),y(1),det,FSTAT,fet,w(1),xg(1),g1,
     1g2,g3,g4,g5,vrs,wt,ybar,ytot,zg(1),zz(1),vv(1),rn(1),sc(1)
      dimension xdata(jb,kobs),joe(1),loe(k,nt),moe(k,me),koe(3,me),
     1lar(1),iii(1),joa(1),jom(1),joh(1),jod(1),job(1),jol(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a5(6),nvar,dum(37)
      common /c/ me,nt,a2(2),istar,a3(10),ir,ln,a7(3),iwo,ira,a4(12),
     1kvrs,jwt,dumc(4)
      common /c2/ vrs
      common /d/ k,n,jb,kobs,lv,lw,lr,le,igm,lz,a1(5),lg,lh,mobs,iqz,
     *inz,dumd(4)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      wt=1.d0
      i11=0
      if(id.eq.5) i11=1
      if(id.ge.4) go to 130
      i5=-nt
c   Loop over equations
      i6=0
      i13=0
    2 i6=i6+1
      i5=i5+nt
      if(joe(i6).ge.2) i5=i5+nt
      i8=joa(i6)+1
      if(id.gt.1) go to 135
      g2=1.d0
      i10=0
    4 i7=jom(i6)-i8+2
      det=0.d0
      ybar=0.d0
      ytot=0.d0
      call MULTIP(y,xx,xx,xx,xx,i7,i7,1)
      if(iwo.ne.2) go to 8
      i3=joh(i6+1)-joh(i6)
      if(i6.eq.me) i3=lz-joh(i6)
      if(joe(i6).ge.2.and.jod(i6).le.2) i3=i3-1
      i2=lg*lh
      do 6 i=1,i2
    6 zz(i)=0.d0
c   Loop over observations (n) and time periods (nt)
    8 i=1
      do 86 ii=1,n
      if(iqz.eq.0) i=ii
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      if(job(i6).le.0.and.i10.ne.1) go to 30
c   Compute means for random or fixed effect models
      i7=jom(i6)-joa(i6)
      g3=0.d0
      do 10 i1=1,i7
   10 xg(i1)=0.d0
      g5=0.d0
      do 20 j=1,nt
      if((joe(i6).le.1.and.xdata(lv+i5+j,i).lt.0.).or.(joe(i6).ge.2.and.
     1xdata(lv+i5+j-nt,i).lt.0.)) go to 20
      if(jwt.gt.0) i9=loe(jwt,j)
      if(jwt.gt.0) wt=dble(xdata(i9,i))/vrs
      g3=g3+wt
      i9=0
      do 15 i1=1,k
      if(moe(i1,i6).gt.7) go to 15
      i2=loe(i1,j)
      i9=i9+1
      xg(i9)=xg(i9)+dble(xdata(i2,i))*wt
   15 continue
      g5=g5+dble(xdata(lv+i5+j,i))*wt
   20 continue
      if(g3.eq.0.) go to 86
      if(i10.eq.0) g3=-1.d0/g3
      if(i10.eq.1) g3=(1.d0/(1.d0-g1+g3*g1)-g2)/g3
c   Compute cross-products of means
c   *** jak 10/6/85
c   Call PHOENX(xx,xg,y,g3,g5,l,i9,0)
      call PHOENX(xx,xg,y,g3,g5,a5(1),i9,0)
      det=det+g3*g5**2
   30 i12=0
      i0=0
      do 85 j=1,nt
      g4=g2
      i0=i0+1
      if((joe(i6).le.1.and.xdata(lv+i5+j,i).lt.0.).or.(joe(i6).ge.2.and.
     1xdata(lv+i5+j-nt,i).lt.0.)) go to 85
      if(jwt.gt.0) i9=loe(jwt,j)
      if(jwt.gt.0) wt=dble(xdata(i9,i))/vrs
      g4=g4*wt
      i9=0
      ybar=ybar+wt*dble(xdata(lv+i5+j,i))
      ytot=ytot+wt
      if(i12.gt.0) go to 45
c   Compute y'y for starting regressions
      det=det+g4*dble(xdata(lv+i5+j,i))**2
      do 40 i1=1,k
      if(moe(i1,i6).gt.7) go to 40
      i2=loe(i1,j)
      i9=i9+1
      xg(i9)=dble(xdata(i2,i))
   40 continue
      if(iwo.eq.2) go to 65
      call PHOENX(xx,xg,y,g4,fet,xdata(lv+i5+j,i),i9,1)
      if(i10-2) 85,60,85
c   Adjust observations for first order autocorrelation
   45 i7=jom(i6)-joa(i6)
      g4=g1**i0
      g5=dble(xdata(lv+i5+j,i))-g4*g5
      do 55 i1=1,k
      if(moe(i1,i6).gt.7) go to 55
      i2=loe(i1,j)
      i9=i9+1
      xg(i7+i9)=dble(xdata(i2,i))-g4*xg(i9)
      xg(i9)=dble(xdata(i2,i))
   55 continue
c   Change made by Jacob Klerman 10/6/85
      call PHOENX(xx,xg(i7+1),y,wt,g5,a5(1),i9,0)
c   Call PHOENX(xx,xg(i7+1),y,wt,g5,l,i9,0)
      det=det+wt*g5**2
   60 g5=dble(xdata(lv+i5+j,i))
      i0=0
      i12=1
      go to 85
   65 i4=0
      do 80 i1=1,k
      if(moe(i1,i6).eq.4.or.moe(i1,i6).ge.15) go to 80
      if((moe(i1,i6).ge.5.and.moe(i1,i6).le.7).or.(moe(i1,i6).ge.12.and.
     1moe(i1,i6).le.14)) go to 67
      i4=i4+1
      i2=loe(i1,j)
      zg(i4)=dble(xdata(i2,i))
   67 if(moe(i1,i6).eq.0.or.moe(i1,i6).eq.8) go to 80
      do 75 l=2,ln
      if(moe(i1,i6).eq.3.or.moe(i1,i6).eq.7.or.moe(i1,i6).eq.11.or.moe(i
     11,i6).eq.14) go to 70
      i4=i4+1
      zg(i4)=0.d0
      if(j+l-1.gt.nt) go to 70
      i2=loe(i1,j+l-1)
      zg(i4)=dble(xdata(i2,i))
   70 if(moe(i1,i6).eq.2.or.moe(i1,i6).eq.6.or.moe(i1,i6).eq.10.or.moe(i
     11,i6).eq.13) go to 75
      i4=i4+1
      zg(i4)=0.d0
      if(j.lt.l) go to 75
      i2=loe(i1,j-l+1)
      zg(i4)=dble(xdata(i2,i))
   75 continue
   80 continue
c   Store cross-products of instruments for type=3
      call PHOENX(xx,zg,y,g4,fet,xdata(lv+i5+j,i),i3,1)
      l=0
      do 83 i2=1,i9
      do 83 i4=1,i3
      l=l+1
   83 zz(l)=zz(l)+g4*zg(i4)*xg(i2)
   85 continue
   86 continue
      if(iqz.gt.0) rewind inz
      if(iwo.ne.2) go to 90
c   Compute auxiliary instrumental regressions for type=3
      call MATIN5(i3,xx,xx,zg,fet,1,ind)
      if(ind.gt.0) go to 95
      i4=i9*i3+1
      call MULTIP(xx,xx,xx,zz,zz(i4),i3,i9,3)
      call MULTIS(y,zz(i4),y,y,y,zz,1,i3,i9,1,1)
c   Invert x'x
   90 call MATIN5(i9,xx,xx,beta(i8),fet,1,ind)
   95 if(ind.gt.0) ind=10
      if(ind.gt.0) return
      if(ir.eq.0.or.me.eq.1.or.igm.eq.2.or.igm.eq.4) go to 105
      i=i9*(i9+1)/2
      do 100 j=1,i
      i13=i13+1
  100 vv(i13)=xx(j)
  105 do 110 i=1,i9
      beta(i8+i-1)=0.d0
      do 110 j=1,i9
      i1=IYYM(i,j)
c   Calculate coefficients as (x'x)-1(x'y)
  110 beta(i8+i-1)=beta(i8+i-1)+y(j)*xx(i1)
      if(joe(i6).le.1) go to 120
c   Calculate starting value for tobit/regression sigma
      do 115 i=1,i9
  115 det=det-beta(i8+i-1)*y(i)
      det=det/dble(koe(1,i6))
      if(i10.eq.2) det=det/(g2**2)
      if(det.gt.0..and.(jod(i6).eq.1.or.jod(i6).eq.3)) det=dsqrt(det)
      i9=jol(i6)
      beta(i9)=.1d0
      if(det.gt.0.) beta(i9)=det
      go to 210
  120 i9=jol(i6)
      if(joe(i6).eq.1) beta(i9)=1.d0
c   Adjust probit/logit starting values by partials
      ybar=ybar/ytot
      ytot=1.d0/(ybar*(1.d0-ybar))
      ybar=dlog((1.d0-ybar)/ybar)-1.d0/(1.d0-ybar)
      if(joe(i6).ge.0) ybar=ybar/1.81d0
      if(joe(i6).ge.0) ytot=ytot/1.81d0
      i9=0
      do 125 i=1,k
      if(moe(i,i6).gt.7) go to 125
      i9=i9+1
      beta(i8+i9-1)=beta(i8+i9-1)*ytot
c   Adjust constant
      if(lar(i).eq.nvar+1) beta(i8+i9-1)=beta(i8+i9-1)+ybar
  125 continue
      go to 210
  130 det=dble(mobs)/dble(me)
      i4=me+1
      go to 140
  135 det=dble(n)
      i4=nt+1
  140 call MULTIP(y,xx,xx,xx,xx,i4,i4,1)
      y(i4)=1.d0
      i=1
      do 180 ii=1,n
      if(iqz.eq.0) i=ii
      if(iqz.gt.0) read(inz) (xdata(j,1),j=1,jb)
      j=0
  145 j=j+1
      if(id.ge.4) go to 150
      i10=j
      go to 160
  150 i5=-nt
      i6=0
  155 i6=i6+1
      i5=i5+nt
      if(joe(i6).ge.2) i5=i5+nt
      i8=joa(i6)+1
      i10=i6
  160 y(i10)=0.d0
      if((joe(i6).eq.1.and.xdata(lv+i5+j,i).lt.0.).or.(joe(i6).ge.2.and.
     1xdata(lv+i5+j-nt,i).lt.0.)) go to 165
      call PITTSB(y(i10),fet,joa(i6),moe(1,i6),loe(1,j),xdata(1,i),
     1beta,k,joe(i6),jol(i6),i6,sc,iscal,-1)
c   Calculate observed residual vector for probit
      if(joe(i6).le.1) y(i10)=dble(xdata(lv+i5+j,i))-1.d0+FSTAT(y(i10),0
     1.,0.,0.,3)
c   Calculate observed residual vector for tobit/regression
      if(joe(i6).ge.2) y(i10)=dble(xdata(lv+i5+j,i))-y(i10)
  165 if(id.le.3) go to 170
      if(i6.lt.me) go to 155
      go to 175
  170 if(j.lt.nt) go to 145
c   Accumulate moment matrix of observed residuals
  175 call ARLING(xx,y,i4,2)
      if(id.ge.4.and.j.lt.nt) go to 145
  180 continue
      if(iqz.gt.0) rewind inz
      i10=i4-1
      i4=i10*(i10+1)/2
      l=0
      do 190 i=1,i10
      y(i)=0.d0
      do 185 i0=1,i
      l=l+1
      if(id.lt.4) go to 185
      det=dmin1(dble(koe(1,i)),dble(koe(1,i0)))
c   Calculate covariance matrix of observed residuals
  185 xx(l)=(xx(l)-xx(i4+i)*xx(i4+i0)/det)/(det-1.d0)
      if(xx(l).gt.0.) y(i)=dsqrt(xx(l))
  190 continue
      if(id.eq.2) go to 202
      l=0
      i9=0
      do 195 i=1,i10
      do 195 i0=1,i
      l=l+1
      if(i.ne.i0) i9=i9+1
      if(id.eq.5.and.joh(i9).lt.0) go to 195
c   Calculate correlation matrix of observed residuals
      if(i.ne.i0.and.y(i).gt.0..and.y(i0).gt.0.) xx(l)=xx(l)/(y(i)*y(i0)
     1)
  195 continue
      if(id.eq.6) go to 250
      l=0
      i1=i11
      do 200 i=1,i10
      do 200 i0=1,i
      l=l+1
      if(i0.eq.i) go to 200
      i1=i1+1
c   Use as starting values for correlation matrix of time period (id=3
c   Or equation (id=4) epsilons.
      if(id.ne.2) w(i1)=xx(l)
  200 continue
      i11=i1
      go to 210
c   Starting value for time period correlation for  single factor ML 
  202 i9=jom(i6)
      beta(i9)=0.d0
      l=0
      g1=0.d0
      do 206 i=1,i10
      do 204 i0=1,i
      l=l+1
      if(i.eq.i0) go to 206
      if(ira.eq.0.or.i0.eq.i-1) beta(i9)=beta(i9)+xx(l)
  204 continue
  206 g1=g1+xx(l)
      g1=g1/dble(nt)
      if(ira.eq.1) go to 207
      beta(i9)=(beta(i9)/dble(i4-nt))/g1
      if(beta(i9).le.0..or.beta(i9).gt.1.) beta(i9)=.5
      g2=1.d0/(1.d0-g1)
      go to 209
  207 beta(i9)=(beta(i9)/dble(nt-1))/g1
      if(dabs(beta(i9)).gt.1.) beta(i9)=dsign(.98d0,beta(i9))
      g2=dsqrt(1.d0-beta(i9)**2)
  209 g1=beta(i9)
      i10=ira+1
      if(istar.eq.2) go to 4
  210 if(id.ne.4.and.id.ne.5.and.i6.lt.me) go to 2
      if(ir.eq.0.or.id.ne.1.or.igm.eq.2.or.igm.eq.4) return
      if(me.gt.1) go to 215
      i4=(i9+1)*(i9+2)/2
      if(joe(1).ge.1) xx(i4)=1.d0/dble(koe(1,1))
      go to 235
  215 i13=0
      call MULTIP(y,xx,xx,xx,xx,le,le,1)
      do 230 i6=1,me
      i1=joa(i6)
      i2=jom(i6)-i1
      if(joe(i6).ge.1) i2=i2-1
      wt=1.d0
      if(joe(i6).gt.1) wt=beta(i1+i2+1)
      if(jod(i6).eq.1.or.jod(i6).eq.3) wt=wt**2
      l=i1*(i1+1)/2
      do 225 i=1,i2
      l=l+i1
      do 225 j=1,i
      l=l+1
      i13=i13+1
  225 xx(l)=vv(i13)*wt
      i2=(i2+i1+1)*(i2+i1+2)/2
      if(joe(i6).gt.1) xx(i2)=wt/dble(koe(1,i6))
  230 continue
c   Compute restricted regression
  235 call RESTRN(beta,vv,xx,rn,iii,6)
      do 240 i=1,le
  240 y(i)=0.d0
      i4=ir+1
      i9=i4+le*ir
c   Compute linear approximation to r' of (r-r'b)
      call RESTRN(beta,y,vv(i9),rn,iii,7)
      call MULTIP(xx,xx,xx,vv(i9),vv(i4),ir,le,3)
      call MATIN5(ir,xx,xx,y,fet,1,i)
      if(i.gt.0) return
      call MULTIS(vv(i4),xx,xx,xx,xx,y,le,ir,1,1,4)
      call MULTIS(vv(i4),vv,xx,xx,xx,y,le,ir,1,1,1)
      do 245 i=1,le
  245 beta(i)=beta(i)+vv(i4+i-1)
      return
  250 do 260 i6=1,me
      i0=jom(i6)
      beta(i0)=0.d0
      do 255 i7=1,me
      if(i7.eq.i6) go to 255
      l=IYYM(i6,i7)
c   Starting values for equation loadings of single factor ML
      beta(i0)=beta(i0)+xx(l)
  255 continue
      beta(i0)=beta(i0)/dble(me-1)
      if(beta(i0).gt.0.) beta(i0)=dsqrt(beta(i0))
      if(beta(i0).lt.0.) beta(i0)=-dsqrt(-beta(i0))
  260 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   STEDE        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes steepest descent iterations.
c
c   This subroutine calls the following subroutines:
C   CPRINT  SEARCH  
c
c   This subroutine is called by the following subroutines:
C   STEDE  CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine STEDE(n,x,y,g,h,d,f0,ii,xdata,joe,r,iii,rn,iin,vb,
     1sc,isc,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),y(1),g(1),h(1),d(1),trial,fact,aa,bb,f,f0,
     1pr,trial1,egr,epa,egf,epsg,epsp,epsf,vb(1),r(1),rn(1),sc(1)
      dimension xdata(1),joe(1),iii(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a1(11),icon,dum(28)
      common /f/ trial,egr,epa,egf,trial1,fact,aa,bb,maxtry,iter,pr,
     1epsg,epsp,epsf,maxite,iv1,iv2,na1,na2,dumf(5)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      trial=trial1
      if(ii.eq.0) call CPRINT(19)
      iter=0
      egf=0.d0
      epa=0.d0
  200 egr=0.d0
      iv1=1
      do 202 i=1,n
      if(dabs(g(i)).gt.egr) iv1=i
      if(dabs(g(i)).gt.egr) egr=dabs(g(i))
  202 continue
      if((icon.eq.1.or.icon.eq.2).and.egr.le.epsg) return
      if(iter.eq.0.or.epa.gt.epsp) na1=0
      if(iter.eq.0.or.egf.gt.epsf) na2=0
      if(iter.eq.0.or.egf.gt.pr) na3=0
      if(iter.eq.0) go to 205
      if(epa.le.epsp) na1=na1+1
      if(egf.le.epsf) na2=na2+1
      if(egf.le.pr) na3=na3+1
      if((egr.le.epsg.and.na1.ge.2.and.na2.ge.2).or.((icon.eq.1.or.icon.
     1eq.3).and.na2.ge.2).or.((icon.eq.1.or.icon.eq.4).and.na1.ge.2)) re
     2turn
      if(na3.ge.2) ind=6
      if(na3.ge.2) return
  205 iter=iter+1
      do 210 i=1,n
  210 d(i)=-g(i)
      call SEARCH(n,x,y,g,h,d,f0,f,xdata,joe,r,iii,rn,iin,vb,ii,sc,isc,
     1ind)
      if(ind.gt.2.or.f.gt.f0.or.ind.eq.1) return
      ind=0
      if(f.ne.0.) egf=dabs((f0-f)/f)
      f0=f
      epa=0.d0
      iv2=1
      do 220 i=1,n
      if(y(i).eq.0.) go to 215 
      if(dabs((x(i)-y(i))/y(i)).gt.epa) iv2=i
      if(dabs((x(i)-y(i))/y(i)).gt.epa) epa=dabs((x(i)-y(i))/y(i))
  215 x(i)=y(i)
  220 g(i)=h(i)
      if(iter.lt.maxite) go to 200
      ind=4
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   TRANSE        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates transformed variables.
c
c   This subroutine calls the following subroutines:
C   READOM  
c
c   This subroutine is called by the following subroutines:
C   TRANSE  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine TRANSE(xbata,nr,jb,rn,iin,jjn,kkn,tar,jj,ntt,nob,ntime,
     1imy)
c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision rn(1),v,v1,y,v2,POW
      dimension xbata(nr,jb),iin(1),jjn(1),kkn(1),tar(6,itran),imy(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ a2(36),gl,inam,mtime,dumb(5)
      common /c/ a1(5),itran,ntar,imin,dumc(32)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l=ntar+1
      if(l.gt.jb) go to 8
      do 5 i2=l,jb
    5 xbata(jj,i2)=0.
    8 do 100 l=1,itran
      if(tar(1,l).eq.0.) go to 10
      if(tar(1,l).eq.1..and.(ntt.lt.tar(2,l).or.ntt.gt.tar(4,l))) go to
     1100
      if(tar(1,l).eq.2..and.(nob.lt.tar(2,l).or.nob.gt.tar(4,l))) go to
     1100
      if(tar(1,l).ne.3.) go to 10
      i2=tar(3,l)
      j5=tar(4,l)
      j1=tar(2,l)
      if(j5.gt.0.and.IOBS(xbata(jj,j1),xbata(jj,j5),i2).eq.0) go to 100
      if(j5.eq.0.and.IOBS(xbata(jj,j1),tar(5,l),i2).eq.0) go to 100
   10 j1=tar(6,l)
      i2=iin(j1+1)
      j5=j1
      j1=j1+3
      v1=0.d0
      j4=0
      do 40 i4=1,i2
      j1=j1+1
      y=rn(j1)
      j2=iin(j1)+j1-1
   15 if(j1.eq.j2) go to 40
      j1=j1+1
c   Accumulate xterm1**xterm2
      if(iin(j1).lt.-3000) go to 20
      call TRANSF(iin(j1),jjn(j1),kkn(j1),rn(j1),xbata,nr,jb,jj,ntt,
     1ntime,y,j4,imy,mtime,imin)
      go to 15
c   Accumulate within parenthesis
   20 v2=0.d0
      j0=j1
      j6=-iin(j0)-3000
      if(iin(j0).lt.-4000) j6=j6-1000
      if(iin(j0).lt.-5000) j6=j6-1000
      i1=0
   25 i1=i1+1
      j1=j1+1
      v=rn(j1)
      j3=iin(j1)+j1-1
   30 if(j1.eq.j3) go to 35
      j1=j1+1
      call TRANSF(iin(j1),jjn(j1),kkn(j1),rn(j1),xbata,nr,jb,jj,ntt,
     1ntime,v,j4,imy,mtime,imin)
      go to 30
   35 v2=v2+v
      if(i1.lt.j6) go to 25
c   Log, exponentiate, and/or raise parenthesis expression to power
      if(iin(j0).lt.-4000.and.iin(j0).gt.-5000.and.v2.ne.0.) v2=dlog(dab
     1s(v2))
      if(iin(j0).lt.-5000) v2=dexp(v2)
      if(v2.eq.0.) go to 37
      if(jjn(j0).eq.0) v2=POW(v2,rn(j0))
      if(jjn(j0).ge.0) go to 37
      i1=jj+kkn(j0)
      if(mtime.gt.0) i1=imy(1-imin+i1-jj)
      if(mtime.gt.0) go to 36
      if(i1.gt.nr) i1=i1-nr
      if(i1.le.0) i1=nr+i1
      if(ntt+kkn(j0).gt.ntime.or.ntt+kkn(j0).lt.1) i1=0
   36 if(i1.eq.0) v2=0.d0
      j6=jjn(j0)
      if(i1.ne.0.and.MISS(xbata(i1,-j6)).ne.0) j4=1
      if(j4.eq.1) go to 37
      if(i1.ne.0) v2=dabs(v2)**(rn(j0)*dble(xbata(i1,-j6)))
   37 y=y*v2
      go to 15
   40 v1=v1+y
c   Raise to power, log, and/or exponentiate left side of equation
      i3=-iin(j5+2)
      if(i3.gt.1000) i3=i3-1000
      if(i3.gt.1000) i3=i3-1000
      if(j4.eq.1) go to 50
      if(iin(j5+2).lt.-1000.and.iin(j5+2).gt.-2000.and.v1.ne.0.) v1=dlog
     1(dabs(v1))
      if(iin(j5+2).lt.-2000) v1=dexp(v1)
      if(rn(j5+1).eq.0..or.v1.eq.0.) go to 70
      if(jjn(j5+2).eq.0) go to 45
      j6=jjn(j5+2)
      i1=jj+jjn(j5+1)
      if(mtime.gt.0) i1=imy(1-imin+i1-jj)
      if(mtime.gt.0) go to 43
      if(i1.gt.nr) i1=i1-nr
      if(i1.le.0) i1=nr+i1
      if(ntt+jjn(j5+1).gt.ntime.or.ntt+jjn(j5+1).lt.1) i1=0
   43 if(i1.eq.0.or.xbata(i1,-j6).eq.0.) go to 60
      if(MISS(xbata(i1,-j6)).ne.0) go to 50
      v1=dabs(v1/rn(j5+1))**(rn(j5+2)/dble(xbata(i1,-j6)))
      go to 70
   45 if(dabs(rn(j5+2)).ne.1.) v1=dabs(v1/rn(j5+1))**rn(j5+2)
      if(dabs(rn(j5+2)).eq.1.) v1=(v1/rn(j5+1))**ifix(sngl(rn(j5+2)))
      go to 70
   50 v1=dble(gl)
      go to 70
   60 v1=0.d0
c   Put new variable in vector
   70 xbata(jj,i3)=v1
  100 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   TRANSF        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates portion of transformed variable.
c
c   This subroutine is called by the following subroutines:
C   TRANSE  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine TRANSF(i1,i2,i5,r,xbata,nr,jb,jj,ntt,ntime,y,mi,imy,
     1mtime,imin)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision r,v,y,POW
      dimension xbata(nr,jb),imy(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      v=0.d0
      j1=jj
      j2=jj
      if(i5.eq.0) go to 10
      if(i5.gt.0) i3=(i5+500)/1000
      if(i5.lt.0) i3=(i5-500)/1000
      i4=i5-i3*1000
      if(i3.eq.0) go to 5
c   Determine lead/lag of xterm1
      j1=jj+i3
      if(mtime.gt.0) j1=imy(1-imin+j1-jj)
      if(mtime.gt.0) go to 5
      if(j1.gt.nr) j1=j1-nr
      if(j1.le.0) j1=nr+j1
      if(ntt+i3.gt.ntime.or.ntt+i3.lt.1) j1=0
    5 if(i4.eq.0) go to 10
c   Determine lead/lag of xterm2
      j2=jj+i4
      if(mtime.gt.0) j2=imy(1-imin+j2-jj)
      if(mtime.gt.0) go to 10
      if(j2.gt.nr) j2=j2-nr
      if(j2.le.0) j2=nr+j2
      if(ntt+i4.gt.ntime.or.ntt+i4.lt.1) j2=0
   10 if(j1.eq.0) y=0.d0
      if(j1.eq.0.or.j2.eq.0) return
      if(i1) 15,60,35
   15 if(i1.lt.-1000) go to 20
c   Set xterm1
      if(MISS(xbata(j1,-i1)).ne.0) go to 70
      v=dble(xbata(j1,-i1))
      go to 65
   20 if(i1.lt.-2000) go to 25
      if(MISS(xbata(j1,-i1-1000)).ne.0) go to 70
c   Log xterm1
      if(xbata(j1,-i1-1000).ne.0.) v=dlog(dabs(dble(xbata(j1,-i1-1000)))
     1)
      go to 65
c   Exponentiate xterm1
   25 if(MISS(xbata(j1,-i1-2000)).ne.0) go to 70
      v=dexp(dble(xbata(j1,-i1-2000)))
      go to 65
   35 if(i1.gt.1000) go to 40
c   Set xterm1 as trend
      if(i1.eq.1) v=dble(ntt)
c   Set xterm1 as time dummy
      if(i1-1.eq.ntt) v=1.d0
      go to 65
   40 if(i1.gt.3000) go to 55
      if(i1.gt.2000) go to 50
c   Set xterm1 as growth trend
      if(i1.eq.1001) v=dlog(dble(ntt))
      if(i1-1001.eq.ntt) v=1.d0
      go to 65
c   Set xterm1 as exponential growth term
   50 if(i1.eq.2001) v=dexp(dble(ntt))
      if(i1.gt.2001) v=1.d0
      if(i1-2001.eq.ntt) v=dexp(1.d0)
      go to 65
c   Set variable as constant**xterm2 if xterm1 not specified
   55 if(i2.lt.0.and.MISS(xbata(j2,-i2)).ne.0) go to 70
      if(i2.lt.0) y=y*dabs(r)**(dble(xbata(j2,-i2)))
   60 return
c   Set variable as xterm1**xterm2
   65 if(i2.lt.0.and.MISS(xbata(j2,-i2)).ne.0) go to 70
      if(i2.lt.0) y=y*dabs(v)**(r*dble(xbata(j2,-i2)))
      if(i2.ge.0) y=y*POW(v,r)
      return
   70 mi=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   TRANSL        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Fills in i subscript for transformations.
c
c   This subroutine is called by the following subroutines:
C   CONDAT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine TRANSL(a,d,j1,j2,i,id,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension a(1),b(16),d(1),c(9)
c** change *** this contains transformation code settings > i
c------------------------DATA STATEMENTS---------------------------------
      data b/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H+,1H-,1H*,
     *1H/,1Hi
     1,1H>/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l4=0
      if(id.eq.0) go to 12
      l1=i
    2 l3=0
    4 j=l1/10
      l3=l3+1
      c(l3)=b(l1-10*j+1)
      l1=l1/10
      if(l1.gt.0) go to 4
      if(l4.eq.1) l3=l3+1
      if(l4.eq.1) c(l3)=b(12)
      do 8 j=1,l3
    8 d(j2+j)=c(l3-j+1)
      j2=j2+l3
      return
   12 l1=0
   15 j1=j1+1
      do 20 j=1,16
      if(a(j1).eq.b(j)) go to 25
   20 continue
      go to 65
   25 if(j.le.10) go to 35
   30 if(j.eq.16) go to 62
      if(j.ge.11.and.j.le.14) l4=j-11
      if(j.eq.15) l3=i
      if(j.eq.15) go to 60
      go to 15
   35 l3=j-1
   40 j1=j1+1
      do 45 j=1,16
      if(a(j1).eq.b(j)) go to 50
   45 continue
      go to 65
   50 if(j.gt.10) go to 55
      l3=l3*10+j-1
      go to 40
   55 if(l3.le.0) go to 65
   60 if(l4.eq.0) l1=l1+l3
      if(l4.eq.1) l1=l1-l3
      if(l4.eq.2) l1=l1*l3
      if(l4.eq.3) l1=l1/l3
      l4=0
      if(j.eq.15) go to 15
      if(j.ne.16) go to 30
   62 if(l1.lt.0) l4=1
      l1=iabs(l1)
      go to 2
   65 ind=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   VARNAM        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Reads variable names.
c
c   This subroutine calls the following subroutines:
C   MARKY  
c
c   This subroutine is called by the following subroutines:
C   CONDAT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine VARNAM(a,ab,i1,nvar,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension ab(9,1),a(1)
c------------------------DATA STATEMENTS---------------------------------
      data vb/4H    /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      j1=i1+1
      do 5 j2=j1,nvar
      do 5 j=1,8
    5 ab(j,j2)=vb
      j1=j1-1
   10 j2=1
c   Read variable name card
      call MARKY(a,2,2,ab,nvar,ierror)
      if(ierror.gt.0) return
      do 20 j=1,82
      if(a(j).eq.vb) go to 15
      if(j2.eq.1) j1=j1+1
      if(j1.gt.nvar) return
      if(j2.eq.1) i4=0
      i4=i4+1
      if(i4.eq.9) j1=j1+1
      if(i4.ne.9) go to 13
      ab(9,j1)=i4
      i4=1
      j1=j1+1
   13 ab(i4,j1)=a(j)
      j2=0
      go to 20
   15 j2=j2+1
      if(j2.gt.1) go to 25
      ab(9,j1)=i4
   20 continue
   25 if(j1.lt.nvar) go to 10
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   WEIMAT        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Constructs weighting matrix patterns for exogeneity testing.
c
c   This subroutine is called by the following subroutines:
C   STANER  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine WEIMAT(b,c,joe,moe,noe,jod,vd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision b(lp,lp),c(lp,lz),vd(1)
      dimension joe(1),moe(k,me),noe(k,me),jod(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,a1(15),ln,a2(2),lm,dum(20)
      common /d/ k,a3(8),lz,lp,dumd(13)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 15 i=1,lp
      vd(i)=0.d0
      do 10 j=1,lp
   10 b(i,j)=0.d0
   15 b(i,i)=1.d0
      i1=0
      i2=0
      do 50 i6=1,me
      do 30 i=1,k
      if(noe(i,i6).lt.4.or.(noe(i,i6).ge.8.and.noe(i,i6).le.11)) i1=i1+1
      if(moe(i,i6).lt.4.or.(moe(i,i6).ge.8.and.moe(i,i6).le.11)) i2=i2+1
      if(moe(i,i6).lt.4.or.(moe(i,i6).ge.8.and.moe(i,i6).le.11).and.(noe
     1(i,i6).lt.4.or.(noe(i,i6).ge.8.and.noe(i,i6).le.11))) vd(i1)=dble
     2(i2)
      if(noe(i,i6).eq.0.or.noe(i,i6).eq.4.or.noe(i,i6).eq.8.or.noe(i,i6)
     1.ge.15) go to 30
      do 25 j=2,lm
      if(noe(i,i6).eq.3.or.noe(i,i6).eq.7.or.noe(i,i6).eq.11.or.noe(i,i6
     1).eq.14) go to 20
      i1=i1+1
      if(moe(i,i6).eq.0.or.moe(i,i6).eq.3.or.moe(i,i6).eq.4.or.moe(i,i6)
     1.eq.7.or.moe(i,i6).eq.8.or.moe(i,i6).eq.12.or.moe(i,i6).ge.14.or.j
     2.gt.ln) go to 20
      i2=i2+1
      vd(i1)=dble(i2)
   20 if(noe(i,i6).eq.2.or.noe(i,i6).eq.6.or.noe(i,i6).eq.10.or.noe(i,i6
     1).eq.13) go to 25
      i1=i1+1
      if(moe(i,i6).eq.0.or.moe(i,i6).eq.2.or.moe(i,i6).eq.4.or.moe(i,i6)
     1.eq.6.or.moe(i,i6).eq.8.or.moe(i,i6).eq.10.or.moe(i,i6).eq.12.or.m
     2oe(i,i6).eq.13.or.moe(i,i6).ge.15.or.j.gt.ln) go to 25
      i2=i2+1
      vd(i1)=dble(i2)
   25 continue
   30 continue
      if(joe(i6).le.1.or.jod(i6).gt.2) go to 50
      i1=i1+1
      i2=i2+1
      vd(i1)=dble(i2)
   50 continue
      do 60 i=1,lp
      do 60 j=1,lp
      if(vd(j).eq.0.d0) go to 60
      i1=ifix(sngl(vd(j)))
      b(i,j)=b(i,j)-c(i,i1)
   60 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   WEPETE        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Computes weighting matrices for gmm 2nd phase.
c
c   This subroutine calls the following subroutines:
C   MULTIP  FCJOEY  MATIN5  
c
c   This subroutine is called by the following subroutines:
C   VINCEN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine WEPETE(xs,xdata,joe,loe,moe,rn,iin,vb,sc,iscal,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision det,vb(1),xs(1),rn(1),sc(1)
      dimension xdata(1),joe(me,10),loe(1),moe(1),iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,dum(38)
      common /d/ a0(9),lz,a3(2),ny,a2(2),lg,a1(7),la
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i1=lg+1
      i2=lz*(lz+1)/2+i1
      i2a=i2+nt*5*me
      i3=i2a
      if(la.gt.1) i3=i2a+la*lz
      i4=i3+lz
      call MULTIP(vb(i3),vb(i1),vb(i1),vb(i1),vb(i1),lz,lz,1)
c   Calculate cross-products matrix of orthogonality conditions
      call FCJOEY(xs,det,vb(i3),vb(i1),xdata,joe,loe,moe,vb(i3),vb(i2),
     1vb(i2),vb(i3),vb,vb(i4),vb(i4),iin,iin(ny),rn,vb,joe(1,2),joe(1,3)
     2,joe(1,5),joe(1,6),joe(1,8),joe(1,9),vb(i2a),vb,2,sc,iscal,ind)
c   Invert weighting matrix of cross-products
      if(ind.eq.0) call MATIN5(lz,vb(i1),vb(i1),vb(i3),det,0,ind)
      if(ind.gt.0) ind=9
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   WITKOW        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Accumulates moments over time periods.
c
c   This subroutine is called by the following subroutines:
C   BROWN  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine WITKOW(gg,xdata,loe,i,l,i5,j5,jj,zx,yx,id1,id2,id3)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision gg,zx,yx,wt,vrs
      dimension xdata(jb,kobs),loe(k,nt)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ me,nt,a1(14),ln,a2(17),kvrs,jwt,dum(4)
      common /c2/ vrs
      common /d/ k,n,jb,kobs,lv,dumd(19)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      wt=1.d0
      do 12 j=1,nt
      if(jwt.eq.0) go to 1
      i2=loe(jwt,j)
      wt=dble(xdata(i2,jj))/vrs
    1 if(xdata(lv+i5+j,jj).lt.2..or.xdata(lv+j5+j,jj).lt.2.) go to 12
      i1=loe(i,j)
      go to (2,4,6,6,8,8,7),id2
    2 i2=loe(l,j)
      go to 10
    4 i2=lv+nt+i5+j
      if(id1.eq.1) yx=yx+wt*dble(xdata(i2,jj))**2
      if(id1.eq.1) zx=zx+wt
      go to 10
    6 if(j+id3-1.gt.ln) go to 12
      i2=loe(l,j+id3-1)
      if(id2.eq.4) i1=lv+i5+nt+j
      go to 10
    7 zx=zx+wt
      gg=gg+dble(xdata(lv+i5+nt+j,jj))*dble(xdata(lv+j5+nt+j,jj))*wt
      go to 12
    8 if(j.lt.id3) go to 12
      i2=loe(l,j-id3+1)
      if(id2.eq.6) i1=lv+i5+nt+j
   10 gg=gg+dble(xdata(i1,jj))*dble(xdata(i2,jj))*wt
   12 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   XBETA        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Calculates g(x,b) and/or its gradients where g(x,b) is either 
c   Non-linear regression or index function.
c
c   This subroutine calls the following subroutines:
C   CALC  PAREN  
c
c   This subroutine is called by the following subroutines:
C   ECOVWR  FCHOTZ - FCPELD  RESIDL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine XBETA(x,g,s,iin,jjn,rn,vd,ve,z,loe,isi,my,le,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),g(1),ve,rn(1),vd,y,v3,v1,v2,v4,vb,v5,s(1)
      dimension z(1),iin(1),jjn(1),loe(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      j1=isi+1
c   Branch if gradient or 2nd derivatives
      if(id.ge.1) go to 15
c   Sum x'b
      vd=0.d0
      i2=iin(j1)
      if(my.eq.0) go to 8
      do 6 i1=1,i2
      j1=j1+1
c   Multiply term by constant
      y=rn(j1)
      j2=iin(j1)+j1-1
    4 if(j1.eq.j2) go to 6
      j1=j1+1
c   Accumulate term1**term2
      if(iin(j1).lt.-2000) go to 5
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,y,v3,v3,g,s,i,0,1)
      go to 4
    5 call PAREN(iin,jjn,rn,g,s,x,loe,z,j1,y,y,v3,y,0,1,0,0)
      y=y*v3
      go to 4
c   Add terms together to get x'b
    6 vd=vd+y
      return
c   Compute equation for linear version
    8 do 12 i1=1,i2
      j1=j1+1
      y=rn(j1)
      j2=iin(j1)+j1-1
    9 if(j1.eq.j2) go to 12
      j1=j1+1
      if(iin(j1)) 10,9,11
   10 i=iin(j1)
      i=loe(-i)
      y=y*dble(z(i))
      go to 9
   11 i=iin(j1)
      y=y*x(i)
      go to 9
   12 vd=vd+y
      return
c   Calculate gradient vector of x'b with respect to b
   15 if(id.eq.1) go to 22
      do 18 i2=1,le
   18 g(i2)=0.d0
   22 i2=iin(j1)
      if((id.eq.1.and.vd.eq.0.).or.(id.eq.2.and.ve.eq.0..and.vd.eq.0.))
     1return
      if(my.eq.0) go to 95
      do 38 i1=1,i2
      j1=j1+1
c   First accumulate term of x'b
      y=rn(j1)
      j6=iin(j1)
      j2=iin(j1)+j1-1
   24 if(j1.eq.j2) go to 30
      j1=j1+1
      if(iin(j1).lt.-2000) go to 29
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,y,v3,v3,g,s,i,0,1)
      go to 24
   29 call PAREN(iin,jjn,rn,g,s,x,loe,z,j1,y,y,v3,y,0,1,0,0)
      y=y*v3
      go to 24
   30 j1=j2-j6+1
      vb=y
      if(id.eq.1) vb=-vd*vb
   31 if(j1.eq.j2) go to 38
      j1=j1+1
      if(iin(j1).lt.-2000) go to 37
      call CALC(iin(j1),jjn(j1),rn(j1),loe,z,x,v1,v2,vb,g,s,i,0,5)
      go to 31
   37 call PAREN(iin,jjn,rn,g,s,x,loe,z,j1,vd,y,v3,y,0,id,0,1)
      go to 31
   38 continue
      if(id.eq.1) return
c   Calculate matrix of second derivatives
      j7=isi+1
      i2=iin(j7)
      do 90 i1=1,i2
      j7=j7+1
c   Accumulate term of x'b for first parameter
      y=rn(j7)
      j6=iin(j7)
      j2=iin(j7)+j7-1
   47 if(j7.eq.j2) go to 53
      j7=j7+1
      if(iin(j7).lt.-2000) go to 52
      call CALC(iin(j7),jjn(j7),rn(j7),loe,z,x,y,v3,v3,g,s,i,0,1)
      go to 47
   52 call PAREN(iin,jjn,rn,g,s,x,loe,z,j7,y,y,v3,y,0,1,0,0)
      y=y*v3
      go to 47
   53 vb=y*ve
      if(vb.eq.0.) go to 90
      j7=j2-j6+1
   55 if(j7.eq.j2) go to 90
      j7=j7+1
      if(iin(j7).lt.-2000) go to 88
      call CALC(iin(j7),jjn(j7),rn(j7),loe,z,x,v1,v2,vb,g,s,j5,0,3)
      if((v1.eq.0..and.v2.eq.0.).or.my.eq.0) go to 55
      j8=j2-j6+1
      v1=v1*vd/ve
      v2=v2*vd/ve
c   Add in first derivative part
   80 if(j8.eq.j2) go to 55
      j8=j8+1
      if(iin(j8).lt.-2000) go to 86
      if(v1.ne.0.) call CALC(iin(j8),jjn(j8),rn(j8),loe,z,x,v3,v4,v1,g,
     1s,i,j5,2)
      v5=vd*y
      if(v1.ne.0..and.j8.eq.j7) call CALC(iin(j8),jjn(j8),rn(j8),loe,
     1z,x,v3,v4,v5,g,s,i,j5,4)
      if(v2.ne.0.) call CALC(iin(j8),jjn(j8),rn(j8),loe,z,x,v3,v4,v2,g,
     1s,i,jjn(j7),2)
      go to 80
   86 j3=j8
      if(v1.ne.0.) call PAREN(iin,jjn,rn,g,s,x,loe,z,j8,vd,y,v3,v1,j5,1,
     10,2)
      if(v2.ne.0.) j8=j3
      if(v2.ne.0.) call PAREN(iin,jjn,rn,g,s,x,loe,z,j8,vd,y,v3,v2,
     1jjn(j7),1,0,2)
      go to 80
   88 j8=j2-j6+1
      call PAREN(iin,jjn,rn,g,s,x,loe,z,j7,vd,ve,v3,y,0,j8,j2,3)
      go to 55
   90 continue
      return
c   Compute 1st and 2nd derivatives for linear version
   95 v5=vd
      if(id.ne.1) v5=-1.d0
      do 120 i1=1,i2
      j6=0
      j1=j1+1
      y=rn(j1)*v5
      j2=iin(j1)+j1-1
  100 if(j1.eq.j2) go to 115
      j1=j1+1
      if(iin(j1)) 105,100,110
  105 i=iin(j1)
      i=loe(-i)
      y=y*dble(z(i))
      go to 100
  110 j6=iin(j1)
      go to 100
  115 if(j6.eq.0) go to 120
      g(j6)=g(j6)-y
  120 continue
      if(id.eq.1) return
      j1=0
      do 130 i=1,le
      do 130 j2=1,i
      j1=j1+1
  130 s(j1)=s(j1)+ve*g(i)*g(j2)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CONTRL        (KEY SUBROUTINE IN CONTIM)
c   Main sub-driver program for CONTIM Models.  Initializes CONTIM runs 
c   And calls CONTIM subroutine.
c
c   THIS SUBROUTINE WAS MODIFIED BY V. Joseph Hotz on 12/1/90.
c
c   This subroutine calls the following subroutines:
C   DECODS  MARKY  MALLAR  TRANSI  RDREST  READCF  RESCS  DASORS
C   CONTIM  ERRWRT  ERRCHK
c
c   This subroutine is called by the following subroutines:
C   HOTZTR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CONTRL(c,xbata,ic,cc,ix5)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension c(1),ic(1),fmt(20),id(5),xbata(1),jj(29),ni(2,50)
      double precision cc(1),epsg,epsp,epsf,vrs,gamm,xt1,xt2,v,stpsim
c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,dum(3)
      common /b/ a3(5),nobs,nvar,ntime,kcore,a1(25),mi1,mi2,dumb(8)
      common /c2/ vrs
      common /c/ iscal,ipun,jc,icon,lt,ivcb,icons,nfun,nsta,nfre,nwei,
     1ibgn,jres,idep,istan,ir,istar,it1,it2,iu1,iu2,iu3,iu4,iu5,vr,
     2iwt,kvrs,kgamm,kxt1,kxt2,nl,lee,ix0,ix2,ix4,nt,dumc(4)
      common /c5/ gamm
      common /c6/ xt1,xt2
      common /d/ npar,npin,jb,kobs,ncas,nbar,ntxz,la,igm,mobs,mm,my,
     1ny,l1,inter,ncar,nint,ifail,iqz,inz,iout,idis,dumd(2)
      common /f/ lv1,lv2,vr1,lv3,lv4,lv5,kd,a5(13),epsg,epsp,epsf,maxite
     *,dumf(9)
c*********************************
      common /k/ jeff,JOFunc
      common /simp1/ last,istsim,ipb,jcc,NUMER
      common /simp2/ stpsim
c*********************************
c---------------------EQUIVALENCE STATEMENTS-----------------------------
      equivalence(iscal,jj(1))
c------------------------DATA STATEMENTS---------------------------------
      data ni/19,3,3,23,5,19,3,14,9,16,16,3,3,15,8,5,14,19,20,18,9,21,
     &11,14,18,16,4,6,16,19,18,5,19,20,4,19,4,3,4,2,6,1,14,4,12,1,
     &19,5,9,20,6,15,7,20,16,20,6,20,13,9,23,5,7,1,12,6,12,19,15,21,
     &13,15,3,8,3,19,20,4,9,9,14,15,20,25,4,5,13,1,14,6,19,12,19,19,
     &15,5,15,6,14,21/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      nvar=nvar+1
c   Initialize parameters
      ierror=0
      do 10 i=1,29
   10 jj(i)=0
      nl=0
      igm=0
      idep=0
      lv2=0
      nt=ntime
      la=ntime
      jeff=0
      JOFunc=0
      NUMER=0
      ny=1
      lee=0
      vr1=0.
      lv3=0
      lv4=-1
      lv5=0
      it1=1
      it2=ntime
      iu4=1
      iu5=nobs
      mi2=0
      nsta=2
      nfre=1
      sec=5.0
      maxite=50
      epsg=.00001d0
      epsp=.0001d0
      epsf=.0000001d0
      stpsim = 1.d0
      istsim = 0
      last = 1
      jdata=0
      iout=0
      mm=6
      gamm=1.d0
      xt1=1.d0
      xt2=2.d0
      ifor=0
      idis=0
      ifl2=0
      iqz=0
      ifail=0
      kd=0
c   Decode master control card for general program options
      j5=0
   30 call DECODS(c(ix5),j5,id,v)
      if(id(1)) 310,50,35
   35 if(id(1).eq.21.or.id(1).eq.24) go to 46
      do 40 l=1,50
      if(id(1).eq.ni(1,l).and.id(2).eq.ni(2,l)) go to 43
   40 continue
      go to 305
   43 if(l.le.17) go to 44
      if(l.eq.18) lv3=id(3)
      if(l.eq.19) lv4=id(3)
      if(l.eq.19.and.id(4).lt.0) lv4=-lv4
      if(l.eq.20) lv5=id(3)
      if(l.eq.21.or.l.eq.38) ifail=id(3)
      if(l.eq.22) jdata=id(3)
      if(l.eq.23) mm=id(3)
      if(l.eq.24) sec=v
      if(l.eq.25) maxite=id(3)
      if(l.eq.26.and.id(3).lt.0) go to 305
      if(l.eq.26) ifor=id(3)
      if(l.eq.27) epsg=v
      if(l.eq.28) epsp=v
      if(l.eq.29) epsf=v
      if(l.eq.30.and.mi1.ne.0) mi2=ifix(sngl(v))
      if(l.eq.31) iwt=id(3)
      if(l.eq.32) gamm=v
      if(l.eq.33) xt1=v
      if(l.eq.34) xt2=v
      if(l.eq.35) iout=id(3)
      if(l.eq.36) idis=id(3)-3
      if(l.eq.36.and.id(3).eq.1) idis=5
      if(l.eq.36.and.id(3).eq.2) idis=0
      if(l.eq.36.and.id(3).eq.8) idis=4
      if(l.eq.36.and.id(3).eq.3) idis=9
      if(l.eq.37) nsta=id(3)
      if(l.eq.39) kd=id(3)
      if(l.eq.40) iqz=id(3)
      if(l.eq.41) nl=id(3)
      if(l.eq.42.and.id(3).ne.6) go to 305
      if(l.eq.44) la=id(3)
      if(l.eq.45) jeff=id(3)
      if(l.eq.46) stpsim=v
      if(l.eq.47) istsim=id(3)
      if(l.eq.48) jeff=id(3)
      if(l.eq.49) JOFunc=id(3)
      if(l.eq.50) NUMER=id(3)
      if(l.ne.43) go to 30
      ifl2=1
      l=14
   44 jj(l)=id(3)
      if(l.ne.14) go to 30
      lv1=id(4)
      lv2=id(5)
      vr1=v
      go to 30
   46 if(id(2)-15) 49,48,47
   47 if(id(3).eq.0) id(3)=1
      if(id(5).eq.0) id(5)=ntime
      it1=id(3)
      it2=id(5)
      nt=it2-it1+1
      if(id(5).gt.ntime.or.id(3).gt.id(5).or.id(3).le.0) go to 320
      if(id(1).eq.21) go to 30
      it1=id(5)+1
      it2=id(3)
      nt=ntime-it1+it2
      go to 30
   48 iu2=id(3)
      iu3=id(5)
      vr=v
      if(id(4).eq.0) id(4)=1
      iu1=id(4)
      go to 30
   49 if(id(3).eq.0) id(3)=1
      if(id(5).eq.0) id(5)=nobs
      iu4=id(3)
      iu5=id(5)
      if(id(3).le.0.or.id(5).gt.nobs.or.id(3).gt.id(5)) go to 320
      if(id(1).eq.21) go to 30
      iu4=id(5)+1
      iu5=id(3)
      go to 30
   50 if(nwei.eq.0) lv5=0
      if(mi1.eq.0) mi2=0
      if(idis.ge.3) idep=lv4
c   Change made by Jacob Klerman 10.6/85
c      if(idis.le.2.and.ifl2.ne.1.and.lv0.le.0.and.lv2.gt.0) idep=lv3
      if(idis.le.2.and.ifl2.ne.1.and.lv2.gt.0) idep=lv3
      if(idis.eq.5) lv4=0
      if(nfre.gt.nsta*nsta-nsta.or.(ibgn.gt.0.and.nsta.gt.2).or.nfre.le.
     10.or.(idis.ne.5.and.nsta.lt.2)) go to 320
      if(idep.lt.0.or.idep.gt.nvar.or.(lv2.lt.0.and.lv3.eq.0).or.lv3.gt.
     1nvar.or.lv4.gt.nvar.or.lv5.gt.nvar) go to 330
      if(((idis.le.2.or.idis.eq.5.or.idis.eq.3.or.idis.eq.6.or.idis.eq.7
     1).and.idep.le.0).or.(idis.eq.3.and.lv4.le.0).or.idis.lt.0.or.idis.
     2gt.9.or.(idis.eq.9.and.nsta.ne.3).or.(nl.eq.1.and.(idis.eq.3.or.id
     3is.eq.4.or.istar.eq.1))) go to 320
      if(((ifl2.eq.0.or.(idis.ne.0.and.idis.ne.3.and.idis.ne.9)).and.ifa
     1il.eq.1).or.(jdata.eq.1.and.idis.eq.4)) go to 320
      if(ifl2.eq.1.and.(nsta.ge.2.or.nfre.ne.1)) go to 320
      if(idis.gt.0.and.(nwei.gt.0.or.ibgn.gt.0.or.nfun.gt.0)) go to 320
      if(idis.eq.3.or.idis.eq.4.or.idis.eq.8.or.idis.eq.9) nfre=nsta
      if((idis.eq.3.or.idis.eq.4.or.idis.eq.8).and.lv3.gt.0) ibgn=1
      if(idis.eq.3) jdata=1
      if(idis.eq.4) jdata=0
      if(idis.eq.5) nsta=1
      if(idis.eq.5.or.idis.eq.6.or.idis.eq.7) nfre=1
      if(idis.eq.8.or.idis.eq.9) nl=1
      if(idis.eq.6.or.idis.eq.7.or.idis.eq.9) lv3=0
      if(idis.eq.5.and.lv3.gt.0) ibgn=1
      if(idis.eq.4) icons=1
      la=la+1
      if(la.ge.nt) la=0
      npin=0
      if(nwei.eq.1.or.nwei.eq.2) npin=1
      if(nwei.ge.3) npin=4
      ntxz=npin
      if(nwei.eq.3) ntxz=2
      inter=1
      if(nwei.ge.3) inter=2
      ix1=ix5+nvar
      ix0=ix1+nfre*(nvar+1)
      if(iqz.eq.1.and.nfun.eq.1.and.ntime.gt.1) iqz=2
      if(iqz.gt.0.and.(istar.eq.1.or.(idis.eq.4.and.kd.eq.0))) iscal=1
      ncar=0
      nint=0
      do 52 i=ix5,ix1
   52 ic(i)=0
      if(nl.eq.1) go to 142
      nbar=ix0+nfre*(nvar+1)
      ix4=nbar+nvar+1
      do 85 i1=1,nfre
      ix3=(i1-1)*(nvar+1)
   53 do 55 j=1,nvar
   55 ic(nbar+j)=-1
      if(idis.eq.4.and.kd.eq.1.and.i1.eq.1) go to 70
      if(icons.eq.0) ic(nbar+nvar)=0
c   Read variable vector
      call MARKY(c(ix4),0,6,c,nvar,ierror)
      if(ierror.gt.0) go to 350
      i2=0
      j5=0
      j8=0
   65 call MALLAR(c(ix4),j5,id,c,nvar,ierror)
      if(ierror.gt.0) go to 350
      if(id(1).eq.0) go to 70
      if(id(1).lt.0.or.id(1).gt.nvar.or.j8.gt.id(1)) go to 330
      if(id(1).eq.nvar) go to 68
      if(id(4).eq.0) go to 66
      if(j8.gt.0) go to 330
      j8=id(1)
      j9=id(3)
      go to 65
   66 i=id(1)
      if(j8.eq.0) j9=id(3)
      if(j8.eq.0) j8=i
      do 67 j=j8,i
      i2=i2+1
      if(j9.eq.1.and.ic(nbar+j).ne.-1) i2=i2-2
      if(j9.eq.0) ic(nbar+j)=id(2)
      if(j9.eq.1) ic(nbar+j)=-1
   67 continue
      j8=0
      go to 65
   68 ic(nbar+nvar)=0
      if(id(3).eq.1.or.id(2).eq.2) ic(nbar+nvar)=-1
      if(id(4).ne.0) go to 330
      go to 65
   70 j5=0
      j8=0
      do 75 j=1,nvar
      if(ic(nbar+j).lt.0) go to 75
      ic(ix5+j-1)=1
      if(ic(nbar+j).le.1) j5=j5+1
      if(ic(nbar+j).le.1) ic(ix1+ix3+j5)=j
      if(idis.ge.1) go to 75
      if(ic(nbar+j).ge.1) j8=j8+1
      if(ic(nbar+j).ge.1) ic(ix0+ix3+j8+1)=j
   75 continue
      ic(ix1+ix3)=j5
      ic(ix0+ix3+1)=j8
      if(idis.eq.4.and.j5.gt.ncar.and.((kd.eq.0.and.i1.eq.2).or.i1.gt.2)
     1) go to 330
      if(j5.gt.ncar) ncar=j5
      if(j8.gt.nint) nint=j8
      if(jdata.eq.1.and.nfre.gt.1) go to 100
   85 continue
      if(nint.eq.0) inter=0
      go to 120
  100 if(ic(ix0+1).eq.0) inter=0
      do 115 i=2,nfre
      i2=ic(ix1)
      ix3=(i-1)*(nvar+1)
      ic(ix1+ix3)=i2
      do 105 j=1,i2
  105 ic(ix1+ix3+j)=ic(ix1+j)
      ic(ix0+ix3+1)=ic(ix0+1)
      if(inter.eq.0) go to 115
      i2=ic(ix0+1)
      do 110 j=1,i2
  110 ic(ix0+ix3+j+1)=ic(ix0+j+1)
  115 continue
  120 nint=nint+2
      ncar=ncar+1
      if(nvar+1.eq.ncar) go to 122
      i=ncar*nfre
      ix3=nvar+1-ncar
      j=0
      i2=0
      do 121 l=1,i
      i2=i2+1
      j=j+1
      if(i2.gt.ncar) j=j+ix3
      if(i2.gt.ncar) i2=1
  121 ic(ix1+l-1)=ic(ix1+j-1)
  122 i=nint*nfre
      ix3=nvar+1-nint
      nbar=ix0
      ix0=ix1+ncar*nfre
      j=0
      i2=0
      do 123 l=1,i
      i2=i2+1
      j=j+1
      if(i2.gt.nint) j=j+ix3
      if(i2.gt.nint) i2=1
  123 ic(ix0+l-1)=ic(nbar+j-1)
      ix4=ix0+nfre*nint
      npar=0
      do 126 i=1,nfre
      ic(ix0+i*nint-nint)=ic(ix1+i*ncar-ncar)+inter*ic(ix0+i*nint-nint+1
     1)+npin+nfun
      if(idis.ge.1) ic(ix0+i*nint-nint+1)=npar
  126 npar=npar+ic(ix0+i*nint-nint)
      if(idis.eq.3) npar=npar-ic(ix0)
      if(idis.eq.4) npar=ic(ix0)
      if(idis.eq.6.or.idis.eq.7) npar=npar+nsta-2
      nbar=0
      do 127 i=1,nvar
      if(ic(ix5+i-1).eq.0) go to 127
      nbar=nbar+1
      ic(ix5+nbar-1)=i
      ic(ix4+i)=nbar
  127 continue
      do 140 i=1,nfre
      i2=ic(ix1+i*ncar-ncar)
      do 130 j=1,i2
      l=ic(ix1+i*ncar-ncar+j)
  130 ic(ix1+i*ncar-ncar+j)=ic(ix4+l)
      if(inter.eq.0) go to 140
      i2=ic(ix0+i*nint-nint+1)
      do 135 j=1,i2
      l=ic(ix0+i*nint-nint+j+1)
  135 ic(ix0+i*nint-nint+j+1)=ic(ix4+l)
  140 continue
      go to 154
  142 continue
c ***** Fill in nonlin
c   Set ix9 for abn  ix8 for iin  ny for jjn  jx4 for rn
c
c   The following is a temporary fix of ix8 and ix9
c
      ix8=1
      ix9=1
      nl=nfre
      lee=npar
      if(idis.eq.0) npar=npar+nfre*(npin+nfun)
      if(idis.eq.9) npar=npar+3
      if(idis.eq.9.and.ifail.eq.1) npar=npar+3
      if(idis.eq.6.or.idis.eq.7) npar=npar+nsta-2
  154 ix2=ix4+nsta*nsta
      if(idis.eq.4.and.kd.eq.1) nbar=(nsta-1)*(ncar-1)
      jb=nbar+4
      if(idis.ge.3) jb=nbar+5-idis
      if(idis.ge.3.and.lv3.gt.0) jb=jb+1
      if(idis.eq.5) jb=nbar+2
      if(idis.eq.5.and.lv4.gt.0) jb=jb+1
      if(iwt.gt.0) jb=jb+1
      if(nwei.gt.0) jb=jb+1
      jx1=ix2
      if(idis.le.2) jx1=ix2+nsta*nfre
      do 155 i=ix4,jx1
  155 ic(i)=0
      jx1=jx1/2+1
      jx2=jx1+npar
      ix3=jx2*2+1
      if(idis.ge.3) go to 175
      if(ifl2.eq.1) go to 171
c   Read Transition vectors
      do 170 j=1,nfre
      call MARKY(c(ix3),0,3,c,nvar,ierror)
      if(ierror.gt.0) go to 350
      call TRANSI(ic(ix4),ic(ix2),c(ix3),nsta,nfre,j,ierror)
      if(ierror.gt.0) go to 350
  170 continue
      go to 175
  171 ic(ix2)=1
      ic(ix4+2)=1
  175 my=0
c   Read restriction card (optional)
      if(ir.eq.0) go to 230
      j2=0
      j=ix3+(kcore-ix3)/4-3*npar
      i9=j+1
      j8=(j+(kcore-ix3)/4-3*npar)/2+1
      j5=j8-npar-1
      i1=j5-npar-1
      jx2=(i1-npar-1)*2
      do 190 i=1,npar
  190 ic(jx2+i-1)=0
      do 200 i=1,ir
      call MARKY(c(i9),1,10,c,nvar,ierror)
      if(ierror.gt.0) go to 350
c   Call RDREST which decodes restrictions
      call RDREST(ic(ix3),ic(ix3),cc(j8),j2,c(i9),cc(j5),cc(j5),cc(i1),
     1ic(ix3),npar,ic(jx2),nvar,l,0,my,ierror)
      if(ierror.gt.0) go to 350
      c(i9-1)=l
      i9=i9+l+1
  200 continue
      j5=i9-j
      i1=ix3+j2+1
      do 210 i=1,j5
  210 c(i1+i-1)=c(j+i-1)
      j5=(i1+j5)/2+2
      do 220 i=1,j2
  220 cc(j5+i-1)=cc(j8+i-1)
      ix3=(j5+j2)*2+1
  230 if(istar.eq.1) go to 240
c   Read coefficients
      call READCF(fmt,cc(jx1),npar,ifor)
      if(ifor.le.0) go to 305
  240 j5=ix5+kcore-nsta*nsta-1
      l=nsta*nsta
      do 242 i=1,l
  242 ic(j5+i-1)=0
      j2=j5/2-nsta*nbar-1
      if(iqz.eq.0.or.iscal.eq.1.or.nl.gt.0) go to 250
      j8=j2-npar
c   Scale for disk runs
      call RESCS(cc(j8),cc(jx1),cc,c,ic(ix2),ic(ix1),ic(ix0),cc,ic,cc,
     1ic,cc(j2),2)
  250 i2=nvar-1
c   Call subroutine DASORS which reads data vectors
      call DASORS(xbata,i2,ic(j5),ic(ix1),c(ix3),ic(ix5),cc(j2))
      i2=ix3+kobs*jb+1
      jx2=i2/2+1
      ix0=1+nfre*ncar
      ix4=ix0+nfre*nint
      ix2=ix4+nsta*nsta
c   Call main execution program CONTIM
      kcore=kcore-jx2*2
c   Change made by Jacob Klerman 10/6/85 - temporary change - add three lines
      jx4 = 0
      cc(jx4)=1
      ic(ix8)=1
      c(ix9)=1
c
      call CONTIM(c,ic(ix1),c(ix3),ic(ix5),cc(jx1),cc(jx2),cc(j5),ic(i1)
     1,c(i2),cc(jx4),ic(ix8),c(ix9))
      nvar=nvar-1
      return
  305 i=max0(j5-4,1)+ix5
      call ERRWRT(0,c(i),8,0,0,v)
  310 ierror=2
      go to 350
  320 ierror=3
      go to 350
  330 ierror=4
  350 call ERRCHK(ierror,0)
  360 stop
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   CONTIM        (SECOND KEY SUBROUTINE IN CONTIM)
C   Controls iteration and estimation of CONTIM Models.
c   Calls the following subroutines:
c   LAGUER  STARS  RESTRN  CPRINT  RESCS  CKTIME  FCTGR  STEDE  SECDRS
C   FLEPOW  PRINTC  PRINTB  PUNCHA  ERRCHK  AMOEBA
c
c   This subroutine is called by the following subroutines:
C   CONTRL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine CONTIM(vnam,ic,xdata,num,x,xx,r,iii,abr,rn,iin,abn)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),x(1),f,f1,trial1,fact,aaa,bb,epsg,epsp,epsf
     1,pr,r(1),gamm,xh,wh,rn(1)
      dimension ic(1),xdata(1),vnam(1),num(1),iii(1),abr(1),abn(1),
     1iin(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /a/ sec,tim1,tim2,dum
      common /b/ ip,a1(7),kcore,a9(31),lwi,dumb(3)
      common /c/ iscal,ipun,jc,icon,lt,ivcb,icons,nfun,a3(4),jres,idep,
     1istan,ir,istar,a8(10),kgamm,a0(4),ix0,ix2,ix4,dumc(5)
      common /c5/ gamm
      common /d/ npar,a2(4),nbar,ntxz,a4(3),mm,my,ny,l1,dumd(10)
      common /e/ xh(15),wh(15),dume(6)
      common /f/ a7(8),trial1,fact,aaa,bb,maxtry,iter,pr,epsg,epsp,epsf,
     1maxite,dumf(9)
c-------------------BEGINNING OF SUBROUTINE------------------------------
c   Call LAGUER initialization
      if(nfun.eq.0) go to 10
      call LAGUER(mm)
      do 5 i=1,mm
    5 wh(i)=dlog(wh(i))+(gamm-1.d0)*dlog(xh(i))
c   Set array dimensions and parameter # (l1) for run
   10 l1=npar
      i0=l1+1
      i1=l1*(l1+1)/2+i0
      i2=i1+l1
      i3=i2+l1
      i4=i3+l1
      i5=i4+l1
      i6=i5*2+1
c   Set maxcor
      maxcor=i6
      if(maxcor.gt.kcore) go to 70
      ind=0
      if(jc.eq.5) go to 48
c   Set Starting Values
      if(istar.eq.1) call STARS(x,xx(i1),xx(i0),xdata,ic(ix4),ic(ix2),
     1ic,ic(ix0),xx(i3),ind)
      if(ind.gt.0) go to 80
      if(ir.gt.0) call RESTRN(x,xx,xx,r,iii,0)
      call CPRINT(18)
      if(lwi.eq.0) write(ip,15) (x(i),i=1,l1)
   15 format(6x,10g12.5)
      if(lwi.eq.1) write(ip,20) (x(i),i=1,l1)
   20 format(1x,7g11.4)
c   Set scaling
      if(iscal.eq.0) call RESCS(xx,x,xx(i0),xdata,ic(ix2),ic,ic(ix0),
     1r,iii,rn,iin,xx(i1),0)
      f=0.d0
c   Set parameters for fletcher-powell.
      pr=.05d0
      maxtry=10
      iter=0
      trial1=.1d0
      fact=.1d0
      aaa=2.d0
      bb=.75d0
c   Initialize timer to zero
      call CKTIME(ind3,0)
      ind1=-1
      ind2=-1
      ind3=-1
      ind4=-1
      if(jc.eq.4) go to 26
c************************
      if(jc.lt.8.or.jc.gt.9) go to 264
c   Call AMOEBA which executes Downhill Simplex Iterations
      call AMOEBA(l1,x,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,
     1xdata,joe,r,iii,rn,iin,xx(i5),xx,iscal,ind1)
      go to 25
 264  continue
c************************
c   Call function/gradient routine
      call FCTGR(x,f,xx(i1),xdata,ic,r,iii,rn,iin,xx(i5),ind1)
      if(ind1.eq.1.or.maxite.eq.0.or.jc.ge.2) go to 25
c   Call STEDE which executes steepest descent iterations
      call STEDE(l1,x,xx(i2),xx(i1),xx(i3),xx(i4),f,lt,xdata,ic,r,iii,
     1rn,iin,xx(i5),xx,iscal,ind1)
      if((ind1.ne.1.and.ind1.ne.6).or.jc.eq.1) go to 26
   25 if(ind1.eq.1.or.maxite.eq.0) ind2=-2
c************************
       if(jc.eq.8) go to 26
c************************
c   Calculate information matrix and invert it.
      call SECDRS(xx(i0),x,xx(i2),xdata,ic,r,iii,rn,iin,xx(i5),1,ind2)
   26 f1=f
      iter1=iter
      tim2=tim1
      if(maxite.eq.0) ind1=6
      if(ind1.ne.1.and.ind1.ne.6.and.jc.lt.2) go to 27
c********************
      if(jc.eq.4.or.jc.eq.1.or.jc.eq.8) go to 30
c********************
      if((jc.eq.2.or.jc.eq.3).and.ind1.eq.0) ind1=-1
c   Stop if problems or convergence in STEDE
      if(ind1.eq.1) ind=12
      if(ind1.ge.0.and.ind1.ne.6) go to 27
      ind1=4
      ind3=0
c********************
      if(jc.eq.1) go to 249
c************************
c   Call FLEPOW which executes fletcher-powell iterations
      call FLEPOW(l1,x,xx(i2),xx(i1),xx(i3),xx(i4),xx(i0),f,lt,xdata,ic,
     1r,iii,rn,iin,xx(i5),xx,iscal,ind3)
 249  iter=iter-iter1
      if(ind3.eq.1) ind=13
   27 if(lwi.eq.0.and.((ind3.lt.0.and.ind1.ne.0).or.ind3.gt.0)) write(ip
     1,28) (xx(i1+i-1),i=1,l1)
   28 format(/40x,'Values of First Derivatives When Iterations Terminate
     1d',/(6x,10g12.5))
      if(lwi.eq.1.and.((ind3.lt.0.and.ind1.ne.0).or.ind3.gt.0)) write(ip
     1,29) (xx(i1+i-1),i=1,l1)
   29 format(/9x,'Values of First Derivatives When Iterations Terminated
     1',/(1x,6g12.5))
c   Compute second derivatives for Standard Errors
   30 call SECDRS(xx(i0),x,xx(i2),xdata,ic,r,iii,rn,iin,xx(i5),0,ind4)
c   Reset coefficients if scaled
      if(iscal.eq.0) call RESCS(xx,x,xx(i0),xdata,ic(ix2),ic,ic(ix0),
     1r,iii,rn,iin,xx(i1),1)
c   Print coefficients
      call PRINTC(x,xx(i0),ind1,ind2,ind3,ind4,f,f1,iter,iter1,num,vnam,
     1abr,ic(ix4),ic,ic(ix0),abn,maxcor)
      if(ind.eq.0.and.ind4.eq.1) ind=11
c   Print covariance matrix
      if(ivcb.eq.1.and.ind.eq.0) call PRINTB(xx(i0),l1,0,istan)
      if(ipun.ne.0) call PUNCHA(x,l1,xx,1,xx)
   48 if(ind.gt.0) go to 80
      return
   70 maxcor=maxcor-kcore
      ind=8
   80 call ERRCHK(ind,maxcor)
      if(ind.gt.8) return
      stop
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   COMPUT        (SUBROUTINE OF CONTIM)
c   Computes likelihood function and derivatives for CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   MOVING  ARLING  YCALC  RECALC  MULTIP  HECALC  DISCRT  
c
c   This subroutine is called by the following subroutines:
C   FCTGR  CONTIM  SECDRS  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine COMPUT(b,f,g,s,xdata,mic,mid,mco,mci,f1,f2,by,u,u1,v,
     1rn,iin,jjn,stor,jnd,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension xdata(jb,kobs),mic(nsta,nsta),mid(nsta,nfre),
     1mco(ncar,nfre),mci(nint,nfre),jjn(1),iin(1)
      double precision g(1),s(1),u(1),u1(1),v(1),b(1),f2(1),h,f1(1),f,
     1vrs,wt,by(2,nfre,15),gy(15),xh,wh,rn(1),stor(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c2/ vrs
      common /c/ a1(7),nfun,nsta,nfre,nwei,ibgn,a2(13),iwt,kvrs,a3(3),
     *nl,dumc(9)
      common /d/ npar,npin,jb,kobs,ncas,nbar,nx,la,ny,mobs,mm,a4(4),
     1ncar,nint,ifail,iqz,inz,iout,idis,dumd(2)
      common /e/ xh(15),wh(15),dume(6)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      wt=1.d0
      if(nfun.eq.0) go to 7
      do 5 i=1,mm
      l=0
      do 5 j=1,nfre
      l=l+mci(1,j)
      by(1,j,i)=xh(i)*b(l)
    5 by(2,j,i)=dexp(by(1,j,i))
    7 mcas=0
      mvap=ncas
      if(iqz.eq.1) mvap=mobs
      do 200 i1=1,mvap
      if(iqz-1) 8,10,12
    8 mspl=xdata(1+nbar,mcas+1)
      icas=mcas
      go to 16
   10 mspl=1
      read(inz) (xdata(i,1),i=1,jb)
      if(xdata(nbar+1,1).eq.0..or.jnd.ne.2.or.la.eq.1) go to 15
      if(la.gt.1) call MOVING(stor,g,s,la,lc,npar,1)
      if(i1.gt.1.and.la.eq.0) call ARLING(s,g,npar,0)
      go to 15
   12 read(inz) (xdata(i,1),i=1,jb)
      mspl=xdata(1+nbar,1)
      if(mspl.eq.1) go to 15
      do 14 icas=2,mspl
   14 read(inz) (xdata(i,icas),i=1,jb)
   15 icas=0
c   Branch for discrete models
   16 if(idis.ge.1) go to 120
c   Branch for heterogeneity
      if(nfun.gt.0) go to 30
      do 25 i=1,mspl
      icas=icas+1
      jsta=ifix(xdata(3+nbar,icas))
      ksta=ifix(xdata(2+nbar,icas))
      icount=xdata(4+nbar,icas)
      if(nwei.gt.0) ibefor=xdata(5+nbar,icas)
      if(iwt.gt.0) wt=dble(xdata(jb,icas))
c   Loop over Transit probabilities
      lstr=1
      do 20 j=1,nfre
      if(mid(ksta,j).eq.0) go to 20
c   Calculate x'b
      call YCALC(h,xdata(1,icas),b(lstr),mco(1,j),mco(2,j),i1,i,ind)
      if(ind.gt.0) return
      id=0
      if(ksta.ne.jsta.and.mic(ksta,jsta).eq.j) id=1
      if(id.eq.1.and.ibgn.eq.1) id=2
c   Compute function/gradient
      call RECALC(f,g(lstr),s,h,b(lstr),xdata(1,icas),icount,ibefor,lstr
     1,mid(ksta,j),wt,id,mco(1,j),mco(2,j),mci(3,j),mci(2,j),jnd,i1,i,
     2ind)
      if(ind.gt.0) return
   20 lstr=lstr+mci(1,j)
      if(jnd.eq.1.or.(jnd.eq.2.and.(la.eq.1.or.(la.eq.0.and.iqz.ne.1.and
     1.i.eq.mspl)))) call ARLING(s,g,npar,0)
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,npar,2)
   25 continue
      go to 190
   30 do 40 i=1,nfre
      f1(i)=0.d0
   40 f2(i)=0.d0
      if(jnd.lt.3) go to 50
      call MULTIP(u1,v,v,v,v,npar,npar,1)
   50 do 55 i=1,npar
      u1(i)=0.d0
   55 u(i)=0.d0
      do 60 i=1,mspl
      icas=icas+1
      jsta=ifix(xdata(3+nbar,icas))
      ksta=ifix(xdata(2+nbar,icas))
      icount=xdata(4+nbar,icas)
      if(nwei.gt.0) ibefor=xdata(5+nbar,icas)
      if(iwt.gt.0) wt=dble(xdata(jb,icas))
c   Loop over Transit probabilities
      lstr=1
      do 60 j=1,nfre
      if(mid(ksta,j).eq.0) go to 60
c   Calculate x'b
      call YCALC(h,xdata(1,icas),b(lstr),mco(1,j),mco(2,j),i1,i,ind)
      if(ind.gt.0) return
      id=0
      if(ksta.ne.jsta.and.mic(ksta,jsta).eq.j) id=1
      f1(j)=f1(j)+dble(id)*wt
      if(id.eq.1.and.ibgn.eq.1) id=2
c   Compute function/gradient
c   Change made by Jacob Klerman 10/6/85
c   Call HECALC(f,g(lstr),s,f2(j),u(lstr),v,h,b(lstr),xdata(1,icas),
c    1icount,ibefor,lstr,mid(ksta,j),wt,id,mco(1,j),mco(2,j),mci(3,j),
c    2jnd)
      call HECALC(f,g(lstr),s,f2(j),u(lstr),v,h,b(lstr),xdata(1,icas),
     *icount,ibefor,lstr,mid(ksta,j),wt,id,mco(1,j),mco(2,j),mci(3,j),
     *mci(2,j),jnd)
   60 lstr=lstr+mci(1,j)
      h=0.d0
      do 75 i=1,mm
      gy(i)=wh(i)
      do 70 j=1,nfre
   70 gy(i)=gy(i)+f1(j)*by(1,j,i)+f2(j)*by(2,j,i)
   75 h=h+dexp(gy(i))
      f=f-dlog(h)
      do 85 i=1,mm
      lstr=0
      do 85 j=1,nfre
      jsta=mci(1,j)-1
      do 80 l=1,jsta
c   Set factor loading derivative
      g(lstr+jsta+1)=g(lstr+jsta+1)+gy(i)*xh(i)*(f1(j)+by(2,j,i)*f2(j))/
     1h
c   Set other derivatives
   80 g(lstr+l)=g(lstr+l)+gy(i)*u(lstr+l)*by(2,j,i)/h
   85 lstr=lstr+mci(1,j)
      if(jnd.eq.1) call ARLING(s,g,npar,0)
      if(jnd.lt.3) go to 190
c***** 2nd derivatives
      go to 190
  120 do 135 i=1,mspl
      icas=icas+1
      if(iwt.gt.0) wt=dble(xdata(jb,icas))
      if(idis.eq.5) go to 127
      if(idis.ge.3) go to 125
      jsta=ifix(xdata(3+nbar,icas))
      ksta=ifix(xdata(2+nbar,icas))
      icount=xdata(4+nbar,icas)
      go to 130
  125 jsta=nsta
      if(idis.eq.3) ksta=ifix(xdata(2+nbar,icas))
      if(ibgn.eq.1) jsta=ifix(xdata(6-idis+nbar,icas))
      go to 130
  127 jsta=ifix(xdata(2+nbar,icas))
      icount=1
      if(ibgn.eq.1) icount=xdata(3+nbar,icas)
  130 call DISCRT(f,g,s,b,xdata(1,icas),f2,f1,ksta,jsta,mic,mid,mco,mci,
     1rn,iin,jjn,icount,wt,jnd,i1,i,ind)
      if(jnd.eq.1.or.(jnd.eq.2.and.(la.eq.1.or.(la.eq.0.and.iqz.ne.1.and
     1.i.eq.mspl)))) call ARLING(s,g,npar,0)
      if(jnd.eq.2.and.la.gt.1) call MOVING(stor,g,s,la,lc,npar,2)
  135 continue
  190 mcas=mcas+mspl
  200 continue
      if(iqz.gt.0) rewind inz
      if(nwei.ne.3.or.jnd.eq.0.or.jnd.eq.2) return
      lstr=0
      do 210 i=1,nfre
      l=(lstr+mco(1,i)+3)*(lstr+mco(1,i)+4)/2
      s(l)=1.d0
      l=(lstr+mco(1,i)+4)*(lstr+mco(1,i)+5)/2
      s(l)=1.d0
  210 lstr=lstr+mci(1,i)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DASORS        (SUBROUTINE OF CONTIM)
c   Selects observations for run.
c
c   This subroutine is called by the following subroutines:
C   CONTRL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DASORS(xbata,ndar,mic,mco,xdata,num,dd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision vrs,dd(nsta,nbar)
      dimension xdata(jb,1),xbata(idim,ndar),mic(nsta,nsta),num(1),
     1mco(ncar,nfre)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a9(2),int,iqv,nobs,nvar,ntime,kcore,idim,a2(25),
     1mi2,a0(2),mtime,jobs,lwi,dum(3)
      common /c2/ vrs
      common /c/ iscal,a1(7),nsta,nfre,nwei,ibgn,jres,lv0,a6(3),it1,
     1it2,iu1,iu2,iu3,iu4,iu5,vr,iwt,kvrs,a3(3),nl,dumc(9)
      common /d/ a4(2),jb,kobs,ncas,nbar,a8(3),mobs,a7(5),ncar,nint,
     1ifail,iqz,inz,iout,idis,dumd(2)
      common /f/ lv1,lv2,vr1,lv3,lv4,lv5,kdata,dumf(29)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      kobs=1
      vrs=0.d0
      icount=iabs(lv4)
      ncas=0
      mabc=0
      nabc=0
      mobs=0
      l2=1
      l4=0
      l3=100000
      ista=0
   10 msta=0
   20 mabc=mabc+1
      if(mabc.gt.jobs) go to 110
      if(iqv.ge.1) go to 29
      l2=mabc
      go to 32
   29 read(int) (xbata(1,i),i=1,ndar)
   32 if(mtime.gt.0) go to 34
      l3=l3+1
      if(l3.le.ntime) go to 42
      l3=1
      go to 36
   34 l=ifix(xbata(l2,mtime))
      if(l.gt.l3) go to 40
   36 if(ista.eq.0) go to 39
      if(iqz.ne.1) xdata(1+nbar,jabc)=ista
      ncas=ncas+1
      if(iqz.le.1) go to 39
      do 38 i=1,ista
      if(iscal.eq.1.or.nl.gt.0) go to 38
      if(idis.le.2) l=xdata(2+nbar,i)
      if(idis.ge.3) l=1
      do 37 nabc=1,nbar
      if(dd(l,nabc).ne.0.) xdata(nabc,l)=xdata(nabc,l)*dd(l,nabc)
   37 continue
   38 write(inz) (xdata(l,i),l=1,jb)
      nabc=0
      kobs=max0(kobs,ista)
   39 jabc=nabc+1
      ista=0
      labc=0
      msta=0
      l4=l4+1
   40 if(mtime.gt.0) l3=iabs(l)
c   Bypass observation if not used
   42 if(iu1.eq.0) go to 44
      wx=vr
      if(iu3.gt.0) wx=xbata(l2,iu3)
      if(IOBS(xbata(l2,iu2),wx,iu1).eq.0) go to 10
   44 if((iu4.le.iu5.and.(l4.lt.iu4.or.l4.gt.iu5)).or.(iu4.gt.iu5.and.l4
     1.ge.iu5.and.l4.lt.iu4)) go to 10
      if((it1.le.it2.and.(l3.lt.it1.or.l3.gt.it2)).or.(it1.gt.it2.and.l3
     1.ge.it2.and.l3.lt.it1)) go to 10
      if(iwt.gt.0.and.xbata(l2,iwt).le.0.) go to 10
      if(mi2-1) 53,50,46
c   Check for missing variables
   46 do 48 i=1,nbar
      l=num(i)
      if(l.eq.nvar) go to 48
      if(MISS(xbata(l2,l)).ne.0) go to 10
   48 continue
      if(lv0.gt.0.and.MISS(xbata(l2,lv0)).ne.0) go to 10
      if(lv3.gt.0.and.MISS(xbata(l2,lv3)).ne.0) go to 10
      if(lv4.gt.0.and.MISS(xbata(l2,lv4)).ne.0) go to 10
      if(lv5.gt.0.and.MISS(xbata(l2,lv5)).ne.0) go to 10
      if(iwt.gt.0.and.MISS(xbata(l2,iwt)).ne.0) go to 10
      go to 53
   50 do 52 i=1,ndar
      if(MISS(xbata(l2,i)).ne.0) go to 10
   52 continue
   53 if(labc.eq.1) go to 10
      ista=ista+1
      if(idis.ge.3) go to 57
      ksta=1
      if(lv2.eq.0) ksta=ifix(xbata(l2,lv0))
      if(lv2.lt.0) ksta=-lv2
      jsta=1
      if(lv3.gt.0.and.lv2.le.0) jsta=ifix(xbata(l2,lv3))
      wx=vr1
      if(lv3.gt.0) wx=xbata(l2,lv3)
      if(lv2.gt.0) jsta=1+IOBS(xbata(l2,lv0),wx,lv2)
      if(lv4.gt.0) icount=ifix(xbata(l2,lv4))
      mic(ksta,jsta)=mic(ksta,jsta)+icount
      if(msta.ne.ksta) jefor=0
      if(lv5.gt.0) ibefor=xbata(l2,lv5)
      if(lv5.eq.0) ibefor=jefor
      if(nwei.gt.0) jefor=jefor+icount
      if(msta.ne.ksta.or.ibefor.ne.ifix(xdata(4+nbar,nabc)).or.(ibgn.eq.
     11.and.ksta.ne.jsta)) go to 75
      do 55 i=1,nbar
      l=num(i)
      if(l.eq.nvar) go to 55
      if(xbata(l2,l).ne.xdata(i,nabc)) go to 75
   55 continue
      ista=ista-1
      xdata(3+nbar,nabc)=jsta
      xdata(4+nbar,nabc)=xdata(4+nbar,nabc)+icount
      go to 100
   57 nabc=nabc+1
      mobs=mobs+1
      if(iqz.ne.1) go to 64
      xdata(1+nbar,1)=ista
      if(iscal.eq.1.or.mobs.eq.1.or.nl.gt.0) go to 63
      do 62 nabc=1,nbar
      if(dd(1,nabc).ne.0.) xdata(nabc,1)=xdata(nabc,1)*dd(1,nabc)
   62 continue
   63 if(mobs.ne.1) write(inz) (xdata(l,1),l=1,jb)
      nabc=1
   64 xdata(1+nbar,nabc)=0.
      go to (100,100,68,72,71,68,68,67,67),idis
   67 ksta=1
      if(lv4.gt.0) ksta=ifix(xbata(l2,lv4))
      go to 69
   68 ksta=ifix(xbata(l2,lv4))
   69 if(ksta.le.0.or.ksta.gt.nsta) go to 150
      if(lv3.gt.0.and.ifix(xbata(l2,lv3)).gt.nsta) go to 150
      xdata(2+nbar,nabc)=ksta
      mic(1,ksta)=mic(1,ksta)+1
      if(lv3.gt.0) xdata(3+nbar,nabc)=ifix(xbata(l2,lv3))
      go to 86
   71 ksta=ifix(xbata(l2,lv0))
      if(ksta.lt.0.or.(lv3.gt.0.and.xbata(l2,lv3).lt.0.)) go to 150
      xdata(2+nbar,nabc)=ksta
      if(lv3.gt.0) xdata(3+nbar,nabc)=ifix(xbata(l2,lv3))
      go to 86
   72 if(lv3.gt.0) xdata(2+nbar,nabc)=ifix(xbata(l2,lv3))
      if(kdata.eq.1) go to 86
      ksta=ifix(xbata(l2,lv4))
      if(ksta.le.0.or.ksta.gt.nsta) go to 150
      mic(1,ksta)=mic(1,ksta)+1
      j=0
      do 74 l=1,ncar
      do 73 i=1,nfre
      if(l.eq.1.or.i.eq.ksta) go to 74
      j=j+1
      i1=mco(l,ksta)
      i2=mco(l,i)
      i1=num(i1)
      i2=num(i2)
      if(i1.eq.nvar.or.i2.eq.nvar) go to 73
      xdata(j,nabc)=xbata(l2,i2)-xbata(l2,i1)
      go to 74
   73 if(i1.eq.nvar.and.i2.eq.nvar) xdata(j,nabc)=0.
      if(i1.eq.nvar.and.i2.ne.nvar) xdata(j,nabc)=xbata(l2,i2)-1.
      if(i1.ne.nvar.and.i2.eq.nvar) xdata(j,nabc)=1.-xbata(l2,i1)
   74 continue
      go to 94
   75 nabc=nabc+1
      mobs=mobs+1
      if(iqz.ne.1) go to 83
      xdata(1+nbar,1)=ista
      if(iscal.eq.1.or.mobs.eq.1.or.nl.gt.0) go to 81
      l=xdata(2+nbar,1)
      do 80 nabc=1,nbar
      if(dd(l,nabc).ne.0.) xdata(nabc,1)=xdata(nabc,1)*dd(l,nabc)
   80 continue
   81 if(mobs.ne.1) write(inz) (xdata(l,1),l=1,jb)
      nabc=1
   83 xdata(1+nbar,nabc)=0.
      if(nwei.gt.0) xdata(5+nbar,nabc)=ibefor
      xdata(2+nbar,nabc)=ksta
      xdata(3+nbar,nabc)=jsta
      xdata(4+nbar,nabc)=icount
   86 do 92 i=1,nbar
      l=num(i)
      if(l.eq.nvar) go to 88
      xdata(i,nabc)=xbata(l2,l)
      go to 92
   88 xdata(i,nabc)=1.
   92 continue
   94 if(iwt.gt.0) xdata(jb,nabc)=xbata(l2,iwt)
      if(iwt.gt.0) vrs=vrs+dble(xdata(jb,nabc))
  100 if(idis.ge.3) go to 20
      if(ifail.gt.0.and.ksta.ne.jsta) labc=1
      msta=0
      if(ksta.eq.jsta) msta=ksta
      go to 20
  110 if(ista.eq.0) go to 119
      if(iqz.eq.1) jabc=1
      xdata(1+nbar,jabc)=ista
      ncas=ncas+1
      if(iqz.eq.0.or.nl.gt.0) go to 121
      i1=ista
      if(iqz.eq.1) i1=1
      do 117 i=1,i1
      if(iscal.eq.1) go to 117
      if(idis.le.2) l=xdata(2+nbar,i)
      if(idis.ge.3) l=1
      do 115 nabc=1,nbar
      if(dd(l,nabc).ne.0.) xdata(nabc,i)=xdata(nabc,i)*dd(l,nabc)
  115 continue
  117 write(inz) (xdata(l,i),l=1,jb)
      if(iqz.eq.2) kobs=max0(kobs,ista)
  119 if(iqz.gt.0) end file inz
      if(iqz.gt.0) rewind inz
  121 if(iqz.eq.0) kobs=mobs
      if(iqv.gt.0) rewind int
      if(lwi.eq.0) write(ip,125) ncas,mobs
  125 format(/39x,'Run Data for',i9,' Cross-Sections and',i6,' Spells')
      if(lwi.eq.1) write(ip,127) ncas,mobs
  127 format(/13x,'Run Data for',i9,' Cross-Sections and',i6,' Spells')
      if(idis.eq.5.or.(idis.eq.4.and.kdata.eq.1)) return
      if(idis.ge.3) go to 137
      if(lwi.eq.0) write(ip,129) (i,i=1,nsta)
  129 format(/39x,'Start',10x,'End State',/39x,'State',8i6,/,(44x,8i6))
      if(lwi.eq.1) write(ip,130) (i,i=1,nsta)
  130 format(/13x,'Start',10x,'End State',/13x,'State',8i6,/,(18x,8i6))
      do 135 i=1,nsta
      if(lwi.eq.0) write(ip,132) i,(mic(i,j),j=1,nsta)
  132 format(/39x,i5,8i6,/,(44x,8i6))
      if(lwi.eq.1) write(ip,133) i,(mic(i,j),j=1,nsta)
  133 format(/13x,i5,8i6,/,(18x,8i6))
  135 continue
      return
  137 if(lwi.eq.0) write(ip,138) (i,i=1,nsta)
  138 format(/39x,'Choice Selection ',6i6,/,(56x,6i6))
      if(lwi.eq.1) write(ip,139) (i,i=1,nsta)
  139 format(/13x,'Choice Selection ',6i6,/,(30x,6i6))
      if(lwi.eq.0) write(ip,142) (mic(1,j),j=1,nsta)
  142 format(/39x,'Number',11x,6i6,/,(56x,6i6))
      if(lwi.eq.1) write(ip,143) (mic(1,j),j=1,nsta)
  143 format(/13x,'Number',11x,6i6,/,(30x,6i6))
      if(idis.ne.4) return
      j=0
      do 145 i=1,nfre
      mco(1,i)=ncar-1
      do 145 l=2,ncar
      j=j+1
  145 mco(l,i)=j
      return
  150 if(lwi.eq.0) write(ip,155) mabc
  155 format(/41x,'Error in File Setup on Observation',i6,' Run End')
      if(lwi.eq.1) write(ip,160) mabc
  160 format(/1x,'Error in File Setup on Observation',i6,' Run End')
      stop
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   DISCRT        (SUBROUTINE OF CONTIM)
c   Computes gradient/hessian for conditiona and multinomial logit 
c   Models and poisson regression model.
c
c   This subroutine calls the following subroutines:
c   YCALC  ERRWRT  FIRSUM  SECSUM  
c
c   This subroutine is called by the following subroutines:
C   COMPUT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine DISCRT(f,g,v,b,z,vv,be,ksta,jsta,mic,mid,mco,mci,
     1rn,iin,jjn,icount,wt,jnd,iobv,itim,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision f,g(1),v(1),b(1),vv(1),be(1),emax,wt,cu,bx,cx,dx,
     1gx,fu,fl,pu,pl,uu,ul,fmax,rn(1)
      dimension z(1),mco(ncar,nfre),mci(nint,nfre),mic(nsta,nsta),
     1mid(nsta,nfre),iin(1),jjn(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a1(8),nsta,nfre,a5(20),nl,dum(9)
      common /d/ a2(15),ncar,nint,ifail,a3(2),iout,idis,dumd(2)
      common /f/ a4(32),emax,fmax
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(idis-3) 110,25,60
c   Multinomial logit   idis = 3
   25 be(1)=0.d0
      cu=0.d0
      j2=1
      do 30 j1=2,jsta
      call YCALC(be(j1),z,b(j2),mco(1,j1),mco(2,j1),iobv,itim,ind)
      if(ind.gt.0) return
      if(ifail.eq.1) be(1)=be(1)-be(j1)
      be(j1)=dexp(be(j1))
      j2=j2+mci(1,j1)
   30 cu=cu+be(j1)
c   Change made by Jacob Klerman 10/6/85 - remove 3 lines
c*****
c   If(obsv.le.2) write(6,1234) jsta,ksta,nfre,ifail,(be(j1),
c    1j1=1,jsta),(b(j1),j1=1,6),cu
c1234 format(' jsta/ksta/nfre/ifail/be(4),b(6),cu',4i6,/4g12.5,/7g12.5)
      if(dabs(be(1)).lt.emax) go to 35
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,be(1))
      be(1)=(be(1)/dabs(be(1)))*(emax-1.d0)
      if(iout.gt.0) go to 35
   32 ind=1
      return
   35 be(1)=dexp(be(1))
      cu=cu+be(1)
      if(jnd.le.1) f=f-wt*(dlog(be(ksta))-dlog(cu))
      j2=1
      do 40 j1=2,jsta
      bx=-wt*be(j1)/cu
      if(ifail.eq.1) bx=bx+wt*be(1)/cu
      if(ifail.eq.1.and.ksta.eq.1) bx=bx-wt
      if(j1.eq.ksta) bx=bx+wt
      call FIRSUM(g(j2),bx,z,mco(1,j1),0,mco(2,j1),mco,0,0,0)
   40 j2=j2+mco(1,j1)
      if(jnd.le.2) return
      l=0
      do 55 j1=2,jsta
      j3=0
      do 50 j4=2,j1
      if(ifail.eq.1) go to 42
      bx=-wt*(be(j1)/cu)*(be(j4)/cu)
      if(j1.eq.j4) bx=bx+wt*be(j1)/cu
      go to 43
   42 if(j1.ne.j4) bx=wt*(be(1)*be(j4)/cu-((be(j1)-be(1))/cu)*((be(j4)-b
     1e(1))/cu))
      if(j1.eq.j4) bx=wt*((be(j1)+be(1))*be(j1)/cu-((be(j1)-be(1))/cu)**
     12)
   43 nzar=mco(1,j1)
      do 45 j=1,nzar
      j5=mco(1,j4)
      if(j1.eq.j4) j5=j
      j2=(l+j)*(l+j-1)/2+j3
      do 45 j6=1,j5
      i1=mco(j+1,j1)
      i2=mco(j6+1,j4)
      j2=j2+1
   45 v(j2)=v(j2)+bx*dble(z(i1))*dble(z(i2))
   50 j3=j3+mco(1,j4)
   55 l=l+mco(1,j1)
      return
   60 nzar=mco(1,1)
      if(idis-5) 62,190,210
c   Conditional logit
   62 if(jnd.le.2) go to 70
      do 65 j=1,nzar
   65 vv(j)=0.d0
   70 cu=1.d0
      do 85 j1=2,jsta
      call YCALC(be(j1),z,b,mco(1,j1),mco(2,j1),iobv,itim,ind)
      if(ind.gt.0) return
      be(j1)=dexp(be(j1))
      if(jnd.le.2) go to 85
      do 80 j=1,nzar
      l=mco(j+1,j1)
   80 vv(j)=vv(j)+be(j1)*dble(z(l))
   85 cu=cu+be(j1)
c   Change made by Jacob Klerman 10/6/85 - remove 2 lines
c*****
c   If(obsv.le.2) write(6,1234) jsta,ksta,nfre,ifail,(be(j1),
c    1j1=1,jsta),(b(j1),j1=1,1),(z(j1),j1=1,5),cu
      if(jnd.le.1) f=f+wt*dlog(cu)
      j2=0
      do 90 j1=2,jsta
      bx=-wt*be(j1)/cu
   90 call FIRSUM(g,bx,z,nzar,0,mco(2,j1),mco,0,0,0)
      if(jnd.le.2) return
      j2=0
      do 100 j=1,nzar
      do 100 j1=1,j
      bx=0.d0
      do 95 j4=2,jsta
      i1=mco(j+1,j4)
      i2=mco(j1+1,j4)
   95 bx=bx+be(j4)*dble(z(i1))*dble(z(i2))
      j2=j2+1
  100 v(j2)=v(j2)+wt*(bx-vv(j)*vv(j1)/cu)/cu
      return
c   Log-linear and double exponential  idis = ?
  110 if(icount.eq.1.and.ksta.ne.jsta) go to 160
      l=icount
      if(ksta.ne.jsta) l=icount-1
      i1=1
      cu=0.d0
      do 115 j=1,nfre
      if(mid(ksta,j).eq.0) go to 115
      call YCALC(be(j),z,b(i1),mco(1,j),mco(2,j),iobv,itim,ind)
      if(ind.gt.0) return
      if(idis.eq.1) go to 112
      bx=-dexp(be(j))
      if(mic(ksta,jsta).eq.j) gx=bx
      if(jnd.ge.2) vv(j)=bx
      if(dabs(be(j)).lt.emax) go to 111
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,be(j))
      if(iout.eq.0) ind=1
      return
  111 be(j)=dexp(bx)
      cu=cu+be(j)*dble(mid(ksta,j))
      be(j)=be(j)*bx
      go to 115
  112 if(mic(ksta,jsta).eq.j) gx=be(j)
      be(j)=dexp(be(j))
      cu=cu+be(j)*dble(mid(ksta,j))
  115 i1=i1+mci(1,j)
      if(cu.gt.0..and.cu.lt.1.) go to 120
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,cu)
      if(iout.eq.0) ind=1
      return
  120 f=f-wt*dble(l)*dlog(1.d0-cu)
      bx=wt*dble(l)/(1.d0-cu)
      i1=1
      do 125 j=1,nfre
      if(mid(ksta,j).eq.0) go to 125
      cx=-be(j)*bx*dble(mid(ksta,j))
      call FIRSUM(g(i1),cx,z,mco(1,j),0,mco(2,j),mco,0,0,0)
  125 i1=i1+mco(1,j)
      if(jnd.le.2) go to 155
      i1=0
      do 150 j=1,nfre
      if(mid(ksta,j).eq.0) go to 150
      nzar=mco(1,j)
      cx=-be(j)*bx*dble(mid(ksta,j))
      do 145 i2=1,nzar
      j1=mco(i2+1,j)
      j4=(i1+i2)*(i1+i2-1)/2
      do 140 j2=1,j
      dx=-cx*be(j2)*dble(mid(ksta,j2))/(1.d0-cu)
      if(j.eq.j2) dx=dx-cx
      if(j.eq.j2.and.idis.eq.2) dx=dx-cx*vv(j2)
      j5=mco(1,j2)
      do 135 i3=1,j5
      if(j.eq.j2.and.i3.gt.i2) go to 145
      j3=mco(i3+1,j2)
  135 v(j4+i3)=v(j4+i3)+dx*dble(z(j3))*dble(z(j1))
  140 j4=j4+mci(1,j2)
  145 continue
  150 i1=i1+mci(1,j)
  155 if(ksta.eq.jsta) return
      l=mic(ksta,jsta)
      j1=mci(2,l)+1
      go to 170
  160 l=mic(ksta,jsta)
      j1=mci(2,l)+1
      call YCALC(gx,z,b(j1),mco(1,l),mco(2,l),iobv,itim,ind)
      if(ind.gt.0) return
      if(idis.eq.2) gx=-dexp(gx)
  170 if(gx.lt.0.) go to 175
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,gx)
      if(iout.eq.0) ind=1
      return
  175 f=f-gx
      cx=wt
      if(idis.eq.2) cx=cx*gx
      call FIRSUM(g(j1),cx,z,mco(1,l),0,mco(2,l),mco,0,0,0)
      if(jnd.le.2.or.idis.eq.1) return
      cx=-cx
      call SECSUM(v,cx,z,j1,mco(1,l),0,mco(2,l),mco,0,0,0)
      return
c   Poisson regression  idis = 5
  190 bx=dble(jsta)
      call YCALC(cu,z,b,mco(1,1),mco(2,1),iobv,itim,ind)
      if(ind.gt.0) return
      cu=cu+dlog(dble(icount))
      cx=dexp(cu)
      f=f-wt*(-cx+bx*cu)
      bx=wt*(bx-cx)
      call FIRSUM(g,bx,z,mco(1,1),0,mco(2,1),mco,0,0,0)
      if(jnd.le.2) return
      cx=cx*wt
      call SECSUM(v,cx,z,1,mco(1,1),0,mco(2,1),mco,0,0,0)
      return
  210 call YCALC(be,z,b,mco(1,1),mco(2,1),iobv,itim,ind)
      if(ind.gt.0) return
c   Idis=logit, idis=7 is probit, ksta is choice, jsta is max
      if(idis.eq.7) go to 255
      fl=0.d0
      fu=1.d0
      if(ksta.eq.1) go to 245
      fl=-be(1)
      if(ksta.gt.2) fl=b(nzar+ksta-2)-be(1)
      if(dabs(fl).lt.emax) go to 220
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,fl)
      fl=(fl/dabs(fl))*(emax-1.d0)
      if(iout.eq.0) go to 32
      return
  220 fl=1.d0/(1.d0+dexp(-fl))
  245 if(ksta.eq.jsta) go to 250
      fu=-be(1)
      if(ksta.gt.1) fu=b(nzar+ksta-1)-be(1)
      if(dabs(fu).lt.emax) go to 247
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,fu)
      fu=(fu/dabs(fu))*(emax-1.d0)
      if(iout.gt.0) go to 32
      return
  247 fu=1.d0/(1.d0+dexp(-fu))
c   Error on lower and upper
  250 if(fu-fl.le.0.) go to 32
      if(jnd.le.1) f=f-wt*dlog(fu-fl)
      be(2)=-wt*(1.d0-fu-fl)
      be(3)=-wt*fl*(1.d0-fl)/(fu-fl)
      be(4)=wt*fu*(1.d0-fu)/(fu-fl)
      call FIRSUM(g,be(2),z,mco(1,1),0,mco(2,1),mco,0,0,0)
      nzar=mco(1,1)
      if(ksta.gt.2) g(nzar+ksta-2)=g(nzar+ksta-2)-be(3)
      if(ksta.gt.1.and.ksta.lt.jsta) g(nzar+ksta-1)=g(nzar+ksta-1)-be(4)
      if(jnd.le.1) return
      uu=fu*(1.d0-fu)
      ul=fl*(1.d0-fl)
      be(5)=wt*(uu+ul)
      if(ksta.le.2) go to 252
      be(6)=wt*ul
      be(7)=-wt*ul*(1.d0-2.d0*fl-ul/(fu-fl))/(fu-fl)
  252 if(ksta.eq.1.or.ksta.eq.jsta) go to 295
      be(8)=wt*uu
      if(ksta.ne.2) be(9)=-wt*uu*ul/((fu-fl)**2)
      be(10)=-wt*uu*(1.d0-2.d0*fu-uu/(fu-fl))/(fu-fl)
      go to 295
  255 if(ksta.gt.2) go to 260
      ul=-be(1)
      if(ksta.eq.2) go to 265
      fl=0.d0
      pl=0.d0
      go to 270
  260 ul=b(nzar+ksta-2)-be(1)
  265 fl=FSTAT(ul,0.,0.,0.,7)
      if(dabs(ul).lt.fmax) go to 267
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,ul)
      ul=(ul/dabs(ul))*(fmax-1.d0)
      if(iout.eq.0) go to 32
      return
  267 pl=1.d0-FSTAT(ul,0.,0.,0.,3)
  270 if(ksta.gt.1.and.ksta.lt.jsta) go to 275
      uu=-be(1)
      if(ksta.eq.1) go to 280
      fu=0.d0
      pu=0.d0
      go to 285
  275 uu=b(nzar+ksta-1)-be(1)
  280 fu=FSTAT(uu,0.,0.,0.,7)
      if(dabs(uu).lt.fmax) go to 282
      if(iout.le.1) call ERRWRT(iobv,z,itim,1,1,uu)
      uu=(uu/dabs(uu))*(fmax-1.d0)
      if(iout.gt.0) go to 32
      return
  282 pu=1.d0-FSTAT(uu,0.,0.,0.,3)
  285 if(pu-pl.le.0.) go to 32
      if(jnd.le.1) f=f-wt*dlog(pu-pl)
      be(2)=wt*(fl-fu)/(pu-pl)
      be(3)=-wt*fl/(pu-pl)
      be(4)=wt*fu/(pu-pl)
      call FIRSUM(g,be(2),z,mco(1,1),0,mco(2,1),mco,0,0,0)
      nzar=mco(1,1)
      if(ksta.gt.2) g(nzar+ksta-2)=g(nzar+ksta-2)-be(3)
      if(ksta.gt.1.and.ksta.lt.jsta) g(nzar+ksta-1)=g(nzar+ksta-1)-be(4)
      if(jnd.le.1) return
      be(5)=-wt*((fl*ul-fu*uu)*(pu-pl)-(fl-fu)**2)/((pu-pl)**2)
      if(ksta.le.2) go to 287
      be(6)=wt*(-fl*ul*(pu-pl)+(fl-fu)*fl)/((pu-pl)**2)
      be(7)=-wt*(fl*ul*(pu-pl)-fl**2)/((pu-pl)**2)
  287 if(ksta.eq.1.or.ksta.eq.jsta) go to 295
      be(8)=wt*(fu*uu*(pu-pl)-(fl-fu)*fu)/((pu-pl)**2)
      if(ksta.ne.2) be(9)=-wt*fl*fu/((pu-pl)**2)
      be(10)=-wt*(-fu*uu*(pu-pl)-fu**2)/((pu-pl)**2)
c   Add here the code for 2nd derivatives
  295 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   FIRSUM        (SUBROUTINE OF CONTIM)
c   Sums first derivatives for CONTIM Models.
c
c   This subroutine is called by the following subroutines:
C   DISCRT  HECALC  RECALC  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine FIRSUM(u,uu,z,nzar,ntxz,mco,mci,nyar,inter,npin)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension z(1),mco(1),mci(1)
      double precision uu(1),u(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 20 i=1,nzar
      l=mco(i)
   20 u(i)=u(i)-dble(z(l))*uu(1)
      if(ntxz.eq.0) return
      do 30 i=1,ntxz
   30 u(nzar+i)=u(nzar+i)-uu(1+i)
      if(nyar.eq.0) return
      j=nzar+npin
      do 40 i=1,nyar
      l=mci(i)
      do 40 i1=1,inter
      j=j+1
   40 u(j)=u(j)-dble(z(l))*uu(1+i1)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   GRADIN        (SUBROUTINE OF CONTIM)
c   Adds in interaction effect in CONTIM Models.
c
c   This subroutine is called by the following subroutines:
C   HECALC  RECALC  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine GRADIN(gg,b,z,nzar,mci,nyar,inter,npin)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision b(1),gg(1)
      dimension mci(1),z(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      do 10 i=1,npin
   10 gg(i)=b(nzar+i)
      if(nyar.eq.0) return
      j=nzar+npin
      do 20 i=1,nyar
      l=mci(i)
      do 20 i1=1,inter
      j=j+1
   20 gg(i1)=gg(i1)+b(j)*dble(z(l))
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   HECALC      (SUBROUTINE OF CONTIM)
c   Computes h = hazard function for all months and heterogeneity in 
c   CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   GRADIN  TICALC  FIRSUM  SECSUM  
c
c   This subroutine is called by the following subroutines:
C   COMPUT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine HECALC(f,u,v,f1,u1,v1,as,b,z,icount,ibefor,lstr,jsum,
     1wt,id,nzar,mco,mci,nyar,jnd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision u(1),v(1),b(1),h,f1,f,as,uu(5),vv(15),
     1at,wt,u1(1),v1(1),gg(4)
      dimension z(1),mco(1),mci(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a1(10),nwei,a3(14),iwt,dumc(14)
      common /d/ npar,npin,a2(4),ntxz,a4(7),inter,dumd(9)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      jtxz=ntxz+1
      do 5 i=1,jtxz
    5 uu(i)=0.d0
      if(jnd.lt.3) go to 15
      j=jtxz*(jtxz+1)/2
      do 10 i=1,j
   10 vv(i)=0.d0
   15 at=dexp(as)
      if(nwei.eq.0) go to 30
      call GRADIN(gg,b,z,nzar,mci,nyar,inter,npin)
      h=0.d0
      call TICALC(uu,h,vv,icount,ibefor,jnd,nwei,jtxz,gg,0)
      go to 35
   30 h=dble(icount)
      uu(1)=dble(icount)
      vv(1)=dble(icount)
   35 h=-h*dble(jsum)*at
      do 40 i=1,jtxz
   40 uu(i)=-uu(i)*at*dble(jsum)
      if(jnd.lt.3) go to 50
      do 45 i=1,j
   45 vv(i)=vv(i)*at*dble(jsum)
   50 f1=f1+h*wt
      if(iwt.eq.0) go to 55
      do 52 i=1,jtxz
   52 uu(i)=uu(i)*wt
      if(jnd.lt.3) go to 55
      do 53 i=1,j
   53 vv(i)=vv(i)*wt
   55 call FIRSUM(u1,uu,z,nzar,ntxz,mco,mci,nyar,inter,npin)
      if(jnd.eq.3) call SECSUM(v1,vv,z,lstr,nzar,ntxz,mco,mci,nyar,inter
     1,npin)
      if(id.ne.1) return
      uu(1)=1.d0
      vv(1)=1.d0
      do 65 i=1,j
   65 vv(i)=0.d0
      if(nwei.gt.0) call TICALC(uu,h,vv,icount,ibefor,jnd,nwei,jtxz,
     1gg,1)
      f=f-as*wt
      if(iwt.eq.0) go to 95
      do 92 i=1,jtxz
   92 uu(i)=uu(i)*wt
      if(jnd.lt.3) go to 95
      do 93 i=1,j
   93 vv(i)=vv(i)*wt
   95 call FIRSUM(u,uu,z,nzar,ntxz,mco,mci,nyar,inter,npin)
      if(jnd.lt.3) return
      call SECSUM(v,vv,z,lstr,nzar,ntxz,mco,mci,nyar,inter,npin)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   LAGUER        (SUBROUTINE OF CONTIM)
c   Fills in weights and hermite points for leguerre integration.
c   xh are evaluation points (0 to inf.), wh are corresponding
c   weights. mm are the number of points desired.  Values from
c   "Handbook of Mathematical Functions", Abramowitz & Stegun, pp. 923.
c
c   This subroutine is called by the following subroutines:
C   CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine LAGUER(mm)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xh,wh
c-------------------------COMMON BLOCKS----------------------------------
      common /e/ xh(15),wh(15),dum(6)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(mm.lt.2) mm=2
      if(mm.gt.15) mm=15
      go to(20,30,40,50,60,70,80,90,100,100,120,120,120,150),mm
   20 xh(1)=0.585786437627
      wh(1)=8.53553390593d-1
      xh(2)=3.414213562373
      wh(2)=1.46446609407d-1
      return
   30 xh(1)=0.415774556783
      wh(1)=7.11093009929d-1
      xh(2)=2.294280360279
      wh(2)=2.78517733569d-1
      xh(3)=6.289945082937
      wh(3)=1.03892565016d-2
      return
   40 xh(1)=0.322547689619
      wh(1)=6.03154104342d-1
      xh(2)=1.745761101158
      wh(2)=3.57418692438d-1
      xh(3)=4.536620296921
      wh(3)=3.88879085150d-2
      xh(4)=9.395070912301
      wh(4)=5.39294705561d-4
      return
   50 xh(1)=0.263560319718
      wh(1)=5.21755610583d-1
      xh(2)=1.413403059107
      wh(2)=3.98666811083d-1
      xh(3)=3.596425771041
      wh(3)=7.59424496817d-2
      xh(4)=7.085810005859
      wh(4)=3.61175867992d-3
      xh(5)=12.640800844276
      wh(5)=2.33699723858d-5
      return
   60 xh(1)=0.222846604179
      wh(1)=4.58964673950d-1
      xh(2)=1.188932101673
      wh(2)=4.17000830772d-1
      xh(3)=2.992736326059
      wh(3)=1.13373382074d-1
      xh(4)=5.775143569105
      wh(4)=1.03991974531d-2
      xh(5)=9.837467418383
      wh(5)=2.61017202815d-4
      xh(6)=15.982873980602
      wh(6)=8.98547906430d-7
      return
   70 xh(1)=0.193043676560
      wh(1)=4.09318951701d-1
      xh(2)=1.026664895339
      wh(2)=4.21831277862d-1
      xh(3)=2.567876744951
      wh(3)=1.47126348658d-1
      xh(4)=4.900353084526
      wh(4)=2.06335144687d-2
      xh(5)=8.182153444563
      wh(5)=1.07401014328d-3
      xh(6)=12.734180291798
      wh(6)=1.58654643486d-5
      xh(7)=19.395727862263
      wh(7)=3.17031547900d-8
      return
   80 xh(1)=0.170279632305
      wh(1)=3.69188589342d-1
      xh(2)=0.903701776799
      wh(2)=4.18786780814d-1
      xh(3)=2.251086629866
      wh(3)=1.75794986637d-1
      xh(4)=4.266700170288
      wh(4)=3.33434922612d-2
      xh(5)=7.045905402393
      wh(5)=2.79453623523d-3
      xh(6)=10.758516010181
      wh(6)=9.07650877336d-5
      xh(7)=15.740678641278
      wh(7)=8.48574671627d-7
      xh(8)=22.863131736889
      wh(8)=1.04800117487d-9
      return
   90 xh(1)=0.152322227732
      wh(1)=3.36126421798d-1
      xh(2)=0.807220022742
      wh(2)=4.11213980424d-1
      xh(3)=2.005135155619
      wh(3)=1.99287525371d-1
      xh(4)=3.783473973331
      wh(4)=4.74605627657d-2
      xh(5)=6.204956777877
      wh(5)=5.59962661079d-3
      xh(6)=9.372985251688
      wh(6)=3.05249767093d-4
      xh(7)=13.466236911092
      wh(7)=6.59212302608d-6
      xh(8)=18.833597788992
      wh(8)=4.11076933035d-8
      xh(9)=26.374071890927
      wh(9)=3.29087403035d-11
      return
  100 xh(1)=0.137793470540
      wh(1)=3.08441115765d-1
      xh(2)=0.729454549503
      wh(2)=4.01119929155d-1
      xh(3)=1.808342901740
      wh(3)=2.18068287612d-1
      xh(4)=3.401433697855
      wh(4)=6.20874560987d-2
      xh(5)=5.552496140064
      wh(5)=9.50151697518d-3
      xh(6)=8.330152746764
      wh(6)=7.53008388588d-4
      xh(7)=11.843785837900
      wh(7)=2.82592334960d-5
      xh(8)=16.279257831378
      wh(8)=4.24931398498d-7
      xh(9)=21.996585811981
      wh(9)=1.83956482398d-9
      xh(10)=29.920697012274
      wh(10)=9.91182721961d-13
      mm=10
      return
  120 xh(1)=0.115722117358
      wh(1)=2.64731371055d-1
      xh(2)=0.611757484515
      wh(2)=3.77759275873d-1
      xh(3)=1.512610269776
      wh(3)=2.44082011320d-1
      xh(4)=2.833751337744
      wh(4)=9.04492222117d-2
      xh(5)=4.599227639418
      wh(5)=2.01023811546d-2
      xh(6)=6.844525453115
      wh(6)=2.66397354187d-3
      xh(7)=9.621316842457
      wh(7)=2.03231592663d-4
      xh(8)=13.006054993306
      wh(8)=8.36505585682d-6
      xh(9)=17.116855187462
      wh(9)=1.66849387654d-7
      xh(10)=22.151090379397
      wh(10)=1.34239103052d-9
      xh(11)=28.487967250984
      wh(11)=3.06160163504d-12
      xh(12)=37.099121044467
      wh(12)=8.14807746743d-16
      mm=12
      return
  150 xh(1)=0.093307812017
      wh(1)=2.18234885940d-1
      xh(2)=0.492691740302
      wh(2)=3.42210177923d-1
      xh(3)=1.215595412071
      wh(3)=2.63027577942d-1
      xh(4)=2.269949526204
      wh(4)=1.26425818106d-1
      xh(5)=3.667622721751
      wh(5)=4.02068649210d-2
      xh(6)=5.425336627414
      wh(6)=8.56387780361d-3
      xh(7)=7.565916226613
      wh(7)=1.21243614721d-3
      xh(8)=10.120228568019
      wh(8)=1.11674392344d-4
      xh(9)=13.130282482176
      wh(9)=6.45992676202d-6
      xh(10)=16.654407708330
      wh(10)=2.22631690710d-7
      xh(11)=20.776478899449
      wh(11)=4.22743038498d-9
      xh(12)=25.623894226729
      wh(12)=3.92189726704d-11
      xh(13)=31.407519169754
      wh(13)=1.45651526407d-13
      xh(14)=38.530683306486
      wh(14)=1.48302705111d-16
      xh(15)=48.026085572686
      wh(15)=1.60059490621d-20
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PRINTC      (SUBROUTINE OF CONTIM)
c   Prints estimated parameters and Standard Errors in CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   CPRINT  HEADNG  COEFFC  
c
c   This subroutine is called by the following subroutines:
C   CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PRINTC(x,xx,ind1,ind2,ind3,ind4,f,f1,iter,iter1,num,
     1vnam,abr,mic,mco,mci,abn,maxcor)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),xx(1),f,f1,d1,d2,d3,vrs,gamm
      dimension ag(5,10),fz(15),vnam(9,1),num(1),abr(1),mv(2,13),
     1mic(nsta,nsta),mco(ncar,nfre),mci(nint,nfre),abn(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(5),nvar,a2(24),m8,m9,m10,a9(6),lwi,dum(3)
      common /c2/ vrs
      common /c/ a3(2),jc,a4(4),nfun,nsta,nfre,nwei,ibgn,jres,idep,
     1istan,ir,istar,a8(8),iwt,kvrs,kgamm,a0(2),nl,lee,dumc(8)
      common /c5/ gamm
      common /d/ npar,npin,a5(2),ncas,nbar,a7(3),mobs,a6(4),inter,
     1ncar,nint,ap(4),idis,dumd(2)
c------------------------DATA STATEMENTS---------------------------------
      data ag/4Hcont,4Hinuo,4Hus t,4Hime ,4Hlog ,4Hdisc,4Hrete,4H log,
     *4H-lin,
     14Hear ,4Hdoub,4Hle e,4Hxpon,4Henti,4Hal  ,4Hmult,4Hinom,4Hial ,
     24Hlogi,4Ht   ,4Hcond,4Hitio,4Hnal ,4Hlogi,4Ht   ,4Hpois,4Hson ,
     34Hregr,4Hessi,4Hon  ,4Horde,4Hred ,4Hlogi,4Hstic,1H ,4Horde,
     *4Hred ,
     44Hprob,2Hit,1H ,4Hunor,4Hdere,4Hd lo,4Hgist,2Hic,4Htri-,4Hchot,
     *4Homou,
     54Hs pr,4Hobit/
      data fz/4Htime,4H  no,1H ,1Ht,4Hweib,4Hgomp,4Hgam1,4Hgam2,4Hlam1,
     14Hlam2,4Hfact,4Hstat,4Hes  ,4Hchoi,4Hces /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(jc.lt.4) call HEADNG(ind1,ind2,ind3,ind4,f1,f,iter1,iter,maxcor
     1)
      df=float(mobs-npar-ir)
      call CPRINT(5)
      m8=17
      m=14
      if(idis.le.2) m=12
      if(lwi.eq.0) write(ip,25) (ag(j7,idis+1),j7=1,5),nbar,fz(m),fz(m+1
     1),nsta,ncas,mobs,nfre,(vnam(j7,idep),j7=1,8),idep
   25 format(/36x,13('*'),2x,5a4,'M O D E L  ',13('*'),//38x,'# of Varia
     1bles ',7('.'),i4,3x,'# of ',2a4,9('.'),i4,/38x,'# of Cross-Section
     2s ',i6,3x,'# of Observations ...',i5,/38x,'# of Prob. Vectors ...'
     3,i4,3x,'Depen. Var.  ',8a1,'(',i3,')',/)
      if(lwi.eq.1) write(ip,30) (ag(j7,idis+1),j7=1,5),nbar,fz(m),fz(m+1
     1),nsta,ncas,mobs,nfre,(vnam(j7,idep),j7=1,8),idep
   30 format(/11x,13('*'),2x,5a4,'M O D E L  ',13('*'),//13x,'# of Varia
     1bles ',7('.'),i4,3x,'# of ',2a4,9('.'),i4,/13x,'# of Cross-Section
     2s ',i6,3x,'# of Observations ...',i5,/13x,'# of Prob. Vectors ...'
     3,i4,3x,'Depen. Var.  ',8a1,'(',i3,')',/)
      if(lwi.eq.0.and.iwt.gt.0) write(ip,35) (vnam(j7,iwt),j7=1,8),iwt
   35 format(38x,'Observations Weighted by Variable ',8('.'),8a1,'(',i3,
     1')',/)
      if(lwi.eq.1.and.iwt.gt.0) write(ip,40) (vnam(j7,iwt),j7=1,8),iwt
   40 format(13x,'Observations Weighted by Variable ',8('.'),8a1,'(',i3,
     1')',/)
      if(istan.eq.1.and.lwi.eq.0) write(ip,45)
   45 format(/47x,'*** Standard Errors Time Adjusted ***')
      if(istan.eq.1.and.lwi.eq.1) write(ip,50)
   50 format(/21x,'*** Standard Errors Time Adjusted ***')
      if(lwi.eq.0.and.istar.eq.1) write(ip,70)
   70 format(/47x,'** Starting Values  0/1 Regression **')
      if(lwi.eq.1.and.istar.eq.1) write(ip,75)
   75 format(/21x,'** Starting Values  0/1 Regression **')
      if(idis.eq.0.and.lwi.eq.0.and.ibgn.eq.1) write(ip,80)
   80 format(/47x,'****** Transit Time Unknown ******')
      if(idis.eq.0.and.lwi.eq.1.and.ibgn.eq.1) write(ip,85)
   85 format(/21x,'****** Transit Time Unknown ******')
      if(ir.eq.0) go to 135
      if(lwi.eq.0) write(ip,115) ir
  115 format(/47x,'Number of Restrictions ',8('.'),i6)
      if(lwi.eq.1) write(ip,118) ir
  118 format(/21x,'Number of Restrictions ',8('.'),i6)
      m=1
      do 130 j1=1,ir
      l=abr(m)
      m8=m8+1+l/55
      if(lwi.eq.0) write(ip,120) (abr(m+j),j=1,l)
  120 format(38x,55a1)
      if(lwi.eq.1) write(ip,125) (abr(m+j),j=1,l)
  125 format(13x,55a1)
  130 m=m+l+1
  135 if(nl.eq.0) go to 175
      m8=m8+2
      if(lwi.eq.0) write(ip,140)
  140 format(/45x,9('*'),' Non-Linear Equations ',10('*'))
      if(lwi.eq.1) write(ip,142)
  142 format(/20x,9('*'),' Non-Linear Equations ',10('*'))
      m=1
      do 145 i3=1,nl
      l=abn(m)
      m8=m8+1+l/55
      if(lwi.eq.0) write(ip,120) (abn(m+j),j=1,l)
      if(lwi.eq.1) write(ip,125) (abn(m+j),j=1,l)
  145 m=m+l+1
  175 continue
      if(lwi.eq.0) write(ip,245)
  245 format(//32x,'Variable     Coefficient   Standard Error    t Stati
     1stic    %Significance',/)
      if(lwi.eq.1) write(ip,250)
  250 format(/10x,'Variable     Coefficient  Standard Error   t Statisti
     1c  %Significance')
      l=0
      j1=0
      do 470 i=1,nfre
      if(idis.eq.4.and.i.gt.1) go to 490
      if(idis.eq.3.and.i.eq.1) go to 470
      if(idis.ge.3) go to 300
      m=0
      do 255 j=1,nsta
      do 255 j7=1,nsta
      if(mic(j,j7).ne.i.or.m.eq.13) go to 255
      m=m+1
      mv(1,m)=j
      mv(2,m)=j7
  255 continue
      j7=m
      if(j7.gt.5) j7=5
      if(lwi.eq.0) write(ip,260) i,(fz(3),mv(1,j),mv(2,j),j=1,j7)
  260 format(/25x,'Transition Vector',i3,5(a1,' (',i2,',',i2,')'))
      if(lwi.eq.1) write(ip,265) i,(fz(3),mv(1,j),mv(2,j),j=1,j7)
  265 format(7x,'Transition Vector',i3,2x,5(a1,' (',i1,',',i1,')'))
      j7=j7+1
      if(m.gt.5.and.lwi.eq.0) write(ip,270) (fz(3),mv(1,j),mv(2,j),j=j7,
     1m)
  270 format(25x,8(a1,' (',i2,',',i2,')'))
      if(m.gt.5.and.lwi.eq.1) write(ip,275) (fz(3),mv(1,j),mv(2,j),j=j7,
     1m)
  275 format(7x,8(a1,' (',i1,',',i1,')'))
  300 if(idis.eq.3.and.lwi.eq.0) write(ip,260) i
      if(idis.eq.3.and.lwi.eq.1) write(ip,265) i
      m8=m8+2
      j3=0
      nzin=mci(1,i)
      nzar=mco(1,i)
      nzab=0
      nzac=0
      do 440 j=1,nzin
      m8=m8+1
      if(m8.ge.58.and.lwi.eq.0) call CPRINT(5)
      if(m8.eq.14.and.lwi.eq.0) write(ip,245)
      if(j.gt.nzar+npin) go to 305
      if(j.gt.nzar) j3=j-nzar
      if(j3.gt.0) j3=3+nwei+j3
      if(j3.gt.0.and.nwei.eq.4) j3=j3-1
      if(j3.eq.0) j2=mco(j+1,i)
      if(j3.eq.0) j2=num(j2)
      go to 315
  305 if(j.eq.nzin.and.nfun.gt.0) go to 310
      nzac=1-nzac
      if(nwei.lt.3) nzac=1
      if(nzac.eq.1.or.inter.eq.1) nzab=nzab+1
      j2=mci(2+nzab,i)
      j2=num(j2)
      j3=3+nwei+2-nzac
      go to 315
  310 j3=11
  315 j1=j1+1
      l=l+j1
      if(nwei.eq.3.and.j3.ge.9.and.j3.le.10.and.nzab.eq.0) xx(l)=0.d0
      call COEFFC(d1,d2,d3,df,x(j1),xx(l))
      if(lwi.eq.1) go to 365
      if(ir.gt.0.and.d1.le.0.) go to 340
      if(nzab.gt.0) go to 330
      if(j3.gt.0) write(ip,320) j1,fz(1),fz(j3),x(j1),d1,d2,d3
  320 format(19x,i3,'.',2x,2a4,9x,4(1x,g14.7,1x))
      if(j3.eq.0) write(ip,325) j1,(vnam(j7,j2),j7=1,8),j2,x(j1),d1,d2,
     1d3
  325 format(19x,i3,'.',2x,8a1,'(',i3,')',4x,4(1x,g14.7,1x))
      go to 440
  330 write(ip,335) j1,(vnam(j7,j2),j7=1,4),j2,fz(j3),x(j1),d1,d2,d3
  335 format(19x,i3,'.',2x,4a1,'(',i3,')*',a4,3x,4(1x,g14.7,1x))
      go to 440
  340 if(nzab.eq.0.and.j3.gt.0) write(ip,350) j1,fz(1),fz(j3),x(j1)
  350 format(19x,i3,'.r ',2a4,10x,g14.7)
      if(nzab.gt.0) write(ip,355) j1,(vnam(j7,j2),j7=1,4),j2,fz(j3),
     1x(j1)
  355 format(19x,i3,'.r ',4a1,'(',i3,')*',a4,3x,g15.7)
      if(j3.eq.0) write(ip,360) j1,(vnam(j7,j2),j7=1,8),j2,x(j1)
  360 format(19x,i3,'.r ',8a1,'(',i3,')',4x,g15.7)
      go to 440
  365 if(ir.gt.0.and.d1.le.0.) go to 390
      if(nzab.gt.0) go to 380
      if(j3.gt.0) write(ip,370) j1,fz(1),fz(j3),x(j1),d1,d2,d3
  370 format(1x,i3,'.',2x,2a4,6x,g14.7,3g15.7)
      if(j3.eq.0) write(ip,375) j1,(vnam(j7,j2),j7=1,8),j2,x(j1),d1,d2,
     1d3
  375 format(1x,i3,'.',2x,8a1,'(',i3,') ',g14.7,3g15.7)
      go to 440
  380 write(ip,385) j1,(vnam(j7,j2),j7=1,4),j2,fz(j3),x(j1),d1,d2,d3
  385 format(1x,i3,'.',2x,4a1,'(',i3,')*',a4,g14.7,3g15.7)
      go to 440
  390 if(nzab.eq.0.and.j3.gt.0) write(ip,395) j1,fz(1),fz(j3),x(j1)
  395 format(1x,i3,'.r ',2a4,6x,g14.7)
      if(nzab.gt.0) write(ip,400) j1,(vnam(j7,j2),j7=1,4),j2,fz(j3),
     1x(j1)
  400 format(1x,i3,'.r ',4a1,'(',i3,')*',a4,g14.7)
      if(j3.eq.0) write(ip,405) j1,(vnam(j7,j2),j7=1,8),j2,x(j1)
  405 format(1x,i3,'.r ',8a1,'(',i3,')',1x,g14.7)
  440 continue
  470 continue
  490 if(lwi.eq.0) write(ip,495) f
  495 format(//45x,'Log of the Likelihood Function',g13.6)
      if(lwi.eq.1) write(ip,500) f
  500 format(/19x,'Log of the Likelihood Function',g13.6)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RECALC      (SUBROUTINE OF CONTIM)
c   Compute h = hazard function for all months in CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   GRADIN  TICALC  ERRWRT  FIRSUM  SECSUM  
c
c   This subroutine is called by the following subroutines:
C   COMPUT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RECALC(f,u,v,as,b,z,icount,ibefor,lstr,jsum,wt,id,nzar,
     1mco,mci,nyar,jnd,iobv,itime,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision u(1),v(1),b(1),h,f,as,uu(5),vv(15),
     1at,wt,gg(4),emax
      dimension z(1),mco(1),mci(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a1(10),nwei,a3(14),iwt,dum(14)
      common /d/ npar,npin,a2(4),ntxz,a4(7),inter,a5(5),iout,dumd(3)
      common /f/ a6(32),emax,dumf(2)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      jtxz=ntxz+1
      do 5 i=1,jtxz
    5 uu(i)=0.d0
      if(jnd.lt.3) go to 15
      j=jtxz*(jtxz+1)/2
      do 10 i=1,j
   10 vv(i)=0.d0
   15 at=dexp(as)
      if(nwei.eq.0) go to 30
      call GRADIN(gg,b,z,nzar,mci,nyar,inter,npin)
      h=0.d0
      call TICALC(uu,h,vv,icount,ibefor,jnd,nwei,jtxz,gg,0)
      go to 35
   30 h=dble(icount)
      uu(1)=dble(icount)
      vv(1)=dble(icount)
   35 h=-h*dble(jsum)*at
      do 40 i=1,jtxz
   40 uu(i)=-uu(i)*at*dble(jsum)
      if(jnd.lt.3) go to 50
      do 45 i=1,j
   45 vv(i)=vv(i)*at*dble(jsum)
   50 if(id-1) 90,60,62
   60 h=h+as
      uu(1)=uu(1)+1.d0
      if(nwei.gt.0) call TICALC(uu,h,vv,icount,ibefor,jnd,nwei,jtxz,
     1gg,1)
      go to 90
   62 if(dabs(h).lt.emax) go to 65
      if(iout.le.1) call ERRWRT(iobv,z,itime,1,1,h)
      h=(h/dabs(h))*(emax-1.d0)
      if(iout.eq.0) ind=1
   65 at=dexp(h)
      h=dlog(1.d0-at)
      at=-at/(1.d0-at)
      if(jnd.lt.3) go to 75
      l=0
      do 70 i=1,jtxz
      do 70 j=1,i
      l=l+1
   70 vv(l)=at*vv(l)+(at+at**2)*uu(i)*uu(j)
   75 do 80 i=1,jtxz
   80 uu(i)=uu(i)*at
   90 f=f-h*wt
      if(iwt.eq.0) go to 95
      do 92 i=1,jtxz
   92 uu(i)=uu(i)*wt
      if(jnd.lt.3) go to 95
      j=jtxz*(jtxz+1)/2
      do 93 i=1,j
   93 vv(i)=vv(i)*wt
   95 call FIRSUM(u,uu,z,nzar,ntxz,mco,mci,nyar,inter,npin)
      if(jnd.lt.3) return
      call SECSUM(v,vv,z,lstr,nzar,ntxz,mco,mci,nyar,inter,npin)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   RESCS        (SUBROUTINE OF CONTIM)
c   Scales and unscales parameter vector in CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   NLSCL  RTSCL  
c
c   This subroutine is called by the following subroutines:
C   CONTRL  CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine RESCS(scal,beta,xx,xdata,mid,mco,mci,r,iii,rn,iin,dd,
     1id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension xdata(jb,kobs),mid(nsta,nfre),dd(nsta,nbar),iii(1),
     1mco(ncar,nfre),mci(nint,nfre),iin(1)
      double precision scal(1),beta(1),xx(1),r(1),rn(1),dd
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ iscal,a1(7),nsta,nfre,a2(5),ir,a6(14),nl,lee,dum(8)
      common /d/ npar,npin,jb,kobs,ncas,nbar,a5(3),mobs,a3(2),ny,l1,
     1inter,ncar,nint,ifail,iqz,a4(2),idis,dumd(2)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(id.eq.1) go to 200
      if(nl.gt.0) go to 97
      if(idis.le.2) go to 40
      l=1
      if(idis.eq.3.or.idis.eq.4) l=2
      do 2 i=1,l1
    2 scal(i)=1.d0
      do 3 i=1,nbar
    3 dd(1,i)=1.d0
      j0=mco(1,l)
      do 5 i1=1,j0
      i2=mco(i1+1,l)
      if(beta(i1).eq.0.) go to 5
      scal(i1)=beta(i1)
      dd(1,i2)=scal(i1)
    5 continue
      if(idis.ne.4.or.nfre.eq.2) go to 15
      do 10 l=3,nfre
      j0=mco(1,l)
      do 10 i1=1,j0
      i2=mco(i1+1,l)
      i3=mco(i1+1,2)
   10 dd(1,i2)=dd(1,i3)
   15 if(id.eq.2) return
      if(idis.ne.3.or.nfre.eq.2) go to 25
      do 20 l=3,nfre
      j0=mco(1,l)
      i3=(l-2)*j0
      do 20 i1=1,j0
   20 scal(i3+i1)=scal(i1)
   25 do 27 i=1,l1
   27 beta(i)=beta(i)/scal(i)
   30 if(iqz.gt.0) go to 100
      do 35 i=1,mobs
      do 35 j=1,nbar
   35 xdata(j,i)=xdata(j,i)*dd(1,j)
      go to 100
   40 do 46 i=1,nsta
      do 44 j=1,nbar
   44 dd(i,j)=0.d0
   46 continue
      do 48 i=1,l1
   48 scal(i)=0.d0
      j5=0
      do 85 j=1,nfre
      j0=mco(1,j)
      i3=mci(2,j)
      do 80 i=1,nsta
      if(mid(i,j).eq.0) go to 80
      do 60 i1=1,j0
      i2=mco(i1+1,j)
      if(dd(i,i2).ne.0.) go to 55
      if(scal(j5+i1).ne.0.) go to 50
      scal(j5+i1)=beta(j5+i1)
      if(beta(j5+i1).eq.0.) scal(j5+i1)=1.d0
   50 dd(i,i2)=scal(j5+i1)
      go to 60
   55 if(scal(j5+i1).ne.0.) go to 210
      scal(j5+i1)=dd(i,i2)
   60 continue
      if(i3.eq.0) go to 80
      i4=j5+j0+npin
      do 75 i1=1,i3
      i2=mci(i1+2,j)
      if(dd(i,i2).ne.0.) go to 65
      if(scal(i4+1).ne.0.) go to 63
      scal(i4+1)=beta(i4+1)
      if(beta(i4+1).eq.0.) scal(i4+1)=1.d0
      if(inter.eq.1) go to 63
      scal(i4+2)=beta(i4+2)/scal(i4+1)
      if(beta(i4+2).ne.0.) go to 63
      scal(i4+1)=1.d0
      scal(i4+2)=1.d0
   63 dd(i,i2)=scal(i4+1)
      go to 75
   65 if(scal(i4+1).ne.0.) go to 210
      scal(i4+1)=dd(i,i2)
      if(inter.eq.2) scal(i4+2)=dd(i,i2)
   75 i4=i4+inter
   80 continue
   85 j5=j5+mci(1,j)
      if(id.eq.2) go to 92
      do 90 i=1,l1
      if(scal(i).eq.0.) scal(i)=1.d0
   90 beta(i)=beta(i)/scal(i)
   92 if(iqz.gt.0) go to 100
      do 95 i=1,mobs
      i1=xdata(2+nbar,i)
      do 95 j=1,nbar
      if(dd(i1,j).ne.0.) xdata(j,i)=xdata(j,i)*dd(i1,j)
   95 continue
      go to 100
c   Adjust scaling for non-linear
   97 call NLSCL(scal,beta,rn,iin,iin(ny),l1,nl,lee)
c   Adjust restrictions to account for scaling
  100 if(ir.gt.0) call RTSCL(scal,beta,r,iii,ir)
      return
  200 l=0
      do 205 i=1,l1
      beta(i)=beta(i)*scal(i)
      do 205 j=1,i
      l=l+1
  205 xx(l)=xx(l)*scal(i)*scal(j)
      return
  210 iscal=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   ROCKVL        (SUBROUTINE OF CONTIM)
c   Accumulates time variables for Starting Values in CONTIM Models.
c
c   This subroutine is called by the following subroutines:
C   
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine ROCKVL(x,icount,ibefor,nwei,amy)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision x(1),amy(1),frx
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(nwei-2) 10,30,40
   10 x(1)=0.d0
      x(2)=0.d0
      do 20 i=1,icount
      x(6)=dlog(dble(i+ibefor))
      x(1)=x(1)+x(6)
   20 x(2)=x(2)+x(6)**2
      return
   30 x(6)=dble(ibefor+icount)
      frx=x(6)*(x(6)+1.d0)/2.d0
      x(2)=dble(ibefor)*dble(ibefor+1)/2.d0
      x(1)=frx-x(2)
      x(2)=frx*(x(6)*2.d0+1.d0)/3.d0-x(2)*(dble(ibefor)*2.d0+1.d0)/3.
      return
   40 do 50 i=1,5
   50 x(i)=0.d0
      do 60 i=1,icount
      x(6)=(dble(i+ibefor)**amy(1)-1.d0)/amy(1)
      x(7)=(dble(i+ibefor)**amy(2)-1.d0)/amy(2)
      x(1)=x(1)+x(6)
      x(2)=x(2)+x(6)**2
      x(3)=x(3)+x(7)
      x(4)=x(4)+x(7)**2
   60 x(5)=x(5)+x(6)*x(7)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SECDRS        (SUBROUTINE OF CONTIM)
c   Calculates the Hessian Matrix for CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   MULTIP  RESTRN  COMPUT  MATIN5  
c
c   This subroutine is called by the following subroutines:
C   CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SECDRS(xx,x,y,xdata,ic,r,iii,rn,iin,vv,jsq,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),x(1),y(1),det,tri,vv(1),r(1),rn(1)
      dimension ic(1),xdata(1),iii(1),iin(1)
      double precision zzz(15000)
c-------------------------COMMON BLOCKS----------------------------------
      common /c/ a0(2),jc,a2(4),nfun,nsta,nfre,a1(4),istan,ir,a5(16),
     1ix0,ix2,ix4,dum(5)
      common /d/ npar,a3(6),la,a4(4),ny,l1,dumd(10)
      common /f/ tri,dumf(34)
      common /hess/ ll1,ihhh,lle
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(jsq.eq.0) tri=0.d0
      if(ind.lt.-1.or.(jc.eq.3.and.jsq.eq.1)) go to 60
      call MULTIP(y,xx,xx,xx,xx,l1,l1,1)
      ind=0
      i=3
      if(jsq.eq.1.or.istan.eq.3) i=1
c   Change made by Jacob Klerman 10/6/85
c   If(ir.gt.0) call RESTRN(x,g,g,r,iii,0)
      if(ir.gt.0) call RESTRN(x,y,y,r,iii,0)
      kx1=nfre+1
      kx2=kx1+1
      kx3=kx2+1
      kx4=kx3+1
      kx5=kx4+1
c   Call COMPUT for function/gradient
      call COMPUT(x,det,y,xx,xdata,ic(ix4),ic(ix2),ic,ic(ix0),vv,vv(kx1)
     1,vv(kx2),vv(kx3),vv(kx4),vv(kx5),rn,iin,iin(ny),vv,i,ind)
      if(i.eq.1) i=2
      if(ir.gt.0) call RESTRN(x,y,xx,r,iii,i)
      if(ind.gt.0) go to 50
c*******************************
      if(jc.lt.10) then
c   Check Hessian Condition and Invert Information Matrix.
              nonpos=1
              call CHSKY(xx,zzz,l1,nonpos)
              if(nonpos.eq.0) call CPRINT(24)
              if(nonpos.eq.0)ihhh=99
              ihhh = IHESSN(zzz,l1)
              call CPRINT(25)
              call MATIN5(l1,xx,xx,y,det,1,ind)
      endif
c*******************************
      if(ir.gt.0) call RESTRN(x,y,xx,r,iii,5)
      if(jsq.eq.0) tri=det
      if(ind.ne.0.or.istan.eq.0.or.jsq.eq.1.or.istan.eq.3) go to 50
      kx0=l1*(l1+1)/2+1
      call MULTIP(y,vv,vv,vv,vv,l1,l1,1)
      kx1=kx0+nfre+1
      kx6=kx1+1
      kx2=kx6+1
      if(la.gt.1) kx2=kx6+la*npar
      kx3=kx2+1
      kx4=kx3+1
      kx5=kx4+1
c   Call COMPUT for function/gradient
      call COMPUT(x,det,y,vv,xdata,ic(ix4),ic(ix2),ic,ic(ix0),vv(kx0),vv
     1(kx1),vv(kx2),vv(kx3),vv(kx4),vv(kx5),rn,iin,iin(ny),vv(kx6),2,
     2ind)
      if(ir.gt.0) call RESTRN(x,y,vv,r,iii,4)
      call MULTIP(xx,vv,vv(kx0),xx,xx,l1,l1,2)
   50 if(ind.eq.0) return
   60 if(jsq.eq.0) go to 70
      call MULTIP(y,xx,xx,xx,xx,l1,l1,1)
   70 if(ind.ge.-1.and.jc.lt.3) ind=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   SECSUM        (SUBROUTINE OF CONTIM)
c   Sums second derivatives in CONTIM Models.
c
c   This subroutine is called by the following subroutines:
C   DISCRT  HECALC  RECALC  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine SECSUM(v,vv,z,lstr,nzar,ntxz,mco,mci,nyar,inter,npin)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension z(1),mco(1),mci(1)
      double precision v(1),vv(1)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      l=(lstr-1)*(lstr)/2
      do 20 i=1,nzar
      l=l+lstr-1
      i1=mco(i)
      do 20 j=1,i
      i2=mco(j)
      l=l+1
   20 v(l)=v(l)+dble(z(i1))*dble(z(i2))*vv(1)
      if(ntxz.eq.0) return
      j=1
      do 70 j1=1,ntxz
      l=(lstr+nzar+j1-1)*(lstr+nzar+j1-2)/2+lstr-1
      j=j+1
      do 45 i=1,nzar
      i1=mco(i)
      l=l+1
   45 v(l)=v(l)+dble(z(i1))*vv(j)
      do 60 j2=1,j1
      j=j+1
      l=l+1
   60 v(l)=v(l)+vv(j)
   70 continue
      if(nyar.eq.0) return
      j=nzar+npin
      do 90 j1=1,nyar
      l=mci(j1)
      do 90 i5=1,inter
      j=j+1
      i3=(j+lstr-1)*(j+lstr)/2+lstr
      do 75 i=1,nzar
      i3=i3+1
      i4=mco(i)
   75 v(i3)=v(i3)+dble(z(i4))*dble(z(l))*vv(2*i5)
      do 80 i=1,ntxz
      i1=i*(i+1)/2+i5+1
      if(i5.gt.i) i1=5
      i3=i3+1
   80 v(i3)=v(i3)+dble(z(l))*vv(i1)
      i4=nzar+npin
      do 85 j2=1,nyar
      j3=mci(j2)
      do 85 i2=1,inter
      i4=i4+1
      if(i4.gt.j) go to 90
      i3=i3+1
      i1=3*i5
      if(i5.ne.i2) i1=5
   85 v(i3)=v(i3)+dble(z(l))*dble(z(j3))*vv(i1)
   90 continue
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   STARS        (SUBROUTINE OF CONTIM)
c   Computes starting values for CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   MULTIP  ROCKVL  MATIN5  
c
c   This subroutine is called by the following subroutines:
C   CONTIM  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine STARS(beta,xy,xx,xdata,mic,mid,mco,mci,xm,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision beta(1),xy(1),xx(1),x(7),y1,y2,y3,vrs,wt,
     1xt1,xt2,gs(2),xm(1)
      dimension xdata(jb,kobs),mic(nsta,nsta),mid(nsta,nfre),
     1mco(ncar,nfre),mci(nint,nfre)
c-------------------------COMMON BLOCKS----------------------------------
      common /c2/ vrs
      common /c/ a1(6),icons,nfun,nsta,nfre,nwei,ibgn,a2(13),iwt,kvrs,
     1a6(1),kxt1,kxt2,dum(10)
      common /c6/ xt1,xt2
      common /d/ npar,npin,jb,kobs,ncas,nbar,ntxz,a4(2),mobs,a3(3),l1,
     1inter,ncar,nint,ifail,iqz,inz,iout,idis,dumd(2)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      j5=1
      wt=1.d0
      i1=1
      if(idis.eq.3) go to 180
      j4=ntxz
      if(ntxz.eq.4) j4=2
      j8=nfre
      if(idis.eq.4) j8=1
      do 140 j3=1,j8
      nzin=mci(1,j3)
      nzar=mco(1,j3)
      j1=nzar*(nzar+1)/2
      i4=mci(2,j3)
      j2=nzin-nfun-npin+j4
      call MULTIP(xy,xx,xx,xx,xx,j2,j2,1)
      y2=0.d0
      y3=0.d0
      if(idis.ge.3) go to 85
c   Set ylam defaults
      if(nwei.ge.3) gs(1)=xt1
      if(nwei.ge.3) gs(2)=xt2
c   Loop over observations
      do 80 ii=1,mobs
      if(iqz.gt.0) read(inz) (xdata(i,1),i=1,jb)
      if(iqz.eq.0) i1=ii
      ksta=ifix(xdata(2+nbar,i1))
      if(mid(ksta,j3).eq.0) go to 80
      if(nwei.gt.0) ibefor=xdata(5+nbar,i1)
      jsta=ifix(xdata(3+nbar,i1))
      icount=xdata(4+nbar,i1)
c   Set weight
      if(iwt.gt.0) wt=dble(xdata(jb,i1))/vrs
      y1=dble(mid(ksta,j3))*dble(icount)*wt
c   Accumulate observations
      y3=y3+y1
      l=0
      do 20 i=1,nzar
      i2=mco(i+1,j3)
      do 20 j=1,i
      i3=mco(j+1,j3)
      l=l+1
   20 xx(l)=xx(l)+y1*dble(xdata(i2,i1))*dble(xdata(i3,i1))
      if(j4.eq.0) go to 58
      y1=dble(mid(ksta,j3))*wt
c   Accumulate time variables
      call ROCKVL(x,icount,ibefor,nwei,gs)
      do 30 i=1,nzar
      i2=mco(i+1,j3)
   30 xx(j1+i)=xx(j1+i)+y1*x(1)*dble(xdata(i2,i1))
      xx(j1+nzar+1)=xx(j1+nzar+1)+y1*x(2)
      if(j4.eq.1) go to 42
      do 40 i=1,nzar
      i2=mco(i+1,j3)
   40 xx(j1+nzar+1+i)=xx(j1+nzar+1+i)+y1*x(3)*dble(xdata(i2,i1))
      xx(j1+nzar+nzar+2)=xx(j1+nzar+nzar+2)+y1*x(5)
      xx(j1+nzar+nzar+3)=xx(j1+nzar+nzar+3)+y1*x(4)
   42 if(mci(2,j3).eq.0) go to 58
      j=nzar+j4
      do 56 i2=1,i4
      i3=mci(i2+2,j3)
      do 56 i5=1,inter
      j=j+1
      if(jsta.eq.ksta.or.mic(ksta,jsta).ne.j3) go to 44
      xy(j)=xy(j)+dble(xdata(i3,i1))*wt*x(5+i5)
   44 i6=j*(j-1)/2
      do 46 i=1,nzar
      i6=i6+1
      l=mco(i+1,j3)
   46 xx(i6)=xx(i6)+y1*x(2*i5-1)*dble(xdata(l,i1))*dble(xdata(i3,i1))
      do 48 i=1,j4
      l=2*i5
      if(i.ne.i5) l=5
      i6=i6+1
   48 xx(i6)=xx(i6)+y1*x(l)*dble(xdata(i3,i1))
      i=nzar+j4
      do 54 i9=1,i4
      l=mci(i9+2,j3)
      do 54 i7=1,inter
      i=i+1
      if(i.gt.j) go to 56
      i8=i5*2
      if(i5.ne.i7) i8=5
      i6=i6+1
   54 xx(i6)=xx(i6)+y1*x(i8)*dble(xdata(i3,i1))*(xdata(l,i1))
   56 continue
   58 if(jsta.eq.ksta.or.mic(ksta,jsta).ne.j3) go to 80
c   Accumulate x'y
      do 60 i=1,nzar
      i2=mco(i+1,j3)
   60 xy(i)=xy(i)+dble(xdata(i2,i1))*wt
c   Add in y
      y2=y2+wt
      if(j4.eq.0) go to 80
c   Add in time variables
      do 70 i=1,j4
   70 xy(nzar+i)=xy(nzar+i)+x(5+i)*wt
   80 continue
      if(y2.eq.0.or.y3.eq.0.) go to 250
      y2=y2/y3
      if(idis.ne.2) y3=dlog(y2)-1.d0
      if(idis.ne.2) go to 110
      y3=dlog(y2)
      y2=y2*y3
      y3=dlog(-y3)-1.d0/y3
      go to 110
   85 if(idis.eq.4) go to 94
      do 92 ii=1,mobs
      if(iqz.gt.0) read(inz) (xdata(i,1),i=1,jb)
      if(iqz.eq.0) i1=ii
      y1=dble(xdata(2+nbar,i1))
      if(idis.ge.6) go to 88
      if(y1.le.0.) y1=.01
      if(ibgn.eq.1) y1=y1*dble(xdata(3+nbar,i1))
      y1=dlog(y1)
      go to 90
   88 y1=y1-1.5
      y2=y2+y1
      y3=y3+y1**2
   90 if(iwt.gt.0) wt=dble(xdata(jb,i1))/vrs
      l=0
      do 92 i=1,nzar
      i2=mco(i+1,j3)
      xy(i)=xy(i)+wt*y1*dble(xdata(i2,i1))
      do 92 j=1,i
      i3=mco(j+1,j3)
      l=l+1
   92 xx(l)=xx(l)+wt*dble(xdata(i2,i1))*dble(xdata(i3,i1))
      go to 110
   94 do 96 ii=1,mobs
      if(iqz.gt.0) read(inz) (xdata(i,1),i=1,jb)
      if(iqz.eq.0) i1=ii
      ksta=nsta
      if(ibgn.gt.1) ksta=ifix(xdata(2+nbar,i1))
      if(iwt.gt.0) wt=dble(xdata(jb,i1))/vrs
      do 96 i5=2,ksta
      l=0
      do 96 i=1,nzar
      i2=mco(i+1,i5)
      xy(i)=xy(i)+wt*dble(xdata(i2,i1))
      do 96 j=1,i
      i3=mco(j+1,i5)
      l=l+1
   96 xx(l)=xx(l)+wt*dble(xdata(i2,i1))*dble(xdata(i3,i1))
  110 if(iqz.gt.0) rewind inz
      call MATIN5(j2,xx,xx,beta(j5),y1,1,ind)
      if(ind.gt.0) go to 250
      do 115 i=1,j2
      beta(j5+i-1)=0.d0
      do 115 j=1,j2
      l=IYYM(i,j)
  115 beta(j5+i-1)=beta(j5+i-1)+xy(j)*xx(l)
      if(idis.ge.3) go to 150
c   Adjust for mean
      do 118 i=1,j2
  118 beta(j5+i-1)=beta(j5+i-1)/y2
      if(icons.eq.0) beta(j5+nzar-1)=beta(j5+nzar-1)+y3
      if(nwei.lt.3) go to 130
      if(mci(2,j3).eq.0) go to 125
      i=nzin-nfun+j5-1
      j=nzar+npin+j5
      do 120 l=j,i
  120 beta(i-l+j)=beta(i-l+j-2)
  125 beta(j5+nzar+2)=gs(1)
      beta(j5+nzar+3)=gs(2)
c   Set Starting Value for factor loading
  130 if(nfun.gt.0) beta(j5+nzin-1)=0.d0
  140 j5=j5+nzin
      return
  150 if(idis.ne.6.and.idis.ne.7) return
      y1=0.d0
      do 155 i=1,j2
  155 y1=y1+beta(i)*xy(i)
      ii=nsta-2
      if(ii.le.0) go to 165
      do 160 i=1,ii
  160 beta(j2+i)=float(i)
  165 y3=(y3-y1)/(float(mobs-j2))
      if(y3.le.0.) return
      y3=dsqrt(y3)
      do 170 i=1,npar
  170 beta(i)=beta(i)/y3
      return
c   Compute Starting Values for multinomial logit
  180 nzar=mco(1,2)
      j1=nzar*(nzar+1)/2
      j2=1
      xm(1)=0.d0
      do 185 i=2,nfre
      xm(i)=0.d0
      call MULTIP(xy(j5),xx(j2),xx,xx,xx,nzar,nzar,1)
      j5=j5+nzar
  185 j2=j2+j1
      do 190 ii=1,mobs
      if(iqz.gt.0) read(inz) (xdata(i,1),i=1,jb)
      if(iqz.eq.0) i1=ii
      ksta=ifix(xdata(2+nbar,i1))
      if(iwt.gt.0) wt=dble(xdata(jb,i1))/vrs
      y1=0.d0
      if(ksta.ne.1) y1=1.d0
      xm(ksta)=xm(ksta)+1.d0
      jsta=nsta
      if(ibgn.gt.0) jsta=ifix(xdata(3+nbar,i1))
      j4=2
      if(ksta.ne.1) j4=ksta
      if(ksta.ne.1) jsta=ksta
      do 190 i5=j4,jsta
      l=j1*(i5-2)
      i4=nzar*(i5-2)
      do 190 i=1,nzar
      i2=mco(i+1,i5)
      xy(i4+i)=xy(i4+i)+wt*y1*dble(xdata(i2,i1))
      do 190 j=1,i
      i3=mco(j+1,i5)
      l=l+1
  190 xx(l)=xx(l)+wt*dble(xdata(i2,i1))*dble(xdata(i3,i1))
      if(iqz.gt.0) rewind inz
      j5=1
      j2=1
      do 205 i4=2,nfre
      call MATIN5(nzar,xx(j2),xx(j2),beta(j5),y1,1,ind)
      if(ind.gt.0) go to 250
      do 195 i=1,nzar
      beta(j5+i-1)=0.d0
      do 195 j=1,nzar
      l=IYYM(i,j)+j2-1
  195 beta(j5+i-1)=beta(j5+i-1)+xy(j5+j-1)*xx(l)
c   Adjust for mean
      y3=xm(i4)/(xm(i4)+xm(1))
      y2=y3*(1.d0-y3)
      y3=dlog((1.d0-y3)/y3)-1.d0/(1.d0-y3)
      do 200 i=1,j2
  200 beta(j5+i-1)=beta(j5+i-1)/y2
      if(icons.eq.0) beta(j5+nzar-1)=beta(j5+nzar-1)+y3
      j5=j5+nzar
  205 j2=j2+j1
      if(ifail.eq.0) return
c   Adjust coefficients if coefficients sum to zero
      do 210 i=1,nzar
  210 xm(i)=0.d0
      l=0
      do 215 j=2,nfre
      do 215 i=1,nzar
      l=l+1
  215 xm(i)=xm(i)+beta(l)
      y2=1.d0/(1.d0-dble(nsta-1))
      l=0
      do 220 j=2,nfre
      do 220 i=1,nzar
      l=l+1
  220 beta(l)=beta(l)+y2*xm(i)
      return
  250 ind=10
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   TICALC      (SUBROUTINE OF CONTIM)
c   Calculates gradient/hessions for time variables in CONTIM Models.
c
c   This subroutine is called by the following subroutines:
C   HECALC  RECALC  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine TICALC(uu,h,vv,it,ibefor,jnd,nwei,jtxz,b,id)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision uu(1),vv(1),ar,h,at,au,b(1),ax,aw,az
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i2=ibefor+it
      if(id.eq.1) go to 60
      i1=ibefor+1
      if(nwei-2) 10,20,40
   10 do 15 i=i1,i2
      ar=dble(i)**b(1)
      at=dlog(dble(i))
      uu(2)=uu(2)+ar*at
      if(jnd.eq.3) vv(3)=vv(3)+ar*at*at
   15 h=h+ar
      go to 55
   20 do 30 i=i1,i2
      ar=dexp(dble(i)*b(1))
      uu(2)=uu(2)+ar*dble(i)
      if(jnd.eq.3) vv(3)=vv(3)+ar*dble(i)**2
   30 h=h+ar
      go to 55
   40 do 50 i=i1,i2
      at=(dble(i)**b(3)-1.d0)/b(3)
      au=(dble(i)**b(4)-1.d0)/b(4)
      ar=dexp(b(1)*at+b(2)*au)
      uu(2)=uu(2)+ar*at
      uu(3)=uu(3)+ar*au
      if(jnd.lt.3) go to 45
      vv(3)=vv(3)+ar*at**2
      vv(5)=vv(5)+ar*au*at
      vv(6)=vv(6)+ar*au**2
   45 if(nwei.eq.3) go to 50
      aw=at*b(3)+1.d0
      ax=au*b(4)+1.d0
      az=dlog(dble(i))
      uu(4)=uu(4)+ar*b(1)*(aw*az-at)/b(3)
      uu(5)=uu(5)+ar*b(2)*(ax*az-au)/b(4)
      if(jnd.lt.3) go to 50
      vv(8)=vv(8)+ar*(aw*az-at)*(1.d0+at*b(1))/b(3)
      vv(9)=vv(9)+ar*au*b(1)*(aw*az-at)/b(3)
      vv(10)=vv(10)+ar*b(1)*(aw*az**2+((aw*az-at)/b(3))*((b(1)*(aw*az-at
     1)/b(3))-2.d0))/b(3)
      vv(12)=vv(12)+ar*at*b(2)*(ax*az-au)/b(4)
      vv(13)=vv(13)+ar*(ax*az-au)*(1.d0+au*b(2))/b(4)
      vv(14)=vv(14)+ar*b(1)*b(2)*(aw*az-at)*(ax*az-au)/(b(3)*b(4))
      vv(15)=vv(15)+ar*b(2)*(ax*az**2+((ax*az-au)/b(4))*((b(2)*(ax*az-au
     1)/b(4))-2.d0))/b(4)
   50 h=h+ar
   55 uu(1)=h
      if(jnd.lt.3) return
      j=0
      do 57 i=1,jtxz
      vv(j+1)=uu(i)
   57 j=j+i
      return
   60 if(nwei-2) 65,70,75
   65 ar=dlog(dble(i2))
      uu(2)=uu(2)+ar
      h=h+ar*b(1)
      return
   70 uu(2)=uu(2)+dble(i2)
      h=h+dble(i2)*b(1)
      return
   75 at=(dble(i2)**b(3)-1.d0)/b(3)
      au=(dble(i2)**b(4)-1.d0)/b(4)
      uu(2)=uu(2)+at
      uu(3)=uu(3)+au
      h=h+b(1)*at+b(2)*au
      if(nwei.eq.3) return
      aw=at*b(3)+1.d0
      ax=au*b(4)+1.d0
      az=dlog(dble(i2))
      uu(4)=uu(4)+b(1)*(aw*az-at)/b(3)
      uu(5)=uu(5)+b(2)*(ax*az-au)/b(4)
      if(jnd.lt.3) return
      vv(8)=vv(8)-(aw*az-at)/b(3)
      vv(10)=vv(10)-b(1)*(aw*az**2-2.d0*(aw*az-at)/b(3))/b(3)
      vv(13)=vv(13)-(ax*az-au)/b(4)
      vv(15)=vv(15)-b(2)*(ax*az**2-2.d0*(ax*az-au)/b(4))/b(4)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   TRANSI        (SUBROUTINE OF MAIN PART OF HOTZTRAN)
c   Decodes Transition vectors in CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   MYRON  
c
c   This subroutine is called by the following subroutines:
C   CONTRL  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine TRANSI(mid,mic,c,nsta,nfre,jlt,ierror)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension mid(nsta,nsta),mic(nsta,nfre),amy(5),c(1)
c------------------------DATA STATEMENTS---------------------------------
      data amy/1H(,1H),1H,,1H ,1H=/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      i=0
    5 i=i+1
      if(c(i).ne.amy(5).and.i.lt.50) go to 5
      if(i.eq.50) go to 60
      i=i+1
      if(c(i).eq.amy(4)) i=i+1
   20 l=0
      j=0
      if(c(i).eq.amy(4)) return
      if(c(i).ne.amy(1)) go to 60
   30 i=i+1
      if(c(i).eq.amy(3)) go to 40
      call MYRON(c(i),m)
      if(m.gt.10) go to 60
      l=l*10+m-1
      go to 30
   40 i=i+1
      if(c(i).eq.amy(2)) go to 50
      call MYRON(c(i),m)
      if(m.gt.10) go to 60
      j=j*10+m-1
      go to 40
   50 if(l.le.0.or.j.le.0.or.l.gt.nsta.or.j.gt.nsta) go to 60
      mid(l,j)=jlt
      mic(l,jlt)=mic(l,jlt)+1
      if(c(i+1).eq.amy(4)) i=i+1
      go to 20
   60 ierror=7
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   YCALC      (SUBROUTINE OF CONTIM)
c   Compute z*beta for all months in a spell for CONTIM Models.
c
c   This subroutine calls the following subroutines:
C   ERRWRT
c
c   This subroutine is called by the following subroutines:
C   YCALC  DISCRT  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine YCALC(y,z,b,nzar,mco,iobv,itime,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension z(1),mco(1)
      double precision y,b(1),emax
c-------------------------COMMON BLOCKS----------------------------------
      common /d/ a1(20),iout,dum(3)
      common /f/ a4(32),emax,dumf(2)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      y=0.d0
      do 10 i=1,nzar
      l=mco(i)
   10 y=y+dble(z(l))*b(i)
      if(dabs(y).lt.emax) return
      if(iout.le.1) call ERRWRT(iobv,z,itime,1,1,y)
      y=dsign(1.d0,y)*(emax-1.d0)
      if(iout.eq.0) ind=1
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   MINREG        (KEY SUBROUTINE)
c   Main sub-driver program for MINREG Models.  
c
c   This sub-driver calls the following subroutines:
c   MARKY  CARDRD  DECODS  MALLAR  PREPRS  PREPOR  PUNCHA  ERRWRT  
C   ERRCHK
c
c   This subroutine is called by the following subroutines:
C   MAIN PROGRAM
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine MINREG(vnam,xbata,xx,ab,ii,aa)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),aa(1),v,rss
      dimension xbata(1),ii(1),id(5),ab(1),vnam(1),vb(4),iuu(8),iut(8)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a3(3),iqv,nobs,nvar,ntime,kcore,idim,ipk,
     1a1(22),m10,mi1,mi2,a2(3),jobs,lwi,dum(3)
      common /c/ iwt,it1,it2,iu1,iu2,iu3,iu4,iu5,vr,jres,li,jma,ifm,
     1nbar,mobs,lobs,jrus,icov,idur,dumc(21)
c---------------------EQUIVALENCE STATEMENTS-----------------------------
      equivalence(iwt,iuu(1))
c------------------------DATA STATEMENTS---------------------------------
      data vb/1Hd,1He,1H=,1H /
c-------------------BEGINNING OF SUBROUTINE------------------------------
      nn1=iwt
      nbar=nvar
      nvar=nvar+1
      lobs=nobs
      nobs=jobs
c   Set Starting Values for program checks and defaults
    5 iqm=0
      jma=0
      iwt=0
      ipp=0
      jres=0
      jrus=0
      icov=0
      icon=0
      idur=0
      mi2=0
      it1=1
      it2=ntime
      iu1=0
      iu4=1
      iu5=lobs
      mobs=nobs
      vr=0.
      if(ipk.eq.1) go to 14
      ls=nvar+2
      go to 8
    6 nn1=1
      do 7 i=1,8
      if(iut(i).ne.iuu(i)) go to 8
    7 continue
      if(mi3.ne.mi2.or.vs.ne.vr) go to 8
      nn1=0
    8 do 9 i=1,8
    9 iut(i)=iuu(i)
      if(nn1.eq.2) iut(1)=-1
      vs=vr
      mi3=mi2
      j5=0
      if(ipk.eq.1) go to 10
      le=ls+nvar+1
      ipk=1
      go to 14
   10 le=ls+nvar+1
      call MARKY(ab(le),0,4,vnam,nvar,ierror)
      if(ierror.gt.0) go to 82
      call CARDRD(ab(le),vnam,nvar,mc,1)
      if(mc.ge.1.and.mc.ne.5) go to 95
      j5=0
      if(mc.eq.5) go to 5
      mc=0
      do 11 i=1,484
      if(ab(le+i-1).eq.vb(4).and.ab(le+i).eq.vb(4)) go to 12
      if(ab(le+i-1).eq.vb(3)) mc=1
   11 continue
   12 if(mc.eq.0) go to 40
      if(ab(le).eq.vb(1).and.ab(le+1).eq.vb(2)) go to 30
      go to 5
c   Decode master control card (MINREG)
   14 call DECODS(ab(le),j5,id,v)
      if(id(1)) 80,6,16
   16 if(id(1).ne.23.and.id(1).ne.21.and.id(1).ne.18.and.id(1).ne.24.and
     1.id(1).ne.3.and.id(1).ne.1.and.id(1).ne.13.and.id(1).ne.20) go to
     277
      if(id(1)-3) 20,26,17
   17 if(id(1).eq.13) go to 21
      if(id(1).eq.24) go to 22
      if(id(1)-21) 18,22,28
c   Set residual code
   18 if(id(1).eq.20) go to 14
      if(id(2).eq.23) go to 19
      jres=id(3)
      go to 14
c   Set residual punch code
   19 jrus=id(3)
      go to 14
c   Set durban-watson code
   20 idur=id(3)
      go to 14
c   Set parameter covariance punch code
   21 if(id(2).eq.23) icov=id(3)
      if(id(2).eq.9.and.mi1.gt.0) mi2=ifix(sngl(v))
      go to 14
   22 if(id(2)-15) 24,23,25
c   Use observations where iu2.(logical operator).iu3 or v
   23 iu2=id(3)
      iu3=id(5)
      vr=v
      if(id(4).eq.0) id(4)=1
      iu1=id(4)
      if(iu2.gt.nvar.or.iu3.gt.nvar.or.iu2.le.0) go to 75
      go to 14
c   Use observations iu4 to iu5 (or exclude if xcros)
   24 iu4=id(3)
      iu5=id(5)
      if(iu4.eq.0) iu4=1
      if(iu5.eq.0) iu5=lobs
      if(iu4.lt.1.or.iu5.gt.lobs.or.iu4.gt.iu5) go to 75
      if(id(1).eq.21) go to 14
      iu4=id(5)+1
      iu5=id(3)
      go to 14
c   Use time periods it1 to it2 (or exclude if xtime)
   25 it1=id(3)
      it2=id(5)
      if(it1.eq.0) it1=1
      if(it2.eq.0) it2=ntime
      if(it1.lt.1.or.it2.gt.ntime.or.it1.gt.it2) go to 75
      if(id(1).eq.21) go to 14
      it1=id(5)+1
      it2=id(3)
      go to 14
c   Set constant default code
   26 if(id(2).eq.23) go to 27
      icon=id(3)
      go to 14
c   Set parameter punch/disk
   27 ipp=id(3)
      go to 14
c   Set variable weight
   28 iwt=id(3)
      if(iwt.gt.nvar) go to 77
      go to 14
c   Decode dependent variable card
   30 iqm=0
      mb=0
      j5=4
   31 call MALLAR(ab(le),j5,id,vnam,nvar,ierror)
      if(ierror.gt.0) go to 82
      if(id(1).eq.0) go to 10
      if(id(1).gt.nvar.or.id(1).lt.0.or.mb.gt.id(1)) go to 77
      if(id(4).eq.0) go to 33
      if(mb.gt.0) go to 77
      mb=id(1)
      mc=id(3)
      go to 31
   33 ifm=id(1)
      if(mb.eq.0) mc=id(3)
      if(mb.eq.0) mb=id(1)
      do 39 llv=mb,ifm
      if(iqm.eq.0) go to 38
      j=iqm
      do 37 i=1,j
      if(ii(i).ne.llv) go to 37
      if(mc.eq.0) go to 39
      md=i+1
      if(md.gt.iqm) go to 36
      do 34 li=md,iqm
   34 ii(li-1)=ii(li)
   36 iqm=iqm-1
      go to 39
   37 continue
   38 if(mc.ne.0) go to 39
      iqm=iqm+1
      ii(iqm)=llv
   39 continue
      mb=0
      go to 31
c   Decode independent variable card
   40 jma=0
      mb=0
      ma=icon
   42 call MALLAR(ab(le),j5,id,vnam,nvar,ierror)
      if(ierror.gt.0) go to 82
      if(id(1).eq.0) go to 60
      if(id(1).gt.nvar.or.id(1).lt.0.or.mb.gt.id(1)) go to 77
      if(id(1).lt.nvar) go to 45
      ma=id(3)
      if(id(4).gt.0.or.mb.gt.0) go to 77
      go to 42
   45 if(id(4).eq.0) go to 46
      if(mb.gt.0) go to 77
      mb=id(1)
      mc=id(3)
      go to 42
   46 ifm=id(1)
      if(mb.eq.0) mc=id(3)
      if(mb.eq.0) mb=id(1)
      do 59 llv=mb,ifm
      if(jma.eq.0) go to 58
      j=jma
      do 56 i=1,j
      if(ii(ls+i-1).ne.llv) go to 56
      if(mc.eq.0) go to 59
      md=i+1
      if(md.gt.jma) go to 54
      do 52 li=md,jma
   52 ii(ls+li-2)=ii(ls+li-1)
   54 jma=jma-1
      go to 59
   56 continue
   58 if(mc.ne.0) go to 59
      jma=jma+1
      ii(ls+jma-1)=llv
   59 continue
      mb=0
      go to 42
   60 if(iqm.eq.0.or.jma.eq.0.or.(nn1.ne.0.and.(iqv.eq.3.or.iqv.eq.5)))
     1go to 75
c   Add constant (if used)
      if(ma.eq.0) jma=jma+1
      if(ma.eq.0) ii(ls+jma-1)=nvar
c   Collect moment if needed
c   Change made by Jacob Klerman 10/6/85
c   If(nn1.ge.1.and.mi2.ne.1) call PREPRS(xx,aa,rss,ab,xbata,ab,0)
      if(nn1.ge.1.and.mi2.ne.1) call PREPRS(xx,aa,rss,ii,xbata,ab,0)
      nn1=0
c   Set dimensions for run
      mb=(ls+jma+1)/2+1
      mc=mb+(jma*(jma+1))/2
      if(mi2.eq.1) mc=mb+(jma+2)*(jma+3)/2
      md=mc+jma
      le=(md+jma)*2+1
      li=le+jma
      if(li+42*jres.gt.kcore) go to 70
      do 64 llv=1,iqm
      ifm=ii(llv)
      m10=m10+1
c   Call PREPOR which selects variables and runs regressions.
c   Aa(md) is the coefficients, aa(mb) is x'x inverse, rss is resi. ss
      call PREPOR(xx,ii(ls),aa(mb),aa(mc),aa(md),vnam,ab(le),rss,xbata,
     1llv,ind)
c   Punch (disk write) coefficients
      if(ipp.ne.0) call PUNCHA(aa(md),jma,aa,1,aa)
c   Call PREPRS which prints and Computes residuals
      if((jres.gt.0.or.jrus.gt.0.or.idur.gt.0).and.ind.eq.0) call PREPRS
     1(xx,aa(md),rss,ii(ls),xbata,ab(li),1)
      if(ind.gt.0.and.mi2.ne.1) go to 10
   64 continue
      go to 10
   70 li=li-kcore+42
      ierror=8
      go to 82
   75 ierror=3
      go to 82
   77 i=max0(j5-3,0)
      call ERRWRT(0,ab(le+i),8,0,0,v)
   80 ierror=2
   82 if(lwi.eq.0) write(ip,83) (ab(le+llv-1),llv=1,50)
   83 format(/41x,'Error Detected on/after Card  ',50a1)
      if(lwi.eq.1) write(ip,84) (ab(le+llv-1),llv=1,50)
   84 format(/1x,'Error Detected on/after Card  ',50a1)
      call ERRCHK(ierror,li)
   85 stop
   95 nvar=nvar-1
      nobs=lobs
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   BPRINT        (SUBROUTINE OF MINREG)
c   Prints regression heading and coefficients for MINREG Models.  
c
c   This subroutine calls the following subroutines:
C   CPRINT  COEFFC  
c
c   This subroutine is called by the following subroutines:
C   LESQAR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine BPRINT(b,s,vt,df,rsq,vnam,nvar,num,m,ifm,m1,mobs)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision b,s,ba(5),vt
      dimension vnam(9,nvar)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(30),m8,a2(8),lwi,dum(3)
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(m.le.0) go to 16
      if(lwi.eq.1) go to 7
      write(ip,1) (vnam(i,ifm),i=1,8),ifm
    1 format(45x,'Dependent Variable ',10('.'),1x,8a1,'(',i3,')')
      write(ip,2) mobs
    2 format(45x,'Number of Observations in Run ',7('.'),i6)
      if(m1.eq.0) write(ip,3)
    3 format(45x,'Constant Not Used -- Regr. F Stat. Adjusted')
      write(ip,4) m
    4 format(45x,'Number of Independent Variables .....',i6,/)
      write(ip,5)
    5 format( /16x,'Variable     Coefficient   Standard Error   t Statis
     1tic   %Significance   Auxi. R Sq.    Variable Mean',/)
      go to 15
    7 write(ip,8) (vnam(i,ifm),i=1,8),ifm
    8 format(19x,'Dependent Variable ',10('.'),1x,8a1,'(',i3,')')
      write(ip,9) mobs
    9 format(19x,'Number of Observations in Run ',7('.'),i6)
      if(m1.eq.0) write(ip,10)
   10 format(19x,'Constant Not Used -- Regr. F Stat. Adjusted')
      write(ip,11) m
   11 format(19x,'Number of Independent Variables .....',i6,/)
      write(ip,12)
   12 format(4x,'Variable',3x,'Coefficient',2x,'Stand.Error',2x,'t Stati
     1stic',4x,'%Signif',1x,'AuxRSq',3x,'Mean',/)
   15 m=0
   16 ba(1)=b
      m8=m8+1
      if(lwi.eq.0.and.m8.gt.58) call CPRINT(15)
      if(lwi.eq.0.and.m8.eq.4) write(ip,5)
      call COEFFC(ba(2),ba(3),ba(4),df,b,s)
c*******
c   Write(9,1234) ba(1),ba(2)
 1234 format(2d16.9)
      ba(5)=1.d0-(1.d0/dble(rsq))
      j=num
      if(num.eq.nvar) j=0
      if(lwi.eq.1) go to 20
      write(ip,18) (vnam(i,num),i=1,8),j,(ba(i),i=1,5),vt
   18 format(13x,8a1,'(',i3,')',g15.7,5g16.7)
      if(m.eq.0.and.m8.gt.50) call CPRINT(15)
      return
   20 if(ba(4).lt..0001) ba(4)=0.d0
      if(ba(5).lt..001) ba(5)=0.d0
      write(ip,22) (vnam(i,num),i=1,8),j,(ba(i),i=1,5),vt
   22 format(1x,8a1,'(',i3,')',1x,3g13.6,f9.4,f6.3,g11.4)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   LESQAR        (SUBROUTINE OF MINREG)
c   Does actual regressions for MINREG Models.
c
c   This subroutine calls the following subroutines:
C   MATIN5  BPRINT  
c
c   This subroutine is called by the following subroutines:
C   PREPOR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine LESQAR(xx,xy,beta,yy,xb,wrk,mobs,ifm,num,vnam,rss,jma,
     1nvar,n1,n2,n3,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      double precision xx(1),xy(1),beta(1),yy,xb(1),rss,r1,r2,r3,r4,r5,
     1FSTAT
      dimension num(1),vnam(1),wrk(1)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(39),lwi,dum(3)
c   Common area containing the print device number
c-------------------BEGINNING OF SUBROUTINE------------------------------
      m1=0
      do 10 i=1,jma
c   Check for constant
      if(num(i).eq.nvar) m1=i
   10 continue
      i2=ifm
      i1=nvar
      if(n3.eq.1) i2=jma+1
      if(n3.eq.1) i1=jma+2
      if(n2.gt.1) go to 25
      l=0
      do 20 i=1,jma
      wrk(i)=0.
      l=l+i
c   Compute part of auxilary R Square of each ind. var. on all others
      if(m1.eq.0.or.m1.eq.i) go to 15
      j=IYYM(i,m1)
      wrk(i)=sngl(xx(l)-xx(j)*xx(j)/xb(i1))
      go to 20
   15 wrk(i)=sngl(xx(l))
   20 continue
c   Invert x'x
      call MATIN5(jma,xx,xx,beta,r1,0,ind)
c   Branch if multicolinear
      if(ind.gt.0) go to 60
   25 l=0
      if(m1.gt.1) m1=1
      do 30 i=1,jma
      beta(i)=0.d0
      do 30 j=1,i
      l=l+1
c   Compute beta coefficient
      if(j.lt.i) beta(j)=beta(j)+xx(l)*xy(i)
   30 beta(i)=beta(i)+xx(l)*xy(j)
      if(n1.eq.0) return
      r3=0.d0
      do 35 i=1,jma
c   Compute predicted sums of squares
   35 r3=r3+beta(i)*xy(i)
c   Compute mean square of the dependent variable
      r1=xb(i2)*xb(i2)/xb(i1)
c   Compute predicted and toal deviation sums of squares
      r4=yy-r1
      r3=r3-r1
c   Compute residual  sums of squares
      rss=r4-r3
      r6=float(mobs-jma)
c   Compute estimate of sigma squared
      r2=rss/dble(r6)
      l=0
      j=jma
      do 45 i=1,jma
      l=l+i
      r5=xx(l)*r2
      r7=sngl(xx(l)*dble(wrk(i)))
      i3=num(i)
      if(n3.eq.1) i3=i
      r1=xb(i3)/xb(i1)
   45 call BPRINT(beta(i),r5,r1,r6,r7,vnam,nvar,num(i),j,ifm,m1,mobs)
c   Compute R Squared
      r5=1.d0-(rss/r4)
      r1=xb(i2)/xb(i1)
      if(lwi.eq.0) write(ip,50) r3,r5,rss,r1,r4,r2
   50 format(///30x,'Predicted Dev SS ...',g15.7,5x,'R Square ',11('.'),
     1g15.7,/30x,'Residual SS ',8('.'),g15.7,5x,'Mean of Dep Var ....',g
     115.7,/30x,'Total Dev SS .......',g15.7,5x,'Sigma Squared ......',g
     115.7)
      if(lwi.eq.1) write(ip,52) r3,r5,rss,r1,r4,r2
   52 format(///5x,'Predicted Dev SS ...',g15.7,5x,'R Square ',11('.'),
     1g15.7,/5x,'Residual SS ',8('.'),g15.7,5x,'Mean of Dep Var ....',
     1g15.7,/5x,'Total Dev SS .......',g15.7,5x,'Sigma Squared ......',
     1g15.7)
c   Compute sigma
      r5=0.d0
      if(r2.gt.0.) r5=dsqrt(r2)
c   Compute degrees of freedom
      m1=jma-m1
      r7=float(m1)
      i=mobs-jma
      if(m1.ne.jma) r1=0.d0
c   Compute regression f statistic
      r4=((r3+r1)/dble(r7))/r2
      r3=FSTAT(r4,r7,r6,0.,0)*100.d0
      if(lwi.eq.0) write(ip,55) r4,r5,m1,i,r3
   55 format(30x,'Regression F .......',g15.7,5x,'Sigma ',14('.'),g15.7,
     1/30x,'Degrees of Freedom .',i7,' &',i6,5x,'Significance (%) F .',g
     215.7)
      if(lwi.eq.1) write(ip,57) r4,r5,m1,i,r3
   57 format(5x,'Regression F .......',g15.7,5x,'Sigma ',14('.'),g15.7,
     1/5x,'Degrees of Freedom .',i7,' &',i6,5x,'Significance (%) F .',
     2g15.7)
      return
   60 write(ip,65) (num(i),i=1,jma)
   65 format(39x,13i4)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PREPOR        (SUBROUTINE OF MINREG)
c   Selects variables and runs regressions for MINREG Models.
c
c   This subroutine calls the following subroutines:
C   CPRINT  PREPRS  LESQAR  
c
c   This subroutine is called by the following subroutines:
C   MINREG  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PREPOR(xx,num,xa,xy,beta,vnam,wrk,rss,xbata,llv,ind)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension xx(1),vnam(9,nvar),num(1),wrk(1),f4(6),xbata(1)
      double precision xa(1),xy(1),beta(1),xx,yy,rss,v1,xb(5)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(5),nvar,ntime,a2(27),mi2,a3(4),lwi,dum(3)
      common /c/ iwt,it1,it2,iu1,iu2,iu3,iu4,iu5,vr,jres,li,jma,ifm,
     1nbar,mobs,lobs,jrus,icov,dumc(22)
c------------------------DATA STATEMENTS---------------------------------
      data f4/4H.gt.,4H.lt.,4H.ge.,4H.le.,4H.eq.,4H.ne./
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(mi2.eq.1) go to 20
      do 5 i=1,jma
      j1=IYYM(ifm,num(i))
    5 xy(i)=xx(j1)
      if(llv.gt.1) go to 15
      l=0
      do 10 i=1,jma
      do 10 j=1,i
      j1=IYYM(num(i),num(j))
      l=l+1
   10 xa(l)=xx(j1)
   15 j1=IYYM(ifm,ifm)
      yy=xx(j1)
   20 call CPRINT(5)
      if(lwi.eq.1) go to 40
      write(ip,25) li
   25 format(/45x,'Regression Core Size ',16('.'),i6)
      if(iwt.gt.0) write(ip,30) (vnam(l,iwt),l=1,8),iwt
   30 format(45x,'Observ. Weighted by  Variable ',8a1,'(',i3,')')
      if((iu4.ne.1.or.iu5.ne.lobs).and.iu4.le.iu5) write(ip,32) iu4,iu5
   32 format(45x,'Observations from',i9,' to',i6,4x,'Used')
      j=iu4-1
      if(iu4.gt.iu5) write(ip,34) iu5,j
   34 format(45x,'Observations from',i6,' to',i6,'   Excluded')
      if((it1.ne.1.or.it2.ne.ntime).and.it1.le.it2) write(ip,35) it1,it2
   35 format(45x,'Time Periods from',i9,' to',i6,4x,'Used')
      j=it1-1
      if(it1.gt.it2) write(ip,37) it2,j
   37 format(45x,'Time Periods from',i6,' to',i6,'   Excluded')
      if(iu1.ge.1.and.iu3.le.0) write(ip,38) (vnam(l,iu2),l=1,8),iu2,
     1f4(iu1),vr
   38 format(45x,'Obsv. Used if ',8a1,'(',i3,')',a4,f8.3)
      if(iu1.ge.1.and.iu3.gt.0) write(ip,39) (vnam(l,iu2),l=1,8),iu2,
     1f4(iu1),(vnam(l,iu3),l=1,8),iu3
   39 format(45x,'Use # if ',8a1,'(',i3,')',a4,8a1,'(',i3,')')
      go to 53
   40 write(ip,41) li
   41 format(/19x,'Regression Core Size ',16('.'),i6)
      if(iwt.gt.0) write(ip,42) (vnam(l,iwt),l=1,8),iwt
   42 format(19x,'Observ. Weighted by  Variable ',8a1,'(',i3,')')
      if((iu4.ne.1.or.iu5.ne.lobs).and.iu4.le.iu5) write(ip,43) iu4,iu5
   43 format(19x,'Observations from',i9,' to',i6,4x,'Used')
      j=iu4-1
      if(iu4.gt.iu5) write(ip,44) iu5,j
   44 format(19x,'Observations from',i6,' to',i6,'   Excluded')
      if((it1.ne.1.or.it2.ne.ntime).and.it1.le.it2) write(ip,45) it1,it2
   45 format(19x,'Time Periods from',i9,' to',i6,4x,'Used')
      j=it1-1
      if(it1.gt.it2) write(ip,47) it2,j
   47 format(19x,'Time Periods from',i6,' to',i6,'   Excluded')
      if(iu1.ge.1.and.iu3.le.0) write(ip,48) (vnam(l,iu2),l=1,8),iu2,
     1f4(iu1),vr
   48 format(19x,'Obsv. Used if ',8a1,'(',i3,')',a4,f8.3)
      if(iu1.ge.1.and.iu3.gt.0) write(ip,49) (vnam(l,iu2),l=1,8),iu2,
     1f4(iu1),(vnam(l,iu3),l=1,8),iu3
   49 format(19x,'Use # if ',8a1,'(',i3,')',a4,8a1,'(',i3,')')
   53 if(mi2.ne.1) go to 55
      j1=IYYM(jma,jma)+1
      l=j1+jma
      j=l+1
      call PREPRS(xa,beta,rss,num,xbata,wrk,-1)
      call LESQAR(xa,xa(j1),beta,xa(l),xa(j),wrk,mobs,ifm,num,vnam,rss,
     1jma,nvar,1,1,1,ind)
      go to 58
   55 j1=IYYM(nvar,nvar)-nvar+1
      call LESQAR(xa,xy,beta,yy,xx(j1),wrk,mobs,ifm,num,vnam,rss,
     1jma,nvar,1,llv,0,ind)
   58 if(icov.eq.0) return
c   Write parameter covariance on punch/disk
      j=jma*(jma+1)/2
      v1=rss/dble(mobs-jma)
      l1=0
   60 l=l1+1
      l1=l+4
      if(l1.gt.j) l1=j
      do 52 i=l,l1
   52 xb(i-l+1)=xa(i)*v1
      write(icov,65) (xb(i-l+1),i=l,l1)
   65 format(5d16.9)
      if(l1.lt.j) go to 60
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

c************************************************************************
c************************************************************************
c   PREPRS        (SUBROUTINE OF MINREG)
c   Accumulates moment matrices and does residual analysis for MINREG
c   Models.  
c
c   This subroutine calls the following subroutines:
C   CPRINT  
c
c   This subroutine is called by the following subroutines:
C   MINREG  PREPOR  
c------------------------------------------------------------------------
c------------------------------------------------------------------------
      subroutine PREPRS(xx,be,rss,num,xbata,a,jd)

c------------------DIMENSIONS & DECLARATIONS-----------------------------
      dimension num(1),xbata(idim,nbar),a(1),e(3)
      double precision be(1),xx(1),rss,r,q,r1,er(5)
c-------------------------COMMON BLOCKS----------------------------------
      common /b/ ip,a1(2),int,iqv,nobs,nvar,ntime,kcore,idim,a2(25),mi2,
     1a3(2),mtime,jobs,lwi,dum(3)
      common /c/ iwt,it1,it2,iu1,iu2,iu3,iu4,iu5,vr,jres,li,jma,ifm,
     1nbar,mobs,lobs,jrus,icov,idur,dumc(21)
c------------------------DATA STATEMENTS---------------------------------
      data e/1H ,1H*,1Hi/
c-------------------BEGINNING OF SUBROUTINE------------------------------
      if(jd.gt.0) go to 10
      if(jd.eq.0) l5=IYYM(nvar,nvar)
      if(jd.lt.0) l5=(jma+2)*(jma+3)/2
      jmb=jma+1
      do 5 i=1,l5
    5 xx(i)=0.d0
      mobs=0
      go to 20
   10 q=0.d0
      if(rss.gt.0.) q=dsqrt(rss/dble(mobs-jma))
      ir=53
      a(6)=e(3)
      a(48)=e(3)
      do 15 i=7,47
   15 a(i)=e(1)
      do 17 i=1,5
   17 er(i)=0.d0
   20 l2=1
      l4=0
      l3=100000
      l6=0
      do 200 l1=1,nobs
      if(iqv.ge.1) go to 23
      l2=l1
      go to 24
   23 read(int) (xbata(1,i),i=1,nbar)
   24 if(mtime.gt.0) go to 34
      l6=l3
      l3=l3+1
      if(l3.le.ntime) go to 42
      l3=1
      go to 36
   34 l=ifix(xbata(l2,mtime))
      l6=l3
      if(l.gt.l3) go to 38
   36 l6=0
      l4=l4+1
   38 if(mtime.gt.0) l3=iabs(l)
c   Bypass observation if not used
   42 if(iu1.eq.0) go to 55
      wx=vr
      if(iu3.gt.0) wx=xbata(l2,iu3)
      if(IOBS(xbata(l2,iu2),wx,iu1).eq.0) go to 200
   55 if((iu4.le.iu5.and.(l4.lt.iu4.or.l4.gt.iu5)).or.(iu4.gt.iu5.and.l4
     1.ge.iu5.and.l4.lt.iu4)) go to 200
      if((it1.le.it2.and.(l3.lt.it1.or.l3.gt.it2)).or.(it1.gt.it2.and.l3
     1.ge.it2.and.l3.lt.it1)) go to 200
      l=0
      if(mi2-1) 80,120,70
c   Check for missing variables
   70 do 75 i=1,nbar
      if(MISS(xbata(l2,i)).ne.0) go to 200
   75 continue
   80 if(jd.gt.0) go to 140
      mobs=mobs+1
      if(iwt.eq.0) go to 105
      r=dble(xbata(l2,iwt))
c   Accumulate Weighted moment
      do 95 i=1,nbar
      do 95 j=1,i
      l=l+1
   95 xx(l)=xx(l)+r*dble(xbata(l2,i))*dble(xbata(l2,j))
      do 100 i=1,nbar
  100 xx(l+i)=xx(l+i)+r*dble(xbata(l2,i))
      xx(l+nvar)=xx(l+nvar)+r
      go to 200
c   Accumulate unWeighted moment
  105 do 110 i=1,nbar
      do 110 j=1,i
      l=l+1
  110 xx(l)=xx(l)+dble(xbata(l2,i))*dble(xbata(l2,j))
      do 115 i=1,nbar
  115 xx(l+i)=xx(l+i)+dble(xbata(l2,i))
      xx(l+nvar)=xx(l+nvar)+1.d0
      go to 200
  120 if(MISS(xbata(l2,ifm)).ne.0.or.(iwt.gt.0.and.MISS(xbata(l2,iwt)).n
     1e.0)) go to 200
      do 130 i=1,jma
      j=num(i)
      if(j.eq.nvar) go to 125
      if(MISS(xbata(l2,j)).ne.0) go to 200
      if(jd.gt.0) go to 130
      be(i)=dble(xbata(l2,j))
      go to 130
  125 if(jd.gt.0) go to 130
      be(i)=1.d0
  130 continue
      if(jd.gt.0) go to 140
      be(jmb)=dble(xbata(l2,ifm))
      mobs=mobs+1
      if(iwt.eq.0) go to 136
      r=dble(xbata(l2,iwt))
      do 132 i=1,jmb
      do 132 j=1,i
      l=l+1
  132 xx(l)=xx(l)+r*be(i)*be(j)
      do 134 i=1,jmb
  134 xx(l+i)=xx(l+i)+r*be(i)
      xx(l+jmb+1)=xx(l+jmb+1)+r
      go to 200
  136 do 138 i=1,jmb
      do 138 j=1,i
      l=l+1
  138 xx(l)=xx(l)+be(i)*be(j)
      do 139 i=1,jmb
  139 xx(l+i)=xx(l+i)+be(i)
      xx(l+jmb+1)=xx(l+jmb+1)+1.d0
      go to 200
  140 ir=ir+1
      if(ir.le.53.or.jres.eq.0) go to 155
c   Print residual headings
      call CPRINT(6)
      if(lwi.eq.0) write(ip,150)
  150 format(' Observ',5x,'Dep Var. Y',6x,'Y Hat',8x,'Residual',3x,'Std.
     1 Residual',5x,'Weight',7x,'-2 Std',4x,'-1 Std',6x,'0',8x,'+1 Std',
     24x,'+2 Std',/1x,128('-'),/85x,4('i',9x),'i')
      if(lwi.eq.1) write(ip,152)
  152 format(' Observ',5x,'Dep Var. Y',6x,'Y Hat',8x,'Residual',3x,'std.
     1 Residual',5x,'Weight',/1x,79('-'),/)
      ir=1
  155 r=0.d0
      a(5)=1.
      if(iwt.gt.0) a(5)=xbata(l2,iwt)
      do 170 i=1,jma
      j=num(i)
      if(j.ne.nvar) go to 160
      r=r+be(i)
      go to 170
  160 r=r+dble(xbata(l2,j))*be(i)
  170 continue
      a(1)=xbata(l2,ifm)
      r1=dble(xbata(l2,ifm))-r
c   Accumulate durban-watson statistic
      if(idur.eq.0) go to 174
      er(5)=er(5)+r1*r1
      if(l6.eq.0) go to 172
      er(2)=er(2)+r1*er(1)
      er(3)=er(3)+r1*r1
      er(4)=er(4)+er(1)*er(1)
      er(1)=r1
      go to 174
  172 er(1)=r1
c   Punch residual vector
  174 if(jrus.gt.0) write(jrus,175) a(1),r,r1
  175 format(3d16.9)
      if(jres.eq.0) go to 200
      a(2)=r
      a(3)=r1
      a(4)=0.
      if(q.gt.0.) a(4)=(dble(xbata(l2,ifm))-r)/q
      if(lwi.eq.1) go to 190
      wx=10.*a(4)
      l=ifix(wx)+22
      if(l.gt.42) l=42
      if(l.lt.2) l=2
      a(5+l)=e(2)
c   Write obsv #, dep. var, Y Hat, residual, std. resi, weight
      write(ip,180) l1,(a(j),j=1,48)
  180 format(i5,6x,5(g13.5,1x),3x,43a1)
      a(5+l)=e(1)
      go to 200
  190 write(ip,180) l1,(a(j),j=1,5)
  200 continue
      if(iqv.eq.1.or.iqv.eq.2) rewind int
      if(jd.gt.0.or.iwt.eq.0.or.xx(l5).eq.0.) go to 208
      r=dble(mobs)/xx(l5)
      do 205 i=1,l5
  205 xx(i)=xx(i)*r
  208 if(jd.le.0.or.idur.eq.0) return
      er(3)=(er(3)+er(4)-2.d0*er(2))/er(5)
      er(4)=(er(2)/dble(mobs-l4))/(er(5)/dble(mobs-jma))
      if(lwi.eq.0) write(ip,210) er(3),er(4)
  210 format(///45x,'Durbin-Watson ',15('.'),g14.6,/45x,'Rho Hat ',21('.
     1'),g14.6)
      if(lwi.eq.1) write(ip,220) er(3),er(4)
  220 format(///19x,'Durbin-Watson ',15('.'),g14.6,/19x,'Rho Hat ',21('.
     1'),g14.6)
      return
      end
c-------------------------END OF SUBROUTINE------------------------------

